//
// Ad9952_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2003 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef Ad9952_MbH
#define Ad9952_MbH

#include <Clockbase_Mb.h>
#include <HardwareRegister_Mb.h>
#include <Trace_Mb.h>

namespace Innovative
{

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4355)
#endif

//=============================================================================
//  CLASS Ad9952  --  DDS timebase control
//=============================================================================

class Ad9952 : public ClockBase
{
	friend class ClockGeneratorDeviceMap;

public:
	//
	//  Member Functions
	Ad9952(int index, AddressingSpace &space, int addr, int data, int ctl);
	Ad9952(double freq, double ref, bool enabled, int index,
		   AddressingSpace &space, int addr, int data, int ctl);

	// Methods
	void                Reapply();
	void                Disable();

	// Output frequency range information
	double				Max() const;
	double 				Min() const;

protected:
	// Overrides
	virtual void    SetFrequency(double freq);
	virtual double  GetFrequencyActual() const;
	virtual void    SetEnabled(bool state);

	// Fields
	unsigned int		FDivisor;

	// Data
	const double 		MaxIntAsFloat;
	double				SysClk;
	Trace				Debug;

	//
	//  Member Data
	ShadowRegister			AddrReg;
	ShadowRegister			DataReg;
	ShadowRegister			CtlReg;

	// Support
	void 			Data(unsigned char reg, unsigned int value);
	unsigned int 	Data(unsigned char reg);
	void 			Control(unsigned int bit, bool value);
	void 			Address(unsigned char value);
	
	void 			DoSetFrequency(double freq);
	void 			DoSetEnabled(bool state);
};

#ifdef _MSC_VER
	#pragma warning(pop)
#endif

} // namespace Innovative

#endif
