// BddFile_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2017 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef BddFile_MbH
#define BddFile_MbH

#include "BinView_Mb.h"
#include "IniFile_Mb.h"
#include "FileSupport_Mb.h"
#include <string>
#include "Magic_Mb.h"


using namespace std;
namespace Innovative
{

//==============================================================================
//  CLASS BddInitObj --
//==============================================================================

class BddInitObj
{
public:

    BddInitObj() :  InputSpan_mv(2000.0)  {} //constructor
    virtual ~BddInitObj()  {} //destructor

    enum FileFormats { ffRaw, ffPmc, ffVelo, ffVita, ffXU = ffRaw, ffX6 = ffVita, ffXA = ffVelo };

    void InitBddFile(BinView& graph); //method

    void   FileFormat(FileFormats ftm)
        {
            switch(ftm)
                {
                default:
                case ffRaw:
                    Fileformat = BinViewOptions::SystemOptions::sFile;
                    break;
                case ffPmc:
                    Fileformat = BinViewOptions::SystemOptions::sPacketFile;
                    break;
                case ffVelo:
                    Fileformat = BinViewOptions::SystemOptions::sVelo;
                    break;
                case ffVita:
                    Fileformat = BinViewOptions::SystemOptions::sVita;
                    break;
                }
        }
    FileFormats  FileFormat() const
        {
            FileFormats fileformat;
            switch(Fileformat)
                {
                default:
                case BinViewOptions::SystemOptions::sFile:
                    fileformat = BddInitObj::ffRaw;
                    break;
                case BinViewOptions::SystemOptions::sPacketFile:
                    fileformat = BddInitObj::ffPmc;
                    break;
                case BinViewOptions::SystemOptions::sVelo:
                    fileformat = BddInitObj::ffVelo;
                    break;
                case BinViewOptions::SystemOptions::sVita:
                    fileformat = BddInitObj::ffVita;
                    break;
                }
        return fileformat;
        }

    void            PacketDataSize(unsigned int packet_data_size)
            {PacketdataSize = packet_data_size;}
    unsigned int    PacketDataSize() const
            {return PacketdataSize;}

    void            SampleRateKhz(double samplerate)
            {SamplerateKhz = samplerate;}
    float           SampleRateKhz() const
            {return SamplerateKhz;}

    void            Bits(unsigned int bits)
            {FBits = bits;}
    unsigned int    Bits() const
            {return FBits;}

    void            ActiveChannels(unsigned int activechannels)
            {Activechannels = activechannels;}
    unsigned int    ActiveChannels() const
            {return Activechannels;}

    void            ActiveDevices(unsigned int activedevices)
            {Activedevices = activedevices;}
    unsigned int    ActiveDevices() const
            {return Activedevices;}

    void            IsUnipolar(bool isunipolar)
            {Isunipolar = isunipolar;}
    bool            IsUnipolar() const
            {return Isunipolar;}

    void            OverWriteBdd(bool overwritebdd)
            {OverwriteBdd = overwritebdd;}
    bool            OverWriteBdd() const
            {return OverwriteBdd;}
    void            BinFile(string binfile)
            {Binfile = binfile;}
    string          BinFile() const
            {return Binfile;}
    void            InputSpan(float inputspan)
            {Inputspan = inputspan;}
    float           InputSpan() const
            {return Inputspan;}


protected:

    virtual void    ApplyCustomSettings(BinView& graph);


private:

    // Fields
    float           Inputspan;
    float           SamplerateKhz;
    unsigned int    FBits;
    unsigned int    PacketdataSize;
    unsigned int    Activechannels;
    unsigned int    Activedevices;
    bool            Isunipolar;
    bool            OverwriteBdd;
    string			Binfile;
    BinViewOptions::SystemOptions::IISource Fileformat;
    float           InputSpan_mv;


};



}  //end namespace

#endif
