// BinviewPlotter_App.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2007 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef BinviewPlotter_AppH
#define BinviewPlotter_AppH

#include <BinView_Mb.h>
#include <Trace_Mb.h>
#if defined(WIN32) || defined(WIN64)
    #include <MappedDataSet_Mb.h>
    typedef Innovative::MappedDataSet RtDataSet;
#else
    // Placeholder, until mapped files are implemented
    #include <FileDataSet_Mb.h>
    typedef Innovative::FileDataSet RtDataSet;
#endif
#include <StopWatch_Mb.h>
#include <Buffer_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class BinviewPlotter
{
public:
    BinviewPlotter(unsigned int instance=0);
    ~BinviewPlotter();

    // Methods
    void Start();
    void Stop();
    void Update(const Innovative::Buffer & buffer);

	void Instance(unsigned int NewInstance);
    unsigned int Instance() const;

	bool  IsStarted()
		{  return FIsStarted;  }

    // Properties
    void        UpdateRate(double Hz)
        {  FUpdateRate=std::max<double>(Hz, .1);  }
    double      UpdateRate() const
        {  return FUpdateRate;  }

    // Binview Data Descriptor is accessible
    Innovative::BinView  Bdd;

private:
	// Fields
	double          		FUpdateRate;

	// Data
	unsigned int    		FInstance;
	double          		Elapsed;
	Innovative::StopWatch   Rtc;
	RtDataSet *             Data;
	bool                    FIsStarted;
	Innovative::Trace		Debug;

    // Methods
    double  UpdatePeriod() const
        {  return 1.0/FUpdateRate;  }
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif

