//   ModuleDebugLog_App.h           Functions to support Module Debug Logging
//
//   PrintModuleDebugLog()   --  Dump Module Log to disk file

#include <vector>
#include <string>
#include <fstream>

//---------------------------------------------------------------------------
//  PrintModuleDebugLog() -- Print Debug Log to file
//---------------------------------------------------------------------------
//  Module Requirements:
//     Debug()->DumpLog() member function that takes a vector<int> &
//        (used to fill the log vector)
template <class Mod>
void  PrintModuleDebugLog(Mod & Module, const std::string & log_file_name)
{
    std::vector<int> log_copy;
    //  copy log to our copy
    Module.Debug()->DumpLog(log_copy);

    //  write log to disk file
	std::fstream file(log_file_name.c_str(), std::ios::out);
	if(!file.good())
		return;

    file << std::hex;
    for (std::vector<int>::iterator iter=log_copy.begin();
            iter !=log_copy.end(); ++iter)
        {
        file << *iter << std::endl;
        }

	file.close();

}
