// ScriptPlayer_App.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2007 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef ScriptPlayer_AppH
#define ScriptPlayer_AppH

#include <sstream>              // Avoids compiler error with _algobase.h
#include <Script_Mb.h>
#include <DataTypes_Mb.h>
#undef SetPort  // Work-around for stupid Windows macro

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//==============================================================================
//  CLASS  ScriptPlayer
//==============================================================================

class ScriptPlayer
{
public:
    // Ctor
    ScriptPlayer();
    virtual ~ScriptPlayer();

    // Methods
    void Execute(const std::string & file);

    // Module register access
    virtual void Port(int address, ii32 data);
    virtual ii32 Port(int address);

    virtual void Logic(int address, ii32 data);
    virtual ii32 Logic(int address);

protected:
	//
    //  Data Members
    Innovative::Scripter    Script;

    // Overrides
    virtual ii32 GetPort(int address) = 0;
	virtual void SetPort(int address, ii32 data) = 0;
    virtual ii32 GetLogic(int address) = 0;
    virtual void SetLogic(int address, ii32 data) = 0;
	virtual void Log(const std::string & msg) = 0;

    // Support Methods
    void  HandleScriptMessage(Innovative::ProcessStatusEvent & Event);
    void  HandleScriptCommand(Innovative::ProcessStatusEvent & Event);

    void  DoLogicStore();
    void  DoLogicFetch();
    void  DoPortStore();
    void  DoPortFetch();
    void  DoDelay();
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif

