//  BddFile_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2017 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include "TxtFile_Mb.h"
#include <sstream>
#include <ctime>
#include <algorithm>
#include <StringSupport_Mb.h>
#include <string.h>

namespace Innovative
{
//------------------------------------------------------------------------------
//  TxtFile::TxtFile() --
//------------------------------------------------------------------------------

TxtFile::TxtFile() : FileName("TextFile.txt")
{

}
//------------------------------------------------------------------------------
//  TxtFile::TxtFile(string name) --
//------------------------------------------------------------------------------

TxtFile::TxtFile(string name) : FileName(name)
{

}
//------------------------------------------------------------------------------
//  TxtFile::~TxtFile() --
//------------------------------------------------------------------------------

TxtFile::~TxtFile()
{
    if(File.is_open())
        File.close();
}
//------------------------------------------------------------------------------
//  TxtFile::Clear() --
//------------------------------------------------------------------------------

void TxtFile::Clear()
{
    File.open(FileName.c_str());
    stringstream ss;
    ss  << "";
    File << ss.rdbuf();
    File.close();
}
//------------------------------------------------------------------------------
//  TxtFile::Append(string data) --
//------------------------------------------------------------------------------

void TxtFile::Append(string data, bool WithDate)
{
    File.open(FileName.c_str(), std::ios_base::app);
    stringstream ss;
    if(WithDate)
        ss << "[ " << CurrentDateTime() << " ]  " << data << endl;
    else
        ss << data << endl;

    File << ss.rdbuf();
    File.close();
}
//---------------------------------------------------------------------------
//  TxtFile::CurrentDateTime()  -- Get current date/time, format is YYYY-MM-DD.HH:mm:ss
//---------------------------------------------------------------------------

std::string TxtFile::CurrentDateTime()
{
    char       buf[80];

    time_t     now = time(0);
    struct tm  tstruct = *std::localtime(&now);

    strftime(buf, sizeof(buf), "%Y-%m-%d@%X", &tstruct);
    // ':' is illegal in filenames
    replace(buf, buf + strlen(buf), ':', '.');
    return buf;
}

}
