//---------------------------------------------------------------------------
// AtroposDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2014 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <AtroposDeviceDriver_Mb.h>
#include <AtroposMemoryMap_Mb.h>

//---------------------------------------------------------------------------

//
//  Nameless namespace for 'static' data
namespace
{

//---------------------------------------------------------------------------
//  Atropos Device Info
//---------------------------------------------------------------------------

const unsigned int Atropos_LogicDeviceBar = 2;  // Second BAR is here cause of 64 bit
                                                //   access requires pairing BARs

//------------------------------------------------
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   Atropos_IntStatusMask        = 0x1;
const unsigned int   Atropos_IntStatusByteAddress =
    Innovative::Atropos_MemoryMap::mmInterruptStatus;
//  Parameters for Driver Open
//  ...Device Driver Name
#define     Atropos_TARGET_BASE             "ATPOSDRV"
#define     Atropos_TARGET_VENDOR_ID         0x1303
#define     Atropos_TARGET_DEVICE_ID         0x0071
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name      Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
        "Atropos", Atropos_TARGET_BASE,    0x1303,      0x0071,     0x00,        false);
    }
};       

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS AtroposSysDeviceDriver  -- Driver level code for Atropos Family system object
//===========================================================================

InnovativeKernel::IsrLog * AtroposDeviceDriver::LOG = 0;

//---------------------------------------------------------------------------
//  constructor for class AtroposDeviceDriver
//---------------------------------------------------------------------------

AtroposDeviceDriver::AtroposDeviceDriver()
    :  InnovativeKernel::DualRegionIsrDeviceDriver(
                                    InnovativeKernel::PciId(Atropos_TARGET_VENDOR_ID, Atropos_TARGET_DEVICE_ID),
                                    Atropos_IntStatusByteAddress,
                                    Atropos_IntStatusMask,
                                    Atropos_LogicDeviceBar)
{
    //  Save static pointer to log info
    LOG = & mIsrInfo;
}

}; // Innovative


