//  AtroposMemoryMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2014  Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef AtroposMemoryMap_MbH
#define AtroposMemoryMap_MbH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace Atropos_MemoryMap
{
    //
    //  Logic Memory Register Offsets
    //
    //  Atropos "Standard" WB section offsets
    const unsigned int  wbPeripheral     = 0x000;
    const unsigned int  wbLogicLoader    = 0x100;
    const unsigned int  wbTempControl    = 0x200;
    //const unsigned int  wb???            = 0x300;
    //const unsigned int  wb???            = 0x400;
    //const unsigned int  wb???            = 0x500;
    //
    //  Atropos Wishbone offsets
    //
    //  WB0 - Peripheral Registers
    const unsigned int  mmInformation           = 0x00;
    const unsigned int  mmReset                 = 0x01;
    const unsigned int  mmSubrevision           = 0x02;
    const unsigned int  mmTempAlert             = 0x03;
    const unsigned int  mmIdromI2C              = 0x04;
    const unsigned int  mmPllExtClkSelect       = 0x05;
    const unsigned int  mmPllControl            = 0x06;
    const unsigned int  mmPllSpi                = 0x07;

    const unsigned int  mmExtSyncSelect         = 0x08;
                                            //  = 0x09;
                                            //  = 0x0a;
    const unsigned int  mmSerDesControl         = 0x0b;
    const unsigned int  mmSofwareTrigger        = 0x0c;
    const unsigned int  mmTriggerControl        = 0x0d;
    const unsigned int  mmDecimation            = 0x0e;
    const unsigned int  mmPriTriggerEn          = 0x0f;
    const unsigned int  mmPriControl            = 0x10;
    const unsigned int  mmPriPulseDelay         = 0x11;
    const unsigned int  mmPriPulseWidth         = 0x12;
    //
    //  WB1 - Vsprom Loader Registers
    const unsigned int  mmVsProm_ControlAddr    = 0x00;
    const unsigned int  mmVsProm_Data           = 0x01;
    const unsigned int  mmVsProm_Opcode         = 0x02;
    //
    //  WB2 - Thermal Registers
    const unsigned int  mmTemp_TempControl      = 0x00;
    const unsigned int  mmTemp_FanThreshold     = 0x01;
    const unsigned int  mmTemp_AlertThreshold   = 0x02;
    const unsigned int  mmTemp_CommandChannel   = 0x03;
    //
    //  Port Memory Register Offsets
    // Interrupts
    const unsigned int  mmInterruptStatus     = 0x19000;
    const unsigned int  mmInterruptEnable     = 0x14400;
    //  Pci
    const unsigned int  mmPciVersion          = 0x15c00;
    const unsigned int  mmPciControl          = 0x19400;
//    const unsigned int  mmEpcStatus           = 0x19800;

} // end namespace Atropos_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
