// BandFilter_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//
#include <BandFilter_Mb.h>

namespace   Innovative
{

#ifdef _MSC_VER		
	#pragma warning(push)	
	#pragma warning(disable : 4355)		
#endif 

//---------------------------------------------------------------------------
//  BandFilter::BandFilter()  -- Ctor
//---------------------------------------------------------------------------

BandFilter::BandFilter() 
    : FFreqLow(5000), FFreqHigh(45000)
{
}

//---------------------------------------------------------------------------
//  BandFilter::BandFilter()  -- Copy ctor
//---------------------------------------------------------------------------

BandFilter::BandFilter(const BandFilter & other)
    : inherited( other ), FFreqLow(other.FFreqLow), FFreqHigh(other.FFreqHigh)
{
}

#ifdef _MSC_VER
	#pragma warning(pop)
#endif

//---------------------------------------------------------------------------
//  BandFilter::operator =  --  Assignment
//---------------------------------------------------------------------------

BandFilter & BandFilter::operator = ( const BandFilter & other )
{
    inherited::operator = ( other );

    FFreqLow = other.FFreqLow;
    FFreqHigh = other.FFreqHigh;

    return *this;
}

//---------------------------------------------------------------------------
//  BandFilter::FreqLow()  --  Set lower bound on filter freq
//---------------------------------------------------------------------------

void BandFilter::FreqLow(float value)
{
    FFreqLow = value;
    Start();
}

//---------------------------------------------------------------------------
//  BandFilter::FreqLow  --  Get lower bound on filter freq
//---------------------------------------------------------------------------

float BandFilter::FreqLow() const
{
    return FFreqLow;
}

//---------------------------------------------------------------------------
//  BandFilter::FreqHigh  --  Set upper bound on filter freq
//---------------------------------------------------------------------------

void BandFilter::FreqHigh(float value)
{
    FFreqHigh = value;
    Start();
}

//---------------------------------------------------------------------------
//  BandFilter::FreqHigh  --  Get upper bound on filter freq
//---------------------------------------------------------------------------

float BandFilter::FreqHigh() const
{
    return FFreqHigh;
}


}   // Innovative namespace
