// BandFilter_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef BandFilter_MbH
#define BandFilter_MbH

#include <CommonFilter_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS BandFilter  --  Bandpass filter class
//===========================================================================

class BandFilter : public CommonFilter
{
    typedef CommonFilter inherited;
    
public:
    // Ctor
    BandFilter();
    BandFilter(const BandFilter & other);
    // Assignment
    BandFilter & operator = (const BandFilter & other);

    // Properties
    void                FreqLow(float value);
    float               FreqLow() const;

    void                FreqHigh(float value);
    float               FreqHigh() const;

protected:
    // Fields
    float               FFreqLow;
    float               FFreqHigh;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // Innovative namespace

#endif
