//---------------------------------------------------------------------------
// Benchmark_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.


#ifndef Benchmark_MbH
#define Benchmark_MbH

#include <vector>
#include <StopWatch_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS AveragedRate  -- Simple low-pass filtered rate data
//===========================================================================

class AveragedRate
{
public:
    AveragedRate(int taps=20);

    // Methods
    void   Reset();
    double Process(double sample);
    double Differential(double sample);
    double Differential();

private:
    // Data
    unsigned int			Taps;
    std::vector<double>		History;
    unsigned int			Cursor;
    bool                    Settled;
    double					LastSample;
    double                  Sum;
    Innovative::StopWatch   Rtc;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace

#endif
