// BinFileEvents.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef BinFileEventsH
#define BinFileEventsH

#include "OWEvents.h"
#include <string>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class BinFile;

//===========================================================================
// CLASS BinFileEvent  --  Binary file progress event
//===========================================================================

class BinFileEvent : public COWEvent
{
public:
    const BinFile *  Sender;
    const int        Percent;

public:
    BinFileEvent( BinFile * sender, int percent )
        :  Sender( sender ), Percent( percent )
        {
        }
};

//===========================================================================
// CLASS BinFileCompletionEvent  --  Binary file complete event
//===========================================================================

class BinFileCompletionEvent : public COWEvent
{
public:
    const BinFile *  Sender;

public:
    BinFileCompletionEvent(  BinFile * sender )
        :  Sender( sender )
        {
        }
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
