// BinFile_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef BinFile_MbH
#define BinFile_MbH

#include <ProcessEvents_Mb.h>
#include <vector>
#include <string>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class BinFile;

//===========================================================================
// CLASS BinFile  --  BIN Image File reader
//===========================================================================

class BinFile
{
    typedef std::vector<unsigned char>    CharArray;

public:
    // CTor
    BinFile(std::string & filename);
    ~BinFile();

    // Methods
    void        LoadFromFile();
    int         GetChecksum() const;
    bool        FileExists(std::string filename);

    // Properties
    std::string  FileName() const
        {  return FFileName;  }
    void  FileName(std::string filename)
        {  FFileName = filename;  };
    size_t Size() const
        {  return Image.size();  }
	const char * ImageBasePtr()
	    {  return Image.data();  }
	const unsigned char * UImageBasePtr()
	    {  return reinterpret_cast<const unsigned char *>(Image.data());  }
	    
    std::string             Image;

    OpenWire::EventHandler<ProcessProgressEvent>      OnProgress;
    OpenWire::EventHandler<ProcessCompletionEvent>    OnComplete;
    
private:
    //
    //  Member Data
    std::string             FFileName;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative

#endif

