// BitFile_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2007 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef BitFile_MbH
#define BitFile_MbH

#include <FpgaImage_Mb.h>
#include <fstream>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif


//========================================================================
//   CLASS BitFile
//========================================================================

class BitFile : public FpgaImage
{
    typedef std::vector<unsigned char>   CharArray;

public:

    //  Ctor
    BitFile();
    virtual ~BitFile();

    // Methods
    virtual void        Parse();
    
    std::string         Tag() const
        {  return FTag;  }
    std::string         Part() const
        {  return FPart;  }
    std::string         Date() const
        {  return FDate;  }
    std::string         Time() const
        {  return FTime;  }

protected:
    // Fields
    std::string         FTag;
    std::string         FPart;
    std::string         FDate;
    std::string         FTime;

    // Data
    std::string         section;
    std::streamoff      filesize;
    std::fstream        file;

    // Methods
    void    Preamble();
    int     ReadSectionHeader();
    void    ReadSection(CharArray & buf, unsigned int length);
    void    ReadSection(std::string & s, unsigned int length);
    int     ReadLength();
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // Innovative

#endif
