//  BufferDatagrams_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2007 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include "BufferDatagrams_Mb.h"

namespace Innovative
{

//------------------------------------------------------------------------------
//  ComplexDG::Real() -- Make a vector containing Real part of our vector
//------------------------------------------------------------------------------

Buffer ComplexDG::Real() const
{
    // construct a buffer with room for our result
    Buffer RealBuffer(Holding<float>(size()));
    FloatDG RealBufferDG(RealBuffer);

    const Complex * CDataPtr = &(*(begin()));
    float * RealDataPtr = &(*(RealBufferDG.begin()));

    for (unsigned int i = 0; i < RealBufferDG.size(); ++i)
        *RealDataPtr++ = CDataPtr[i].real();

    return RealBuffer;
}

//------------------------------------------------------------------------------
//  ComplexDG::GetImaginary() -- Make a vector of Imaginary part of vector
//------------------------------------------------------------------------------

Buffer  ComplexDG::Imaginary() const
{
    // construct a buffer with room for our result
    Buffer ImagBuffer(Holding<float>(size()));
    FloatDG ImagBufferDG(ImagBuffer);

    const Complex * CDataPtr = &(*(begin()));
    float * ImagDataPtr = &(*(ImagBufferDG.begin()));

    for (unsigned int i = 0; i < ImagBufferDG.size(); ++i)
        *ImagDataPtr++ = CDataPtr[i].imag();

    return ImagBuffer;
}

}  // end namespace Innovative
