// C64xDspDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <C64xDspDeviceDriver_Mb.h>

namespace
{
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "C64XDSPDRV"
#define     II_TARGET_VENDOR_ID         0x1303
#define     II_TARGET_DEVICE_ID         0x0008
#define     TI_TARGET_VENDOR_ID         0x104C
#define     TI_TARGET_DEVICE_ID         0xA106

//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   C64xIntStatusMask        = 0x0001;
const unsigned int   C64xIntBaseByteAddress   = 0x01800000;
const unsigned int   C64xIntStatusByteAddress = 0x01c1fff0 - C64xIntBaseByteAddress;

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
        "C64xDsp",      TARGET_BASE,         0x1303,      0x0008,     0x00,        false);
    }
};

RegisterBoard Registrar;
}

namespace   Innovative
{
//===========================================================================
//  CLASS C64xDspDeviceDriver  -- Driver level code for C64x Cpus
//===========================================================================
//---------------------------------------------------------------------------
//  constructor for class C64xDspDeviceDriver
//---------------------------------------------------------------------------

C64xDspDeviceDriver::C64xDspDeviceDriver(DeviceMode mode)
    :  InnovativeKernel::TiCpuDeviceDriver(
                    InnovativeKernel::PciId(mode == iiC64xMode ? II_TARGET_VENDOR_ID:TI_TARGET_VENDOR_ID,
                                            mode == iiC64xMode ? II_TARGET_DEVICE_ID:TI_TARGET_DEVICE_ID),
                    C64xIntStatusByteAddress,
                    C64xIntStatusMask)
{
}


}   // Innovative
