// C64xDsp_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <C64xDsp_Mb.h>

namespace   Innovative
{

//---------------------------------------------------------------------------
//  C64xDsp::C64xDsp() - Ctor
//---------------------------------------------------------------------------

C64xDsp::C64xDsp()
    : Device(C64xDspDeviceDriver::iiC64xMode)
{
}

//---------------------------------------------------------------------------
//  C64xDsp::C64xDsp() - Ctor 
//---------------------------------------------------------------------------

C64xDsp::C64xDsp(C64xDspDeviceDriver::DeviceMode /*mode*/)
    : Device(C64xDspDeviceDriver::tiC64xMode)
{
}

//---------------------------------------------------------------------------
//  C64xDsp::~C64xDsp() - Dtor
//---------------------------------------------------------------------------

C64xDsp::~C64xDsp()
{
}

//---------------------------------------------------------------------------
//  C64xDsp::BoardCount() -- Return # of enumerated boards
//---------------------------------------------------------------------------

size_t C64xDsp::BoardCount()
{
    return Device.BoardCount();
}

//---------------------------------------------------------------------------
//  C64xDsp::Open() -- Open the baseboard
//---------------------------------------------------------------------------

void  C64xDsp::Open()
{
    Device.Open();
    //
    //  Warm start the device
    Warm();
}

//---------------------------------------------------------------------------
//  C64xDsp::Close() -- Close the baseboard
//---------------------------------------------------------------------------

void  C64xDsp::Close()
{
    Device.Close();
}

//---------------------------------------------------------------------------
//  C64xDsp::Target() -- Get the target number of the board
//---------------------------------------------------------------------------

int  C64xDsp::Target()
{
    return Device.Target();
}

//---------------------------------------------------------------------------
//  C64xDsp::Target() -- Set the target number of the board
//---------------------------------------------------------------------------

void  C64xDsp::Target( int value )
{
    Device.Target(value);
}

//---------------------------------------------------------------------------
// C64xDsp::Eeprom() -- Read the EEPROM at specified addr
//---------------------------------------------------------------------------

short  C64xDsp::Eeprom(int addr)
{
    return Device.Eeprom(addr);
}

//---------------------------------------------------------------------------
//  C64xDsp::Eeprom() -- Write the EEPROM at specified addr
//---------------------------------------------------------------------------

void  C64xDsp::Eeprom(int addr, short value)
{
    Device.Eeprom(addr, value);
}

//------------------------------------------------------------------------------
//  C64xDsp::Log() -- Add to system log
//------------------------------------------------------------------------------

void C64xDsp::Log(int code, int data)
{
    Device.Log(code, data);
}

//------------------------------------------------------------------------------
//  C64xDsp::Reset() --
//------------------------------------------------------------------------------

void C64xDsp::Reset()
{
    Device.Reset();
}

//------------------------------------------------------------------------------
//  C64xDsp::Warm() --
//------------------------------------------------------------------------------

void C64xDsp::Warm()
{
    Device.Warm();
}

//---------------------------------------------------------------------------
//  C64xDsp::Cpu() -- Return reference to Cpu Interface object
//---------------------------------------------------------------------------

IUsesOnboardCpu & C64xDsp::Cpu()
{
    return Device;
}

//---------------------------------------------------------------------------
//  C64xDsp::RegisterStreamPlugIn() -- attach to a streaming object
//---------------------------------------------------------------------------

void  C64xDsp::RegisterStreamPlugIn( ITiBmStreamManager *plug_in )
{
    StreamManager = plug_in;
    Device.RegisterStreamPlugIn(StreamManager);
}

//---------------------------------------------------------------------------
//  C64xDsp::Internals() -- Internal Operations Interface
//---------------------------------------------------------------------------

ITiBmStreamDeviceInternals *  C64xDsp::Internals()
{
    return &Device;
}

//---------------------------------------------------------------------------
//  C64xDsp::DeviceInfo() --
//---------------------------------------------------------------------------

InnovativeKernel::DeviceEntry & C64xDsp::DeviceInfo()
{
    return Device.DeviceInfo();
}

//---------------------------------------------------------------------------
//  C64xDsp::BusMasterSize() --
//---------------------------------------------------------------------------

void C64xDsp::BusMasterSize(int bytes)
{
	Device.BusMasterSizeWords(bytes/sizeof(int));
}

//---------------------------------------------------------------------------
//  C64xDsp::BusMasterSize() --
//---------------------------------------------------------------------------

int  C64xDsp::BusMasterSize() const
{
	return Device.BusMasterSizeWords() * sizeof(int);
}



} //Innovative
