// C64xDsp_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef C64xDsp_MbH
#define C64xDsp_MbH

#include <LoadMsgEvent_Mb.h>
#include <BaseboardInterfaces_Mb.h>
#include <TiBmStreamSupport_Mb.h>
#include <C64xDspDeviceMap_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class MemWriteEvent;

//===========================================================================
//  CLASS C64xDsp  -- Stand-alone C64x DSP interface
//===========================================================================

class C64xDsp  :  public ITiBmStreamDevice
{
public:
    //
    //  Member Functions
    C64xDsp();
    virtual ~C64xDsp();

    size_t          BoardCount();
    void            Open();
    void            Close();

	int   Target();
    void  Target( int value );

    short Eeprom(int addr);
    void  Eeprom(int addr, short value);

    virtual void  Reset();
    virtual void  Warm();
	virtual void  Log(int code, int data);

	void  		  BusMasterSize(int bytes);
	int   		  BusMasterSize() const;

	IUsesOnboardCpu &  Cpu();

    InnovativeKernel::DeviceEntry & DeviceInfo();

public: // Pseudo-protected
	virtual void  RegisterStreamPlugIn( ITiBmStreamManager *plug_in );
    virtual ITiBmStreamDeviceInternals *  Internals();
    C64xDspDeviceMap * Debug() { return &Device; };

protected:
    C64xDsp(C64xDspDeviceDriver::DeviceMode mode);

private:
    //
    //  Member Data
    C64xDspDeviceMap       Device;
    ITiBmStreamManager *   StreamManager;

};

//===========================================================================
//  CLASS TiC64xDsp  -- For the "unconfigured" C64xDsp ROM -- II use.
//===========================================================================

class TiC64xDsp : public C64xDsp
{
public:
    TiC64xDsp()
        : C64xDsp(C64xDspDeviceDriver::tiC64xMode) {};
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} //Innovative

#endif
