//---------------------------------------------------------------------------
// CardSharpDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2014 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <CardSharpDeviceDriver_Mb.h>

//---------------------------------------------------------------------------

namespace Innovative
{
//===========================================================================
//  CLASS CardSharpDeviceDriver  -- Driver level code for CardSharp Family system object
//===========================================================================

InnovativeKernel::IsrLog * CardSharpDeviceDriver::LOG = 0;


//---------------------------------------------------------------------------
//  constructor for class CardSharpDeviceDriver
//---------------------------------------------------------------------------

CardSharpDeviceDriver::CardSharpDeviceDriver()
    :  InnovativeKernel::MultiChannelBMDeviceDriver(*this,
                                    InnovativeKernel::PciId(), 0, 0, 0)
{
	LogicMemory.RawPhysAddr 	= reinterpret_cast<unsigned int*>(0x43C00000);
	LogicMemory.Size 			= 0x3FFFF;
	LogicMemory.MemType 		= InnovativeKernel::mtMemory;

	PortMemory.RawPhysAddr 		= reinterpret_cast<unsigned int*>(0x43C40000);
	PortMemory.Size 			= 0xFFFF;
	PortMemory.MemType 			= InnovativeKernel::mtPort;

    //  Save static pointer to log info
    LOG = & mIsrInfo;
}

//---------------------------------------------------------------------------
//  CardSharpDeviceDriver::InitializeResources
//---------------------------------------------------------------------------

void  CardSharpDeviceDriver::InitializeResources()
{
    inherited::InitializeResources();

    Device.MapMemory(LogicMemory);
    Device.MapMemory(PortMemory);
}

//---------------------------------------------------------------------------
//  CardSharpDeviceDriver::ReleaseResources
//---------------------------------------------------------------------------

void  CardSharpDeviceDriver::ReleaseResources()
{
    inherited::ReleaseResources();

    Device.UnmapMemory(LogicMemory);
    Device.UnmapMemory(PortMemory);
}



}; // Innovative
