// ChicoDeviceMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef ChicoDeviceMap_MbH
#define ChicoDeviceMap_MbH

#include <HardwareRegister_Mb.h>
#include <ContiguousMemoryBlocks_Mb.h>

namespace Innovative
{

class ChicoDeviceDriver;
//===========================================================================
//  CLASS ChicoDeviceMap  --
//===========================================================================

class ChicoDeviceMap
{
public:
	ChicoDeviceMap();
	virtual ~ChicoDeviceMap();

	void 			Open();
	void 			Close();
	unsigned int  	Target() const;
	void          	Target(unsigned int);
	void          	Led(bool state);
	bool          	Led() const;
	void 			Reset();
	void 			DioData(int value);
	int  			DioData();
	void 			DioConfig(int mask);
	int  			DioConfig();

protected:
	class ControlRegister : public ShadowRegister
	{
	public:
	  RegisterBit       Led;
	  RegisterBit       BaseboardReset;
	  ControlRegister( AddressingSpace &space, int offset );
	};

	AddressingSpace                 mPorts;
	ControlRegister                 mControlRegister;
	ChicoDeviceDriver *             mDeviceDriver;
	ShadowRegister                  DioConfigReg;
	Register                        DioDataReg;

};

} // namespace Innovative

#endif
