//  ClockGeneratorMemoryMap.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2006 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef ClockGeneratorMemoryMapH
#define ClockGeneratorMemoryMapH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace ClockGenerator_MemoryMap
{
    //
    //  Port Memory Registers
    const unsigned int  mmGeneral             = 0x03c00;
    const unsigned int  mmJtag                = 0x12c00;

    const unsigned int  mmPciVersion          = 0x15c00;
    const unsigned int  mmPciTestControl      = 0x17000;
    const unsigned int  mmChipScopeControl    = 0x17400;

    const unsigned int  mmControl             = 0x19400;    // PCI control
    const unsigned int  mmStatus              = 0x19800;    // PCI status

	// Sync PLL
	const unsigned int  mmPllControl          = 0x1A000;
	const unsigned int  mmPllStatus           = 0x1A000;
	const unsigned int  mmPllQADivider        = 0x1A400;
	const unsigned int  mmPllQBDivider        = 0x1A800;
	const unsigned int  mmPllOutputDivider    = 0x1Ac00;
	const unsigned int  mmPllFeedbackDivider  = 0x1B000;
	const unsigned int  mmPllInputDivider     = 0x1B400;

	// DDS
	const unsigned int  mmDdsInstruction      = 0x1B800;
	const unsigned int  mmDdsData             = 0x1Bc00;
	const unsigned int  mmDdsControl          = 0x1c000;


	// Output PLL
	const unsigned int  mmClockControl		  = 0x1c400;
	const unsigned int  mmOutputMux     	  = 0x1cc00;

} // end namespace ClockGenerator_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
