// Codec_Mb.h
//
//  u-law, A-law and linear PCM conversions.
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

//---------------------------------------------------------------------------
#ifndef Codec_MbH
#define Codec_MbH
//---------------------------------------------------------------------------

namespace Innovative
{

#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class Codec
{
public: 
    enum CodecType { aLaw, uLaw };
    
    // CTors
    Codec()
        { FValue = 0; }
    Codec(int val)
        { FValue = val; }
    Codec(unsigned char val, CodecType type)
        { FValue = (type==aLaw) ? FromALaw(val) : FromMuLaw(val); }

    // Methods      
    int asInt() const
        {  return FValue;  }
    int & asInt()
        {  return FValue;  }
    unsigned char asALaw()
        { return ToALaw(FValue); }
    unsigned char asMuLaw()
        { return ToMuLaw(FValue); }
        
    unsigned char   ALawToMuLaw(unsigned char aval);
    unsigned char   MuLawToALaw(unsigned char uval);
    
private:
    // Data
    int             FValue;
    
    // Methods
    unsigned char   ToALaw(int pcm_val);
    int             FromALaw(unsigned char a_val);
    unsigned char   ToMuLaw(int pcm_val);
    int             FromMuLaw(unsigned char u_val);
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif

}; // namespace Innovative

#endif
