// CoffThread_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef CoffThread_MbH
#define CoffThread_MbH

#include <CoffFile_Mb.h>
#include <Thread_Mb.h>
#include <Event_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
// CLASS: CoffThread - COFF4 background-loader class
//===========================================================================

class CoffThread : public Thread
{
    typedef Thread inherited;

public:
    CoffThread();
    virtual ~CoffThread();

    // Methods
    void                Load(const std::string & Filename);
    void                Parse(const std::string & Filename);

    // Data
    CoffFile            Image;

protected:
    virtual void Init();

private:
    enum { sParsing=inherited::sLast, sLoading, sLast };

    int                 DoLoad();
    int                 DoParse();
    virtual void        Execute();

    // Data
    std::string         FFilename;
    Event               Loading;
    Event               Parsing;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative
//---------------------------------------------------------------------------
#endif
