// CommonFilter_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef CommonFilter_MbH
#define CommonFilter_MbH

#include <WindowType_Mb.h>
#include <IppFloatDG_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//=============================================================================
//  CLASS CommonFilter  --  
//=============================================================================

class CommonFilter
{
public:
    // Ctor
    CommonFilter();
    CommonFilter(const CommonFilter & other);
    virtual ~CommonFilter();

    // Assignment
    CommonFilter & operator = (const CommonFilter & other);

    // Methods
	virtual bool    Filter(const IppFloatDG & in, IppFloatDG & out);

    // Properties
	void 			Order(size_t count);
	size_t 	        Order() const;
	size_t 	        Taps()  const;

	void            Alpha(float value);
    float           Alpha() const;

	void            SampleRate(float value);
    float           SampleRate() const;

	void            WindowType(WindowTypes value);
	WindowTypes     WindowType() const;

protected:
	// Fields
    float           FAlpha;
    WindowTypes     FWindowType;
	typedef std::vector<float> FloatArray;
	typedef std::vector<unsigned char> UCharArray;
	FloatArray      FCoefficient;
	FloatArray      FDelay;
	float           FSampleRate;
	UCharArray		FWork;
	UCharArray		FSpec;


    // Methods
    virtual void    SetOrder(size_t count);
    virtual void    CalculateCoefficients() = 0;
	virtual bool    Start();
	virtual void    Stop();
};


void ApplyWindow( float *coef, size_t coef_count, WindowTypes window_type, float alpha );

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // Innovative

#endif
