// CommonFourier_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef CommonFourier_MbH
#define CommonFourier_MbH

#include <IppComplexDG_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//=============================================================================
//  CLASS CommonFourier  --
//=============================================================================

class CommonFourier
{
public:
    enum NormalizationType { NormalizeNone, Normalize, NormalizeSqrt };

    // Ctors
    CommonFourier();
    CommonFourier(const CommonFourier & other);
	virtual ~CommonFourier();

	// Assignment
	CommonFourier & operator = (const CommonFourier & other);

    // Methods
	virtual bool    Transform(const IppComplexDG & in, IppComplexDG & out) = 0;
	virtual bool    Transform() = 0;

	// Properties
	virtual void    Normalization(NormalizationType value)
		{  FNormalization = value;  Stop();  }
	virtual NormalizationType      Normalization() const
		{  return FNormalization;  }

	virtual void    Order(int value);
	virtual int     Order() const
		{  return FOrder;  }

	virtual void    Samples (int value);
	virtual int     Samples() const
		{  return FSamples;  };

	IppComplexDG    Time()
		{  return IppComplexDG(mTime);  }
	IppComplexDG    Frequency()
		{  return IppComplexDG(mFrequency);  }

protected:
	// Data
	NormalizationType   FNormalization;
	int                 FOrder;
	int                 FSamples;
	int                 FReach;

	Buffer              mTime;
	Buffer              mFrequency;
	void *              mState;

	std::vector<unsigned char>   mSpec;
	std::vector<unsigned char>   mWorking;

	// Methods
	virtual bool Start();
	virtual void Stop();

	virtual bool transform(const IppComplexDG & in, IppComplexDG & out) = 0;
	virtual bool alloc(int flag, int hint);
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // Innovative

#endif
