// ContiguousMemoryBlocks_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef ContiguousMemoryBlocks_MbH
#define ContiguousMemoryBlocks_MbH

#include <DataTypes_Mb.h>
#include <vector>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//=============================================================================
//  CLASS ContiguousMemoryBlock  --  
//=============================================================================

class ContiguousMemoryBlock
{
protected:
    ii32 *   mBase;
    int      mSize;

public:
    ContiguousMemoryBlock( ii32 * base, int size_in_words ) 
        : mBase( base ),
          mSize( size_in_words )
        {
        }

public:
    ii32 *  Address() const 
        { return mBase; }
    int     Size()    const 
        { return mSize; }
};

//=============================================================================
//  CLASS ContiguousMemoryBlocks  --  
//=============================================================================

class ContiguousMemoryBlocks
{
public:
    ContiguousMemoryBlocks( int block_count );
    ~ContiguousMemoryBlocks();

    ContiguousMemoryBlock operator [] ( int index )
        {
        ContiguousMemoryBlock block(mBaseAddress + index*mSize, mSize);
        return block;
        }       

    int     Size() const      
        { return mSize; }
    void    Size( int size ) 
        { mSize = size; }

    ii32 *  Address() const 
        { return mBaseAddress; }
    void    Address( ii32 *address ) 
        { mBaseAddress = address; }

    int     FullSize() const 
        { return mSize * mBlockCount; }
    int     Count() const 
        { return mBlockCount; }

protected:
    ii32 *     mBaseAddress;
    int        mSize;
    int        mBlockCount;

};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
