#include "Copious_Board_Mb.h"

namespace Innovative {

//===========================================================================
//  CLASS Copious  -- Baseboard class boilerplate
//===========================================================================
//---------------------------------------------------------------------------
//  constructor for class Copious
//---------------------------------------------------------------------------

Copious::Copious()
{
}

//---------------------------------------------------------------------------
//  destructor for class Copious
//---------------------------------------------------------------------------

Copious::~Copious()
{
}

//---------------------------------------------------------------------------
//   Copious::Name() --
//---------------------------------------------------------------------------

string Copious::Name() const
{
    return Device.Name();
}

//---------------------------------------------------------------------------
//  Copious::Revision() --
//---------------------------------------------------------------------------

string Copious::Revision() const
{
    return Device.Revision();
}

//---------------------------------------------------------------------------
//  Copious::Target() --
//---------------------------------------------------------------------------

int Copious::Target()
{
    return Device.Target();
}

//---------------------------------------------------------------------------
//  Copious::Target() --
//---------------------------------------------------------------------------

void Copious::Target(int value)
{
    Device.Target(value);
}

//---------------------------------------------------------------------------
//  Copious::Led() --
//---------------------------------------------------------------------------

bool Copious::Led(Copious::LedColor color)
{

}

//---------------------------------------------------------------------------
//  Copious::MasterTrigger() --
//---------------------------------------------------------------------------

void Copious::MasterTrigger(bool state)
{

}

//---------------------------------------------------------------------------
//  Copious::SoftwareTrigger() --
//---------------------------------------------------------------------------

void Copious::SoftwareTrigger(bool state)
{

}

//---------------------------------------------------------------------------
//  Copious::Open() --
//---------------------------------------------------------------------------

void Copious::Open()
{
    Device.Open();
}

//---------------------------------------------------------------------------
//  Copious::Close() --
//---------------------------------------------------------------------------

void Copious::Close()
{
    Device.Close();
}

//---------------------------------------------------------------------------
//  Copious::Reset() --
//---------------------------------------------------------------------------

void Copious::Reset()
{
    Device.Reset();
}

//---------------------------------------------------------------------------
//  Copious::Start() --
//---------------------------------------------------------------------------

void Copious::Start()
{
    //Device.Start();
}

//---------------------------------------------------------------------------
//  Copious::Stop() --
//---------------------------------------------------------------------------

void Copious::Stop()
{
    //Device.Stop();
}

//---------------------------------------------------------------------------
//  Copious::PokeLogic() --
//---------------------------------------------------------------------------

ii32 Copious::PeekLogic(int offset)
{
    return Device.PeekLogic(offset);
}

//---------------------------------------------------------------------------
//  Copious::PokeLogic() --
//---------------------------------------------------------------------------

void Copious::PokeLogic(int offset, ii32 value)
{
    Device.PokePort(offset, value);
}

//---------------------------------------------------------------------------
//  Copious::PokePort() --
//---------------------------------------------------------------------------

ii32 Copious::PeekPort(int offset)
{
    return Device.PeekPort(offset);
}

//---------------------------------------------------------------------------
//  Copious::PokePort() --
//---------------------------------------------------------------------------

void Copious::PokePort(int offset, ii32 value)
{
    Device.PokePort(offset, value);
}

//---------------------------------------------------------------------------
//  Copious::AfterFiclStart() --
//---------------------------------------------------------------------------

void Copious::AfterFiclStart(FiclSystem &engine)
{
    engine.Evaluate("  0 constant Pll   1 constant Vcxo  2 constant SioPll "
                    "  3 constant Adc0Spi   4 constant Adc1Spi  5 constant Adc2Spi  6 constant Adc3Spi");

    engine.Evaluate(": ?COPious "
                    "    cr .\" --- SubDevice Constants --- \" "
                    "    cr .\"   Pll  Vcxo  SioPll Adc0Spi Adc1Spi Adc2Spi Adc3Spi\" "
                    "    cr  "
                    "    cr .\" ---- COPious Definitions ---- \" "
                    "    cr .\"   l@  ( addr -- data )  fetch from logic space  \" "
                    "    cr .\"   l!  ( data addr  -- ) : store to logic space   \" "
                    "    cr .\"   p@  ( addr -- data ) : fetch from pci space  \" "
                    "    cr .\"   p!  ( data addr -- ) : store to pci space   \" "
                    "    cr .\"   d@  ( addr dev -- data ) : fetch from sub-device space \" "
                    "    cr .\"   d!  ( data addr dev -- ) : store to sub-device space \" "
                    "    cr .\"   dFreq  ( f:freq dev -- ) : Set device frequency \" "
                    "    cr .\"   dFreqActual  ( dev -- f:freq) : read actual frequency \" "
                    "    cr .\"   ?COPious  : display this message \" "
                    "    cr  ; ");

    engine.Evaluate(": ?COPious  ?COPious  ; "  );    // alias
    engine.Evaluate("marker app");

    engine.Display("COPious-specific wordset loaded \n" );
    //
    //  Call base class FICL init
    //AfterFiclStart(engine);

}


}
