// Copious_DeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2006 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <Copious_DeviceDriver_Mb.h>
#include <Copious_MemoryMap_Mb.h>
//
//  Nameless namespace for 'static' data
namespace
{
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   IntStatusMask        = 0xF;
const unsigned int   IntStatusByteAddress =
    Innovative::Copious_MemoryMap::mmInterruptStatus * sizeof(int);

//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "VelociaDRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x0070
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard -- Register Copious
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID         Device ID      Sub ID   CheckSubID
        "COPious",    TARGET_BASE,       TARGET_VENDOR_ID, TARGET_DEVICE_ID, 0x00,     false);
    }
};

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS CopiousDeviceDriver  -- Driver level code for Copious baseboard
//===========================================================================

//---------------------------------------------------------------------------
//  constructor for class CopiousDeviceDriver
//---------------------------------------------------------------------------

Copious_DeviceDriver::Copious_DeviceDriver()
    :  InnovativeKernel::DualRegionDeviceDriver(
               InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID),
               IntStatusByteAddress,
               IntStatusMask,
               2
           )
{
}

} // namespace Innovative
