#ifndef COPMEMORYMAP_MB_H
#define COPMEMORYMAP_MB_H

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace Copious_MemoryMap
{
    //
    //  Logic Memory Register Offsets
    //
    //  COPious Unit "Standard" WB section offsets
    const unsigned int  wbPeripheral            = 0x000;
    const unsigned int  wbPacketizer            = 0x300;
    const unsigned int  wbAlerts                = 0x400;
    const unsigned int  wbDigitalIo             = 0x600;
    const unsigned int  wbMatlab                = 0x700;
    const unsigned int  wbAurora0               = 0x120;
    const unsigned int  wbApplication           = 0x1a0;

    //
    //  COPious Wishbone offsets
    //

    //  WB0 - Peripheral Registers
    const unsigned int  mmInformation         = 0x00;
    const unsigned int  mmReset               = 0x01;
    const unsigned int  mmBitstreamDate       = 0x02;
    const unsigned int  mmSubrevision         = 0x03;
                                     //       = 0x04;
    const unsigned int  mmHostTrigger         = 0x05;
    const unsigned int  mmSioXo               = 0x06;
    const unsigned int  mmLPDDR               = 0x07;
    const unsigned int  mmVeloOutTestLB       = 0x08;   // Outbound Velo Pids
    const unsigned int  mmVeloOutDataPid      = 0x09;   // Outbound Velo Pids
    const unsigned int  mmK7SourceMux         = 0x10;   // K7 only

    //
    //  WB3 - Packetizer Config
    const unsigned int  mmPktzer_Enable         = 0x00;
    const unsigned int  mmPktzer_AuxHdr         = 0x01;
    const unsigned int  mmPktzer_AlertHdr       = 0x02;  // Reserved for alert cfg
    const unsigned int  mmPktzer_VeloInHdr      = 0x03;  // Array of mmPktzer_TotalVeloHdr
    const unsigned int  mmPktzer_TotalVeloHdr   =    8;
    const unsigned int  mmPktzer_ForceSize      = 0x22;
    const unsigned int  mmPktzer_IntervalPeriod = 0x23;

    //
    //  WB4 - Alert Registers
    const unsigned int  mmAlert_Enable        = 0x00;
    const unsigned int  mmAlert_Control       = 0x01;
    const unsigned int  mmAlert_Software      = 0x02;
    const unsigned int  mmAlert_Clear         = 0x03;

    //
    //  PCI Logic Memory Registers
    //
    // Fpga management
    const unsigned int  mmFpgaData            = 0x12000;
    const unsigned int  mmFpgaControl         = 0x12400;
    const unsigned int  mmI2c                 = 0x12800;
    //const unsigned int  mmFpa                 = 0x12c00;
    // Interrupts
    const unsigned int  mmInterruptEnable     = 0x14400;
    const unsigned int  mmCreditQueue         = 0x14800;
    const unsigned int  mmKernelCacheAvail    = 0x18400;    // sent to release target hold, as cache is free to use
    const unsigned int  mmInterruptStatus     = 0x19000;
    // Communications
    const unsigned int  mmBmRingBaseAddress   = 0x15000;
    const unsigned int  mmBmRingSize          = 0x15400;
    const unsigned int  mmPciVersion          = 0x15c00;
    const unsigned int  mmRxPacketTimer       = 0x17400;
    const unsigned int  mmTxPacketTimer       = 0x16c00;
    const unsigned int  mmPciTestControl      = 0x17000;
    // Misc
    const unsigned int  mmLinkControl         = 0x18000;
    const unsigned int  mmControl             = 0x19400;
    const unsigned int  mmStatus              = 0x19800;

} // end namespace Copious_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative

#endif // COPMEMORYMAP_MB_H
