// DataPlayer_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef DataPlayer_MbH
#define DataPlayer_MbH

#include <DataTypes_Mb.h>
#include <ProcessEvents_Mb.h>
#include <Buffer_Mb.h>
#include <ProgressEvent_Mb.h>
#include <string>
#include <DriveIo_Mb.h>

namespace   Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//=============================================================================
//  CLASS DataPlayer  --
//=============================================================================

struct DataPlayerFile;

class DataPlayer
{
public:
    enum IIMode { pmStop, pmRepeat, pmZero };
	// enum IIClockSource { csInternal, csExternal };

    // Ctor
    DataPlayer();
    DataPlayer(const DataPlayer & other);
    ~DataPlayer();

    // Assignment
	DataPlayer & operator = (const DataPlayer & other);

	// Methods
	bool            Start();
	bool            Stop();

	unsigned int   	Play(int* data, unsigned int size_in_ints);
	unsigned int    Play(Buffer & buffer);
    unsigned int    Play(IDatagrammable & dg_object);
	unsigned int	PlayWithHeader(Buffer & buffer);
	ii64  			Played() const;	
	ii64            Total() const;
	
    unsigned int    Percent() const
						{  return CurrentPercent;  }

	// Properties
	void            Mode(IIMode value);
	IIMode          Mode() const;

	void            FileName(const std::string & value);
	std::string     FileName() const;

	void            Enabled(bool value);
	bool            Enabled() const;

	// Events
    OpenWire::EventHandler<ProgressEvent>           OnProgress;
    OpenWire::EventHandler<StartBufferEvent>        OnStart;
    OpenWire::EventHandler<OpenWire::NotifyEvent>   OnStop;

protected:
    // Fields
    IIMode              FMode;
	bool                FEnabled;
	ii64      			FPlayed;
    int                 CurrentPercent;

	// Data
    DriveIo             mFile;

	// Methods
	void    SetEnabled(bool value);
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace

#endif
