// Datagram_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <Datagram_Mb.h>

namespace   Innovative
{
//---------------------------------------------------------------------------
//  IDatagram::SizeInInts() -- size of datagram in INTs
//---------------------------------------------------------------------------
 
size_t  IDatagram::SizeInInts() const
{
    return DatagramSize()*sizeof(int)/sizeof(int);
}

//---------------------------------------------------------------------------
//  IDatagram::SizeInFloats() -- size of datagram in Floats
//---------------------------------------------------------------------------
 
size_t  IDatagram::SizeInFloats() const
{
    return DatagramSize()*sizeof(int)/sizeof(float);
}

//---------------------------------------------------------------------------
//  IDatagram::SizeInChars() -- size of datagram in Chars
//---------------------------------------------------------------------------
 
size_t  IDatagram::SizeInChars() const
{
    return DatagramSize()*sizeof(int)/sizeof(char);
}

//---------------------------------------------------------------------------
//  IDatagram::SizeInShorts() -- size of datagram in Shorts
//---------------------------------------------------------------------------
 
size_t  IDatagram::SizeInShorts() const
{
    return DatagramSize()*sizeof(int)/sizeof(short);
}

//---------------------------------------------------------------------------
//  IDatagram::AsInt() -- Random access data as Ints
//---------------------------------------------------------------------------
 
int IDatagram::AsInt(int idx) const
{
    return DatagramBasePtr()[idx];
}

//---------------------------------------------------------------------------
//  IDatagram::AsInt() -- Random access data as Ints
//---------------------------------------------------------------------------
 
void IDatagram::AsInt(int idx, int data)
{
    DatagramBasePtr()[idx] = data;
}

//---------------------------------------------------------------------------
//  IDatagram::AsFloat() -- Random access data as Floats
//---------------------------------------------------------------------------
 
float IDatagram::AsFloat(int idx) const
{
    const float * dgb = reinterpret_cast< const float * >(DatagramBasePtr());
    return dgb[idx];
}

//---------------------------------------------------------------------------
//  IDatagram::AsFloat() --  Random access data as Floats
//---------------------------------------------------------------------------
 
void  IDatagram::AsFloat(int idx, float data)
{
    float * dgb = reinterpret_cast< float * >(DatagramBasePtr());
    dgb[idx] = data;
}

//---------------------------------------------------------------------------
//  IDatagram::AsShort() -- Random access data as shorts
//---------------------------------------------------------------------------
 
short IDatagram::AsShort(int idx) const
{
    const short * dgb = reinterpret_cast< const short * >(DatagramBasePtr());
    return dgb[idx];
}

//---------------------------------------------------------------------------
//  IDatagram::AsShort() -- Random access data as shorts
//---------------------------------------------------------------------------
 
void IDatagram::AsShort(int idx, short data)
{
    short *  dgb = reinterpret_cast< short * >(DatagramBasePtr());
    dgb[idx] = data;
}

//---------------------------------------------------------------------------
//  IDatagram::AsChar() -- Random access data as chars
//---------------------------------------------------------------------------
 
char IDatagram::AsChar(int idx) const
{
    const char * dgb = reinterpret_cast< const char * >(DatagramBasePtr());
    return dgb[idx];
}

//---------------------------------------------------------------------------
//  IDatagram::AsChar() -- Random access data as chars
//---------------------------------------------------------------------------
 
void IDatagram::AsChar(int idx, char data)
{
    char * dgb = reinterpret_cast< char * >(DatagramBasePtr());
    dgb[idx] = data;
}

//---------------------------------------------------------------------------
//  IDatagram::ResetPos() --
//---------------------------------------------------------------------------
 
void IDatagram::ResetPos()
{
    FPos = 0;
}

//---------------------------------------------------------------------------
//  IDatagram::ExtractInt() -- Extract data from datagram
//---------------------------------------------------------------------------
 
int IDatagram::ExtractInt()
{
    return AsInt(FPos++);
}

//---------------------------------------------------------------------------
//  IDatagram::InsertInt() -- Insert data onto datagram
//---------------------------------------------------------------------------
 
void IDatagram::InsertInt(int data)
{
    AsInt(FPos++, data);
}

//---------------------------------------------------------------------------
//  IDatagram::ExtractFloat() -- Extract data from datagram
//---------------------------------------------------------------------------
 
float IDatagram::ExtractFloat()
{
    return AsFloat(FPos++);
}

///---------------------------------------------------------------------------
//  IDatagram::InsertFloat() -- Insert data onto datagram
//---------------------------------------------------------------------------
 
void IDatagram::InsertFloat(float data)
{
    AsFloat(FPos++, data);
}

//---------------------------------------------------------------------------
//  IDatagram::ExtractShort() -- Extract data from datagram
//---------------------------------------------------------------------------
 
short IDatagram::ExtractShort()
{
    // Use all of the word for the short integer
    return AsInt(FPos++);
}

//---------------------------------------------------------------------------
//  IDatagram::InsertShort() -- Insert data onto datagram
//---------------------------------------------------------------------------
 
void IDatagram::InsertShort(short data)
{
    // Use all of the word for the short integer
    AsInt(FPos++, (int)data);
}

//---------------------------------------------------------------------------
//  IDatagram::ExtractChar() -- Extract data from datagram
//---------------------------------------------------------------------------
 
char IDatagram::ExtractChar()
{
    // Use all of the word for the character
    return AsInt(FPos++);
}

//---------------------------------------------------------------------------
//  IDatagram::InsertChar(char) -- Insert data onto datagram
//---------------------------------------------------------------------------
 
void IDatagram::InsertChar(char data)
{
    // Use all of the word for the character
    AsInt(FPos++, (int)data);
}

//---------------------------------------------------------------------------
//  IDatagram::Insert(int) -- Insert data onto datagram
//---------------------------------------------------------------------------
 
void IDatagram::Insert(int data)
{
    InsertInt(data);
}

//---------------------------------------------------------------------------
//  IDatagram::Insert(float) -- Insert data onto datagram
//---------------------------------------------------------------------------
 
void IDatagram::Insert(float data)
{
    InsertFloat(data);
}

//---------------------------------------------------------------------------
//  IDatagram::Insert(short) -- Insert data onto datagram
//---------------------------------------------------------------------------
 
void IDatagram::Insert(short data)
{
    InsertShort(data);
}

//---------------------------------------------------------------------------
//  IDatagram::Insert(char) -- Insert data onto datagram
//---------------------------------------------------------------------------
 
void IDatagram::Insert(char data)
{
    InsertChar(data);
}

} // namespace Innovative
