// Datagram_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef Datagram_MbH
#define Datagram_MbH

#include <stddef.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS IDatagram  -- Interface to view buffer data as a glob of POD types
//===========================================================================

class IDatagram
{
public:
    IDatagram() :  FPos(0)
        {}
    virtual ~IDatagram()
    	{}
        
    size_t   SizeInInts() const;
    size_t   SizeInFloats() const;
    size_t   SizeInChars() const;
    size_t   SizeInShorts() const;
    //
    //  Random access interface
    int   AsInt( int idx) const;
    void  AsInt( int idx, int data);
    float AsFloat( int idx) const;
    void  AsFloat( int idx, float data);
    short AsShort( int idx) const;
    void  AsShort( int idx, short data);
    char  AsChar( int idx) const;
    void  AsChar( int idx, char data);
    //
    //  Queue interface
    void   ResetPos(); 
    int    ExtractInt();
    void   InsertInt(int data);
    float  ExtractFloat();
    void   InsertFloat(float data);
    short  ExtractShort();
    void   InsertShort(short data);
    char   ExtractChar();
    void   InsertChar(char data);
    void   Insert(int data);
    void   Insert(float data);
    void   Insert(short data);
    void   Insert(char data);
    
protected:
    virtual size_t     DatagramSize() const = 0;   // size in INTs if known
    virtual int *           DatagramBasePtr() const = 0;     
    
private:
    //
    //  Member Data
    unsigned int FPos;     
    
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
