// DeviceEnum_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <DeviceEnum_Mb.h>
#include <string>
#include <algorithm>
#include <stdexcept>
#include <sstream>
#include <iterator>
#include <functional>
#include <SingletonManager_Mb.h>
#include <KernelPci_Mb.h>
#include <Osal_Mb.h>

namespace InnovativeKernel
{

//==============================================================================
//  CLASS DeviceEntryArraySingleton --
//==============================================================================

class DeviceEntryArraySingleton : public OpenWire::SingletonService
{
public:
    DeviceEntryArray Devices;

private:
    static DeviceEntryArraySingleton *Instance;

public:
    static DeviceEntryArraySingleton *GetInstance()
    {
        if( ! Instance )
            Instance = new DeviceEntryArraySingleton();

        return Instance;
    }

};

//------------------------------------------------------------------------------
DeviceEntryArraySingleton *DeviceEntryArraySingleton::Instance = NULL;

class DeviceDebugOutput : public Osal::IOsDeviceDebugUI
{
public:
    virtual ~DeviceDebugOutput() {}

    virtual void  IsrLog(unsigned int /*isr_log_data*/) {}
    virtual void  TraceLog(int /*code*/, int /*data*/)      {}

};

//=============================================================================
//  CLASS DeviceEnum  --
//=============================================================================
//------------------------------------------------------------------------------
//  DeviceEnum constructor
//------------------------------------------------------------------------------

DeviceEnum::DeviceEnum()
//:  DDevice(new DeviceDebugOutput)
{
}
//------------------------------------------------------------------------------
//  DeviceEnum::Scan() --
//------------------------------------------------------------------------------
#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4800)
#endif

bool DeviceEnum::Scan(PciId & /*ID*/)
{
    if ( DeviceEntryArraySingleton::GetInstance()->Devices.size())
        return true;

   //Scan the PCI Bus looking for boards that match our ID
   // DDevice.ScanPci();

//    DeviceEntry Entry;
//    for (unsigned int board = 0; board < DDevice.BoardCount(); board++)
//    	{
//        //
//        //  Fill the Config Space structure from the bus
//        //WinDriver.ReadPciConfig(Entry, Result[board].Location);
//        //Entry.PositionFrom(Result[board].Location);
//        //
//        //  Save Entry in Singleton
//        DeviceEntryArraySingleton::GetInstance()->Devices.push_back(Entry);
//    	}

    return true;
}

#ifdef _MSC_VER		
	#pragma warning(pop)	
#endif
//------------------------------------------------------------------------------
//  DeviceEnum::Scan() --
//------------------------------------------------------------------------------

bool DeviceEnum::Scan()
{
    BoardEnumData   Boards;

    for (size_t i = 0; i < Boards.Count(); ++i)
        {
        PciId ID(Boards.VendorId(i), Boards.DeviceId(i));
        if (Scan(ID))
            return true;
        }

    return false;
}

//------------------------------------------------------------------------------
//  DeviceEnum::Device() --  Return specified device entry within specified vector
//------------------------------------------------------------------------------

const DeviceEntry &DeviceEnum::Device(int i, DeviceEntryArray&  devices) const
{
    return devices[i];
}

//------------------------------------------------------------------------------
//  DeviceEnum::Device() --  Return specified system device entry
//------------------------------------------------------------------------------

const DeviceEntry &DeviceEnum::Device(int i) const
{
    return Device(i, DeviceEntryArraySingleton::GetInstance()->Devices );
}

//------------------------------------------------------------------------------
//  DeviceEnum::Count() --  Return count of devices with given ID
//------------------------------------------------------------------------------

size_t  DeviceEnum::Count()
{
    // return DDevice.BoardCount();

    return 0;
}

}  // InnovativeKernel
