// DeviceEnum_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef DeviceEnum_MbH
#define DeviceEnum_MbH
//---------------------------------------------------------------------------
#include <string>
#include <vector>
#include <KernelPci_Mb.h>
#include <Osal_Mb.h>

//---------------------------------------------------------------------------
namespace InnovativeKernel
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//==============================================================================
//  CLASS BoardEnumData --
//==============================================================================

class BoardEnumData
{
public:
    // Properties
    size_t                      Count();
    std::string                 BoardName(size_t i);
    std::string                 DriverName(size_t i);
    int                         VendorId(size_t i);
    int                         DeviceId(size_t i);
    int                         SubsystemId(size_t i);
    bool                        CheckSubsystemId(size_t i);
    int                         IndexOf(const std::string & board_name);

};

//---------------------------------------------------------------------------
typedef std::vector<DeviceEntry> DeviceEntryArray;

//==============================================================================
//  CLASS DeviceEnum --
//==============================================================================

class DeviceEnum : public Osal::IOsDeviceDebugUI
{
public:
    // Constructor
    DeviceEnum();
    
public:
    // Methods
    bool                      Scan(PciId & ID);
    bool                      Scan();

    const DeviceEntryArray &  Devices() const;

    const DeviceEntry &       Device(int i) const;
    const DeviceEntry &       Device(int i, DeviceEntryArray & devices) const;

    size_t                    Count();



protected:
	// Data
	unsigned int			Fallow; // Placeholder to avoid zero length 
   // Osal::OsDevice          DDevice;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // InnovativeKernel
//---------------------------------------------------------------------------
#endif
