//---------------------------------------------------------------------------

#include "DigitalReceiverDeviceDriver_Mb.h"
#include "DigitalReceiverMemoryMap_Mb.h"

//---------------------------------------------------------------------------

//
//  Nameless namespace for 'static' data
namespace
{
//------------------------------------------------
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   IntStatusMask        = 0xF;
const unsigned int   IntStatusByteAddress =
    Innovative::DigitalReceiver_MemoryMap::mmInterruptStatus;
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "DRPMCDRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x0010
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
        "DR Pmc",     TARGET_BASE,         0x1303,      0x0010,     0x00,        false);
    }
};

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS DigitalReceiverDeviceDriver  -- Driver level code for DigitalReceiver baseboard
//===========================================================================

InnovativeKernel::IsrLog * DigitalReceiverDeviceDriver::LOG = 0;

//---------------------------------------------------------------------------
//  constructor for class DigitalReceiverDeviceDriver
//---------------------------------------------------------------------------

DigitalReceiverDeviceDriver::DigitalReceiverDeviceDriver()
    :  InnovativeKernel::DualRegionDeviceDriver(
                                    InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID),
                                    IntStatusByteAddress,
                                    IntStatusMask)
{
	//  Default busmaster size is 4 MB
    BusMasterSizeWords(0x400000/sizeof(int));

    //  Save static pointer to log info
    LOG = & mIsrInfo;
}

//---------------------------------------------------------------------------
}; // Innovative
