//  DigitalReceiverMemoryMap.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef DigitalReceiverMemoryMapH
#define DigitalReceiverMemoryMapH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace DigitalReceiver_MemoryMap
{
    //
    //  Port Memory Registers
    const unsigned int  mmFpgaData            = 0x12000;
    const unsigned int  mmFpgaControl         = 0x12400;
    const unsigned int  mmI2c                 = 0x12800;
    const unsigned int  mmJtag                = 0x12c00;

    const unsigned int  mmInterruptEnable     = 0x14400;
    const unsigned int  mmCreditQueue         = 0x14800;

    const unsigned int  mmBmRingBaseAddress   = 0x15000;
    const unsigned int  mmBmRingSize          = 0x15400;
    const unsigned int  mmPciVersion          = 0x15c00;

    const unsigned int  mmRxPacketTimer       = 0x16c00;    // Mocked
    const unsigned int  mmTxPacketTimer       = 0x16c00;

    const unsigned int  mmPciTestControl      = 0x17000;

    const unsigned int  mmInterruptStatus     = 0x19000;
    const unsigned int  mmControl             = 0x19400;
    const unsigned int  mmStatus              = 0x19800;

    const unsigned int  mmHpiControlLo        = 0x1c000;
    const unsigned int  mmHpiControlHi        = 0x1c400;
    const unsigned int  mmHpiAddressLo        = 0x1c800;
    const unsigned int  mmHpiAddressHi        = 0x1cc00;

    const unsigned int  mmHpiDataIncrLo       = 0x1d000;
    const unsigned int  mmHpiDataIncrHi       = 0x1d400;
    const unsigned int  mmHpiDataLo           = 0x1d800;
    const unsigned int  mmHpiDataHi           = 0x1dc00;
    //
    //  Logic Memory Registers
    const unsigned int  mmFpgaVersion         = 0x00;
    const unsigned int  mmUserControl         = 0x01;
    const unsigned int  mmAdcGainCoeff0       = 0x03;
    const unsigned int  mmAdcOffsetCoeff0     = 0x07;
    const unsigned int  mmChannelEnable       = 0x0b;
    const unsigned int  mmChannelDestination  = 0x0c;
    const unsigned int  mmZbtSramAddress      = 0x0e;
    const unsigned int  mmZbtSramReadData     = 0x0f;
    const unsigned int  mmZbtSramWriteData    = 0x0f;
    const unsigned int  mmClockControl        = 0x10;
    const unsigned int  mmClockSelect         = 0x12;
    const unsigned int  mmPacketHeader        = 0x20;
    const unsigned int  mmTrigger             = 0x17;
    const unsigned int  mmDdcDataFormat0      = 0x1b;
    const unsigned int  mmClockTest           = 0x02;
    const unsigned int  mmDdc0                = 0x40;
    const unsigned int  mmFifoIntegrity       = 0xc2;
} // end namespace DR_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
