//   DriveIo_Mb.h
//   Fast sequential large disk file access
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2008 Innovative Integration Corporation.
//  All Rights Reserved.
//---------------------------------------------------------------------------

#ifndef DriveIo_MbH
#define DriveIo_MbH

#include <string>
#include <DataTypes_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS  DriveIo   ---  Large disk file access support class
//===========================================================================

class DriveIoImpl;

class DriveIo
{
public:
    // Ctors
    DriveIo();
    DriveIo(const std::string & filename);
    DriveIo(const DriveIo & other);
    ~DriveIo();

    // Assignment
    DriveIo & operator = (const DriveIo & other);

	// Methods
	bool            Open();
    bool            Opened() const;
    bool            Create();
    bool            Append();
    bool            Close();

    unsigned int    Write(const char * buffer, unsigned int size);
    unsigned int    Read(char * buffer, unsigned int size);

    // Properties
	void            WriteThrough(bool state);
	bool            WriteThrough() const;

	void            Size(ii64 size);
    ii64            Size() const;

    void            FileName(const std::string & name);
    std::string     FileName() const;

    bool            Position(ii64 value);
    ii64            Position() const;

private:
    DriveIoImpl *   Impl;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative

#endif
