//
// Ds4026_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2009 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef Ds4026_MbH
#define Ds4026_MbH

#include <I2C_Mb.h>
#include <Trace_Mb.h>

namespace Innovative
{

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4355)
#endif

//=============================================================================
//  CLASS Ds4026 --  Calibratable TCXO Chip Support
//=============================================================================

class Ds4026
{
public:

	Ds4026(I2CDevice & device);

	void    Init();
	void    Reapply();

    bool     TempCompEnabled()
                {  return FTempCompEnabled;  }
    void     TempCompEnabled(bool enabled)
                {  FTempCompEnabled = enabled;  }

    int      TuningPPB()
                {  return FTuningPPB;  }
    void     TuningPPB(int ppb) 
                {  FTuningPPB = ppb;  }

    float    Temperature()
                {  ReadTemperature();  return FLastTemperature;  }

    //  Raw configuration accesses
	void 			Port(unsigned char reg, unsigned char value);
	unsigned char 	Port(unsigned char reg);

protected:
    bool            FTempCompEnabled;
    int             FTuningPPB;
    float           FLastTemperature;

    I2CDevice &     Device;

	Trace			Debug;

    void            SetTuningRegister();
    void            ReadTemperature();
};

#ifdef _MSC_VER
	#pragma warning(pop)
#endif

} // namespace Innovative

#endif
