// Event_Mb2.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2007 Innovative Integration Corporation.
//  All Rights Reserved.

//  Port to use POCO event
//

#ifndef Event_MbH
#define Event_MbH

#include <SyncObject_Mb.h>
#include <Mutex_Mb.h>
#include <Poco/Event.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//==============================================================================
//  CLASS  Event
//==============================================================================
//  Wrapper for Event object to fit in with MultiObject class.

class Event : public SyncObject
{
public:
    static const bool AutoReset = false;
    static const bool ManualReset = true;

    // Ctor
    Event(bool ManReset=true, bool InitState=false);
    ~Event();

    //  Member Functions
    bool            Set();
	bool            Clear();
	bool            Get();
    bool            Check() {  return IsSignalled();  }  // does not wait_for

    // Generic methods
	virtual bool    WaitFor(unsigned int mS=Infinite);

protected:
    // Interface
	virtual bool    IsSignalled();
    //virtual bool    ShouldReassert();
	//
    //  Data Members
	bool                               Manual;
    //  Member Data
    Poco::Event                        Handle;
    Mutex							   mLock;
    bool                               mSignaled;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif

