// Exception_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <Exception_Mb.h>


namespace Innovative
{

#ifdef _MSC_VER

//---------------------------------------------------------------------------
//  MalibuException::MalibuException() --  Default Ctor
//---------------------------------------------------------------------------

MalibuException::MalibuException() throw()
	: FMsg("Unknown exception")
{
	Debug.Log(What());
}

//---------------------------------------------------------------------------
//  MalibuException::MalibuException() --  Ctor
//---------------------------------------------------------------------------

MalibuException::MalibuException(const char * msg) throw()
	: exception(msg), FMsg(msg)
{
	Debug.Log(What());
}

//---------------------------------------------------------------------------
//  MalibuException::MalibuException() --  Ctor
//---------------------------------------------------------------------------

MalibuException::MalibuException(const std::string & msg) throw()
	: exception(msg.c_str()), FMsg(msg)
{
	Debug.Log(What());
}

//---------------------------------------------------------------------------
//  MalibuException::MalibuException() --  Dtor
//---------------------------------------------------------------------------

MalibuException::~MalibuException() throw()
{
}

//---------------------------------------------------------------------------
//  MalibuException::What() --  Display
//---------------------------------------------------------------------------

const char* MalibuException::What() const throw()
{
	return what();
}

#endif



#ifdef __BORLANDC__

//#include <windows.h>

//---------------------------------------------------------------------------
//  MalibuException::MalibuException() --  Default Ctor
//---------------------------------------------------------------------------

MalibuException::MalibuException() throw()
	: FMsg("Unknown exception")
{
//	MessageBox(GetActiveWindow(), what(), "Malibu Exception", MB_OK);
	Debug.Log(what());
}

//---------------------------------------------------------------------------
//  MalibuException::MalibuException() --  Ctor
//---------------------------------------------------------------------------

MalibuException::MalibuException(const char * msg) throw()
	: FMsg(msg)
{
//	MessageBox(GetActiveWindow(), what(), "Malibu Exception", MB_OK);
	Debug.Log(what());
}

//---------------------------------------------------------------------------
//  MalibuException::MalibuException() --  Ctor
//---------------------------------------------------------------------------

MalibuException::MalibuException(const std::string & msg) throw()
	: FMsg(msg)
{
//	MessageBox(GetActiveWindow(), what(), "Malibu Exception", MB_OK);
	Debug.Log(what());
}

//---------------------------------------------------------------------------
//  MalibuException::MalibuException() --  Dtor
//---------------------------------------------------------------------------

MalibuException::~MalibuException() throw()
{
}

//---------------------------------------------------------------------------
//  MalibuException::what() --  Display
//---------------------------------------------------------------------------

const char* MalibuException::what() const throw()
{
	return FMsg.c_str();
}


#endif

#if defined(__GNUC__)

//---------------------------------------------------------------------------
//  MalibuException::MalibuException() --  Default Ctor
//---------------------------------------------------------------------------

MalibuException::MalibuException() throw()
	: FMsg("Unknown exception")
{
	Debug.Log(what());
}

//---------------------------------------------------------------------------
//  MalibuException::MalibuException() --  Ctor
//---------------------------------------------------------------------------

MalibuException::MalibuException(const char * msg) throw()
	: FMsg(msg)
{
	Debug.Log(what());
}

//---------------------------------------------------------------------------
//  MalibuException::MalibuException() --  Ctor
//---------------------------------------------------------------------------

MalibuException::MalibuException(const std::string & msg) throw()
	: FMsg(msg)
{
	Debug.Log(what());
}

//---------------------------------------------------------------------------
//  MalibuException::MalibuException() --  Dtor
//---------------------------------------------------------------------------

MalibuException::~MalibuException() throw()
{
}

//---------------------------------------------------------------------------
//  MalibuException::what() --  Display
//---------------------------------------------------------------------------

const char* MalibuException::what() const throw()
{
	return FMsg.c_str();
}

#endif  // #ifdef __GNUC__



} // namespace Innovative
