// Exception_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef Exception_MbH
#define Exception_MbH


#include <string>
#include <stdexcept>
#include <Trace_Mb.h>

#ifdef __BORLANDC__
	#include <Ficl/FiclFixup_Mb.h>
#endif

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

#ifdef __BORLANDC__

//==============================================================================
//  CLASS MalibuException -- Portable exception class
//==============================================================================

class MalibuException : public std::exception
{
public:
    // Ctor
	MalibuException() throw();
	MalibuException(const char * msg) throw();
	MalibuException(const std::string & msg) throw();
	virtual ~MalibuException() throw();

	// Methods
	virtual const char* what() const throw();

private:
	std::string     FMsg;
	Trace           Debug;
};

#endif  // #ifdef __BORLANDC__



#ifdef _MSC_VER

//==============================================================================
//  CLASS MalibuException -- Portable exception class
//==============================================================================

class MalibuException : public std::exception
{
public:
	// Ctor
	MalibuException() throw();
	MalibuException(const char * msg) throw();
	MalibuException(const std::string & msg) throw();
	virtual ~MalibuException() throw();

	// Methods
	virtual const char* What() const throw();

private:
	std::string     FMsg;
	Trace           Debug;
};

//  Use these to aid in wrapping a function to display Exception Messages
#define MSVC_IIEXCEPTION_BEGIN_TRY() try\
									 {

#define MSVC_IIEXCEPTION_STD_END_TRY_CATCH() }\
											 catch (std::exception exception)\
                                             {\
											 MessageBox(exception.what(), "Malibu Exception", MB_OK);\
                                             }

#endif  // #ifdef _MSC_VER


#if defined(__GNUC__)

//==============================================================================
//  CLASS MalibuException -- Portable exception class
//==============================================================================

class MalibuException : public std::exception
{
public:
	// Ctor
	MalibuException() throw();
	MalibuException(const char * msg) throw();
	MalibuException(const std::string & msg) throw();
	virtual ~MalibuException() throw();

	// Methods
	virtual const char* what() const throw();

private:
	std::string     FMsg;
	Trace           Debug;
};

#endif  // #ifdef __GNUC__



#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative



#endif  // #ifndef IIExceptionH


