// FcfFile_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//
#include <FcfFile_Mb.h>
#include <StringSupport_Mb.h>

using namespace std;

namespace   Innovative
{

//===========================================================================
// CLASS FcfFile  --  Matlab filter coefficient file parser
//===========================================================================

//---------------------------------------------------------------------------
//  FcfFile::FcfFile() --  Ctor
//---------------------------------------------------------------------------

FcfFile::FcfFile()
{
}

//---------------------------------------------------------------------------
//  FcfFile::Read() --  Parse and load coef file into filter
//---------------------------------------------------------------------------

bool FcfFile::Read(const std::string & filename)
{
    Coefficient.clear();

    if (!FFile.LoadFromFile(filename))
        return false;

    for (size_t i = 0; i < FFile.Count(); ++i)
        {
        string line = FFile.StringAt(i);
        line = Trim(line);

        // Skip blank lines
        if (!line.size())
            continue;

        bool ok = true;
        double coef = StringToDouble(line, ok);
        if (!ok)
            continue;

        Coefficient.push_back(coef);
        }

    return (Coefficient.size() > 0) ? true : false;
}




} // namespace Innovative

