/*******************************************************************
                    f i c l _ s i z e s . h
** Forth Inspired Command Language
**
** Per-platform customization of file sizes
*******************************************************************/
#if !defined (__FICL_SIZES_H__)
#define __FICL_SIZES_H__

/*
** detect 64-bit Support for a platform
*/
#if defined (__x86_64__) || defined (_M_X64)
#define OS_64BIT
#endif

/*
** 64-bit Support
*/
#if defined (OS_64BIT)
#define BITS_PER_CELL 64
//#define INT32 int
//#define UNS32 unsigned int
    #ifdef _WIN64
        #define FICL_INT long long
        #define FICL_UNS unsigned long long
    #else
        #define FICL_INT long
        #define FICL_UNS unsigned long
    #endif
#define FICL_FLOAT double
#define FICL_ALIGN 3
#define FICL_ALIGN_ADD ((1 << FICL_ALIGN) - 1)
#endif

/*
** 32-bit Support
*/
#if !defined (OS_64BIT)
#define BITS_PER_CELL 32
//#define INT32 long
//#define UNS32 unsigned long
#define FICL_INT long
#define FICL_UNS unsigned long
#define FICL_FLOAT float
#define FICL_ALIGN 2
#define FICL_ALIGN_ADD ((1 << FICL_ALIGN) - 1)
#endif


#endif

