//  FifoExtension_Mb.h
//
//  Definition of FIFO extension registers and functions to support data polling.
//---------------------------------------------------------------------------

#ifndef FifoExtensionsH
#define FifoExtensionsH

#include <X3Servo_Mb.h>
#include <HardwareRegister_Mb.h>
#include <X3MemoryMap_Mb.h>
#include <Events_Mb.h>
#include <AlertSystem_Mb.h>

//---------------------------------------------------------------------------
namespace Innovative
{
//==============================================================================
//  CLASS IFifoExtension  -- Interfaces to access Fifo extension registers
//==============================================================================

class IFifoExtension
{

public:
    //
    //  Member Functions
    virtual ii32 RecvFifoWordCount() = 0;
    virtual ii32 ReadRecvFifoWord() = 0;
    virtual ii32 SendFifoWordCount() = 0;
    virtual void WriteSendFifoWord(ii32 sendWord)  = 0;

    //ticks: 15ns per tick, 16777216 max (24-bits)
    virtual void SetDacDelay(ii32 ticks) = 0;
    virtual ii32 GetDacDelay() = 0;
};

}  // end namespace Innovative
#endif
