// FileDataSet_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//


#ifndef FileDataSet_MbH
#define FileDataSet_MbH

#include <DataSetBase_Mb.h>
#include <DriveIo_Mb.h>

namespace Innovative
{

#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
// Class FileDataSet
//===========================================================================

class FileDataSet : public EventStreamDataSet
{
public:
	FileDataSet();
	virtual ~FileDataSet();

	// Properties
	void				AutoCreate(bool value)
		{  FAutoCreate=value;  }
	bool				AutoCreate() const
		{  return FAutoCreate;  }

protected:
    // Override Methods
	virtual bool        ImageOpen();
    virtual void        ImageClose();
	virtual void        ImageFetch(Subsample & sample);
	virtual void        ImageStore(Subsample & sample);
	virtual void        ImageSkip(ii64 offset);
	virtual void        ImageSeek(ii64 offset);
	virtual ii64     	ImageSize() const;
	virtual void        ImageSize(ii64 size);
	virtual void        ImageFlush();

private:
	// Data

    DriveIo                 File;
	char *                  Cache;
	int                     CacheOffset;
	ii64                 	CurrentOffset;
	bool                    Dirty;              // True after cache modification

	// Fields
	bool                    FAutoCreate;        // Auto-create files on open fail
	ii64                 	FSize;              // Size of image, in bytes
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
