//---------------------------------------------------------------------------
// FmcBoard_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2010 Innovative Integration Corporation.
//  All Rights Reserved.
//


#include <FmcBoard_Mb.h>
#include <FmcCarrierMemoryMap_Mb.h>
#include <SystemSupport_Mb.h>
#include <FloatingPtSupport_Mb.h>   // WithinRange template

namespace Innovative
{

#ifdef _MSC_VER
    #pragma warning(push)
    #pragma warning(disable : 4355)
#endif

//===========================================================================
//  CLASS FmcBoard  -- Fmc Daughter card Common baseboard class
//===========================================================================
//---------------------------------------------------------------------------
//  housekeeping for class FmcBoard
//---------------------------------------------------------------------------
using namespace FmcCarrier_MemoryMap;

FmcInformation::MapRegisters FmcInfoRegAddrs =
    {
    mmFmc_ControlStatus,     //  ControlStatus_Addr
    mmFmc_BoardId,           //  FmcId_Addr
    mmFmc_BidirClock,        //  FmcBidir_Addr
    mmFmc_Clk0_M2C_Status,   //  FmcClk0_M2C_Status_Addr
    mmFmc_Clk1_M2C_Status,   //  FmcClk1_M2C_Status_Addr
    mmFmc_Clk2_M2C_Status,   //  FmcClk2_M2C_Status_Addr
    mmFmc_Clk3_M2C_Status,   //  FmcClk3_M2C_Status_Addr
    mmFmc_Clk2_C2M_Status,   //  FmcClk2_C2M_Status_Addr
    mmFmc_Clk3_C2M_Status,   //  FmcClk3_C2M_Status_Addr
    };

FmcInformation::Pex7CopModeMapRegisters Pex7CopInfoRegAddrs =
    {
    mmPex7Cop_FmcVadj,      //  Pex7_VAdj_Status_Addr
    mmPex7Cop_FmcC2M_CC,    //  Pex7_C2M_Clock_Ctrl_Addr
    };

FmcStd_I2C_Bus::MapRegisters FmcStdI2CBusRegAddrs =
    {
    mmFmc_I2C,           //  I2CControl_Addr
    };

FmcStd_I2C_Bus::I2C_SubAddr FmcStdI2CBus_SubAddrs =   //(left justified to byte)
    {
    0x30,                //  TempControl_SubAddr  (left justified)
    0xA0,                //  FmcIdrom_SubAddr
    };

X6VitaPacketizerCfg::MapRegisters FmcVitaPacketizerRegAddrs =
    {
    mmFmc_AdcTStampInit,     //  TimestampInit_Addr
    mmFmc_AdcTStampCtl,      //  TimestampCtrl_Addr
    mmFmc_AdcAdcVitaSize,    //  VitaAdcSize_Addr
    mmFmc_AdcVitaStreamId,   //  VitaAdcStreamId_Addr
    };

//    const unsigned int  mmFmc_AdcVitaControl    = 0x22;   Implement?

X6VitaDepacketizerCfg::MapRegisters FmcVitaDepacketizerRegAddrs =
    {
    mmFmc_DacVitaStreamId,   //  VitaDacStreamId_Addr;
    };

X6Aurora::MapRegisters FmcAuroraRegAddrs =
    {
    mmAurora_TestControl,   //  TestControl_Addr
    mmAurora_ControlStatus, //  ControlStatus_Addr
    mmAurora_WritePort,     //  WritePort_Addr
    mmAurora_ReadPort,      //  ReadPort_Addr
    mmAurora_SfpPortControl, //  SfpPortControl_Addr
    mmAurora_SfpPortI2C,     //  SfpPortI2C_Addr
    };

FmcBoard::MapRegisters  PrimarySlotWishboneAddrs =
    {
    wbFmc0_0,          //  Wishbone_0_Addr
    wbFmc0_1,          //  Wishbone_1_Addr;
    wbFmc0_2,          //  Wishbone_2_Addr;
    wbFmc0_3,          //  Wishbone_3_Addr;
    wbFmc0_4,          //  Wishbone_4_Addr;
    wbFmc0_5,          //  Wishbone_5_Addr;
    wbFmc0_6,          //  Wishbone_6_Addr;
    wbFmc0_Jesd0,      //  Wishbone_Jesd0_Addr;
    wbFmc0_Jesd1,      //  Wishbone_Jesd1_Addr;
    wbFmc0_Jesd2,      //  Wishbone_Jesd2_Addr;
    wbFmc0_Jesd3,      //  Wishbone_Jesd3_Addr;
    };

FmcBoard::MapRegisters  RtmSlotWishboneAddrs =
    {
    wbFmc1_0,          //  Wishbone_0_Addr
    wbFmc1_1,          //  Wishbone_1_Addr;
    wbFmc1_2,          //  Wishbone_2_Addr;
    wbFmc1_3,          //  Wishbone_3_Addr;
    wbFmc1_4,          //  Wishbone_4_Addr;
    wbFmc1_5,          //  Wishbone_5_Addr;
    wbFmc1_6,          //  Wishbone_6_Addr;
    wbFmc1_Jesd0,      //  Wishbone_Jesd0_Addr;
    wbFmc1_Jesd1,      //  Wishbone_Jesd1_Addr;
    wbFmc1_Jesd2,      //  Wishbone_Jesd2_Addr;
    wbFmc1_Jesd3,      //  Wishbone_Jesd3_Addr;
    };

FmcBoard::MapRegisters  RtmSlotWishboneAddrs_K7 =
    {
    wbFmc1_0_K7,          //  Wishbone_0_Addr
    wbFmc1_1_K7,          //  Wishbone_1_Addr;
    wbFmc1_2_K7,          //  Wishbone_2_Addr;
    wbFmc1_3_K7,          //  Wishbone_3_Addr;
    wbFmc1_4_K7,          //  Wishbone_4_Addr;
    wbFmc1_5_K7,          //  Wishbone_5_Addr;
    wbFmc1_6_K7,          //  Wishbone_6_Addr;
    wbFmc1_Jesd0_K7,      //  Wishbone_Jesd0_Addr;
    wbFmc1_Jesd0_K7,      //  Wishbone_Jesd1_Addr;
    wbFmc1_Jesd2_K7,      //  Wishbone_Jesd2_Addr;
    wbFmc1_Jesd3_K7,      //  Wishbone_Jesd3_Addr;
    };


FmcBoard::MapRegisters & SlotWBAddr(FmcBoard::FmcSlot assigned_slot)
{
    switch(assigned_slot)
        {
        default:
            return PrimarySlotWishboneAddrs;
        case FmcBoard::fmcRtm:
            return RtmSlotWishboneAddrs;
        case FmcBoard::fmcRtmK7:
            return RtmSlotWishboneAddrs_K7;
        }
}

//---------------------------------------------------------------------------
//  constructor for class FmcBoard
//---------------------------------------------------------------------------

FmcBoard::FmcBoard(FmcSlot assigned_slot)
    :   WB_FMC_0(LogicMemory, SlotWBAddr(assigned_slot).Wishbone_0_Addr),
        WB_FMC_1(LogicMemory, SlotWBAddr(assigned_slot).Wishbone_1_Addr),
        WB_FMC_2(LogicMemory, SlotWBAddr(assigned_slot).Wishbone_2_Addr),
        WB_FMC_3(LogicMemory, SlotWBAddr(assigned_slot).Wishbone_3_Addr),
        WB_FMC_4(LogicMemory, SlotWBAddr(assigned_slot).Wishbone_4_Addr),
        WB_FMC_5(LogicMemory, SlotWBAddr(assigned_slot).Wishbone_5_Addr),
        WB_FMC_6(LogicMemory, SlotWBAddr(assigned_slot).Wishbone_6_Addr),
        WB_JESD_0(LogicMemory, SlotWBAddr(assigned_slot).Wishbone_Jesd0_Addr),
        WB_JESD_1(LogicMemory, SlotWBAddr(assigned_slot).Wishbone_Jesd1_Addr),
        WB_JESD_2(LogicMemory, SlotWBAddr(assigned_slot).Wishbone_Jesd2_Addr),
        WB_JESD_3(LogicMemory, SlotWBAddr(assigned_slot).Wishbone_Jesd3_Addr),
        FmcInfo_SDev  (this, WB_FMC_0, FmcInfoRegAddrs, LogicMemory, Pex7CopInfoRegAddrs),
        FmcI2CBus_SDev(this, WB_FMC_0, FmcStdI2CBusRegAddrs, FmcStdI2CBus_SubAddrs),
        VitaIn_SDev   (this, WB_FMC_2, FmcVitaPacketizerRegAddrs),
        VitaOut_SDev  (this, WB_FMC_3, FmcVitaDepacketizerRegAddrs),
        Aurora0_SDev  (this, WB_FMC_4, FmcAuroraRegAddrs),
        Aurora1_SDev  (this, WB_FMC_5, FmcAuroraRegAddrs),
        Aurora2_SDev  (this, WB_FMC_6, FmcAuroraRegAddrs),
        FmcVadj_MinSupportedV(0x4),   // 2.5V
        FmcVadj_MaxSupportedV(0x4)    // 2.5V

{
}

//---------------------------------------------------------------------------
//  FmcBoard::ConstructCustomParts()
//---------------------------------------------------------------------------

void  FmcBoard::ConstructCustomParts()
{
    // Subdevice Parts Construction
    FmcInfo_SDev.ConstructCustomParts();
    FmcI2CBus_SDev.ConstructCustomParts();
    VitaIn_SDev.ConstructCustomParts();
    VitaOut_SDev.ConstructCustomParts();
    Aurora0_SDev.ConstructCustomParts();
    Aurora1_SDev.ConstructCustomParts();
    Aurora2_SDev.ConstructCustomParts();

}

//---------------------------------------------------------------------------
//  FmcBoard::Pex7Cop_PrePowerCustomization()
//---------------------------------------------------------------------------

void FmcBoard::Pex7Cop_PrePowerCustomization()
{
    FmcInfo_SDev.SetPex7Cop_PowerMode();
}

//---------------------------------------------------------------------------
//  FmcBoard::InitCardPower()
//---------------------------------------------------------------------------

void  FmcBoard::InitCardPower()
{
    ScopedTraceRef ref(Debug, "FmcBoard::InitCardPower()");

    // request carrier specific customization

    // check which power sequence to use
    if (FmcInfo_SDev.Pex7CarrierPowerMode())
        InitCardPower_Pex7Cop();
    else
        InitCardPower_Original();

}

//---------------------------------------------------------------------------
//  FmcBoard::InitCardPower_Pex7Cop()
//---------------------------------------------------------------------------

void FmcBoard::InitCardPower_Pex7Cop()
{
    ScopedTraceRef ref(Debug, "FmcBoard::InitCardPower_Pex7Cop()");

    //  assume FmcInfo_SDev.FmcC2MPower(false) and FmcInfo_SDev.FmcVadjEnable(false)
    BoardStatus(dsCardPoweredDown);

    //  Check if FMC board is present
    // #1
    Debug.Log("CSR @ #1: 0x", FmcInfo_SDev.ControlStatusReg.Value() ,16);
    if (!FmcInfo_SDev.FmcPresent())
        {
        Debug.Log("No Fmc Card Present");
        BoardStatus(dsNoCardPresent);
        return;
        }

    //  #2-A
    //  Read Board Vadj Level in K7 Style
    short board_vadj_level = FmcInfo_SDev.Pex7_FmcVadjLevel();
    Debug.Log("Board Vadj Level", board_vadj_level);
    short logic_level = FmcInfo_SDev.FmcVadjLevel();
    Debug.Log(" Logic Vadj Level", logic_level);

    if (board_vadj_level != logic_level)
        {
        Debug.Log("Board VAdj does not match Logic VAdj");
        BoardStatus(dsLogicPowerMismatch);
        return;
        }

    //  #3 - VADJ in range check
    //  load FmcVadj_MinSupportedV, FmcVadj_MaxSupportedV overrides
    LoadSupportedVAdjRange(FmcVadj_MinSupportedV, FmcVadj_MaxSupportedV);
    Debug.Log(" Supported Range Min", FmcVadj_MinSupportedV);
    Debug.Log(" Supported Range Max", FmcVadj_MaxSupportedV);

    if (!WithinRange(logic_level, FmcVadj_MinSupportedV, FmcVadj_MaxSupportedV))
        {
        //  #3  Logic Vadj Code out of supported range
        FmcInfo_SDev.FmcVadjEnable(false);
        BoardStatus(dsLogicPowerMismatch);
        Debug.Log("Logic Power Mismatch - VAdj out of supported range");
        return;
        }

    //  Step #4
    Debug.Log("CSR after Success: 0x", FmcInfo_SDev.ControlStatusReg.Value() , 16);
    //  Wait for VADJ Power Good #5
    FmcInfo_SDev.WaitForVadjPowerGood();
    if (FmcInfo_SDev.FmcVadjPower()==false)
        {
        FmcInfo_SDev.FmcVadjEnable(false);
        BoardStatus(dsCarrierVadjPowerFailure);
        Debug.Log("FMC Carrier VADJ Power Failure");
        return;
        }

    //  Enable FMC Power
    FmcInfo_SDev.FmcC2MPower(true);
    //  Wait for Power Good
    FmcInfo_SDev.WaitForPowerGood();

    //  Check for Power Good
    if (FmcInfo_SDev.FmcM2CPower()==false)
        {
        Debug.Log("FMC Module Power Failure");
        FmcInfo_SDev.FmcC2MPower(false);
        FmcInfo_SDev.FmcVadjEnable(false);
        BoardStatus(dsCardPowerFailure);
        return;
        }

    //  Success!
    Debug.Log("CSR @ Last: 0x", FmcInfo_SDev.ControlStatusReg.Value() ,16);
    BoardStatus(dsOk);
}

//---------------------------------------------------------------------------
//  FmcBoard::InitCardPower_Original()
//---------------------------------------------------------------------------

void FmcBoard::InitCardPower_Original()
{
    ScopedTraceRef ref(Debug, "FmcBoard::InitCardPower_Original()");
    //  assume FmcInfo_SDev.FmcC2MPower(false) and FmcInfo_SDev.FmcVadjEnable(false)
    BoardStatus(dsCardPoweredDown);

    //  Check if FMC board is present
	// #1
	Debug.Log("CSR @ #1: 0x", FmcInfo_SDev.ControlStatusReg.Value() ,16);
	if (FmcInfo_SDev.FmcPresent())
        {
        //  #2
        //  Read FMC IDROM and check Power Structure (NOT DONE)
        //  ...instead, load FmcVadj_MinSupportedV, FmcVadj_MaxSupportedV overrides
        LoadSupportedVAdjRange(FmcVadj_MinSupportedV, FmcVadj_MaxSupportedV);
        //  Read Logic Level
		short logic_level = FmcInfo_SDev.FmcVadjLevel();

        if (!WithinRange(logic_level, FmcVadj_MinSupportedV, FmcVadj_MaxSupportedV))
            {
            //  #3  Logic Vadj Code out of supported range
            FmcInfo_SDev.FmcVadjEnable(false);
            BoardStatus(dsLogicPowerMismatch);
            Debug.Log("Logic Power Mismatch");
            return;
            }
        }
    //  Step #4
    //  Enable VADJ
	Debug.Log("CSR @ #4: 0x", FmcInfo_SDev.ControlStatusReg.Value() ,16);
	FmcInfo_SDev.FmcVadjEnable(true);
	Innovative::Sleep(200);   // give time for cap to charge up on readback
	Debug.Log("CSR after EN: 0x", FmcInfo_SDev.ControlStatusReg.Value() ,16);
	//  Check VADJ Enable Status
    if (FmcInfo_SDev.FmcVadjEnable()==false)
        {
		FmcInfo_SDev.FmcVadjEnable(false);
        BoardStatus(dsPowerForcedOff);
        Debug.Log("Logic Power Forced Off Externally");
		Debug.Log("CSR after Fail: 0x", FmcInfo_SDev.ControlStatusReg.Value() ,16);
		return;
        }

	Debug.Log("CSR after Success: 0x", FmcInfo_SDev.ControlStatusReg.Value() , 16);
	//  Wait for VADJ Power Good #5
    FmcInfo_SDev.WaitForVadjPowerGood();
    if (FmcInfo_SDev.FmcVadjPower()==false)
        {
        FmcInfo_SDev.FmcVadjEnable(false);
        BoardStatus(dsCarrierVadjPowerFailure);
        Debug.Log("FMC Carrier VADJ Power Failure");
        return;
        }

    //  Enable FMC Power
    FmcInfo_SDev.FmcC2MPower(true);
    //  Wait for Power Good
    FmcInfo_SDev.WaitForPowerGood();

    //  Check for Power Good
    if (FmcInfo_SDev.FmcM2CPower()==false)
        {
        Debug.Log("FMC Module Power Failure");
        FmcInfo_SDev.FmcC2MPower(false);
        FmcInfo_SDev.FmcVadjEnable(false);
        BoardStatus(dsCardPowerFailure);
        return;
        }

    //  Success!
    Debug.Log("CSR @ Last: 0x", FmcInfo_SDev.ControlStatusReg.Value() ,16);
    BoardStatus(dsOk);

}

//---------------------------------------------------------------------------
//  FmcBoard::OpenHardware()
//---------------------------------------------------------------------------

void  FmcBoard::OpenHardware()
{
    FmcInfo_SDev.OpenHardware();
    FmcI2CBus_SDev.OpenHardware();
    VitaIn_SDev.OpenHardware();
    VitaOut_SDev.OpenHardware();
    Aurora0_SDev.OpenHardware();
    Aurora1_SDev.OpenHardware();
    Aurora2_SDev.OpenHardware();
}

//---------------------------------------------------------------------------
//  FmcBoard::PreconfigureHardware() - configuration outside streaming
//---------------------------------------------------------------------------

void  FmcBoard::PreconfigureHardware()
{
    // Subdevice Configuration
    FmcInfo_SDev.PreconfigureHardware();
    FmcI2CBus_SDev.PreconfigureHardware();
    VitaIn_SDev.PreconfigureHardware();
    VitaOut_SDev.PreconfigureHardware();
    Aurora0_SDev.PreconfigureHardware();
    Aurora1_SDev.PreconfigureHardware();
    Aurora2_SDev.PreconfigureHardware();
}

//---------------------------------------------------------------------------
//  FmcBoard::ConfigureHardware()
//---------------------------------------------------------------------------

void  FmcBoard::ConfigureHardware()
{
    FmcInfo_SDev.ConfigureHardware();
    FmcI2CBus_SDev.ConfigureHardware();
    VitaIn_SDev.ConfigureHardware();
    VitaOut_SDev.ConfigureHardware();
    Aurora0_SDev.ConfigureHardware();
    Aurora1_SDev.ConfigureHardware();
    Aurora2_SDev.ConfigureHardware();
}

//---------------------------------------------------------------------------
//  FmcBoard::StreamStopHardware()
//---------------------------------------------------------------------------

void  FmcBoard::StreamStopHardware()
{
    VitaIn_SDev.StreamStopHardware();
    VitaOut_SDev.StreamStopHardware();
}

//---------------------------------------------------------------------------
//  FmcBoard::CloseHardware()
//---------------------------------------------------------------------------

void  FmcBoard::CloseHardware()
{
}

//---------------------------------------------------------------------------
//  FmcBoard::RemoveCardPower()
//---------------------------------------------------------------------------

void  FmcBoard::RemoveCardPower()
{
    ScopedTraceRef ref(Debug, "FmcBoard::RemoveCardPower()");

    FmcInfo_SDev.FmcC2MPower(false);
    FmcInfo_SDev.FmcVadjEnable(false);
    BoardStatus(dsCardPoweredDown);
}

//---------------------------------------------------------------------------
//  FmcBoard::VitaIn() -- Return reference to Vita Packetizer Control
//---------------------------------------------------------------------------

IVitaPacketizer & FmcBoard::VitaIn()
{
    return VitaIn_SDev;
}

//---------------------------------------------------------------------------
//  FmcBoard::VitaIn_TS() -- Return reference to Vita Timestamp Control
//---------------------------------------------------------------------------

IVitaTimestamp & FmcBoard::VitaIn_TS()
{
    return VitaIn_SDev;
}

//---------------------------------------------------------------------------
//  FmcBoard::VitaOut() -- Return reference to Vita Depacketizer Control
//---------------------------------------------------------------------------

IVitaDepacketizer & FmcBoard::VitaOut()
{
    return VitaOut_SDev;
}

//---------------------------------------------------------------------------
//  FmcBoard::Aurora() -- return ref to Aurora subdevs
//---------------------------------------------------------------------------

IX6Aurora &  FmcBoard::Aurora(unsigned int idx)
{
    switch (idx)
        {
        default:
        case 0: return Aurora0_SDev;
		case 1: return Aurora1_SDev;
        case 2: return Aurora2_SDev;
        }
}

//---------------------------------------------------------------------------
//  FmcBoard::RomInfo() -- Return reference to FMC IDROM Info Class
//---------------------------------------------------------------------------

FmcStandardRomInfo & FmcBoard::RomInfo()
{
	return FmcI2CBus_SDev.RomInfo();
}

//---------------------------------------------------------------------------
//  FmcBoard::FmcInfo() -- Return reference to FMC Info Class
//---------------------------------------------------------------------------

IFmcInformation & FmcBoard::FmcInfo()
{
	return FmcInfo_SDev;
}
//---------------------------------------------------------------------------
//  FmcBoard::IdRom() -- Return reference to FMC IDROM
//---------------------------------------------------------------------------

AdvI2CIdrom & FmcBoard::IdRom()
{
    return FmcI2CBus_SDev.FmcIdrom();
}


//---------------------------------------------------------------------------
//  FmcBoard::PeekLogic() - read relative to the FMC base
//---------------------------------------------------------------------------

ii32  FmcBoard::PeekLogic(ii32 offset)
{
    return WB_FMC_0.At(offset);
}

//---------------------------------------------------------------------------
//  FmcBoard::PokeLogic() - write relative to the FMC base
//---------------------------------------------------------------------------

void  FmcBoard::PokeLogic(ii32 offset, ii32 data)
{
    WB_FMC_0.At(offset, data);
}

//---------------------------------------------------------------------------
//  FmcBoard::PeekJesdLogic() - read relative to the JESD base
//---------------------------------------------------------------------------

ii32  FmcBoard::PeekJesdLogic(unsigned int which, ii32 offset)
{
    WishboneBusSpace & JESD((which==0)? WB_JESD_0 : ((which==1)? WB_JESD_1 :
                           ((which==2)? WB_JESD_2 : WB_JESD_3)));
    return JESD.At(offset);
}

//---------------------------------------------------------------------------
//  FmcBoard::PokeJesdLogic() - write relative to the FMC base
//---------------------------------------------------------------------------

void  FmcBoard::PokeJesdLogic(unsigned int which, ii32 offset, ii32 data)
{
    WishboneBusSpace & JESD((which==0)? WB_JESD_0 : ((which==1)? WB_JESD_1 :
                           ((which==2)? WB_JESD_2 : WB_JESD_3)));
    JESD.At(offset, data);
}

//---------------------------------------------------------------------------
//  FmcBoard::InitializeFmcRomInfo() - Initialize FMC ROM Data for a board
//---------------------------------------------------------------------------

void  FmcBoard:: InitializeFmcRomInfo()
{
    RomInfo().MultiR().Clear();

    Configure_FmcRomInfo(RomInfo());
}

//===========================================================================
//  CLASS FmcAnalogBoard  -- Fmc Daughter card Common baseboard class
//===========================================================================
//---------------------------------------------------------------------------
//  housekeeping for class FmcAnalogBoard
//---------------------------------------------------------------------------
using namespace FmcCarrier_MemoryMap;


FmcAFE_Common::MapRegisters FmcAFECommonRegAddrs =
    {
    mmFmc_TestControl,       //  AfeTestControl_Addr
    mmFmc_SoftwareTrig,      //  AfeSoftwareTrigger_Addr
    mmFmc_ExtSyncControl,    //  AfeExtSyncSelect_Addr
    };

//---------------------------------------------------------------------------
//  constructor for class FmcAnalogBoard
//---------------------------------------------------------------------------

FmcAnalogBoard::FmcAnalogBoard(FmcSlot assigned_slot)
    :  FmcBoard(assigned_slot),
       AFECommon_SDev(this, WB_FMC_1, FmcAFECommonRegAddrs)//,
{
}

//---------------------------------------------------------------------------
//  FmcAnalogBoard::ConstructCustomParts()
//---------------------------------------------------------------------------

void  FmcAnalogBoard::ConstructCustomParts()
{
    FmcBoard::ConstructCustomParts();
    // Subdevice Parts Construction
    AFECommon_SDev.ConstructCustomParts();

}

//---------------------------------------------------------------------------
//  FmcAnalogBoard::OpenHardware()
//---------------------------------------------------------------------------

void  FmcAnalogBoard::OpenHardware()
{
    FmcBoard::OpenHardware();

    AFECommon_SDev.OpenHardware();
}

//---------------------------------------------------------------------------
//  FmcAnalogBoard::PreconfigureHardware() - configuration outside streaming
//---------------------------------------------------------------------------

void  FmcAnalogBoard::PreconfigureHardware()
{
    FmcBoard::PreconfigureHardware();

    // Subdevice Configuration
    AFECommon_SDev.PreconfigureHardware();

}

//---------------------------------------------------------------------------
//  FmcAnalogBoard::ConfigureHardware()
//---------------------------------------------------------------------------

void  FmcAnalogBoard::ConfigureHardware()
{
    FmcBoard::ConfigureHardware();

    AFECommon_SDev.ConfigureHardware();

}

//---------------------------------------------------------------------------
//  FmcAnalogBoard::StreamStopHardware()
//---------------------------------------------------------------------------

void  FmcAnalogBoard::StreamStopHardware()
{
    FmcBoard::StreamStopHardware();
}

//===========================================================================
//  CLASS FmcAdcBoard  -- Fmc Daughter card Common baseboard class
//===========================================================================
//---------------------------------------------------------------------------
//  housekeeping for class FmcAdcBoard
//---------------------------------------------------------------------------
using namespace FmcCarrier_MemoryMap;

FmcAFE_AdcCommon::MapRegisters FmcAfeAdcCommonRegAddrs =
    {
    mmFmc_AdcEnableLo,        //  AfeAdcEnable_Lo_Addr
    mmFmc_AdcEnableHi,        //  AfeAdcEnable_Hi_Addr
    mmFmc_AdcPowerDownLo,     //  AfeAdcPower_Lo_Addr
    mmFmc_AdcPowerDownHi,     //  AfeAdcPower_Hi_Addr
    mmFmc_AdcTriggerCfg,      //  AfeAdcTriggerCfg_Addr
    mmFmc_AdcDecimation,      //  AfeAdcDecimation_Addr
    };

X6AFE_PulseRepetitionInterval::MapRegisters FmcAfeAdcPriRegAddrs =
    {
    mmFmc_AdcPriEnable,      //  PriTriggerEnable_Addr;
    mmFmc_AdcPriInterval,    //  PriInterval_Addr;
    mmFmc_AdcPriTrigParam,   //  PriTriggerParam_Addr;
    mmFmc_AdcCaptureWin      //  PriCaptureWindow_Addr;
    };

Fmc_AdcCalCoefficientLoad::MapRegisters FmcAfeAdcCalCoeffRegAddrs =
    {
    mmFmc_AdcGainCoeff,      //  GainCoeff_Addr;
    mmFmc_AdcOffsetCoeff,    //  OffsetCoeff_Addr
    };


//---------------------------------------------------------------------------
//  constructor for class FmcAdcBoard
//---------------------------------------------------------------------------

FmcAdcBoard::FmcAdcBoard(FmcSlot assigned_slot)
    :   FmcAnalogBoard(assigned_slot),
        AFEAdcC_SDev  (this, WB_FMC_2, FmcAfeAdcCommonRegAddrs),
        AFEAdcPri_SDev(this, true, WB_FMC_2, FmcAfeAdcPriRegAddrs),  // true=AdcPri
        AFEAdcCal_SDev(this, WB_FMC_2, FmcAfeAdcCalCoeffRegAddrs, mmFmc_TotalAdcs)//,
{
}

//---------------------------------------------------------------------------
//  FmcAdcBoard::ConstructCustomParts()
//---------------------------------------------------------------------------

void  FmcAdcBoard::ConstructCustomParts()
{
    FmcAnalogBoard::ConstructCustomParts();
    // Subdevice Parts Construction
    AFEAdcC_SDev.ConstructCustomParts();
    AFEAdcPri_SDev.ConstructCustomParts();
    AFEAdcCal_SDev.ConstructCustomParts();
}

//---------------------------------------------------------------------------
//  FmcAdcBoard::OpenHardware()
//---------------------------------------------------------------------------

void  FmcAdcBoard::OpenHardware()
{
    FmcAnalogBoard::OpenHardware();

    AFEAdcC_SDev.OpenHardware();
    AFEAdcPri_SDev.OpenHardware();
    AFEAdcCal_SDev.OpenHardware();

}

//---------------------------------------------------------------------------
//  FmcAdcBoard::PreconfigureHardware() - configuration outside streaming
//---------------------------------------------------------------------------

void  FmcAdcBoard::PreconfigureHardware()
{
    FmcAnalogBoard::PreconfigureHardware();

    // Subdevice Configuration
    AFEAdcC_SDev.PreconfigureHardware();
    AFEAdcPri_SDev.PreconfigureHardware();
    AFEAdcCal_SDev.PreconfigureHardware();
}

//---------------------------------------------------------------------------
//  FmcAdcBoard::ConfigureHardware()
//---------------------------------------------------------------------------

void  FmcAdcBoard::ConfigureHardware()
{
    FmcAnalogBoard::ConfigureHardware();

    AFEAdcC_SDev.ConfigureHardware();
    AFEAdcPri_SDev.ConfigureHardware();
    AFEAdcCal_SDev.ConfigureHardware();

}

//---------------------------------------------------------------------------
//  FmcAdcBoard::StreamStopHardware()
//---------------------------------------------------------------------------

void  FmcAdcBoard::StreamStopHardware()
{
    FmcAnalogBoard::StreamStopHardware();
    AFEAdcCal_SDev.StreamStopHardware();
}

//===========================================================================
//  CLASS FmcAdcBoard_T1  -- Fmc Daughter card Common baseboard class
//===========================================================================
//---------------------------------------------------------------------------
//  housekeeping for class FmcAdcBoard_T1
//---------------------------------------------------------------------------

FmcSpiDevice::MapRegisters FmcAfeAdcSpiRegAddrs =
    {
    mmFmc_AdcSpiEnable,      //  Device_Addr;
    mmFmc_AdcSpiCtrl,        //  Write_Addr;
    mmFmc_AdcSpiStatus,      //  Read_Addr;
    };

FmcVga_I2C_Bus::MapRegisters VgaI2CBusRegAddrs =
    {
    mmFmc_VGA,           //  I2CControl_Addr
    };

FmcVga_I2C_Bus::I2C_SubAddr VgaI2CBus_SubAddrs =   //(left justified to byte)
    {
    0x20,                //  Vga0_SubAddr
    0x24,                //  Vga1_SubAddr
    0x44,                //  Vga2_SubAddr
    0x60,                //  Vga3_SubAddr
    0xA4,                //  Vga4_SubAddr
    0xA0,                //  VgaIdrom_SubAddr
    };

FmcAFE_AdcCalibrationControl::MapRegisters FmcAfeAdcCalRegAddrs =
    {
    mmFmc_AdcCalStatus,      //  AfeAdcCal_Addr;
    };


//---------------------------------------------------------------------------
//  constructor for class FmcAdcBoard_T1
//---------------------------------------------------------------------------

FmcAdcBoard_T1::FmcAdcBoard_T1(FmcSlot assigned_slot)
    :   FmcAdcBoard(assigned_slot),
        AFEAdcSpi_SDev(this, WB_FMC_2, FmcAfeAdcSpiRegAddrs),
        AFEAdcCalCtrl_SDev(this, WB_FMC_2, FmcAfeAdcCalRegAddrs),
        VgaI2CBus_SDev(this, WB_FMC_2, VgaI2CBusRegAddrs, VgaI2CBus_SubAddrs)//,
{
}

//---------------------------------------------------------------------------
//  FmcAdcBoard_T1::ConstructCustomParts()
//---------------------------------------------------------------------------

void  FmcAdcBoard_T1::ConstructCustomParts()
{
    FmcAdcBoard::ConstructCustomParts();
    // Subdevice Parts Construction
    AFEAdcSpi_SDev.ConstructCustomParts();
    VgaI2CBus_SDev.ConstructCustomParts();
    AFEAdcCalCtrl_SDev.ConstructCustomParts();

}

//---------------------------------------------------------------------------
//  FmcAdcBoard_T1::OpenHardware()
//---------------------------------------------------------------------------

void  FmcAdcBoard_T1::OpenHardware()
{
    FmcAdcBoard::OpenHardware();

    AFEAdcSpi_SDev.OpenHardware();
    VgaI2CBus_SDev.OpenHardware();
    AFEAdcCalCtrl_SDev.OpenHardware();

}

//---------------------------------------------------------------------------
//  FmcAdcBoard_T1::PreconfigureHardware() - configuration outside streaming
//---------------------------------------------------------------------------

void  FmcAdcBoard_T1::PreconfigureHardware()
{
    FmcAdcBoard::PreconfigureHardware();

    // Subdevice Configuration
    AFEAdcSpi_SDev.PreconfigureHardware();
    VgaI2CBus_SDev.PreconfigureHardware();
    AFEAdcCalCtrl_SDev.PreconfigureHardware();

}

//---------------------------------------------------------------------------
//  FmcAdcBoard_T1::ConfigureHardware()
//---------------------------------------------------------------------------

void  FmcAdcBoard_T1::ConfigureHardware()
{
    FmcAdcBoard::ConfigureHardware();

    AFEAdcSpi_SDev.ConfigureHardware();
    VgaI2CBus_SDev.ConfigureHardware();
    AFEAdcCalCtrl_SDev.ConfigureHardware();

}

//---------------------------------------------------------------------------
//  FmcAdcBoard_T1::StreamStopHardware()
//---------------------------------------------------------------------------

void  FmcAdcBoard_T1::StreamStopHardware()
{
    FmcAdcBoard::StreamStopHardware();
}

//===========================================================================
//  CLASS FmcBidirBoard  -- Fmc Daughter card Common baseboard class
//===========================================================================
//---------------------------------------------------------------------------
//  housekeeping for class FmcBidirBoard
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//  constructor for class FmcBidirBoard
//---------------------------------------------------------------------------

FmcBidirBoard::FmcBidirBoard(FmcSlot assigned_slot, bool Fmc500Mode)
    :   FmcAdcBoard(assigned_slot),
        FmcDacDeviceMixin(this),
        //AFEAdcC_SDev  (this, WB_FMC_2, FmcAfeAdcCommonRegAddrs),
        //AFEAdcPri_SDev(this, true, WB_FMC_2, FmcAfeAdcPriRegAddrs),
        AFEAdcSpi_SDev(this, WB_FMC_2, FmcAfeAdcSpiRegAddrs, Fmc500Mode)//,
{
}

//---------------------------------------------------------------------------
//  FmcBidirBoard::ConstructCustomParts()
//---------------------------------------------------------------------------

void  FmcBidirBoard::ConstructCustomParts()
{
    FmcAdcBoard::ConstructCustomParts();
    FmcDacDeviceMixin::ConstructCustomParts();
    // Subdevice Parts Construction
    AFEAdcSpi_SDev.ConstructCustomParts();

}

//---------------------------------------------------------------------------
//  FmcBidirBoard::OpenHardware()
//---------------------------------------------------------------------------

void  FmcBidirBoard::OpenHardware()
{
    FmcAdcBoard::OpenHardware();
    FmcDacDeviceMixin::OpenHardware();

    AFEAdcSpi_SDev.OpenHardware();
}

//---------------------------------------------------------------------------
//  FmcBidirBoard::PreconfigureHardware() - configuration outside streaming
//---------------------------------------------------------------------------

void  FmcBidirBoard::PreconfigureHardware()
{
    FmcAdcBoard::PreconfigureHardware();
    FmcDacDeviceMixin::PreconfigureHardware();

    // Subdevice Configuration
    AFEAdcSpi_SDev.PreconfigureHardware();
}

//---------------------------------------------------------------------------
//  FmcBidirBoard::ConfigureHardware()
//---------------------------------------------------------------------------

void  FmcBidirBoard::ConfigureHardware()
{
    FmcAdcBoard::ConfigureHardware();
    FmcDacDeviceMixin::ConfigureHardware();

    AFEAdcSpi_SDev.ConfigureHardware();
}

//---------------------------------------------------------------------------
//  FmcBidirBoard::StreamStopHardware()
//---------------------------------------------------------------------------

void  FmcBidirBoard::StreamStopHardware()
{
    FmcAdcBoard::StreamStopHardware();
    FmcDacDeviceMixin::StreamStopHardware();
}

//===========================================================================
//  CLASS FmcDacDeviceMixin  -- DAC Mixin Devices for Output and Bidir cards
//===========================================================================
//---------------------------------------------------------------------------
//  housekeeping for class FmcDacBoard
//---------------------------------------------------------------------------
using namespace FmcCarrier_MemoryMap;

FmcAFE_DacCommon::MapRegisters FmcAfeDacCommonRegAddrs =
    {
    mmFmc_DacEnableLo,        //  AfeDacEnable_Lo_Addr
    mmFmc_DacEnableHi,        //  AfeDacEnable_Hi_Addr
    mmFmc_DacPowerDownLo,     //  AfeDacPower_Lo_Addr
    mmFmc_DacPowerDownHi,     //  AfeDacPower_Hi_Addr
    mmFmc_DacTriggerCfg,      //  AfeDacTriggerCfg_Addr
    mmFmc_DacDecimation,      //  AfeDacDecimation_Addr
    mmFmc_DacPhaseIncr,       //  AfeDacPhaseIncr_Addr
    mmFmc_DacReset,           //  AfeDacReset_Addr
    };

X6AFE_PulseRepetitionInterval::MapRegisters FmcAfeDacPriRegAddrs =
    {
    mmFmc_DacPriEnable,      //  PriTriggerEnable_Addr;
    mmFmc_DacPriInterval,    //  PriInterval_Addr;
    mmFmc_DacPriTrigParam,   //  PriTriggerParam_Addr;
    mmFmc_DacCaptureWin      //  PriCaptureWindow_Addr;
    };

FmcSpiDevice::MapRegisters FmcAfeDacSpiRegAddrs =
    {
    mmFmc_DacSpiEnable,      //  Device_Addr;
    mmFmc_DacSpiCtrl,        //  Write_Addr;
    mmFmc_DacSpiStatus,      //  Read_Addr;
    };

Fmc_DacCalCoefficientLoad::MapRegisters FmcAfeDacCalCoeffRegAddrs =
    {
    mmFmc_DacGainCoeff,      //  GainCoeff_Addr;
    mmFmc_DacOffsetCoeff,    //  OffsetCoeff_Addr
    };

//---------------------------------------------------------------------------
//  constructor for class FmcDacDeviceMixin
//---------------------------------------------------------------------------

FmcDacDeviceMixin::FmcDacDeviceMixin(FmcAnalogBoard * owner)
    :   DDMxOwner(owner),
        AFEDacC_SDev  (this, DDMxOwner->WB_FMC_3, FmcAfeDacCommonRegAddrs),
        AFEDacPri_SDev(this, false, DDMxOwner->WB_FMC_3, FmcAfeDacPriRegAddrs),  // false=DacPri
        AFEDacSpi_SDev(this, DDMxOwner->WB_FMC_3, FmcAfeDacSpiRegAddrs),
        AFEDacCal_SDev(this, DDMxOwner->WB_FMC_3, FmcAfeDacCalCoeffRegAddrs, mmFmc_TotalDacs)
{
}

//---------------------------------------------------------------------------
//  FmcDacDeviceMixin::ConstructCustomParts()
//---------------------------------------------------------------------------

void  FmcDacDeviceMixin::ConstructCustomParts()
{
    // Subdevice Parts Construction
    AFEDacC_SDev.ConstructCustomParts();
    AFEDacPri_SDev.ConstructCustomParts();
    AFEDacSpi_SDev.ConstructCustomParts();
    AFEDacCal_SDev.ConstructCustomParts();

}

//---------------------------------------------------------------------------
//  FmcDacDeviceMixin::OpenHardware()
//---------------------------------------------------------------------------

void  FmcDacDeviceMixin::OpenHardware()
{
    AFEDacC_SDev.OpenHardware();
    AFEDacPri_SDev.OpenHardware();
    AFEDacSpi_SDev.OpenHardware();
    AFEDacCal_SDev.OpenHardware();

}

//---------------------------------------------------------------------------
//  FmcDacDeviceMixin::PreconfigureHardware() - configuration outside streaming
//---------------------------------------------------------------------------

void  FmcDacDeviceMixin::PreconfigureHardware()
{
    // Subdevice Configuration
    AFEDacC_SDev.PreconfigureHardware();
    AFEDacPri_SDev.PreconfigureHardware();
    AFEDacSpi_SDev.PreconfigureHardware();
    AFEDacCal_SDev.PreconfigureHardware();

}

//---------------------------------------------------------------------------
//  FmcDacDeviceMixin::ConfigureHardware()
//---------------------------------------------------------------------------

void  FmcDacDeviceMixin::ConfigureHardware()
{
    AFEDacC_SDev.ConfigureHardware();
    AFEDacPri_SDev.ConfigureHardware();
    AFEDacSpi_SDev.ConfigureHardware();
    AFEDacCal_SDev.ConfigureHardware();

}

//---------------------------------------------------------------------------
//  FmcDacDeviceMixin::StreamStopHardware()
//---------------------------------------------------------------------------

void  FmcDacDeviceMixin::StreamStopHardware()
{
    AFEDacC_SDev.StreamStopHardware();
    AFEDacPri_SDev.StreamStopHardware();
    AFEDacSpi_SDev.StreamStopHardware();
    AFEDacCal_SDev.StreamStopHardware();

}

/*
//===========================================================================
//  CLASS FmcDacBoard  -- Fmc Daughter card Common baseboard class
//===========================================================================
//---------------------------------------------------------------------------
//  constructor for class FmcDacBoard
//---------------------------------------------------------------------------

FmcDacBoard::FmcDacBoard(FmcSlot assigned_slot)
    :   FmcAnalogBoard(assigned_slot),
        FmcDacDeviceMixin(this)
{
}

//---------------------------------------------------------------------------
//  FmcDacBoard::ConstructCustomParts()
//---------------------------------------------------------------------------

void  FmcDacBoard::ConstructCustomParts()
{
    FmcAnalogBoard::ConstructCustomParts();
    FmcDacDeviceMixin::ConstructCustomParts();
}

//---------------------------------------------------------------------------
//  FmcDacBoard::OpenHardware()
//---------------------------------------------------------------------------

void  FmcDacBoard::OpenHardware()
{
    FmcAnalogBoard::OpenHardware();
    FmcDacDeviceMixin::OpenHardware();

}

//---------------------------------------------------------------------------
//  FmcDacBoard::PreconfigureHardware() - configuration outside streaming
//---------------------------------------------------------------------------

void  FmcDacBoard::PreconfigureHardware()
{
    FmcAnalogBoard::PreconfigureHardware();
    FmcDacDeviceMixin::PreconfigureHardware();
}

//---------------------------------------------------------------------------
//  FmcDacBoard::ConfigureHardware()
//---------------------------------------------------------------------------

void  FmcDacBoard::ConfigureHardware()
{
    FmcAnalogBoard::ConfigureHardware();
    FmcDacDeviceMixin::ConfigureHardware();
}

//---------------------------------------------------------------------------
//  FmcDacBoard::StreamStopHardware()
//---------------------------------------------------------------------------

void  FmcDacBoard::StreamStopHardware()
{
    FmcAnalogBoard::StreamStopHardware();
    FmcDacDeviceMixin::StreamStopHardware();
}
*/
//===========================================================================
//  CLASS FmcInputDevice  -- Partially Implemented X6 Input Device
//===========================================================================
//---------------------------------------------------------------------------
//  FmcInputDevice::Devices() -- return device count
//---------------------------------------------------------------------------

unsigned int  FmcInputDevice::Devices()
{
     return AdcCommon().Devices();
}

//---------------------------------------------------------------------------
//  FmcInputDevice::ChannelsPerDevice() -- return channels per device
//---------------------------------------------------------------------------

unsigned int  FmcInputDevice::ChannelsPerDevice()
{
     return AdcCommon().ChannelsPerDevice();
}

//---------------------------------------------------------------------------
//  FmcInputDevice::Channels() -- return channels
//---------------------------------------------------------------------------

unsigned int  FmcInputDevice::Channels()
{
     return AdcCommon().Channels();
}

//---------------------------------------------------------------------------
//  FmcInputDevice::DeviceEnabled() -- Enable specified I/O devices
//---------------------------------------------------------------------------

void  FmcInputDevice::DeviceEnabled(int dev, bool state)
{
     AdcCommon().DeviceIsEnabled(dev, state);
     AdcCommon().DevicePowered(dev, state);  // have power state follow enabled state
}

//---------------------------------------------------------------------------
//  FmcInputDevice::DeviceEnabled() -- Query state of specified I/O devices
//---------------------------------------------------------------------------

bool FmcInputDevice::DeviceEnabled(int dev) const
{
    return AdcCommon().DeviceIsEnabled(dev);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::ActiveDevices() -- Return number of active devices
//---------------------------------------------------------------------------

unsigned int FmcInputDevice::ActiveDevices()
{
    return AdcCommon().ActiveDevices();
}

//---------------------------------------------------------------------------
//  FmcInputDevice::DevicePowered() -- Power specified I/O devices
//---------------------------------------------------------------------------

void  FmcInputDevice::DevicePowered(int ch, bool state)
{
     AdcCommon().DevicePowered(ch, state);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::DevicePowered() -- Query power state of an I/O devices
//---------------------------------------------------------------------------

bool FmcInputDevice::DevicePowered(int ch) const
{
    return AdcCommon().DevicePowered(ch);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::ChannelDisableAll() -- Disable all channels
//---------------------------------------------------------------------------

void  FmcInputDevice::ChannelDisableAll()
{
     AdcCommon().ChannelDisableAll();
     AdcCommon().ChannelPowerDownAll();
}

//---------------------------------------------------------------------------
//  FmcInputDevice::ChannelEnabled() -- Enable specified I/O channel
//---------------------------------------------------------------------------

void  FmcInputDevice::ChannelEnabled(int ch, bool state)
{
     AdcCommon().ChannelEnabled(ch, state);
     ChannelPowered(ch, state);  // have power state follow enabled state
}

//---------------------------------------------------------------------------
//  FmcInputDevice::ChannelEnabled() -- Query state of specified I/O channel
//---------------------------------------------------------------------------

bool FmcInputDevice::ChannelEnabled(int ch) const
{
    return AdcCommon().ChannelEnabled(ch);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::ActiveChannels() -- Return number of active channels
//---------------------------------------------------------------------------

unsigned int FmcInputDevice::ActiveChannels()
{
    return AdcCommon().ActiveChannels();
}

//---------------------------------------------------------------------------
//  FmcInputDevice::ChannelPowered() -- Power specified I/O channel
//---------------------------------------------------------------------------

void  FmcInputDevice::ChannelPowered(int ch, bool state)
{
     AdcCommon().ChannelPowered(ch, state);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::ChannelPowered() -- Query power state of an I/O channel
//---------------------------------------------------------------------------

bool FmcInputDevice::ChannelPowered(int ch) const
{
    return AdcCommon().ChannelPowered(ch);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::SoftwareTrigger() -- Enable Test Mode on input
//---------------------------------------------------------------------------

void  FmcInputDevice::SoftwareTrigger(bool state)
{
    Common().SoftwareTrigger(FmcAFE_Common::tInput, state);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::SoftwareTrigger() -- Enable Test Mode on input
//---------------------------------------------------------------------------

void  FmcInputDevice::SoftwareTrigger(AfeDirection which, bool state)
{
    FmcAFE_Common::AfeDirection which2 = static_cast<FmcAFE_Common::AfeDirection>(which);
    Common().SoftwareTrigger(which2, state);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::TestModeEnabled() -- Enable Test Mode on input
//---------------------------------------------------------------------------

void  FmcInputDevice::TestModeEnabled(bool state, unsigned int mode)
{
    Common().TestModeEnabled(FmcAFE_Common::tInput, state, mode);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::Decimation() -- Set decimation
//---------------------------------------------------------------------------

void  FmcInputDevice::Decimation(unsigned int samples)
{
    AdcCommon().Decimation(samples);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::Decimation() -- Read decimation
//---------------------------------------------------------------------------

unsigned int   FmcInputDevice::Decimation() const
{
    return AdcCommon().Decimation();
}


//===========================================================================
//  CLASS FmcInputDevice::TriggerCfgImpl  --
//===========================================================================
//---------------------------------------------------------------------------
//  FmcInputDevice::TriggerCfgImpl::FramedMode() -- Setter
//---------------------------------------------------------------------------

void  FmcInputDevice::TriggerCfgImpl::FramedMode(bool state)
{
    InD->AdcCommon().FramedTriggerEnabled(state);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::TriggerCfgImpl::FramedMode() -- Getter
//---------------------------------------------------------------------------

bool FmcInputDevice::TriggerCfgImpl::FramedMode() const
{
    return InD->AdcCommon().FramedTriggerEnabled();
}

//---------------------------------------------------------------------------
//  FmcInputDevice::TriggerCfgImpl::Edge() -- Setter
//---------------------------------------------------------------------------

void  FmcInputDevice::TriggerCfgImpl::Edge(bool state)
{
    InD->AdcCommon().EdgeTrigger(state);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::TriggerCfgImpl::Edge() -- Getter
//---------------------------------------------------------------------------

bool FmcInputDevice::TriggerCfgImpl::Edge() const
{
    return InD->AdcCommon().EdgeTrigger();
}

//---------------------------------------------------------------------------
//  FmcInputDevice::TriggerCfgImpl::External() -- Setter
//---------------------------------------------------------------------------

void  FmcInputDevice::TriggerCfgImpl::External(bool state)
{
    InD->AdcCommon().ExternalTrigger(state);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::TriggerCfgImpl::External() -- Getter
//---------------------------------------------------------------------------

bool FmcInputDevice::TriggerCfgImpl::External() const
{
    return InD->AdcCommon().ExternalTrigger();
}

//---------------------------------------------------------------------------
//  FmcInputDevice::TriggerCfgImpl::FrameSize() -- Setter
//---------------------------------------------------------------------------

void  FmcInputDevice::TriggerCfgImpl::FrameSize(unsigned int samples)
{
    InD->AdcCommon().FramedTriggerSize(samples);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::TriggerCfgImpl::FrameSize() -- Getter
//---------------------------------------------------------------------------

unsigned int FmcInputDevice::TriggerCfgImpl::FrameSize() const
{
    return InD->AdcCommon().FramedTriggerSize();
}

//---------------------------------------------------------------------------
//  FmcInputDevice::TriggerCfgImpl::ExternalSyncSource() -- Setter
//---------------------------------------------------------------------------

void  FmcInputDevice::TriggerCfgImpl::ExternalSyncSource(AfeExtSyncOptions src)
{
    InD->Common().ExternalSyncSelection(
                static_cast<FmcAFE_Common::AfeExtSyncOptions>(src) );

    InD->CustomAdcExternalSyncSource(src);
}

//---------------------------------------------------------------------------
//  FmcInputDevice::TriggerCfgImpl::ExternalSyncSource() -- Getter
//---------------------------------------------------------------------------

FmcInputDevice::AfeExtSyncOptions FmcInputDevice::TriggerCfgImpl::ExternalSyncSource() const
{
    FmcAFE_Common::AfeExtSyncOptions opt = InD->Common().ExternalSyncSelection();
    return static_cast<FmcInputDevice::AfeExtSyncOptions>( opt );
}

//===========================================================================
//  CLASS FmcInputDevice_T1  -- Partially Implemented Fmc Input Device
//===========================================================================
//---------------------------------------------------------------------------
//  FmcInputDevice_T1::Spi() -- write to a SPI device
//---------------------------------------------------------------------------

void  FmcInputDevice_T1::Spi(unsigned int device, unsigned int address, unsigned int data)
{
    AdcSpi().Spi(device, address, data);
}

//---------------------------------------------------------------------------
//  FmcInputDevice_T1::Spi() -- read from a SPI device
//---------------------------------------------------------------------------

unsigned int  FmcInputDevice_T1::Spi(unsigned int device, unsigned int address)
{
    return AdcSpi().Spi(device, address);
}

//---------------------------------------------------------------------------
//  FmcInputDevice_T1::Vga() -- write to the ADC VGA
//---------------------------------------------------------------------------

void  FmcInputDevice_T1::Vga(unsigned int ch, float gain_db)
{
    unsigned int dev = ch/ChannelsPerDevice();
    unsigned int adc = ch%ChannelsPerDevice();
    VgaBus().VgaDev().SetAdcGain(dev, adc, gain_db );
}

//===========================================================================
//  CLASS FmcInputDevice_Bidir  -- Partially Implemented Fmc Input Device
//===========================================================================
//---------------------------------------------------------------------------
//  FmcInputDevice_Bidir::Spi() -- write to a SPI device
//---------------------------------------------------------------------------

void  FmcInputDevice_Bidir::Spi(unsigned int device, unsigned int address, unsigned int data)
{
    AdcSpi().Spi(device, address, data);
}

//---------------------------------------------------------------------------
//  FmcInputDevice_Bidir::Spi() -- read from a SPI device
//---------------------------------------------------------------------------

unsigned int  FmcInputDevice_Bidir::Spi(unsigned int device, unsigned int address)
{
    return AdcSpi().Spi(device, address);
}

//===========================================================================
//  CLASS FmcOutputDevice  -- Partially Implemented X6 Output Device
//===========================================================================
//---------------------------------------------------------------------------
//  FmcOutputDevice::Devices() -- return device count
//---------------------------------------------------------------------------

unsigned int  FmcOutputDevice::Devices()
{
     return DacCommon().Devices();
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::ChannelsPerDevice() -- return channels per device
//---------------------------------------------------------------------------

unsigned int  FmcOutputDevice::ChannelsPerDevice()
{
     return DacCommon().ChannelsPerDevice();
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::Channels() -- return channels
//---------------------------------------------------------------------------

unsigned int  FmcOutputDevice::Channels()
{
     return DacCommon().Channels();
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::DeviceEnabled() -- Enable specified I/O devices
//---------------------------------------------------------------------------

void  FmcOutputDevice::DeviceEnabled(int dev, bool state)
{
     DacCommon().DeviceIsEnabled(dev, state);
     DacCommon().DevicePowered(dev, state);  // have power state follow enabled state
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::DeviceEnabled() -- Query state of specified I/O devices
//---------------------------------------------------------------------------

bool FmcOutputDevice::DeviceEnabled(int dev) const
{
    return DacCommon().DeviceIsEnabled(dev);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::ActiveDevices() -- Return number of active devices
//---------------------------------------------------------------------------

unsigned int FmcOutputDevice::ActiveDevices()
{
    return DacCommon().ActiveDevices();
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::DevicePowered() -- Power specified I/O devices
//---------------------------------------------------------------------------

void  FmcOutputDevice::DevicePowered(int ch, bool state)
{
     DacCommon().DevicePowered(ch, state);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::DevicePowered() -- Query power state of an I/O devices
//---------------------------------------------------------------------------

bool FmcOutputDevice::DevicePowered(int ch) const
{
    return DacCommon().DevicePowered(ch);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::ChannelDisableAll() -- Disable all channels
//---------------------------------------------------------------------------

void  FmcOutputDevice::ChannelDisableAll()
{
     DacCommon().ChannelDisableAll();
     DacCommon().ChannelPowerDownAll();
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::ChannelEnabled() -- Enable specified I/O channel
//---------------------------------------------------------------------------

void  FmcOutputDevice::ChannelEnabled(int ch, bool state)
{
     DacCommon().ChannelEnabled(ch, state);
     ChannelPowered(ch, state);  // have power state follow enabled state
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::ChannelEnabled() -- Query state of specified I/O channel
//---------------------------------------------------------------------------

bool FmcOutputDevice::ChannelEnabled(int ch) const
{
    return DacCommon().ChannelEnabled(ch);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::ActiveChannels() -- Return number of active channels
//---------------------------------------------------------------------------

unsigned int FmcOutputDevice::ActiveChannels()
{
    return DacCommon().ActiveChannels();
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::ChannelPowered() -- Power specified I/O channel
//---------------------------------------------------------------------------

void  FmcOutputDevice::ChannelPowered(int ch, bool state)
{
     DacCommon().ChannelPowered(ch, state);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::ChannelPowered() -- Query power state of an I/O channel
//---------------------------------------------------------------------------

bool FmcOutputDevice::ChannelPowered(int ch) const
{
    return DacCommon().ChannelPowered(ch);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::SoftwareTrigger() -- Enable Test Mode on Output
//---------------------------------------------------------------------------

void  FmcOutputDevice::SoftwareTrigger(bool state)
{
    Common().SoftwareTrigger(FmcAFE_Common::tOutput, state);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::SoftwareTrigger() -- Enable Test Mode on Output
//---------------------------------------------------------------------------

void  FmcOutputDevice::SoftwareTrigger(AfeDirection which, bool state)
{
    FmcAFE_Common::AfeDirection which2 = static_cast<FmcAFE_Common::AfeDirection>(which);
    Common().SoftwareTrigger(which2, state);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::TestModeEnabled() -- Enable Test Mode on Output
//---------------------------------------------------------------------------

void  FmcOutputDevice::TestModeEnabled(bool state, unsigned int mode)
{
    Common().TestModeEnabled(FmcAFE_Common::tOutput, state, mode);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::Decimation() -- Power specified I/O channel
//---------------------------------------------------------------------------

void  FmcOutputDevice::Decimation(unsigned int samples)
{
     DacCommon().Decimation(samples);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::Decimation() -- Query power state of an I/O channel
//---------------------------------------------------------------------------

unsigned int FmcOutputDevice::Decimation() const
{
    return DacCommon().Decimation();
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::TestFrequency() -- Set frequency for Test Mode on Output
//---------------------------------------------------------------------------

void  FmcOutputDevice::TestFrequency(double frequency_hz)
{
    unsigned int channels = DacCommon().ActiveChannels();
    //    unsigned int dacdevs = ActiveDevices();
    //    unsigned int factor;
    //    if (channels==0 || dacdevs==0)
    //        factor = 1;
    //    else
    //        factor = channels/dacdevs;
    unsigned int factor;
    if (channels==0)
        factor = 1;
    else
        factor = channels;

    DacCommon().DacTestToneFrequency(Owner->DacClockFrequency(), frequency_hz, factor);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::TestFrequency() -- Get frequency for Test Mode on Output
//---------------------------------------------------------------------------

double  FmcOutputDevice::TestFrequency()
{
    unsigned int channels = DacCommon().ActiveChannels();
    if (channels==0)
         channels = 1;
    return DacCommon().DacTestToneFrequency(Owner->DacClockFrequency(), channels);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::Spi() -- write to a SPI device
//---------------------------------------------------------------------------

void  FmcOutputDevice::Spi(unsigned int device, unsigned int address, unsigned int data)
{
    DacSpi().Spi(device, address, data);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::Spi() -- read from a SPI device
//---------------------------------------------------------------------------

unsigned int  FmcOutputDevice::Spi(unsigned int device, unsigned int address)
{
    return DacSpi().Spi(device, address);
}

//===========================================================================
//  CLASS FmcOutputDevice::TriggerCfgImpl  --
//===========================================================================
//---------------------------------------------------------------------------
//  FmcOutputDevice::TriggerCfgImpl::FramedMode() -- Setter
//---------------------------------------------------------------------------

void  FmcOutputDevice::TriggerCfgImpl::FramedMode(bool state)
{
    OutD->DacCommon().FramedTriggerEnabled(state);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::TriggerCfgImpl::FramedMode() -- Getter
//---------------------------------------------------------------------------

bool FmcOutputDevice::TriggerCfgImpl::FramedMode() const
{
    return OutD->DacCommon().FramedTriggerEnabled();
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::TriggerCfgImpl::Edge() -- Setter
//---------------------------------------------------------------------------

void  FmcOutputDevice::TriggerCfgImpl::Edge(bool state)
{
    OutD->DacCommon().EdgeTrigger(state);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::TriggerCfgImpl::Edge() -- Getter
//---------------------------------------------------------------------------

bool FmcOutputDevice::TriggerCfgImpl::Edge() const
{
    return OutD->DacCommon().EdgeTrigger();
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::TriggerCfgImpl::External() -- Setter
//---------------------------------------------------------------------------

void  FmcOutputDevice::TriggerCfgImpl::External(bool state)
{
    OutD->DacCommon().ExternalTrigger(state);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::TriggerCfgImpl::External() -- Getter
//---------------------------------------------------------------------------

bool FmcOutputDevice::TriggerCfgImpl::External() const
{
    return OutD->DacCommon().ExternalTrigger();
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::TriggerCfgImpl::FrameSize() -- Setter
//---------------------------------------------------------------------------

void  FmcOutputDevice::TriggerCfgImpl::FrameSize(unsigned int samples)
{
    OutD->DacCommon().FramedTriggerSize(samples);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::TriggerCfgImpl::FrameSize() -- Getter
//---------------------------------------------------------------------------

unsigned int FmcOutputDevice::TriggerCfgImpl::FrameSize() const
{
    return OutD->DacCommon().FramedTriggerSize();
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::TriggerCfgImpl::ExternalSyncSource() -- Setter
//---------------------------------------------------------------------------

void  FmcOutputDevice::TriggerCfgImpl::ExternalSyncSource(AfeExtSyncOptions src)
{
    OutD->Common().ExternalSyncSelection(
                static_cast<FmcAFE_Common::AfeExtSyncOptions>(src) );
    OutD->CustomDacExternalSyncSource(src);
}

//---------------------------------------------------------------------------
//  FmcOutputDevice::TriggerCfgImpl::ExternalSyncSource() -- Getter
//---------------------------------------------------------------------------

FmcOutputDevice::AfeExtSyncOptions FmcOutputDevice::TriggerCfgImpl::ExternalSyncSource() const
{
    FmcAFE_Common::AfeExtSyncOptions opt = OutD->Common().ExternalSyncSelection();
    return static_cast<FmcOutputDevice::AfeExtSyncOptions>( opt );
}


#ifdef _MSC_VER
    #pragma warning(pop)
#endif


}  // namespace Innovative
