//  FmcCarrierMemoryMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2011 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef FmcCarrierMemoryMap_MbH
#define FmcCarrierMemoryMap_MbH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace FmcCarrier_MemoryMap
{
    //
    //  FmcCarrier "Standard" WB section offsets
    const unsigned int  wbPeripheral          = 0x000;
    const unsigned int  wbLogicLoader         = 0x100;
    const unsigned int  wbTempControl         = 0x200;    // ADV, P7Cop cards only
    const unsigned int  wbPacketizer          = 0x300;
    const unsigned int  wbAlerts              = 0x400;
    const unsigned int  wbDigitalIo           = 0x500;    // ADV, P7Cop cards only
    const unsigned int  wbROM                 = 0x600;
    const unsigned int  wbMatlab              = 0x700;
    //const unsigned int  wbAFE                 = 0x800;
    const unsigned int  wbUart_K7             = 0x900;    // K7 cards only
    const unsigned int  wbAurora0             = 0xa00;    // ADV cards only
    //const unsigned int  wbAurora1             = 0xb00;
    const unsigned int  wbFmc0_0              = 0xc00;
    const unsigned int  wbFmc0_1              = 0xd00;
    const unsigned int  wbFmc0_2              = 0xe00;
    const unsigned int  wbFmc0_3              = 0xf00;
    const unsigned int  wbFmc0_4              = 0x1000;
    const unsigned int  wbFmc0_5              = 0x1100;
    const unsigned int  wbFmc0_6              = 0x1200;
    const unsigned int  wbFmc0_Jesd0          = 0x4000;
    const unsigned int  wbFmc0_Jesd1          = 0x5000;
    const unsigned int  wbFmc0_Jesd2          = 0x6000;
    const unsigned int  wbFmc0_Jesd3          = 0x7000;

	//  End Map for "ADV" family cards  (PexCop/Vpx Cop)
    const unsigned int  wbApplication         = 0x1300;

    const unsigned int  wbMemory              = 0x1400;
                                            //  0x1500  0x1600 0x1700
    const unsigned int  wbTrigger             = 0x1800;
    const unsigned int  wbVpxClk              = 0x1900;
	
    const unsigned int  wbFmc1_0              = 0xc00;
    const unsigned int  wbFmc1_1              = 0xd00;
    const unsigned int  wbFmc1_2              = 0xe00;
    const unsigned int  wbFmc1_3              = 0xf00;
    const unsigned int  wbFmc1_4              = 0x1000;
    const unsigned int  wbFmc1_5              = 0x1100;
    const unsigned int  wbFmc1_6              = 0x1200;
    const unsigned int  wbFmc1_Jesd0          = 0x4000;  // JESD not valid on 1, use 0 space
    const unsigned int  wbFmc1_Jesd1          = 0x5000;
    const unsigned int  wbFmc1_Jesd2          = 0x6000;
    const unsigned int  wbFmc1_Jesd3          = 0x7000;


	//
	//  End Map for "K7" family cards 
    const unsigned int  wbFmc1_0_K7           = 0x1300;
    const unsigned int  wbFmc1_1_K7           = 0x1400;
    const unsigned int  wbFmc1_2_K7           = 0x1500;
    const unsigned int  wbFmc1_3_K7           = 0x1600;
    const unsigned int  wbFmc1_4_K7           = 0x1700;
    const unsigned int  wbFmc1_5_K7           = 0x1800;
    const unsigned int  wbFmc1_6_K7           = 0x1900;
    const unsigned int  wbFmc1_Jesd0_K7       = 0x4000;  // JESD not valid on 1, use 0 space
    const unsigned int  wbFmc1_Jesd1_K7       = 0x5000;
    const unsigned int  wbFmc1_Jesd2_K7       = 0x6000;
    const unsigned int  wbFmc1_Jesd3_K7       = 0x7000;


    const unsigned int  wbApplication_K7      = 0x1a00;

    //
    //  FmcCarrier WB Register offsets
    //
    //  WB0 - Peripheral Registers
    const unsigned int  mmInformation             = 0x00;
    const unsigned int  mmReset                   = 0x01;
    const unsigned int  mmBitstreamDate           = 0x02;
    const unsigned int  mmSubrevision             = 0x03;
                                     //           = 0x04;
    const unsigned int  mmHostTrigger             = 0x05;
    const unsigned int  mmSioXo                   = 0x06;
    const unsigned int  mmPex7Cop_LTC_SPI_Control = 0x05;    // Pex7Cop
    const unsigned int  mmPex7Cop_LTC_SPI_Stat    = 0x06;    // Pex7Cop

    const unsigned int  mmLPDDR                   = 0x07;
    const unsigned int  mmVeloOutTestLB           = 0x08;   // Outbound Velo Pids
    const unsigned int  mmVeloOutDataPid          = 0x09;   // Outbound Velo Pids
                                          // = 0x0A to 0xF  //  reserved for Outbound Velo PIDs.
    const unsigned int  mmK7SourceMux             = 0x10;   // K7 only
    const unsigned int  mmPex7Cop_FmcVadj         = 0x10;   // Pex7Cop
    const unsigned int  mmPex7Cop_FmcC2M_CC       = 0x11;   // Pex7Cop

    //
    //  WB1 - Logic Fpa Bitfile Loader
    const unsigned int  mmFpa_Address         = 0x00;
    const unsigned int  mmFpa_Data            = 0x01;
    const unsigned int  mmFpa_Command         = 0x02;
    const unsigned int  mmFpa_Opcode          = mmFpa_Command;   // Alias for K7
    //
    //  WB2 - Logic Temperature Control
    const unsigned int  mmTemp_TempControl      = 0x00;
    const unsigned int  mmTemp_FanThreshold     = 0x01;
    const unsigned int  mmTemp_AlertThreshold   = 0x02;
    const unsigned int  mmTemp_CommandChannel   = 0x03;
    //
    //  WB3 - Packetizer Config
    const unsigned int  mmPktzer_Enable       = 0x00;
    const unsigned int  mmPktzer_AuxHdr       = 0x01;
    const unsigned int  mmPktzer_AlertHdr     = 0x02;  // Reserved for alert cfg
    const unsigned int  mmPktzer_VeloInHdr    = 0x03;  // Array of mmPktzer_TotalVeloHdr
    const unsigned int  mmPktzer_TotalVeloHdr =    8;
    const unsigned int  mmPktzer_ForceSize      = 0x22;
    const unsigned int  mmPktzer_IntervalPeriod = 0x23;
    //
    //  WB4 - Alert Registers
    const unsigned int  mmAlert_Enable        = 0x00;
    const unsigned int  mmAlert_Control       = 0x01;
    const unsigned int  mmAlert_Software      = 0x02;
    const unsigned int  mmAlert_Clear         = 0x03;
    //
    //  WB5 - DigitalIo
    const unsigned int  mmDio_DataLo          = 0x00;
    const unsigned int  mmDio_DataHi          = 0x01;
    const unsigned int  mmDio_OutEnableLo     = 0x02;
    const unsigned int  mmDio_OutEnableHi     = 0x03;
    //
    //  WB6 - Serial Flash Rom
    const unsigned int  mmRom_AddrCtl         = 0x00;
    const unsigned int  mmRom_Data            = 0x01;
    const unsigned int  mmRom_Opcode          = 0x02;
    //
    //  WB8 - Analog Front End
    //  ...Clock Config
    //
    //  WB9 - Dual UART (K7 only)
    const unsigned int  mmUart_0_Control      = 0x00;
    const unsigned int  mmUart_0_Tx           = 0x01;
    const unsigned int  mmUart_0_Rx           = 0x02;
    const unsigned int  mmUart_1_Control      = 0x03;
    const unsigned int  mmUart_1_Tx           = 0x04;
    const unsigned int  mmUart_1_Rx           = 0x05;
    const unsigned int  mmUartMode            = 0x06;
    const unsigned int  mmInterrupt           = 0x07;
    const unsigned int  mmGpioData            = 0x08;
    const unsigned int  mmGpioDirection       = 0x09;
    //
    //  WB_x0A, WB_FMC4, WB_FMC5, WB_FMC6 - Aurora 0, Fmc Aurora 0, 1, 2
    const unsigned int  mmAurora_TestControl    = 0x00;
    const unsigned int  mmAurora_ControlStatus  = 0x01;
    const unsigned int  mmAurora_WritePort      = 0x02;
    const unsigned int  mmAurora_ReadPort       = 0x03;
    const unsigned int  mmAurora_SfpPortControl = 0x04;
    const unsigned int  mmAurora_SfpPortI2C     = 0x05;
    const unsigned int  mmAurora_SioXoI2C       = 0x06;
    //
    //  WB_FMC0 - FMC Information
    const unsigned int  mmFmc_ControlStatus     = 0x00;
    const unsigned int  mmFmc_I2C               = 0x01;
    const unsigned int  mmFmc_BoardId           = 0x02;
    const unsigned int  mmFmc_BidirClock        = 0x03;
    const unsigned int  mmFmc_Clk0_M2C_Status   = 0x04;
    const unsigned int  mmFmc_Clk1_M2C_Status   = 0x05;
    const unsigned int  mmFmc_Clk2_M2C_Status   = 0x06;
    const unsigned int  mmFmc_Clk3_M2C_Status   = 0x07;
    const unsigned int  mmFmc_Clk2_C2M_Status   = 0x08;
    const unsigned int  mmFmc_Clk3_C2M_Status   = 0x09;

    //
    //  WB_FMC1 - FMC AFE
    const unsigned int  mmFmc_PllControl        = 0x00;
    const unsigned int  mmFmc_PllSpi            = 0x01;
    const unsigned int  mmFmc_VcxoControl       = 0x02;
    const unsigned int  mmFmc_ClockControl      = 0x03;
    const unsigned int  mmFmc_CpldSpiStatus     = 0x04;   //  Fmc110
    const unsigned int  mmFmc_CpldSpi           = 0x05;   //  Fmc110
    const unsigned int  mmFmc_TestControl       = 0x06;
    const unsigned int  mmFmc_SoftwareTrig      = 0x07;
    const unsigned int  mmFmc_ExtSyncControl    = 0x08;
    const unsigned int  mmFmc1000_ExtClkCfg     = 0x09;   // Fmc1000
    const unsigned int  mmFmc1000_ExtSyncCfg    = 0x0A;   // Fmc1000
    const unsigned int  mmFmcSDF_Tachometer     = 0x0F;   // FmcSDF

    //
    //  WB_FMC2 - FMC ADC AFE
    const unsigned int  mmFmc_AdcEnableLo       = 0x00;
    const unsigned int  mmFmc_AdcEnableHi       = 0x01;
    const unsigned int  mmFmc_AdcPowerDownLo    = 0x02;
    const unsigned int  mmFmc_AdcPowerDownHi    = 0x03;

    const unsigned int  mmFmc_AdcTriggerCfg     = 0x04;
    const unsigned int  mmFmc_AdcDecimation     = 0x05;
    const unsigned int  mmFmc_AdcPriEnable      = 0x06;
    const unsigned int  mmFmc_AdcPriInterval    = 0x07;
    const unsigned int  mmFmc_AdcPriTrigParam   = 0x08;
    const unsigned int  mmFmc_AdcCaptureWin     = 0x09;

    const unsigned int  mmFmc_AdcSpiCtrlBase   = 0x10;  // One SPI per Adc Device
    const unsigned int  mmFmc_AdcSpiCtrlDelta  =    2;
    const unsigned int  mmFmc_AdcSpiStatBase   = 0x11;
    const unsigned int  mmFmc_AdcSpiStatDelta  =    2;

    const unsigned int  mmFmc_AdcSpiEnable      = 0x10;
    const unsigned int  mmFmc_AdcSpiCtrl        = 0x11;
    const unsigned int  mmFmc_AdcSpiStatus      = 0x12;
    const unsigned int  mmFmc_AdcCalStatus      = 0x13;
    const unsigned int  mmFmc_VGA               = 0x14;  // not used anymore

    const unsigned int  mmFmc1000_AdcPHYCal     = 0x14;   // Fmc1000

    const unsigned int  mmFmcSDF_Adc_Reset      = 0x16;   // FmcSDF

    const unsigned int  mmFmc_AdcCalStatus_T2   = 0x18;
    
    const unsigned int  mmFmc_ServoAdcControl   = 0x1a;  // FmcServo
    const unsigned int  mmFmc_ServoAdcFifoCtl   = 0x1b;  // FmcServo
    const unsigned int  mmFmc_ServoAdcFifoThrs  = 0x1c;  // FmcServo
    const unsigned int  mmFmc_ServoAdcFifoData  = 0x1d;  // FmcServo
    
    const unsigned int  mmFmc_ServoAdcGain      = 0x1e;  // FmcServo
    

    const unsigned int  mmFmc_AdcTStampInit     = 0x20;
    const unsigned int  mmFmc_AdcTStampCtl      = 0x21;
    const unsigned int  mmFmc_AdcVitaControl    = 0x22;

    const unsigned int  mmFmc_AdcAdcVitaSize    = 0x30;
    const unsigned int  mmFmc_TotalAdcVitas    =    16;
    const unsigned int  mmFmc_AdcVitaStreamId   = 0x40;
    //  Total number is also  mmFmc_TotalAdcVitas

    const unsigned int  mmFmc_AdcGainCoeff      = 0x50;
    const unsigned int  mmFmc_AdcOffsetCoeff    = 0x90;
    const unsigned int  mmFmc_TotalAdcs        =    64;   // for both
    //
    //  WB_FMC3 - FMC DAC AFE
    const unsigned int  mmFmc_DacEnableLo       = 0x00;
    const unsigned int  mmFmc_DacEnableHi       = 0x01;
    const unsigned int  mmFmc_DacPowerDownLo    = 0x02;
    const unsigned int  mmFmc_DacPowerDownHi    = 0x03;

    const unsigned int  mmFmc_DacTriggerCfg     = 0x04;
    const unsigned int  mmFmc_DacDecimation     = 0x05;

    const unsigned int  mmFmc_DacPriEnable      = 0x06;
    const unsigned int  mmFmc_DacPriInterval    = 0x07;
    const unsigned int  mmFmc_DacPriTrigParam   = 0x08;
    const unsigned int  mmFmc_DacCaptureWin     = 0x09;
    const unsigned int  mmFmc_DacPhaseIncr      = 0x0a;
    const unsigned int  mmFmc_DacReset          = 0x0b;

    const unsigned int  mmFmc_DacSpiEnable      = 0x10;
    const unsigned int  mmFmc_DacSpiCtrl        = 0x11;
    const unsigned int  mmFmc_DacSpiStatus      = 0x12;

    const unsigned int  mmFmc_ServoDacFifoCtl   = 0x1a;  // FmcServo  
    const unsigned int  mmFmc_ServoDacFifoThrs  = 0x1b;  // FmcServo  
    const unsigned int  mmFmc_ServoDacFifoData  = 0x1c;  // FmcServo 
    const unsigned int  mmFmc_ServoDacDelay     = 0x1d;  // FmcServo 


    const unsigned int  mmFmc_DacVitaStreamId   = 0x20;
    const unsigned int  mmFmc_TotalDacVitas    =    16;

    const unsigned int  mmFmc_DacGainCoeff      = 0x30;
    const unsigned int  mmFmc_DacOffsetCoeff    = 0x70;
    const unsigned int  mmFmc_TotalDacs        =    64;   // for both
    //
    //  WB_x13 - Vpx Application
    const unsigned int  mmApp_ControlStatus     = 0x00;
    //
    //  WB_x14 - Vpx Memory
    const unsigned int  mmMem_Ddr3_ControlStatus  = 0x00;
    const unsigned int  mmMem_Ddr3_WriteMask      = 0x01;
    const unsigned int  mmMem_Ddr3_Write0         = 0x02;
    const unsigned int  mmMem_Ddr3_Write1         = 0x03;
    const unsigned int  mmMem_Ddr3_Write2         = 0x04;
    const unsigned int  mmMem_Ddr3_Write3         = 0x05;
    const unsigned int  mmMem_Ddr3_Read0          = 0x06;
    const unsigned int  mmMem_Ddr3_Read1          = 0x07;
    const unsigned int  mmMem_Ddr3_Read2          = 0x08;
    const unsigned int  mmMem_Ddr3_Read3          = 0x09;
    //                                            = 0x0a;
    const unsigned int  mmMem_Qdr0_ControlStatus  = 0x0b;
    const unsigned int  mmMem_Qdr0_WriteMask      = 0x0c;
    const unsigned int  mmMem_Qdr0_Write0         = 0x0d;
    const unsigned int  mmMem_Qdr0_Write1         = 0x0e;
    const unsigned int  mmMem_Qdr0_Write2         = 0x0f;
    const unsigned int  mmMem_Qdr0_ReadCSR        = 0x10;
    const unsigned int  mmMem_Qdr0_Read0          = 0x11;
    const unsigned int  mmMem_Qdr0_Read1          = 0x12;
    const unsigned int  mmMem_Qdr0_Read2          = 0x13;
    //                                            = 0x14;
    const unsigned int  mmMem_Qdr1_ControlStatus  = 0x15;
    const unsigned int  mmMem_Qdr1_WriteMask      = 0x16;
    const unsigned int  mmMem_Qdr1_Write0         = 0x17;
    const unsigned int  mmMem_Qdr1_Write1         = 0x18;
    const unsigned int  mmMem_Qdr1_Write2         = 0x19;
    const unsigned int  mmMem_Qdr1_ReadCSR        = 0x1a;
    const unsigned int  mmMem_Qdr1_Read0          = 0x1b;
    const unsigned int  mmMem_Qdr1_Read1          = 0x1c;
    const unsigned int  mmMem_Qdr1_Read2          = 0x1d;
    //
    //  WB_x15 - Vpx Trigger
    const unsigned int  mmTrigger_Control         = 0x00;
    const unsigned int  mmTrigger_ItfOtf          = 0x01;
    const unsigned int  mmTrigger_PlLt            = 0x02;
    const unsigned int  mmTrigger_PlMd            = 0x03;
    const unsigned int  mmTrigger_PpsGt           = 0x04;
    //
    //  PCI Logic Memory Registers
    //
    // Fpga management
    const unsigned int  mmFpgaData            = 0x12000;
    const unsigned int  mmFpgaControl         = 0x12400;
    const unsigned int  mmI2c                 = 0x12800;
    //const unsigned int  mmFpa                 = 0x12c00;
    // Interrupts
    const unsigned int  mmInterruptEnable     = 0x14400;
    const unsigned int  mmCreditQueue         = 0x14800;
    const unsigned int  mmKernelCacheAvail    = 0x18400;    // sent to release target hold, as cache is free to use
    const unsigned int  mmInterruptStatus     = 0x19000;
    // Communications
    const unsigned int  mmBmRingBaseAddress   = 0x15000;
    const unsigned int  mmBmRingSize          = 0x15400;
    const unsigned int  mmPciVersion          = 0x15c00;
    const unsigned int  mmRxPacketTimer       = 0x17400;
    const unsigned int  mmTxPacketTimer       = 0x16c00;
    const unsigned int  mmPciTestControl      = 0x17000;
    // Misc
    const unsigned int  mmLinkControl         = 0x18000;
    const unsigned int  mmControl             = 0x19400;
    const unsigned int  mmStatus              = 0x19800;


} // end namespace FmcCarrier_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
