// Fmc_QSfp_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2012 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef Fmc_QSfp_MbH
#define Fmc_QSfp_MbH

#include <FmcBoard_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class FmcQSfp;

//===========================================================================
//  CLASS ISuppliesAdded_QSfp_Requirements -- FMC Board Map Requirements
//===========================================================================
//  none...

class ISuppliesAdded_QSfp_Requirements : public IRequires_SioPll
{
public:
    virtual ~ISuppliesAdded_QSfp_Requirements()
        {}

};

//==============================================================================
//  CLASS FmcQSfp_SioPll -- RX SIO PLL Chip (Specialization of Si5338)
//==============================================================================

class FmcQSfp_SioPll : public Si5338
{
public:
    FmcQSfp_SioPll(FmcQSfp * owner, I2CDevice & device);

    // ...Si5338 interface impl
    virtual void            OnInit();
    virtual void            OnReapply();

    virtual void    OutputFrequency(unsigned int output, double freq);
	virtual double  OutputFrequency(unsigned int output) const;
protected:
	FmcQSfp * Owner;
};

//===========================================================================
//  CLASS FmcQSfp  -- Fmc Daughter card Common baseboard class
//===========================================================================

class FmcQSfp : public FmcBoard, public ISuppliesAdded_QSfp_Requirements
{
public:
    FmcQSfp();
    virtual ~FmcQSfp()
        {}

	IX6SioPllControl &  SioPll()  {  return SioPll_SDev;  }

	// pseudo-protected
    //virtual void    InitCardPower();
    virtual void    OpenHardware();
    virtual void    PreconfigureHardware();
    virtual void    ConfigureHardware();
    virtual void    StreamStopHardware();

	//  FMC Requirements Supplier Methods
	virtual unsigned int    GetVitaInStreamCount();
	virtual unsigned int    GetVitaOutStreamCount();
	virtual Si5338 *        MakeSioPllObject(I2CDevice & device);

    //  Ficl Interface
    virtual void    AfterFiclStart(FiclSystem & engine);

    virtual int     Do_DFetch(int dev, int addr);
    virtual void    Do_DStore(int dev, int addr, int value);
    virtual void    Do_DFreq(int dev, float freq);
    virtual float   Do_DFreqActual(int dev);

protected:
	//  Board Specific Subdevices
    X6SioPll                 SioPll_SDev;

	void LocalConstructCustomParts();

    virtual void  Configure_FmcRomInfo(FmcStandardRomInfo & RI);

    virtual void  LoadSupportedVAdjRange(short & minFmcVadjCode, short & maxFmcVadjCode);

};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative

#endif
