// FpaLoadBase.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef IIFpaLoadBaseH
#define IIFpaLoadBaseH

namespace   Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//==============================================================================
//  CLASS FpaLoadBase -- Interface to FPA register
//==============================================================================

class FpaLoadBase
{
public:
    FpaLoadBase()
        {  }
    virtual ~FpaLoadBase()
        {  }        

    // Methods
    // Read/Write data
    virtual bool            Read() = 0;
    virtual void            Write(bool state) = 0;
    // Read/write clock state
    virtual void            Clock(bool state) = 0;

    // Mode set
    virtual void            Mode(int mode) = 0;
    // Device select
    virtual void            Device(int device) = 0;
    // Firmware revision readback
    virtual int             FirmwareRevision() = 0;
    // PCB revision readback
    virtual int             PcbRevision() = 0;
    // ID readback
    virtual int             Id() = 0;
};

//==============================================================================
//  CLASS IX6FpaCpld -- Interface to X6 style CPLD
//==============================================================================

class IX6FpaCpld
{
public:
    IX6FpaCpld()
        {  }
    virtual ~IX6FpaCpld()
        {  }        

    // Methods
    //  Openrations
    virtual void           CPLD_Write(unsigned int addr, unsigned int data) = 0;
    virtual unsigned int   CPLD_Read(unsigned int addr) = 0;
    virtual void           CPLD_GoldenImageActive(bool state) = 0;
    virtual void           CPLD_UpdateStatus() = 0;
    virtual unsigned int   CPLD_ReadPowerStatus() = 0;

    // Primitives
    virtual void          CPLD_Address(unsigned int addr) = 0;
    virtual void          CPLD_Data(unsigned int data) = 0;
    virtual unsigned int  CPLD_Data() = 0;
    virtual void          CPLD_Command(unsigned int code) = 0;

    virtual unsigned int  CPLD_Version() = 0;
    virtual unsigned int  CPLD_FlashType() = 0;
    virtual bool          CPLD_GoldenImageActive() = 0;
    virtual bool          CPLD_GoldenImageBooted() = 0;
    virtual bool          CPLD_Busy() = 0;
    virtual bool          CPLD_ReadValid() = 0;
    virtual bool          CPLD_FlashReady() = 0;
    virtual bool          CPLD_OverTemperature() = 0;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative

#endif
