// FpgaLogicVersionInfo_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <FpgaLogicVersionInfo_Mb.h>


//---------------------------------------------------------------------------
namespace Innovative
{

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4355)
#endif

//===========================================================================
//  CLASS FpgaLogicVersionReg  --  PMC Module User Logic ID info register
//===========================================================================

class FpgaLogicVersionReg : public ReadOnlyRegister
{
    typedef ReadOnlyRegister inherited;

public:
    ReadOnlyRegisterBitGroup       Version;
    ReadOnlyRegisterBitGroup       HdwVariant;
    ReadOnlyRegisterBitGroup       HdwRev;
    ReadOnlyRegisterBitGroup       HdwType;

    FpgaLogicVersionReg(AddressingSpace & space, unsigned int offset)
        : inherited(space, offset),
          Version(*this, 0, 16), HdwVariant(*this, 16, 4),
          HdwRev(*this, 20, 4), HdwType(*this, 24, 8)
    {  }
};

#ifdef _MSC_VER
	#pragma warning(pop)
#endif

//===========================================================================
//  CLASS IUsesFpgaLogicVersionInfo -- User Interface to user logic ID
//===========================================================================
//---------------------------------------------------------------------------
//  constructor for class IUsesFpgaLogicVersionInfo
//---------------------------------------------------------------------------

IUsesFpgaLogicVersionInfo::IUsesFpgaLogicVersionInfo(AddressingSpace & space,
    unsigned int addr)
    :  Reg(new FpgaLogicVersionReg(space, addr))
{
}

//---------------------------------------------------------------------------
//  destructor for class IUsesFpgaLogicVersionInfo
//---------------------------------------------------------------------------

IUsesFpgaLogicVersionInfo::~IUsesFpgaLogicVersionInfo()
{
    delete Reg;    Reg = 0;
}

//---------------------------------------------------------------------------
//  IUsesFpgaLogicVersionInfo::FpgaLogicVersion() --
//---------------------------------------------------------------------------

short IUsesFpgaLogicVersionInfo::FpgaLogicVersion() const
{
    return Reg->Version;
}

//---------------------------------------------------------------------------
//  IUsesFpgaLogicVersionInfo::FpgaLogicVariant() --
//---------------------------------------------------------------------------

short IUsesFpgaLogicVersionInfo::FpgaLogicVariant() const
{
    return Reg->HdwVariant;
}

//---------------------------------------------------------------------------
//  IUsesFpgaLogicVersionInfo::FpgaLogicRevision() --
//---------------------------------------------------------------------------

short IUsesFpgaLogicVersionInfo::FpgaLogicRevision() const
{
    return Reg->HdwRev;
}

//---------------------------------------------------------------------------
//  IUsesFpgaLogicVersionInfo::FpgaLogicType() --
//---------------------------------------------------------------------------

short IUsesFpgaLogicVersionInfo::FpgaLogicType() const
{
    return Reg->HdwType;
}

//---------------------------------------------------------------------------
//  IUsesFpgaLogicVersionInfo::FpgaLogicRawValue() --
//---------------------------------------------------------------------------

unsigned int IUsesFpgaLogicVersionInfo::FpgaLogicRawValue() const
{
    return Reg->Value();
}


}  // end namespace Innovative



