// FpgaLogicVersionInfo_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef FpgaLogicVersionInfo_MbH
#define FpgaLogicVersionInfo_MbH

#include <FpgaLogicVersionInfoIntf_Mb.h>
#include <HardwareRegister_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS IUsesNullFpgaLogicVersionInfo -- User Interface to user logic ID
//===========================================================================

class IUsesNullFpgaLogicVersionInfo : public FpgaLogicVersionInfoIntf
{
public:
    IUsesNullFpgaLogicVersionInfo()     {  }
    virtual ~IUsesNullFpgaLogicVersionInfo()     {  }

    //
    //  Interface Functions
    virtual short           FpgaLogicVersion() const        {  return 0;  }
    virtual short           FpgaLogicVariant() const        {  return 0;  }
    virtual short           FpgaLogicRevision() const       {  return 0;  }
    virtual short           FpgaLogicType() const           {  return 0;  }
    virtual unsigned int    FpgaLogicRawValue() const       {  return 0;  }
};

//===========================================================================
//  CLASS IUsesFpgaLogicVersionInfo -- User Interface to user logic ID
//===========================================================================

class IUsesFpgaLogicVersionInfo : public FpgaLogicVersionInfoIntf
{
public:
    IUsesFpgaLogicVersionInfo(AddressingSpace & space, unsigned int addr);
    virtual ~IUsesFpgaLogicVersionInfo();

    //
    //  Interface Functions
    virtual short           FpgaLogicVersion() const;
    virtual short           FpgaLogicVariant() const;
    virtual short           FpgaLogicRevision() const;
    virtual short           FpgaLogicType() const;
    virtual unsigned int    FpgaLogicRawValue() const;

protected:
    // Data
    class FpgaLogicVersionReg *  Reg;
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
