//---------------------------------------------------------------------------

#include <Framework/GuiLoader_Mb.h>

#ifndef _MSC_VER
//
//  This code is only for Borland or Linux versions. .Net version is in
//     Framework/Net/GuiLoader_Net.cpp file

namespace Innovative
{


//==============================================================================
//  CLASS GuiLoader
//==============================================================================
//------------------------------------------------------------------------------
//  constructor for class GuiLoader
//------------------------------------------------------------------------------

GuiLoader::GuiLoader()
{
}

//------------------------------------------------------------------------------
//  destructor for class GuiLoader
//------------------------------------------------------------------------------

GuiLoader::~GuiLoader()
{
}

//------------------------------------------------------------------------------
//  GuiLoader::Install(const IGuiLoadable & )  -- register a setting
//------------------------------------------------------------------------------

void  GuiLoader::Install(const IGuiLoadable & loader)
{
    loaders.push_back( CountedPtr<IGuiLoadable>( loader.Clone() ));
}

//------------------------------------------------------------------------------
//  GuiLoader::Install(IGuiLoadable * )  -- register a setting
//------------------------------------------------------------------------------

void  GuiLoader::Install(IGuiLoadable * loader)
{
    loaders.push_back( CountedPtr<IGuiLoadable>( loader->Clone() ));
}

//------------------------------------------------------------------------------
//  GuiLoader::Load()  -- Load registered settings to GUI
//------------------------------------------------------------------------------

void  GuiLoader::Load()
{
    for (LoaderStoreType::iterator iter=loaders.begin() ;
                 iter != loaders.end(); ++iter)
        {
        (*iter)->Load();
        }
}

//------------------------------------------------------------------------------
//  GuiLoader::Save()  -- Save registered settings to settings
//------------------------------------------------------------------------------

void  GuiLoader::Save()
{
    for (LoaderStoreType::iterator iter=loaders.begin() ;
                 iter != loaders.end(); ++iter)
        {
        (*iter)->Save();
        }
}

//------------------------------------------------------------------------------
//  GuiLoader::Invalidate()  -- Invalidate cache for all
//------------------------------------------------------------------------------

void  GuiLoader::Invalidate()
{
    for (LoaderStoreType::iterator iter=loaders.begin() ;
                 iter != loaders.end(); ++iter)
        {
        (*iter)->Invalidate();
        }
}

//------------------------------------------------------------------------------
//  GuiLoader::Invalidate()  -- Invalidate cache for a given element
//------------------------------------------------------------------------------
void  GuiLoader::Invalidate(unsigned int *id)
{
    if (id == 0) return; // insanity check

    for (LoaderStoreType::iterator iter=loaders.begin() ;
                 iter != loaders.end(); ++iter)
        {
        if ((*iter)->Id() && (*iter)->Id() == id)
            (*iter)->Invalidate();
        }
}

}  // end namespace Innovative
#endif
