// ClrSupport_Net.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2006 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef ClrSupport_NetH
#define ClrSupport_NetH

#ifdef __CLR_VER
#include <vcclr.h>
#include <string>
#endif

namespace OpenWire
{
#ifdef __CLR_VER

inline std::string MarshalString( System::String ^ s ) 
{
    std::string str;
    using namespace System::Runtime::InteropServices;
    const char* chars = 
        (const char*)(Marshal::StringToHGlobalAnsi(s)).ToPointer();
    str = chars;
    Marshal::FreeHGlobal(System::IntPtr((void*)chars));
    return str;
}

template<class _DELEGATE_,class _EVENT_> class DelegateEvent
{
protected:
    gcroot<_DELEGATE_ ^> mCallBack;

public:
    DelegateEvent( gcroot<_DELEGATE_ ^> aPtr ) : mCallBack( aPtr )
        {
        }

public:
    void Delegate( _EVENT_ &Event )
        {
        mCallBack->Invoke( Event );
        }
};

#endif
} // OpenWire

#endif
