// Thunker_Qt.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef Thunker_QtH
#define Thunker_QtH

#include <string>
#include <ThunkerIntf_Mb.h>
#include <Event_Mb.h>
#include <QApplication>

namespace Innovative
{

class Thunker;

//=============================================================================
//  CLASS Dispatcher  --
//=============================================================================

class Dispatcher : public QObject
{
Q_OBJECT

public:
    // Ctor
    Dispatcher ( Thunker & owner );
    virtual ~Dispatcher();

    void Send ();

signals:
    void send (int e);

public slots:
    void receive (int e);

private:
    Thunker &   Owner;
    int		    Doorbell;
};


//=============================================================================
//  CLASS Thunker  --  "Thunk" call into UI thread, unlocked with caller
//=============================================================================

class Thunker : public ThunkerIntf
{
friend class Dispatcher;

public:
    // Ctor
    Thunker();
    virtual ~Thunker();

    // Methods
    virtual bool    Notify();
    virtual void    Dispatch();

private:
    Dispatcher		Messenger;
};

	
} // Innovative

#endif

