// DosThread_Win.h
//
//  Class to extract version information from DLLs and EXEs
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2003 Innovative Integration Corporation.
//  All Rights Reserved.
//

//---------------------------------------------------------------------------
#ifndef DosThread_WinH
#define DosThread_WinH

#include <Thread_Mb.h>
#include <Semaphore_Mb.h>
#include <windows.h>

namespace Innovative
{

class Dos;

//---------------------------------------------------------------------------

class DosThread : public Thread
{
    typedef Thread inherited;

public:
    // Ctors
    DosThread(Dos *owner);
    virtual ~DosThread();

    void                LaunchProcess();
    bool                Write(void *Buffer, int Count);

    // Properties
    void                Abort(bool state)
        {  Aborting = state;  }
    bool                Abort() const
        {  return Aborting;  }

    void                Pause(bool state)
        {  Pausing = state;  }
    bool                Pause() const
        {  return Pausing;  }

protected:
    enum { sSpawn=inherited::sLast, sLast };

    virtual void    Execute(void);
    virtual void    Init();

private:
    // Data
    int                         InputMsg;
    Dos                       * Owner;
    STARTUPINFO               * StartupInfo;
    PROCESS_INFORMATION       * ProcessInfo;
    HANDLE                      StdIn;
    HANDLE                      StdInRd;
    HANDLE                      StdInWr;
    HANDLE                      StdOut;
    HANDLE                      StdOutRd;
    HANDLE                      StdOutWr;
    volatile bool               cResult;
    char *                      SBuf;
    bool                        Aborting;
    bool                        Pausing;
    Innovative::Semaphore       Spawning;

    // Methods
    void                        OpenHandles();
    void                        CloseHandles();
    bool                        Eat(const HANDLE &Handle);
    void                        Spawn();
};

} // namespace Innovative

#endif

