// FileFindThread_Win.h
//
//  Class to extract version information from DLLs and EXEs
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2003 Innovative Integration Corporation.
//  All Rights Reserved.
//
//   Background file search
//
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#ifndef FileFindThread_WinH
#define FileFindThread_WinH
//---------------------------------------------------------------------------

#include "Windows.h"
#include <Event_Mb.h>
#include <Thread_Mb.h>
#include <vector>
#include <StringList_Mb.h>

namespace Innovative
{

class FileFind;

class FileFindThread : public Innovative::Thread
{
    typedef Thread inherited;

public:
    // Ctors
    FileFindThread(FileFind *owner);
    virtual  ~FileFindThread();

    // Support
    void                Start(const Innovative::StringList & directories,
                              const Innovative::StringList & filespecs,
                              bool recursive);
    void                Stop();

protected:
    virtual void Execute(void);

private:
    enum { sParsing=inherited::sLast, sScan, sLast };

    // Data
    Innovative::StringList      Directories;
    Innovative::StringList      FileSpecs;
    Innovative::Event           Scanning;
    FileFind *                  Owner;
    bool                        Recursive;
    bool                        Abort;

    // Methods
    virtual void    Init();
    void            ScanDirectories(string directory);
    void            Scan();
    void            OnMatch(const std::string & path, const std::string & filename);
    int             WildcardCompare(const char *wild, const char *string);
};

} // namespace Innovative

#endif
