// MemDrvCtrl_Win.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2003 Innovative Integration Corporation.
//  All Rights Reserved.
//
#ifndef MEMDRVCTRL_WIN_H
#define MEMDRVCTRL_WIN_H

#include "MemDriver_Mb.h"
#include <String>

#define MAXBUFSIZE 200

namespace Innovative
{

//=============================================================================
//  CLASS MemDrvCtrl
//=============================================================================

class MemDrvCtrl
{
public:
    MemDrvCtrl();
    ~MemDrvCtrl();

    bool ResetLMemDrv();
    bool ResetHMemDrv();
    bool GetLMemDrvStatus(DrvOutputType &drvOut);
    bool GetHMemDrvStatus(DrvOutputType &drvOut);
    bool TestLMemDrv(size_t bytes);
    bool TestHMemDrv(size_t bytes);
	bool RegWrite(const std::string & subkey, const std::string & key, const size_t value);
	bool RegRead(const std::string & subkey, const std::string & key, size_t & value);
    bool CfgWrite(const std::string &key, const ULONGLONG value);
    bool CfgRead(const std::string &key, PULONGLONG value);

private:

};

}

#endif
