// MultiMedia_Win.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef MultiMedia_WinH
#define MultiMedia_WinH

#include <windows.h>
#include <mmsystem.h>
#include <StimulusResponse_Mb.h>
#include <SoftwareTimer_Mb.h>

#define DDS_START_DELAY 2000

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace Windows
{

class MultiMedia : public StimulusResponse
{
    typedef StimulusResponse inherited;

public:
    MultiMedia();

    // Overrides
    virtual         ~MultiMedia();
    virtual void    Initialize(double nSampleRate, bool bStereo);
    virtual void    Process(size_t position);

private:
    // Methods
    void                QueueWriteData(WAVEHDR *const whdr);
    static DWORD WINAPI WaveThread(LPVOID arg);
    void                Start();
    void                Stop();
    void                Finalize();
    void                HandleTimer(OpenWire::NotifyEvent & event);    

    // Data
    HWAVEIN             m_pcmRead;
    HWAVEOUT            m_pcmWrite;
    WAVEHDR             m_waveReadHeader[2];
    WAVEHDR             m_waveWriteHeader[2];
    WAVEFORMATEX        m_waveFormat;
    BOOL                m_inRead;
    BOOL                m_inWrite;
    unsigned int        m_readComplete;
    unsigned int        m_writeComplete;
    unsigned int        m_totalRecorded;
    bool                m_initialized;

    SoftwareTimer       Timer;

    //Audio loop indices
    unsigned int        m_ir;
    unsigned int        m_iw;
};

}  // namespace Windows

#ifdef __CLR_VER
#pragma managed(pop)
#endif

}  // namespace Innovative

#endif //MultiMedia_WinH

