// OsDetector_Mb.cpp
//
//  Class to extract version information from DLLs and EXEs
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2003 Innovative Integration Corporation.
//  All Rights Reserved.
//
//   OS shutdown
//
//---------------------------------------------------------------------------

#include "OsDetector_Win.h"
//#include <cstdio>
#include <lm.h>

using namespace std;
namespace Innovative
{

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4996)
#endif


//============================================================================
//  CLASS OsDetector -- OS Detection Utility Class
//============================================================================
//----------------------------------------------------------------------------
//  constructor for class OsDetector
//----------------------------------------------------------------------------

OsDetector::OsDetector()
    : FOsType(otUnknown)
{
	//
	//  Figure out what type of OS we have to load OsType property variable
    //bool bOsVersionInfoEx;

	FOsType = otUnknown;
	LPBYTE pinfoRawData;
	if (NetWkstaGetInfo(NULL, 100, &pinfoRawData) != NERR_Success)
		return;

	WKSTA_INFO_100 * pworkstationInfo = (WKSTA_INFO_100 *)pinfoRawData;
	FMajorVersion = pworkstationInfo->wki100_ver_major;
	FMinorVersion = pworkstationInfo->wki100_ver_minor;
	FPlatformId = pworkstationInfo->wki100_platform_id;
//	FComputerName = StdString(pworkstationInfo->wki100_computername);
//	FLanGroup = pworkstationInfo->wki100_langroup;
	::NetApiBufferFree(pinfoRawData);

	switch (FPlatformId)
		{
		case PLATFORM_ID_DOS:
			FOsType = otDos;
			break;

		case PLATFORM_ID_OS2:
			FOsType = otOs2;
			break;

		case PLATFORM_ID_NT:
            if (FMajorVersion < 5)
                {
                FOsType = otNT;
                }
			if (FMajorVersion == 5)
				{
				switch (FMinorVersion)
					{
                    case 0:     FOsType = ot2000;   break;
                    default:
                    case 1:     FOsType = otXP;     break;
                    }
                }
			if ((FMajorVersion == 6) && (FMinorVersion == 0))
				{
				FOsType = otVista;
				}
			if ((FMajorVersion == 6) && (FMinorVersion == 1))
				{
				FOsType = otWin7;
				}
			break;

		case PLATFORM_ID_OSF:
			FOsType = otOsf;
			break;

		case PLATFORM_ID_VMS:
			FOsType = otVms;
			break;
		}
}

//----------------------------------------------------------------------------
//  OsDetector::IsWin9x
//----------------------------------------------------------------------------

bool OsDetector::IsWin9x()
{
	return ( FOsType==ot95 || FOsType==ot98 || FOsType ==otME );
}

//----------------------------------------------------------------------------
//  OsDetector::GetWindowsVersion
//----------------------------------------------------------------------------

bool OsDetector::GetWindowsVersion(DWORD& major, DWORD& minor)
{
	LPBYTE pinfoRawData;
	if (NERR_Success == NetWkstaGetInfo(NULL, 100, &pinfoRawData))
		{
		WKSTA_INFO_100 * pworkstationInfo = (WKSTA_INFO_100 *)pinfoRawData;
		major = pworkstationInfo->wki100_ver_major;
		minor = pworkstationInfo->wki100_ver_minor;
		::NetApiBufferFree(pinfoRawData);
		return true;
		}

	return false;
}



#ifdef _MSC_VER
#pragma warning(pop)
#endif


} // namespace Innovative
