// OsDetector_Mb.h
//
//  Class to extract version information from DLLs and EXEs
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2003 Innovative Integration Corporation.
//  All Rights Reserved.
//
//   OS detection
//
//---------------------------------------------------------------------------

#ifndef OsDetectorMbH
#define OsDetectorMbH

#include "windows.h"
#include <string>

namespace Innovative
{
enum TOsType { otUnknown, otWin32s, ot95, ot98, otNT, ot2000, otME, otXP,
               otVista, otWin7, otOs2, otOsf, otVms, otDos };

//============================================================================
//  CLASS OsDetector -- OS Detection Utility Class
//============================================================================

class OsDetector
{
public:
    //
    //  Properties
    TOsType  OsType() const
        {  return FOsType;  }
    //
    //  Member Functions
    OsDetector();

	bool  IsWin9x();

    int MinorVersionNumber() const
		{  return FMinorVersion;  }
	int MajorVersionNumber() const
		{  return FMajorVersion;  }

private:
    //
    //  Member Data
    TOsType          FOsType;
	int              FMinorVersion;
	int              FMajorVersion;
	int				 FPlatformId;
//	std::string		 FComputerName;
//	std::string 	 FLanGroup;

	bool 		  	GetWindowsVersion(DWORD& major, DWORD& minor);

	OSVERSIONINFOEX  osvi;
};

} // namespace Innovative

#endif
