// Overlapped_Win.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2007 Innovative Integration Corporation.
//  All Rights Reserved.
//
//---------------------------------------------------------------------------

#ifndef Overlapped_WinH
#define Overlapped_WinH

#include <windows.h>
#include <DataTypes_Mb.h>
#include "Framework\Windows\Event_Win.h"

namespace Innovative
{

namespace Windows
{

#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//=============================================================================
//  CLASS Overlapped  --  Windows-specific overlapped wrapper class
//=============================================================================

class Overlapped
{
public:
    Overlapped()
        {
        ::ZeroMemory(&Overlap, sizeof(OVERLAPPED));
        }

    void Offset(ii64 value)
        {
        Int64 temp;
        temp.All = value;
        Overlap.Offset = temp.Lo;
        Overlap.OffsetHigh = temp.Hi;
        }
    ii64 Offset() const
        {
        Int64 temp;
        temp.Lo = Overlap.Offset;
        temp.Hi = Overlap.OffsetHigh;

        return temp.All;
        }
    void Advance(ii64 value) 
        {
        Int64 temp;
        temp.All = Offset();
        temp.All += value;
        Offset(temp.All);
        }
    void SetEvent(Event & event)
        {  Overlap.hEvent = event.Handle();  }

    OVERLAPPED & Handle()
        { return Overlap; };

private:
    OVERLAPPED                  Overlap;
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif

} // Windows

} // Innovative

#endif
