// GaussGen_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef GaussGen_MbH
#define GaussGen_MbH

//---------------------------------------------------------------------------
#include <Buffer_Mb.h>
#include <CommonGen_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//=============================================================================
//  CLASS GaussGen  --  
//=============================================================================

class GaussGen : public CommonGen
{
    typedef CommonGen inherited;

public:
    // Ctor
    GaussGen();
    GaussGen( const GaussGen & other );

    // Assignment
    GaussGen & operator = ( const GaussGen & other );

	// Methods
	virtual bool    Generate(IppFloatDG & buffer);
	virtual bool    Generate(IppComplexDG & buffer);

    // Properties
    void            Mean(float value);
    float           Mean() const;

    void            StdDev(float value);
    float           StdDev() const;

    void            Seed(unsigned int value);
    unsigned int    Seed() const;

protected:
	// Methods
	bool 			update();

    // Fields
    float           FMean;
    float           FStdDev;
	unsigned int    FSeed;
	// Data
	void *          mState;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // Innovative

#endif
