// GcScript_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef GcScript_MbH
#define GcScript_MbH

#include <stack>
#include <StringVector_Mb.h>
#include <ProcessEvents_Mb.h>

namespace   Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
// CLASS GcScriptCommandEvent  --  Script command dispatch event
//===========================================================================

class GcScriptCommandEvent : public OpenWire::Event
{
public:
    const int Channel;
    const int Offset;
    const int Value;

    GcScriptCommandEvent(int ch, int off, int val)
        :  Channel(ch), Offset(off), Value(val)
        {
        }
};

//===========================================================================
//  CLASS GcScripter  --  Graychip script command dispatcher
//===========================================================================

class GcScripter
{
public:
    // Ctor
    GcScripter();

    // Methods
    void Execute(std::string file, int channel=0);

    // Events
    OpenWire::SynchronizedEventHandler<Innovative::GcScriptCommandEvent> OnCommand;
    OpenWire::SynchronizedEventHandler<Innovative::ProcessStatusEvent> OnMessage;

private:
    // Data
    Innovative::StringVector        File;

    // Methods
    void ParseLine(std::string line, int channel);
    std::string ToHex(unsigned int value, int width);
    unsigned int FromHex(std::string txt);
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif

} // namespace Innovative

#endif
