// Gps_CSAC_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2009 Innovative Integration Corporation.
//  All Rights Reserved.
//
//---------------------------------------------------------------------------

#include <Gps_Csac_Mb.h>

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4355)
#endif

namespace Innovative
{

//===========================================================================
//  CLASS Gps_CSAC  -- Support for Jackson Labs CSAC GPS unit
//===========================================================================

Gps_CSAC::Gps_CSAC()
	: IGps(new StandardGpsMessageParser())
{
}
	
//---------------------------------------------------------------------------
//  Gps_CSAC::GpsBaud() --  Set baud-rate
//---------------------------------------------------------------------------

void Gps_CSAC::GpsBaud(BaudRates /*rate*/)
{
}

//---------------------------------------------------------------------------
//  Gps_CSAC::OnProcessMessages() --  Process Epoch Message List
//---------------------------------------------------------------------------

void Gps_CSAC::OnProcessMessages(GpsMessageList & Messages)
{
    //
    //  Need to set "Time()" state from $GPZDA message
    int ZdaIdx = Messages.FindMessage("$GPZDA");
    if (ZdaIdx != -1)
        {
        GpsMessage ZdaMsg = Messages.MessageAt(ZdaIdx);
        GpZdaCracker Zda(ZdaMsg);
        if (Zda.IsValid)
            FTime = Zda.Time;
        }
    //
    //  Need to set Position and other state from $GPGGA message
    int GgaIdx = Messages.FindMessage("$GPGGA");
    if (GgaIdx != -1)
        {
        GpsMessage GgaMsg = Messages.MessageAt(GgaIdx);
        GpGgaCracker Gga(GgaMsg);
        if (Gga.IsValid)
            {
            //  Latitude
            FLatitude.Degrees = Gga.LatDegrees;
            FLatitude.Minutes = Gga.LatMinutes;
            FLatitude.Units   = Gga.LatUnits;
            //  Longitude
            FLongitude.Degrees = Gga.LongDegrees;
            FLongitude.Minutes = Gga.LongMinutes;
            FLongitude.Units   = Gga.LongUnits;
            //  Fix
            FFix = static_cast<FixStatus>(Gga.Fix);
            //  Satellites
            FSatellites = Gga.Satellites;
            }
        }
}

}  // end namespace Innovative
