// Gps_CSAC_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2009 Innovative Integration Corporation.
//  All Rights Reserved.
//
//---------------------------------------------------------------------------

#ifndef Gps_CSAC_MbH
#define Gps_CSAC_MbH

#include <Gps_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS Gps_CSAC  -- Support for Jackson Labs CSAC GPS unit
//===========================================================================

class Gps_CSAC : public IGps
{
public:
    Gps_CSAC();
protected:
    //
    //  Gps Impl functions
    virtual void   GpsBaud(BaudRates baud);
    virtual void   OnProcessMessages(GpsMessageList & Messages);

    virtual bool    IsLocked() const
		{  return FFix != IGps::fixNoFix;  }
};


class Gps_CSACPlugin : public GpsPluginSocket<Gps_CSAC>
{
public:
    Gps_CSACPlugin( IGps_Plugin * plug )
        :  GpsPluginSocket<Gps_CSAC>(plug)
        {}

};



#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // end namespace Innovative

//---------------------------------------------------------------------------
#endif
