// Gps_Ieee1588_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2015 Innovative Integration Corporation.
//  All Rights Reserved.
//
//---------------------------------------------------------------------------

#include <Gps_Ieee1588_Mb.h>

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4355)
#endif

namespace Innovative
{

//===========================================================================
//  CLASS Gps_Ieee1588  -- Support for IEEE1588 Device
//===========================================================================

Gps_Ieee1588::Gps_Ieee1588()
	: IGps(new StandardGpsMessageParser())
{
}
	
//---------------------------------------------------------------------------
//  Gps_Ieee1588::GpsBaud() --  Set baud-rate
//---------------------------------------------------------------------------

void Gps_Ieee1588::GpsBaud(BaudRates /*rate*/)
{
}

//---------------------------------------------------------------------------
//  Gps_Ieee1588::OnProcessMessages() --  Process Epoch Message List
//---------------------------------------------------------------------------

void Gps_Ieee1588::OnProcessMessages(GpsMessageList & Messages)
{
    //
    //  Need to set all state from $GPRMC message
    int RmcIdx = Messages.FindMessage("$GPRMC");
    if (RmcIdx != -1)
        {
        GpsMessage RmcMsg = Messages.MessageAt(RmcIdx);
        GpRmcCracker Rmc(RmcMsg);
        if (Rmc.IsValid)
            {
            FTime = Rmc.Time;
            //  Latitude
            FLatitude.Degrees = Rmc.LatDegrees;
            FLatitude.Minutes = Rmc.LatMinutes;
            FLatitude.Units   = Rmc.LatUnits;
            //  Longitude
            FLongitude.Degrees = Rmc.LongDegrees;
            FLongitude.Minutes = Rmc.LongMinutes;
            FLongitude.Units   = Rmc.LongUnits;
            }

        }
}

}  // end namespace Innovative
