// Gps_MiniT_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2009 Innovative Integration Corporation.
//  All Rights Reserved.
//
//---------------------------------------------------------------------------

#ifndef Gps_MINIT_MbH
#define Gps_MINIT_MbH

#include <Gps_Mb.h>
namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS Gps_MiniT  -- Support for Trimble Mini-T GPS Hardware
//===========================================================================

class Gps_MiniT : public IGps
{
public:
    enum PktSize {szPTime = 21, szSTime = 72};
    enum PktCode {idPTime = 0xAB, idSTime = 0xAC};
    Gps_MiniT();

protected:
    //
    //  Gps Impl functions
    virtual void   	OnProcessMessages(GpsMessageList & Messages);
    virtual void	GpsBaud(BaudRates baud);
    virtual bool    IsAntenna() const
        {  return FAntennaOk;  }
    virtual bool    IsLocked() const
        {  return FGpsLocked;  }

protected:
    // Fields
    bool			FAntennaOk;
    bool			FGpsLocked;
    double			FAltitude;
    float			FTemperature;

    // Methods
    void            ProcessPrimaryTP(std::vector<unsigned char> & pkt);
    void            ProcessSuplementalTP(std::vector<unsigned char> & pkt);
};


class Gps_MiniTPlugin : public GpsPluginSocket<Gps_MiniT>
{
public:
    Gps_MiniTPlugin( IGps_Plugin * plug )
        :  GpsPluginSocket<Gps_MiniT>(plug)
        {}

};

//===========================================================================
// CLASS TsipGpsMessageParser  --  Normal Message String Parser
//===========================================================================

class TsipGpsMessageParser : public IGpsMessageParser
{
public:
    TsipGpsMessageParser();
    virtual ~TsipGpsMessageParser(){};

    virtual std::string EndToken() {return CmdEndToken;;}
    virtual void  Parse(std::string & queue, GpsMessageList & messages);

protected:
    void  ParseMessage(std::string text, GpsMessageList & messages);
    int   FindStartOfPacket(std::vector<unsigned char> & raw);
    int   FindEndOfPacket(std::vector<unsigned char> & raw);

    std::string  CmdEndToken;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif

}  // end namespace Innovative

//---------------------------------------------------------------------------
#endif
