/////////////////////////////////////////////////////////////////////////////
  // opennurbs_guiddef.h
  //
  // The following declarations are found in guiddef.h, which is included with
  // the Microsoft Platform SDK. If you are building openNURBS using a Microsoft
  // compiler and you do not also have the Microsoft Platform SDK, then you need
  // to included this header in the openNURBS project. Include this header in
  // opennurbs.h, which is the pre-compiled header file for the project. Locate
  // this include statement immediately following the #include "opennurbs_uuid.h"
  // statement. For example:
  //
  //   #include "opennurbs_uuid.h"    /* universally unique identifiers (UUID, a.k.a, GUID) */
  //
  //   #include "opennurbs_guiddef.h" /* microsoft platform sdk uuid inlines */
  //
  //   #if defined(ON_CPLUSPLUS)
  //

#ifndef Guid_MbH
#define Guid_MbH

#include <string>

#ifndef __GNUC__
	#include <guiddef.h>
#else

#include <initguid.h>

#ifdef LINUX
// clipped from   <objbase.h>
inline bool IsEqualGUID(REFGUID rguid1, REFGUID rguid2)
	{ return !memcmp(&rguid1, &rguid2, sizeof(GUID)); }
inline bool operator==(const GUID& guidOne, const GUID& guidOther)
	{ return !memcmp(&guidOne,&guidOther,sizeof(GUID)); }
inline bool operator!=(const GUID& g1, const GUID& g2)
	{ return !(g1 == g2); }
#else

#include <objbase.h>

#endif

#endif // #ifndef __GNUC__

#endif // #ifndef Guid_MbH
