//
// HardwareInfoIntf_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2003 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef _HardwareInfoIntf_MbH
#define _HardwareInfoIntf_MbH

#include <SpanInfo_Mb.h>
#include <ChannelInfo_Mb.h>

namespace Innovative
{

//=============================================================================
//  CLASS IoInfoIntf  --  Interface to custom Analog Device Information
//=============================================================================

class IoInfoIntf
{
public:
	//  ...Ins
	virtual ChannelInfo &		    Channels() = 0;
	virtual float               	MaxRate() const  = 0;
	virtual float               	MinRate() const  = 0;
	virtual const SpanArray &   	Span() const  = 0;
	virtual int                 	GangSize() const  = 0;
	virtual bool                	IsStackable() const  = 0;
	virtual bool                	IsInverted() const  = 0;
	virtual bool                	IsMuxed() const  = 0;
	virtual bool                	MuxDepth() const  = 0;
	virtual int                 	BufferSize() const  = 0;
	virtual int                 	ClockFactor() const  = 0;
	virtual float               	ReferenceClock() const = 0;
	virtual int               	    SamplesPerFrame() const = 0;
    //
    //  Optional Feature Detection 
    virtual bool                    HasPretriggering() const
                                        {  return false;  }
    virtual bool                    HasTriggerDelay() const
                                        {  return false;  }

	virtual ~IoInfoIntf() {}

};


} // namespace Innovative

#endif
