// 
// Ics8442_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2003 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef Ics8442_MbH
#define Ics8442_MbH

#include <Clockbase_Mb.h>
#include <HardwareRegister_Mb.h>

namespace Innovative
{

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4355)
#endif

//=============================================================================
//  CLASS Ics8442  --  PLL timebase control
//=============================================================================

class Ics8442 : public ClockBase
{
public:
    enum IITestMode { toDisabled, toShiftReg, toFeedbackDivider, toNormal };
    enum IIReferenceClk { rcDivider, rcCrystal };
    //
    //  Member Functions
    Ics8442(int index, AddressingSpace &space, int offset);
    Ics8442(double freq, double ref, bool enabled, int index,
            AddressingSpace & space, int offset);

    // Methods
    Ics8442 &           ReferenceClock(IIReferenceClk value);
    IIReferenceClk      ReferenceClock() const;

    Ics8442 &           MultiplierEnable(bool state);
    bool                MultiplierEnable() const;

    Ics8442 &           TestMode(IITestMode output);
    IITestMode          TestMode() const;

    void                Reapply();

protected:
    // Overrides
    virtual void    SetFrequency(double freq);
    virtual double  GetFrequencyActual() const;
    virtual void    SetEnabled(bool state);

    class ControlRegister : public ShadowRegister
    {
        typedef ShadowRegister inherited;

    public:
        RegisterBitGroup      M;
        RegisterBitGroup      N;
        RegisterBitGroup      TestOutput;
        RegisterBit           MultiplierEnable;
        RegisterBit           Reference;
        RegisterBit           Reset;

        ControlRegister(AddressingSpace &space,
            int offset)
        :  inherited(space, offset),
           M(*this, 0, 9), N(*this, 12, 2), TestOutput(*this, 16, 2),
           MultiplierEnable(*this, 20), Reference(*this, 24), Reset(*this, 28)
            {
            }
    };

    //
    //  Member Data
	ControlRegister     CtlReg;

	// Support Methods
	void    DoSetFrequency(double freq);
	void    DoSetEnabled(bool state);

};

#ifdef _MSC_VER
	#pragma warning(pop)
#endif

} // namespace Innovative

#endif

