/*++

Module Name:

    public.h

Abstract:

    This module contains the common declarations shared by driver
    and user applications.

Environment:

    user and kernel

--*/

// Define an Interface Guid so that apps can find the device and talk to it.

DEFINE_GUID (GUID_DEVINTERFACE_IIDrvr,
    0x02bc0636,0x3911,0x4444,0xa0,0x28,0x5e,0xad,0x9f,0x81,0x15,0xfb); // {02bc0636-3911-4444-a028-5ead9f8115fb}

// The IOCTL function codes from 0x800 to 0xFFF are for customer use. 0x000 to 0x799 are reserved for microsoft.

#define  IOCTL_GET_BD_RESOURCES_1303 \
    CTL_CODE ( FILE_DEVICE_UNKNOWN, 0x801, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define  IOCTL_PORT_READ_1303 \
    CTL_CODE ( FILE_DEVICE_UNKNOWN, 0x802, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define  IOCTL_PORT_WRITE_1303 \
    CTL_CODE ( FILE_DEVICE_UNKNOWN, 0x803, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define  IOCTL_LOGIC_READ_1303 \
    CTL_CODE ( FILE_DEVICE_UNKNOWN, 0x804, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define  IOCTL_LOGIC_WRITE_1303 \
    CTL_CODE ( FILE_DEVICE_UNKNOWN, 0x805, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define  IOCTL_PREP_INTERRUPT_1303 \
    CTL_CODE ( FILE_DEVICE_UNKNOWN, 0x806, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define  IOCTL_QUEUE_INTERRUPT_1303 \
    CTL_CODE ( FILE_DEVICE_UNKNOWN, 0x807, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define  IOCTL_FREE_QUEUE_1303 \
    CTL_CODE ( FILE_DEVICE_UNKNOWN, 0x808, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define  IOCTL_INTSTAT_RESULT_1303 \
    CTL_CODE ( FILE_DEVICE_UNKNOWN, 0x809, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define  IOCTL_ISR_CLEARQ_1303 \
    CTL_CODE ( FILE_DEVICE_UNKNOWN, 0x80A, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define  IOCTL_MSG_INTDEPTH_1303 \
    CTL_CODE ( FILE_DEVICE_UNKNOWN, 0x80B, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define  IOCTL_FREE_MDL_1303 \
    CTL_CODE ( FILE_DEVICE_UNKNOWN, 0x80C, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define  IOCTL_MICRO_SLEEP_1303 \
    CTL_CODE ( FILE_DEVICE_UNKNOWN, 0x80D, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define  IOCTL_DEBUG_PRINT_ALL_1303 \
    CTL_CODE ( FILE_DEVICE_UNKNOWN, 0x80E, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define DEVICE_QUEUE_DEPTH 128

//==================================================
//   Structures for IOCTL Commands
//==================================================
typedef struct _IO_1303
{
	ULONG           Offset;
	ULONG           Data;
} IO_1303, *PIO_1303;

typedef struct _LOGICIO_1303
{
	ULONG           Offset;
	ULONG           Data;
} LOGICIO_1303, *PLOGICIO_1303;

typedef struct _INTERRUPT_INFO_1303
{
	ULONG           IntStatusMask;
	ULONG           IntStatusRegisterOffset;
	ULONG           IntHandlerType;
} INTERRUPT_INFO_1303, *PINTERRUPT_INFO_1303;

//Result structure for INTSTAT message 
typedef struct 
{
	ULONG Depth;
	ULONG Queue[DEVICE_QUEUE_DEPTH];
} INTSTAT_RESULT, *PINTSTAT_RESULT;

typedef struct _MemoryInfo
{
	LARGE_INTEGER		PortPhysAddr;		// Physical Address of Port Memory
	PVOID				PortKernelAddr;		// Mapped Address of Port Memory
	PVOID				PortUserAddr;		// Registers user base address
	ULONG				PortSize;			// Size of Port Memory

	LARGE_INTEGER		LogicPhysAddr;		// Physical Address of Logic Memory
	PVOID				LogicKernelAddr;	// Mapped Address of Logic Memory
	PVOID				LogicUserAddr;		// Registers user base address
	ULONG				LogicSize;			// Size of Logic Memory
} MemoryInfo, *PMemoryInfo;
