// 
// Ics8402_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2003 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef Ics8402_MbH
#define Ics8402_MbH

#include <ICS8442_Mb.h>

namespace Innovative
{

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4355)
#endif

//=============================================================================
//  CLASS Ics8402  --  PLL timebase control
//=============================================================================

class Ics8402 : public Ics8442
{
    typedef Innovative::Ics8442 inherited;

public:
    //
    //  Member Functions
    Ics8402(int index, AddressingSpace &space, int offset);
    Ics8402(double freq, double ref, bool enabled, int index,
            AddressingSpace & space, int offset);

	// Output frequency range information
	void 				Max(double value);
	double				Max() const;

	void 				Min(double value);
	double 				Min() const;
	int  				MaxOutputDivider() const;

protected:
    // Overrides
    virtual void    SetFrequency(double freq);
    virtual double  GetFrequencyActual() const;
    virtual void    SetEnabled(bool state);

	// Support Methods
	void    		DoSetFrequency(double freq);
	void    		DoSetEnabled(bool state);

private:
    double 			VcoLow;
	double 			VcoHigh;

};

#ifdef _MSC_VER
	#pragma warning(pop)
#endif

} // namespace Innovative

#endif

