// InverseFourier_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <InverseFourier_Mb.h>
#include <ipp.h>   // ipp.h is not redistributable!
#include <cmath>
#include <Magic_Mb.h>
#include <BufferDatagrams_Mb.h>
#include <algorithm>

using namespace std;

namespace   Innovative
{

//===========================================================================
//  CLASS InverseFourier  --
//===========================================================================

//---------------------------------------------------------------------------
// InverseFourier::InverseFourier() --
//---------------------------------------------------------------------------

InverseFourier::InverseFourier()
{
}

//---------------------------------------------------------------------------
//  InverseFourier::Transform() --
//---------------------------------------------------------------------------

bool InverseFourier::Transform(const IppComplexDG & in, IppComplexDG & out)
{
	if (!mSpec.size())
		Start();

	return transform(in, out);
}

//---------------------------------------------------------------------------
//  InverseFourier::Transform() --
//---------------------------------------------------------------------------

bool InverseFourier::Transform()
{
	IppComplexDG t(mTime);
	IppComplexDG f(mFrequency);

	return Transform(f, t);
}

//---------------------------------------------------------------------------
//  InverseFourier::transform() --
//---------------------------------------------------------------------------

bool InverseFourier::transform(const IppComplexDG & in, IppComplexDG & out)
{
    bool result = true;

	FFTSpec_C_32fc ** pSpec = reinterpret_cast<FFTSpec_C_32fc**>(&mState);

	IppStatus status = ippsFFTInv_CToC_32fc(reinterpret_cast<const Ipp32fc*>(in.Ptr()),
		reinterpret_cast<Ipp32fc*>(out.Ptr()),
		*pSpec,
		reinterpret_cast<Ipp8u*>(&(mWorking.front())));

	result &= (status == ippStsNoErr);

	return result;
}


} // namespace Innovative
