// IppSupport_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <IppSupport_Mb.h>
#include <ipps.h>   
#include <ippcore.h>

namespace   Innovative
{

//===========================================================================
//  CLASS IppVersion  --  IPP library version info
//===========================================================================

//---------------------------------------------------------------------------
// IppVersion::IppVersion() --  Ctor
//---------------------------------------------------------------------------

IppVersion::IppVersion()
    : mMajor(0), mMinor(0), mRelease(0), mBuild(0)
{
    const IppLibraryVersion* lib = ippsGetLibVersion();
    mName = lib->Name;
    mVersion = lib->Version;
    mMajor = lib->major;
    mMinor = lib->minor;
    mRelease = lib->majorBuild;
    mBuild = lib->build;
}

//---------------------------------------------------------------------------
// IppVersion::IppVersion() --  Return library name
//---------------------------------------------------------------------------

std::string IppVersion::Name()
{
    return mName;
}

//---------------------------------------------------------------------------
// IppVersion::IppVersion() --  Return library version
//---------------------------------------------------------------------------

std::string IppVersion::Version()
{
    return mVersion;
}

//---------------------------------------------------------------------------
// IppVersion::Major() --  Return library major release number
//---------------------------------------------------------------------------

int IppVersion::Major()
{
    return mMajor;
}

//---------------------------------------------------------------------------
// IppVersion::Minor() --  Return library minor release number
//---------------------------------------------------------------------------

int IppVersion::Minor()
{
    return mMinor;
}

//---------------------------------------------------------------------------
// IppVersion::Release() --  Return library subrelease number
//---------------------------------------------------------------------------

int IppVersion::Release()
{
    return mRelease;
}

//---------------------------------------------------------------------------
// IppVersion::Build() --  Return library build number
//---------------------------------------------------------------------------

int IppVersion::Build()
{
	return mBuild;
}

//===========================================================================
//  CLASS IppCpu  --  IPP library CPU info
//===========================================================================

//---------------------------------------------------------------------------
// IppCpu::IppCpu() --  Ctor
//---------------------------------------------------------------------------

IppCpu::IppCpu()
{
	ippGetCpuFeatures(reinterpret_cast<Ipp64u*>(&Mask), CpuId);
}

//---------------------------------------------------------------------------
// IppCpu::Clocks() --  Return processor clocks
//---------------------------------------------------------------------------

ii64 IppCpu::Clocks()
{
    return ippGetCpuClocks();
}


} // namespace Innovative
