// IppSupport_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef IppSupport_MbH
#define IppSupport_MbH

#include <string>
#include <DataTypes_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS IppVersion  --  IPP library version info
//===========================================================================

class IppVersion
{
public:
    // Ctor
    IppVersion();

    // Methods
    std::string     Name();
    std::string     Version();
    int             Major();
    int             Minor();
    int             Release();
    int             Build();

private:
	// Data
	std::string     mName;
	std::string     mVersion;
	int             mMajor;
	int             mMinor;
	int             mRelease;
	int             mBuild;
};

//===========================================================================
//  CLASS IppCpu  --  IPP library CPU info
//===========================================================================

class IppCpu
{
public:
	// Ctor
	IppCpu();

	// Methods
	ii64            Clocks();

	// Data
	ii64			Mask;
	ii32            CpuId[4];
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // Innovative

#endif
