//---------------------------------------------------------------------------
// JESDSubDevice_Stream_Tables_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2016 Innovative Integration Corporation.
//  All Rights Reserved.

#include <JESDSubDevice_Stream_Mb.h>
//#include <SystemSupport_Mb.h>
//#include <StringSupport_Mb.h>

using namespace std;

//===========================================================================
//  CLASS JESD_PHY -- JESD PHY IP interface
//===========================================================================
namespace {

Innovative::JESD_PHY::MgtPllRangesType MgtCPLLRanges[] = {
    {1600.0e6, 3300.0e6, 500.0e6, 6600.0e6,  8},  // 7Series,     GTXE2, 1,        FF/RF
    {1600.0e6, 3300.0e6, 500.0e6, 6600.0e6,  8},  // 7Series,     GTXE2, 1,        FB/SB/RB
    {1600.0e6, 3300.0e6, 500.0e6, 6600.0e6,  8},  // 7Series,     GTXE2, 2/2L,     FF/RF
    {1600.0e6, 3300.0e6, 500.0e6, 6600.0e6,  8},  // 7Series,     GTXE2, 2/2L,     FB/SB/RB
    {1600.0e6, 3300.0e6, 500.0e6, 6600.0e6,  8},  // 7Series,     GTXE2, 3,        FF
    {1600.0e6, 3300.0e6, 500.0e6, 6600.0e6,  8},  // 7Series,     GTXE2, 3,        FB/SB
    {1600.0e6, 4000.0e6, 500.0e6, 8000.0e6,  8},  // 7Series,     GTHE2, 1,        *
    {1600.0e6, 5160.0e6, 500.0e6, 10312.5e6, 8},  // 7Series,     GTHE2, 2/2L,     *
    {1600.0e6, 5160.0e6, 500.0e6, 10312.5e6, 8},  // 7Series,     GTHE2, 3,        *
    {2000.0e6, 4250.0e6, 500.0e6, 8500.0e6,  8},  // Ultrascale,  GTHE3, 1/1LV,    *
    {2000.0e6, 6250.0e6, 500.0e6, 12500.0e6, 8},  // Ultrascale,  GTHE3, 1H/2/3,   FF/FL
    {2000.0e6, 6250.0e6, 500.0e6, 12500.0e6, 8},  // Ultrascale,  GTHE3, 2/3,      FB
    {2000.0e6, 4250.0e6, 500.0e6, 8500.0e6,  8},  // Ultrascale,  GTYE3, 1,        *
    {2000.0e6, 6250.0e6, 500.0e6, 12500.0e6, 8},  // Ultrascale,  GTYE3, 1H/2/3,   *
    {2000.0e6, 4250.0e6, 500.0e6, 8500.0e6,  8},  // Ultrascale+, GTHE4, 1LV,      *
    {2000.0e6, 4250.0e6, 500.0e6, 8500.0e6,  8},  // Ultrascale+, GTHE4, 1/1L/2LV, *
    {2000.0e6, 6250.0e6, 500.0e6, 12500.0e6, 8},  // Ultrascale+, GTHE4, 2/2L/3,   *
};

Innovative::JESD_PHY::MgtPllRangesType MgtQPLL0Ranges[] = {
    {0.0,       0.0,       0.0,       0.0,       0},   // 7Series,     GTXE2, 1,        FF/RF
    {0.0,       0.0,       0.0,       0.0,       0},   // 7Series,     GTXE2, 1,        FB/SB/RB
    {9800.0e6,  10312.5e6, 612.5e6,   10312.5e6, 16},  // 7Series,     GTXE2, 2/2L,     FF/RF
    {9800.0e6,  10312.5e6, 612.5e6,   5156.25e6, 16},  // 7Series,     GTXE2, 2/2L,     FB/SB/RB
    {9800.0e6,  12500.0e6, 612.5e6,   12500.0e6, 16},  // 7Series,     GTXE2, 3,        FF
    {9800.0e6,  12500.0e6, 612.5e6,   6250.0e6,  16},  // 7Series,     GTXE2, 3,        FB/SB
    {0.0,       0.0,       0.0,       0.0,       0},   // 7Series,     GTHE2, 1,        *
    {11850.0e6, 12500.0e6, 740.625e6, 6250.0e6,  16},  // 7Series,     GTHE2, 2/2L,     *
    {11850.0e6, 13100.0e6, 740.625e6, 13100.0e6, 16},  // 7Series,     GTHE2, 3,        *
    {9800.0e6,  16375.0e6, 612.5e6,   12500.0e6, 16},  // Ultrascale,  GTHE3, 1/1LV,    *
    {9800.0e6,  16375.0e6, 612.5e6,   16375.0e6, 16},  // Ultrascale,  GTHE3, 1H/2/3,   FF/FL
    {9800.0e6,  16375.0e6, 612.5e6,   12500.0e6, 16},  // Ultrascale,  GTHE3, 2/3,      FB
    {9800.0e6,  16375.0e6, 612.5e6,   12500.0e6, 16},  // Ultrascale,  GTYE3, 1,        *
    {9800.0e6,  16375.0e6, 612.5e6,   16375.0e6, 16},  // Ultrascale,  GTYE3, 1H/2/3,   *
    {9800.0e6,  16375.0e6, 612.5e6,   10312.5e6, 16},  // Ultrascale+, GTHE4, 1LV,      *
    {9800.0e6,  16375.0e6, 612.5e6,   12500.0e6, 16},  // Ultrascale+, GTHE4, 1/1L/2LV, *
    {9800.0e6,  16375.0e6, 612.5e6,   16375.0e6, 16},  // Ultrascale+, GTHE4, 2/2L/3,   *
};

Innovative::JESD_PHY::MgtPllRangesType MgtQPLL1Ranges[] = {
    {5930.0e6, 8000.0e6,  741.25e6, 8000.0e6,  8},   // 7Series,     GTXE2, 1,        FF/RF
    {5930.0e6, 8000.0e6,  741.25e6, 6600.0e6,  8},   // 7Series,     GTXE2, 1,        FB/SB/RB
    {5930.0e6, 8000.0e6,  741.25e6, 8000.0e6,  8},   // 7Series,     GTXE2, 2/2L,     FF/RF
    {5930.0e6, 8000.0e6,  741.25e6, 6600.0e6,  8},   // 7Series,     GTXE2, 2/2L,     FB/SB/RB
    {5930.0e6, 8000.0e6,  741.25e6, 8000.0e6,  8},   // 7Series,     GTXE2, 3,        FF
    {5930.0e6, 8000.0e6,  741.25e6, 6600.0e6,  8},   // 7Series,     GTXE2, 3,        FB/SB
    {8000.0e6, 8500.0e6,  500.0e6,  8500.0e6,  16},  // 7Series,     GTHE2, 1,        *
    {8000.0e6, 11850.0e6, 500.0e6,  11300.0e6, 16},  // 7Series,     GTHE2, 2/2L,     *
    {8000.0e6, 11850.0e6, 500.0e6,  11850.0e6, 16},  // 7Series,     GTHE2, 3,        *
    {8000.0e6, 13000.0e6, 500.0e6,  12500.0e6, 16},  // Ultrascale,  GTHE3, 1/1LV,    *
    {8000.0e6, 13000.0e6, 500.0e6,  13000.0e6, 16},  // Ultrascale,  GTHE3, 1H/2/3,   FF/FL
    {8000.0e6, 13000.0e6, 500.0e6,  12500.0e6, 16},  // Ultrascale,  GTHE3, 2/3,      FB
    {8000.0e6, 13000.0e6, 500.0e6,  12500.0e6, 16},  // Ultrascale,  GTYE3, 1,        *
    {8000.0e6, 13000.0e6, 500.0e6,  13000.0e6, 16},  // Ultrascale,  GTYE3, 1H/2/3,   *
    {8000.0e6, 13000.0e6, 500.0e6,  10312.5e6, 16},  // Ultrascale+, GTHE4, 1LV,      *
    {8000.0e6, 13000.0e6, 500.0e6,  12500.0e6, 16},  // Ultrascale+, GTHE4, 1/1L/2LV, *
    {8000.0e6, 13000.0e6, 500.0e6,  13000.0e6, 16},  // Ultrascale+, GTHE4, 2/2L/3,   *
};

Innovative::JESD_PHY::MgtRefclkRangeType MgtRefclkRanges[] = {
    {60.0e6, 670.0e6},  // 7Series,     GTXE2, 1/1M,     FF/RF
    {60.0e6, 670.0e6},  // 7Series,     GTXE2, 1,        FB/SB/RB
    {60.0e6, 670.0e6},  // 7Series,     GTXE2, 2/2L,     FF/RF
    {60.0e6, 670.0e6},  // 7Series,     GTXE2, 2/2L,     FB/SB/RB
    {60.0e6, 700.0e6},  // 7Series,     GTXE2, 3,        FF
    {60.0e6, 700.0e6},  // 7Series,     GTXE2, 3,        FB/SB
    {60.0e6, 820.0e6},  // 7Series,     GTHE2, 1,        *
    {60.0e6, 820.0e6},  // 7Series,     GTHE2, 2/2L,     *
    {60.0e6, 820.0e6},  // 7Series,     GTHE2, 3,        *
    {60.0e6, 820.0e6},  // Ultrascale,  GTHE3, 1/1LV,    *
    {60.0e6, 820.0e6},  // Ultrascale,  GTHE3, 1H/2/3,   FF/FL
    {60.0e6, 820.0e6},  // Ultrascale,  GTHE3, 2/3,      FB
    {60.0e6, 820.0e6},  // Ultrascale,  GTYE3, 1,        *
    {60.0e6, 820.0e6},  // Ultrascale,  GTYE3, 1H/2/3,   *
    {60.0e6, 820.0e6},  // Ultrascale+, GTHE4, 1LV,      *
    {60.0e6, 820.0e6},  // Ultrascale+, GTHE4, 1/1L/2LV, *
    {60.0e6, 820.0e6},  // Ultrascale+, GTHE4, 2/2L/3,   *
};

}  // nameless namespace

namespace Innovative
{

#ifdef _MSC_VER
    #pragma warning(push)
    #pragma warning(disable : 4355)
#endif

//---------------------------------------------------------------------------
//  JESD_PHY::LoadFpgaMgtPllRanges() -- Load the FPGA MGT PLL ranges
//---------------------------------------------------------------------------

void  JESD_PHY::LoadFpgaMgtPllRanges()
{
    unsigned int idx;

    if (FpgaType == ft7Series && FpgaMgtType == fmtGTXE2)
        {
        if (     FpgaSpeedGrade == fsg1   && FpgaPackage == fpFF)     idx = 0;
        else if (FpgaSpeedGrade == fsg1   && FpgaPackage == fpRF)     idx = 0;
        else if (FpgaSpeedGrade == fsg1   && FpgaPackage == fpFB)     idx = 1;
        else if (FpgaSpeedGrade == fsg1   && FpgaPackage == fpSB)     idx = 1;
        else if (FpgaSpeedGrade == fsg1   && FpgaPackage == fpRB)     idx = 1;
        else if (FpgaSpeedGrade == fsg2   && FpgaPackage == fpFF)     idx = 2;
        else if (FpgaSpeedGrade == fsg2   && FpgaPackage == fpRF)     idx = 2;
        else if (FpgaSpeedGrade == fsg2L  && FpgaPackage == fpFF)     idx = 2;
        else if (FpgaSpeedGrade == fsg2L  && FpgaPackage == fpRF)     idx = 2;
        else if (FpgaSpeedGrade == fsg2   && FpgaPackage == fpFB)     idx = 3;
        else if (FpgaSpeedGrade == fsg2   && FpgaPackage == fpSB)     idx = 3;
        else if (FpgaSpeedGrade == fsg2   && FpgaPackage == fpRB)     idx = 3;
        else if (FpgaSpeedGrade == fsg2L  && FpgaPackage == fpFB)     idx = 3;
        else if (FpgaSpeedGrade == fsg2L  && FpgaPackage == fpSB)     idx = 3;
        else if (FpgaSpeedGrade == fsg2L  && FpgaPackage == fpRB)     idx = 3;
        else if (FpgaSpeedGrade == fsg3   && FpgaPackage == fpFF)     idx = 4;
        else if (FpgaSpeedGrade == fsg3   && FpgaPackage == fpFB)     idx = 5;
        else if (FpgaSpeedGrade == fsg3   && FpgaPackage == fpSB)     idx = 5;
        else
            {
            Debug.Log("No 7Series GTXE2 speed grade and package type match found, defaulting to -1 speed grade in FF package");
            idx            = 0;
            FpgaSpeedGrade = fsg1;
            FpgaPackage    = fpFF;
            }
        }
    else if (FpgaType == ft7Series && FpgaMgtType == fmtGTHE2)
        {
        if (     FpgaSpeedGrade == fsg1)                              idx = 6;
        else if (FpgaSpeedGrade == fsg2)                              idx = 7;
        else if (FpgaSpeedGrade == fsg2L)                             idx = 7;
        else if (FpgaSpeedGrade == fsg3)                              idx = 8;
        else
            {
            Debug.Log("No 7Series GTHE2 speed grade and package type match found, defaulting to -1 speed grade in FF package");
            idx            = 6;
            FpgaSpeedGrade = fsg1;
            FpgaPackage    = fpFF;
            }
        }
    else if (FpgaType == ftUltrascale && FpgaMgtType == fmtGTHE3)
        {
        if (     FpgaSpeedGrade == fsg1)                              idx = 9;
        else if (FpgaSpeedGrade == fsg1LV)                            idx = 9;
        else if (FpgaSpeedGrade == fsg1H  && FpgaPackage == fpFF)     idx = 10;
        else if (FpgaSpeedGrade == fsg2   && FpgaPackage == fpFF)     idx = 10;
        else if (FpgaSpeedGrade == fsg3   && FpgaPackage == fpFF)     idx = 10;
        else if (FpgaSpeedGrade == fsg1H  && FpgaPackage == fpFL)     idx = 10;
        else if (FpgaSpeedGrade == fsg2   && FpgaPackage == fpFL)     idx = 10;
        else if (FpgaSpeedGrade == fsg3   && FpgaPackage == fpFL)     idx = 10;
        else if (FpgaSpeedGrade == fsg2   && FpgaPackage == fpFB)     idx = 11;
        else if (FpgaSpeedGrade == fsg3   && FpgaPackage == fpFB)     idx = 11;
        else
            {
            Debug.Log("No UltraScale GTHE3 speed grade and package type match found, defaulting to -1 speed grade in FF package");
            idx            = 9;
            FpgaSpeedGrade = fsg1;
            FpgaPackage    = fpFF;
            }
        }
    else if (FpgaType == ftUltrascale && FpgaMgtType == fmtGTYE3)
        {
        if (     FpgaSpeedGrade == fsg1)                              idx = 12;
        else if (FpgaSpeedGrade == fsg1H)                             idx = 13;
        else if (FpgaSpeedGrade == fsg2)                              idx = 13;
        else if (FpgaSpeedGrade == fsg3)                              idx = 13;
        else
            {
            Debug.Log("No UltraScale GTYE3 speed grade and package type match found, defaulting to -1 speed grade in FF package");
            idx            = 12;
            FpgaSpeedGrade = fsg1;
            FpgaPackage    = fpFF;
            }
        }
    else if (FpgaType == ftUltrascalePlus && FpgaMgtType == fmtGTHE4)
        {
        if (     FpgaSpeedGrade == fsg1LV)                            idx = 14;
        else if (FpgaSpeedGrade == fsg1)                              idx = 15;
        else if (FpgaSpeedGrade == fsg1L)                             idx = 15;
        else if (FpgaSpeedGrade == fsg2LV)                            idx = 15;
        else if (FpgaSpeedGrade == fsg2)                              idx = 16;
        else if (FpgaSpeedGrade == fsg2L)                             idx = 16;
        else if (FpgaSpeedGrade == fsg3)                              idx = 16;
        else
            {
            Debug.Log("No UltraScale+ GTHE4 speed grade and package type match found, defaulting to -1 speed grade in FF package");
            idx            = 15;
            FpgaSpeedGrade = fsg1;
            FpgaPackage    = fpFF;
           }
        }
    else
        {
        Debug.Log("No FPGA type match found, defaulting to 7Series GTXE2 -1 speed grade in FF package");
        idx            = 0;
        FpgaType       = ft7Series;
        FpgaMgtType    = fmtGTXE2;
        FpgaSpeedGrade = fsg1;
        FpgaPackage    = fpFF;
        }

    CPLLRange = MgtCPLLRanges[idx];
    QPLLRange[0] = MgtQPLL0Ranges[idx];
    QPLLRange[1] = MgtQPLL1Ranges[idx];
    MgtRefclkRange = MgtRefclkRanges[idx];

    std::stringstream msg;
    msg << "FPGA MGT CPLL VCO range (GHz) = " << (CPLLRange.VcoLow/1.0e9) << " - " << (CPLLRange.VcoHigh/1.0e9);
    Debug.Log(msg.str());
    msg.str("");
    msg << "FPGA MGT CPLL line rate range (Gbps) = " << (CPLLRange.LineRateLow/1.0e9) << " - " << (CPLLRange.LineRateHigh/1.0e9);
    Debug.Log(msg.str());
    msg.str("");

    std::string QPLL0;
    std::string QPLL1;
    if (FpgaType == ft7Series)
        {
        QPLL0 = "FPGA MGT Upper band QPLL";
        QPLL1 = "FPGA MGT Lower band QPLL";
        }
    else if (FpgaType == ftUltrascale)
        {
        QPLL0 = "FPGA MGT QPLL0";
        QPLL1 = "FPGA MGT QPLL1";
        }
    else
        {
        QPLL0 = "The unknown FPGA MGT QPLL0";
        QPLL1 = "The unknown FPGA MGT QPLL1";
        }

    msg << QPLL0 << " VCO range (GHz) = " << (QPLLRange[0].VcoLow/1.0e9) << " - " << (QPLLRange[0].VcoHigh/1.0e9);
    Debug.Log(msg.str());
    msg.str("");
    msg << QPLL0 << " line rate range (Gbps) = " << (QPLLRange[0].LineRateLow/1.0e9) << " - " << (QPLLRange[0].LineRateHigh/1.0e9);
    Debug.Log(msg.str());
    msg.str("");
    msg << QPLL1 << " VCO range (GHz) = " << (QPLLRange[1].VcoLow/1.0e9) << " - " << (QPLLRange[1].VcoHigh/1.0e9);
    Debug.Log(msg.str());
    msg.str("");
    msg << QPLL1 << " line rate range (Gbps) = " << (QPLLRange[1].LineRateLow/1.0e9) << " - " << (QPLLRange[1].LineRateHigh/1.0e9);
    Debug.Log(msg.str());
    msg.str("");
    msg << "FPGA MGT REFCLK range (MHz) = " << (MgtRefclkRange.Low/1.0e6) << " - " << (MgtRefclkRange.High/1.0e6);
    Debug.Log(msg.str());
    msg.str("");
}

}  // namespace Innovative
