// JtagLoadBase_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef JtagLoadBase_MbH
#define JtagLoadBase_MbH

namespace   Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//==============================================================================
//  CLASS JtagLoadBase -- Virtex JTAG EEPROM programmer interface base class
//==============================================================================

class JtagLoadBase
{
public:
    JtagLoadBase()
        {  }

    // Methods
    // Pulse the PROG pin
    virtual void            Program(bool state) = 0;
    // Return state of INIT
    virtual bool            IsInit() = 0;
    // Return state of DONE
    virtual bool            IsDone() = 0;
    // Return state of DONE
    virtual void            Load(char * buffer, int count) = 0;

    // Optional:  Reset the logic device
    virtual void            Reset()
        {  }
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative

#endif
