//---------------------------------------------------------------------------
// K7Board_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2012 Innovative Integration Corporation.
//  All Rights Reserved.
//


#include <K7Board_Mb.h>

namespace Innovative
{

#ifdef _MSC_VER
    #pragma warning(push)
    #pragma warning(disable : 4355)
#endif

//===========================================================================
//  CLASS K7Board  -- K7 Common baseboard class
//===========================================================================
//---------------------------------------------------------------------------
//  constructor for class K7Board
//---------------------------------------------------------------------------

K7Board::K7Board(K7DeviceMap & deviceMap)
    :  FmcCarrierBoard(deviceMap),
       K7DeviceRef(deviceMap)
{
}

//---------------------------------------------------------------------------
//  destructor for class K7Board
//---------------------------------------------------------------------------

K7Board::~K7Board()
{
    // Don't call anything using K7DeviceRef here - put in most derived class
}

//---------------------------------------------------------------------------
//  K7Board::Uart() - access UARTs on K7
//---------------------------------------------------------------------------

IMulticharUart & K7Board::Uart(unsigned int device)
{
    return K7DeviceRef.Uart(device);
}

//---------------------------------------------------------------------------
//  K7Board::Selector() - access K7 clock/PPS selector muxes
//---------------------------------------------------------------------------

IK7SourceSelector &  K7Board::Selector()
{
    return K7DeviceRef.Selector();
}

//---------------------------------------------------------------------------
//  K7Board::IdRom() --
//---------------------------------------------------------------------------

IK7_IdRom & K7Board::IdRom()
{
    return K7DeviceRef.IdRom();
}


#ifdef _MSC_VER
    #pragma warning(pop)
#endif


}  // namespace Innovative
