// K7Board_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2012 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef K7Board_MbH
#define K7Board_MbH

#include <FmcCarrierBoard_Mb.h>
#include <K7DeviceMap_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS K7Board  -- K7 Common baseboard class
//===========================================================================

class K7Board : public FmcCarrierBoard
{

public:
    //
    //  Member Functions
    K7Board(K7DeviceMap & deviceMap);
    virtual ~K7Board();

    //  Informational Methods
    IMulticharUart &     Uart(unsigned int device);
    IK7SourceSelector &  Selector();

    IK7_IdRom &          IdRom();
    K7DioPortIntf &      Gpio()       {  return K7DeviceRef.Gpio();  }


public: //Pseudo protected

     // FPGA type name function
      std::string FpgaName(const short Number)
      {
          switch(Number)
          {
           case 0x00: return "N/A";
           case 0x01: return "325T";
           case 0x02: return "410T";
           default: return "Unknown";
          }
      }



protected:
    //
    //  Member Data
    K7DeviceMap &                  K7DeviceRef;

};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative

#endif

