//  K7SysMemoryMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2013  Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef K7SysMemoryMap_MbH
#define K7SysMemoryMap_MbH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace K7Sys_MemoryMap
{
    //
    //  Logic Memory Register Offsets
    //
    //  K7System Unit "Standard" WB section offsets
    const unsigned int  wbPeripheral     = 0x000;
    const unsigned int  wbLogicLoader    = 0x100;
    const unsigned int  wbTempControl    = 0x200;
    const unsigned int  wbLCD            = 0x300;
    //const unsigned int  wb???            = 0x400;
    //const unsigned int  wb???            = 0x500;
    const unsigned int  wbROM            = 0x600;
    const unsigned int  wbUart           = 0x700;
    const unsigned int  wbIRIG           = 0x800;
    const unsigned int  wbIeee1588       = 0x900;
    //
    //  K7System Wishbone offsets
    //
    //  WB0 - Peripheral Registers
    const unsigned int  mmInformation           = 0x00;
    const unsigned int  mmReset                 = 0x01;
    const unsigned int  mmSubrevision           = 0x02;
    const unsigned int  mmExtIo                 = 0x03;
    const unsigned int  mmFpgaPower             = 0x04;
    const unsigned int  mmSsdPower              = 0x05;
    const unsigned int  mmK7Config              = 0x06;
    const unsigned int  mmTempSensorI2C         = 0x07;
    const unsigned int  mmPpsInput              = 0x08;
    const unsigned int  mmVbatInput             = 0x09;
    const unsigned int  mmCustomIntSrc          = 0x0a;
                                            //  = 0x0b;
    const unsigned int  mmExtIoDirection        = 0x0c;
    const unsigned int  mmLTC_SPI_Control       = 0xd;
    const unsigned int  mmLTC_SPI_Stat          = 0xe;
    //
    //  WB1 - Vsprom Loader Registers
    const unsigned int  mmVsProm_ControlAddr    = 0x00;
    const unsigned int  mmVsProm_Data           = 0x01;
    const unsigned int  mmVsProm_Opcode         = 0x02;
    //
    //  WB2 - Thermal Registers
    const unsigned int  mmTemp_TempControl      = 0x00;
    const unsigned int  mmTemp_FanThreshold     = 0x01;
    const unsigned int  mmTemp_AlertThreshold   = 0x02;
    const unsigned int  mmTemp_CommandChannel   = 0x03;
    //
    //  WB3 - LCD Registers
    const unsigned int  mmLcdWdata              = 0x00;
    const unsigned int  mmLcdRdata              = 0x01;
    const unsigned int  mmLcdSLWdata            = 0x02;
    //
    //  WB6 - Serial Flash Rom
    const unsigned int  mmRom_AddrCtl           = 0x00;
    const unsigned int  mmRom_Data              = 0x01;
    const unsigned int  mmRom_Opcode            = 0x02;
    //
    //  WB7 - UART
    const unsigned int  mmUart0_Ctl             = 0x00;
    const unsigned int  mmUart0_Tx              = 0x01;
    const unsigned int  mmUart0_Rx              = 0x02;
    const unsigned int  mmUart1_Ctl             = 0x03;
    const unsigned int  mmUart1_Tx              = 0x04;
    const unsigned int  mmUart1_Rx              = 0x05;
    const unsigned int  mmUart2_Ctl             = 0x06;
    const unsigned int  mmUart2_Tx              = 0x07;
    const unsigned int  mmUart2_Rx              = 0x08;
    const unsigned int  mmUart_Mode             = 0x09;
    const unsigned int  mmUart_IntStatus        = 0x0a;
    const unsigned int  mmUart_PpsArm           = 0x0b;
    //
    //  WB8 - IRIG
    const unsigned int  mmIrig_Date             = 0x00;
    const unsigned int  mmIrig_FracSecs         = 0x01;
    const unsigned int  mmIrig_DdsCtrl          = 0x02;
    const unsigned int  mmIrig_SpiCtrl          = 0x03;
    const unsigned int  mmIrig_SpiData          = 0x04;
    const unsigned int  mmIrig_DesiredClks      = 0x05;
    const unsigned int  mmIrig_FreqTuning       = 0x06;
    //
    //  WB9 - IEEE 1588
    const unsigned int  mm1588_Ctrl             = 0x00;
    const unsigned int  mm1588_ClkId_Lo         = 0x01;
    const unsigned int  mm1588_ClkId_Hi         = 0x02;
    const unsigned int  mm1588_Time             = 0x03;
    const unsigned int  mm1588_EEPromI2C        = 0x04;
    const unsigned int  mm1588_Uart_Ctl         = 0x05;
    const unsigned int  mm1588_Uart_Tx          = 0x06;
    const unsigned int  mm1588_Uart_Rx          = 0x07;
    const unsigned int  mm1588_Int              = 0x08;
    const unsigned int  mm1588_Arm              = 0x09;
    //
    //  Port Memory Register Offsets
    // Interrupts
    const unsigned int  mmInterruptStatus     = 0x19000;
    const unsigned int  mmInterruptEnable     = 0x14400;
    //  Pci
    const unsigned int  mmPciVersion          = 0x15c00;
    const unsigned int  mmPciControl          = 0x19400;
//    const unsigned int  mmEpcStatus           = 0x19800;

} // end namespace K7Sys_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
