// K7_SbcDeviceMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2011 Innovative Integration Corporation.
//  All Rights Reserved.
//


#ifndef K7_SbcDeviceMap_MbH
#define K7_SbcDeviceMap_MbH

#include <K7_Sbc_Mb.h>
#include <K7DeviceMap_Mb.h>
#include <Trace_Mb.h>

namespace Innovative
{

#ifdef __CLR_VER
#pragma managed(push, off)
#endif

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4355)
#endif

class K7_SbcDeviceMap;

//===========================================================================
//  CLASS K7_SbcDeviceMap  -- Register & low level support for K7_Sbc module
//===========================================================================
class K7_Sbc;

class K7_SbcDeviceMap :  public K7DeviceMap

{
    friend class K7_Sbc;
    
public:
    //
    //  Member Functions
    K7_SbcDeviceMap(K7_Sbc * owner);
    virtual ~K7_SbcDeviceMap();

public: // pseudo-protected
    virtual void  OpenHardware();

    //  Subdevice Customization Handlers

    virtual unsigned int GetVeloInStreamCount();
    virtual unsigned int GetVeloOutStreamCount();
    virtual unsigned int GetVeloOutCommandStreamCount();

	virtual IIsAVitaPacketStreamBoard *   GetBaseboardPtr();
	virtual unsigned int                  GetPatternModeAlignment();
	virtual unsigned int                  GetPatternModeScaleFactor();
	virtual bool                          GetPatternModeSingleMemoryFlag();

protected:
    // Data
    K7_Sbc *           Owner;
    
public:
    Trace               Debug;

protected:
    // Methods
    void  OnStreamPreconfigHandler(OpenWire::NotifyEvent & Event);
    void  OnStreamSingleTimeAtStartConfigHandler(OpenWire::NotifyEvent & Event);
    void  OnStreamConfigureHandler(OpenWire::NotifyEvent & Event);
    void  OnBeforeStreamStartHandler(OpenWire::NotifyEvent & Event);
    void  OnAfterStreamStartHandler(OpenWire::NotifyEvent & Event);
    void  OnBeforeStreamStopHandler(OpenWire::NotifyEvent & Event);
    void  OnAfterStreamStopHandler(OpenWire::NotifyEvent & Event);
};

#ifdef _MSC_VER
    #pragma warning(pop)
#endif

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // Innovative
//---------------------------------------------------------------------------
#endif
