// K7_Sbc_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2011 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef K7_Sbc_MbH
#define K7_Sbc_MbH

#include <K7Board_Mb.h>
#include <K7_SbcDeviceMap_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS K7_Sbc  -- K7_Sbc PCI Express baseboard object
//===========================================================================

class K7_Sbc : public K7Board
{

public:
    //
    //  Member Functions
    K7_Sbc();
    virtual ~K7_Sbc();

    // Methods
//  ...Currently no base class override needed
//    virtual void                Open();
//    virtual void                Close();
//    virtual void                Reset();

    // Device access methods

public: //Pseudo protected

protected:
    //
    //  Member Data
    K7_SbcDeviceMap             Device;

    //  Ficl Interface
    virtual void    AfterFiclStart(FiclSystem & engine);

    virtual int     Do_DFetch(int dev, int addr);
    virtual void    Do_DStore(int dev, int addr, int value);
    virtual void    Do_DFreq(int dev, float freq);
    virtual float   Do_DFreqActual(int dev);
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative

#endif

