//
//  Kernel_Mb.h   Universal Kernel processing routines for II Cards
//

#ifndef Kernel_MbH
#define Kernel_MbH

#include <KernelTypes_Mb.h>

namespace InnovativeKernel
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

#ifdef _MSC_VER
  #ifdef _USRDLL
    #define II_DllExport   __declspec( dllexport )
  #else
    #define II_DllExport   __declspec( dllimport )
  #endif
#else
  #define II_DllExport
#endif

//------------------------------------------------------------------------------
//  struct DEVICE_EXTENSION -- Device Driver Extension Block
//------------------------------------------------------------------------------

const int QUEUE_DEPTH = 128;

struct DEVICE_EXTENSION
{
    int     nHeadCount;
    int     nTailCount;
    DWORD   Queue[ QUEUE_DEPTH + 1 ];
    DWORD   IntStatusMask;
    DWORD   IntStatusOffsetBytes;
    DWORD   IntStatusRegionIdx;
};
//---------------------------------------------------------------------------
bool II_DllExport InstallKernelRoutines( HWDEVICE *mHwDevice, KernelIsrType type );
//---------------------------------------------------------------------------

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace InnovativeKernel
#endif
