#ifndef LICENSELOADERINTERFACE_H
#define LICENSELOADERINTERFACE_H

namespace IILicenseLoaderNS {

// License Loader Interface
struct ILicenseLoader
{
    ILicenseLoader() {}
    virtual ~ILicenseLoader() {}

    virtual bool Load()                  = 0;
    virtual int  Version()               = 0;
    virtual const char *LicenseVersion() = 0;
};

#if (defined(_WIN32) || defined(_WIN64)) && !defined(GCC)
#    ifdef LIBRARY_EXPORTS
#        define LIBRARY_API extern "C" __declspec(dllexport)
#    else
#        define LIBRARY_API extern "C" __declspec(dllimport)
#    endif
#else
#    define LIBRARY_API extern "C"
#endif

LIBRARY_API ILicenseLoader* CreateLicenseLoader(HANDLE h, const char *ver);

LIBRARY_API bool SimpleLoader(HANDLE h, const char *ver);

LIBRARY_API int SimpleVersion();

typedef ILicenseLoader* (*CreateLicenseLoader_t)(HANDLE h, const char *ver);

typedef bool (*SimpleLoader_t)(HANDLE h, const char *ver);

} // namespace IILicenseLoaderNS

#endif // LICENSELOADERINTERFACE_H
