// LinearRegression_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef LinearRegression_Mb_H
#define LinearRegression_Mb_H

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class LinearRegression 
{
    int DataPoints;
    int slopeCacheValid;
    float slopeCacheValue;
    float sumX;
    float sumY;
    float sumXX;
    float sumXY;

public:
    LinearRegression() 
    {
        DataPoints = 0;
        sumX = 0;
        sumY = 0;
        sumXX = 0;
        sumXY = 0;
        slopeCacheValid = false;
        slopeCacheValue = 0;
    }

    void addDataPoint(float newX, float newY) 
    {
        sumX += newX;
        sumY += newY;
        sumXX += (newX * newX);
        sumXY += (newX * newY);
        DataPoints += 1;
        slopeCacheValid = false;
    }

    float getSlope() 
    {
        if (slopeCacheValid == false) 
        	{
            float partA, partB;

            partA = (DataPoints * sumXY) - (sumX * sumY);
            partB = (DataPoints * sumXX) - (sumX * sumX);
            if (partB == 0.0f) 
            	{
                slopeCacheValue = 0;
            	} 
            else 
            	{
                slopeCacheValue = (partA / partB);
            	}
            slopeCacheValid = true;
        	}
        return slopeCacheValue;
	};

    float getIntercept() 
    	{  return (sumY - (this->getSlope()*sumX)) / DataPoints;  }
};

}; // Innovative
//---------------------------------------------------------------------------

#endif // LinearRegression_Mb_H