// LoadMsgEvent_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef LoadMsgEvent_MbH
#define LoadMsgEvent_MbH

#include <Events_Mb.h>
#include <string>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//=============================================================================
//  CLASS LoadMsgEvent  --  
//=============================================================================

class LoadMsgEvent : public OpenWire::Event
{
public:
    std::string Msg;

public:
    LoadMsgEvent( std::string msg )
        : Msg( msg )
        {
        }
};

//=============================================================================
//  CLASS DownloadProgressEvent  --
//=============================================================================

class DownloadProgressEvent : public OpenWire::Event
{
public:
    const unsigned int BytesCompleted;
    const unsigned int TotalBytes;
    const float Percent;

public:
    DownloadProgressEvent(unsigned int bytes_completed, unsigned int total_bytes,
                          float percent )
        :  BytesCompleted( bytes_completed ),
           TotalBytes( total_bytes ),
           Percent( percent )
        {
        }

};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
