// Lock_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef Lock_MbH
#define Lock_MbH

#include <Mutex_Mb.h>


namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//=============================================================================
//  CLASS Lock  --  
//=============================================================================

class Lock
{

public:
    Lock();

    void EnterRead();
    void LeaveRead();
    void EnterWrite();
    void LeaveWrite();

private:
    Mutex           Read;
    Mutex           Write;
};

//=============================================================================
//  CLASS ReadSection  --
//=============================================================================

class ReadSection
{
public:
    ReadSection( Lock &lock )
        : mLock(lock)
        {  mLock.EnterRead();  }

    ~ReadSection()
        {  mLock.LeaveRead();  }

protected:
    Lock &mLock;
};

//=============================================================================
//  CLASS WriteSection  --
//=============================================================================

class WriteSection
{
public:
    WriteSection( Lock &lock )
        : mLock(lock)
        {  mLock.EnterWrite();  }

    ~WriteSection()
        {  mLock.LeaveWrite();  }

protected:
    Lock &mLock;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative

#endif
