//---------------------------------------------------------------------------
// M6713DeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include "M6713DeviceDriver_Mb.h"

//---------------------------------------------------------------------------

//
//  Nameless namespace for 'static' data
namespace
{
//------------------------------------------------
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   M67IntStatusMask        = 0xF;
const unsigned int   M67IntStatusByteAddress = 0x64000;
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "M6713DRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x000b
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
        "M6713",      TARGET_BASE,         0x1303,      0x000b,     0x00,        false);
    }
};

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS M6713DeviceDriver  -- Driver level code for M6713 baseboard
//===========================================================================

InnovativeKernel::IsrLog * M6713DeviceDriver::LOG = 0;

//---------------------------------------------------------------------------
//  constructor for class M6713DeviceDriver
//---------------------------------------------------------------------------

M6713DeviceDriver::M6713DeviceDriver()
    :  InnovativeKernel::DualRegionDeviceDriver(
                            InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID),
                            M67IntStatusByteAddress,
                            M67IntStatusMask)
{
    //  Save static pointer to log info
    LOG = & mIsrInfo;
}

//---------------------------------------------------------------------------
}; // Innovative

