// M6713DeviceMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//


#ifndef M6713DeviceMap_MbH
#define M6713DeviceMap_MbH


#include <PacketDeviceMap_Mb.h>
#include <vector>
#include <ProcessEvents_Mb.h>
#include <VirtexFpgaLoader_Mb.h>
#include <BaseboardCpuInterfaces_Mb.h>
#include <PacketDeviceImpl_Mb.h>
#include <FpgaLogicVersionInfo_Mb.h>
#include <PciLogicVersionInfo_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class M6713;
class M6713DeviceDriver;
class M6713DeviceMap;
class Event;
class PmcBuffer;

//===========================================================================
//  CLASS M6713DeviceMap  -- Register & low level support for M6713
//===========================================================================

class M6713DeviceMap :  public PacketDeviceImpl,
                        public PacketDeviceMap,
                        public IUsesVirtexFpgaLoader,
                        public IUsesStandardHpiCpu,
                        public IUsesNullFpgaLogicVersionInfo,
                        public IUsesNullPciLogicVersionInfo,
						public IUsesHpiControl
{
    friend class M6713;

public:
    //
    //  Member Functions
    M6713DeviceMap(M6713 * owner);
    virtual ~M6713DeviceMap();

    void  OpenHardware();

    void  LocalLoopbackMode(bool state);

protected:

    M6713 *               Owner;
    M6713DeviceDriver *   DDeviceDriver;

    void  OnBeforeCoffLoadHandler(ProcessCompletionEvent & Event);
    void  OnStreamConfigureHandler(OpenWire::NotifyEvent & Event);
    void  OnBeforeStreamStartHandler(OpenWire::NotifyEvent & Event);
    void  OnAfterStreamStartHandler(OpenWire::NotifyEvent & Event);
    void  OnBeforeStreamStopHandler(OpenWire::NotifyEvent & Event);
    void  OnAfterStreamStopHandler(OpenWire::NotifyEvent & Event);

private:
    //
    //  Member Data
    // FPA Eeprom programmer
    class FpaLoadThread *              EepromLoader;
    class FpaLoader *                  FFpa;

public:
    int  RcvPacketSize;
    int  XmitPacketSize;

    void  DumpIsrStatus(std::vector<int> & vec);

protected:
    // HPI Support
	virtual void ResetBaseBoard();

    //
    //  Class PciTestRegister
    class PciTestRegister : public ShadowRegister
    {
        typedef ShadowRegister inherited;

    public:
        RegisterBit       TestModeEnable;
        RegisterBit       GenerateRxData;
        RegisterBit       LoopbackEnable;
        RegisterBit       ClearTxCredit;
        RegisterBit       ClearRxCredit;
        RegisterBit       DrainXmitData;
        RegisterBitGroup  GenPacketSize;
        RegisterBit       GenPacketSizeUpdate;

    public:
        PciTestRegister( AddressingSpace &space, int offset );
    };
    //
    //  ...Registers
    PciTestRegister                    PciTestControlReg;
    

};

#ifdef __CLR_VER
#pragma managed(pop)
#endif

}; // Innovative
//---------------------------------------------------------------------------
#endif
