// M6713_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef M6713_MbH
#define M6713_MbH


#include <LegacyBoard_Mb.h>
#include <DataTypes_Mb.h>
#include <ProcessEvents_Mb.h>
#include <M6713DeviceMap_Mb.h>
#include <BaseboardInterfaces_Mb.h>
#include <FpgaLogicVersionInfoIntf_Mb.h>
#include <PciLogicVersionInfoIntf_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class FpaLoadThread;

//===========================================================================
//  CLASS M6713  -- M6713 Base Board object
//===========================================================================

class M6713 :  public LegacyBoard,
               public IStreamDeviceEvents
{
    friend class M6713DeviceMap;
    
public:
    //
    //  Member Functions
    M6713();
    virtual ~M6713();

    size_t          BoardCount();
    void            Open();
    void            Close();

    void  LocalLoopbackMode(bool state) {  FLocalLoopbackMode = state;  };
    FpgaLogicVersionInfoIntf & UserLogicVersion();
    PciLogicVersionInfoIntf & PciLogicVersion();

    int   Target();
    void  Target( int value );

    bool  Led();
    void  Led( bool value );

    ii32  PeekLogic( int offset );
    void  PokeLogic( int offset, ii32 value );
    ii32  PeekPort( int offset );
    void  PokePort( int offset, ii32 value );

	void  BusMasterSize(int bytes);
	int   BusMasterSize() const;

	//
	// Logic programming
	IUsesVirtexFpgaLoader & Logic();
	// EEprom programming
	FpaLoadThread &         VsProm();
	// Coff loader
	IUsesOnboardHpiCpu &    Cpu();


public: // Pseudo-protected
    //  IPacketStreamDevice interface implementation
    virtual void  Reset();

    M6713DeviceMap * Debug() { return &Device; };
    virtual void   Log(int type, int data);

private:
    //
    //  Member Data
    M6713DeviceMap          Device;
    bool                    FLocalLoopbackMode;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative

#endif

