// Magic_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef Magic_MbH
#define Magic_MbH
#include <algorithm>

namespace Innovative
{

#ifdef __CLR_VER
#pragma managed(push, off)
#endif

// Population Count (Ones Count)
unsigned int Ones(unsigned int x);

// Log base 2 of integer (floored version)
unsigned int FloorLog2(register unsigned int x);

// Log base 2 of integer (ceiling version)
unsigned int CeilLog2(register unsigned int x);

// Next Largest Power of 2
unsigned int NextLargestPowerOfTwo(register unsigned int x);
unsigned int NextSmallestPowerOfTwo(register unsigned int x);

// Bit Reversal
unsigned int BitReverse(register unsigned int x);
unsigned short BitReverse(register unsigned short x);
unsigned char BitReverse(register unsigned char x);

// Most Significant 1 Bit
unsigned int MostSignificantOneBit(register unsigned int x);

// Trailing Zero Count
unsigned int TrailingZeroCount(register int x);

// Determining if the number is a power of 2
template<class T>
bool IsPowerOfTwo(T v)
{
    return !(v & (v - 1)) && v;
}

// Counting bits set
unsigned int BitsSet(unsigned int v);

// LogN() -- Logarithm of general base, n.
double LogN(double n, double x);

//  Gcd()  --  Return greatest common factor, binary Euclid's method for GCD
template<class T>
T Gcd(T u, T v)
{
    T g = 1;
    //	u is even and v is even
    while (!(u&1) && !(v&1))
        {
        u >>= 1;
        v >>= 1;
        g <<= 1;
        }

    // now a or b (or both) are odd
    while (u > 0)
        {
        if (!(u&1))
            u >>= 1;
        else if (!(v&1))
            v >>= 1;
        else
            {
            T t =  (u>v) ? u-v : v-u;
            t = t >> 1;
            if (u < v)
                v = t;
            else
                u = t;
            }
        }

    return g*v;
}


//  Lcm()  --  Return least common multiple
int Lcm(int a, int b);

//  RelativePrime()  --  Test for relative prime
bool RelativePrime(int a, int b);

// Rational approximation of a floating-point number
class RationalApproximation
{
public:
    RationalApproximation(float value, int bits);

    // Methods
    int     Numerator();
    int     Denominator();
    double  Ratio();

private:
    // Data
	double num[2];
    double den[2];
    double ratio;
    int range;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif  
