// MappedDataSet_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//
//---------------------------------------------------------------------------

#ifndef MappedDataSet_MbH
#define MappedDataSet_MbH

#include <DataSetBase_Mb.h>

namespace Innovative
{

#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class Impl;

//===========================================================================
// Class MappedDataSet
//===========================================================================

class MappedDataSet : public EventStreamDataSet
{
public:
	MappedDataSet();
	virtual ~MappedDataSet();

	// Properties
	void				AutoCreate(bool value)
		{  FAutoCreate=value;  }
	bool				AutoCreate() const
		{  return FAutoCreate;  }

protected:
    // Override Methods
	virtual bool        ImageOpen();
    virtual void        ImageClose();
	virtual void        ImageFetch(Subsample & sample);
	virtual void        ImageStore(Subsample & sample);
	virtual void        ImageSkip(ii64 offset);
	virtual void        ImageSeek(ii64 offset);
	virtual ii64     	ImageSize() const;
	virtual void        ImageSize(ii64 size);
	virtual void        ImageFlush();

private:
    // Data
    char *              Cache;              // Pointer to memory block
    ii64                Position;
    Impl *              pImpl;

    // Fields
    bool                FAutoCreate;        // Auto-create files on open fail
    ii64                FSize;              // Size of image, in bytes
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
