// MatadorDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2006 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <MatadorDeviceDriver_Mb.h>

//
//  Nameless namespace for 'static' data
namespace
{
//------------------------------------------------
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   MatadorIntStatusMask        = 0x67FF;
const unsigned int   MatadorIntStatusByteAddress = 0x64000;
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "MATADORDRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x0006

//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterMatadorBoardTypes -- 
//==============================================================================

class RegisterMatadorBoardTypes
{

public:
    RegisterMatadorBoardTypes()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID    Device ID   Sub ID    CheckSubID
        "Vista",      "MATADORDRV",         0x1303,      0x0006,     0x20,       true);
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID    Device ID   Sub ID    CheckSubID
        "Toro",       "MATADORDRV",         0x1303,      0x0006,      0x40,       true);
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID    Device ID   Sub ID    CheckSubID
        "Conejo",     "MATADORDRV",         0x1303,      0x0006,      0x60,       true);
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID    Device ID   Sub ID    CheckSubID
        "Delfin",     "MATADORDRV",         0x1303,      0x0006,      0x80,       true);
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID    Device ID   Sub ID    CheckSubID
        "Lobo",       "MATADORDRV",         0x1303,      0x0006,       0xa0,       true);
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID    Device ID   Sub ID    CheckSubID
        "Oruga",      "MATADORDRV",         0x1303,      0x0006,      0xc0,       true);
    }

};

RegisterMatadorBoardTypes   Registrator;


}  // namespace nameless

namespace Innovative
{
//===========================================================================
//  CLASS MatadorDeviceDriver  -- Driver level code for Matador baseboard
//===========================================================================

InnovativeKernel::IsrLog * MatadorDeviceDriver::MAT = 0;

//---------------------------------------------------------------------------
//  constructor for class MatadorDeviceDriver
//---------------------------------------------------------------------------

MatadorDeviceDriver::MatadorDeviceDriver()
    :  InnovativeKernel::SimpleBusMasterDeviceDriver(
                            InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID),
                            MatadorIntStatusByteAddress,
                            MatadorIntStatusMask)
{
    //  Save static pointer to log info
    MAT = & mIsrInfo;
}

} // namespace Innovative


