// MatadorMessageStream_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef MatadorMessageStream_MbH
#define MatadorMessageStream_MbH

#include <MatadorMessageSupport_Mb.h>
#include <Events_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS MatadorMessageEvent  --  
//===========================================================================

class MatadorMessageEvent : public OpenWire::Event
{
public:
    MatadorMessage Msg;

public:
    MatadorMessageEvent( class MatadorMessage &msg ) :
        Msg( msg )
          {
          }
};


class MatadorMessageQueue;
class MatadorMessageThread;

//===========================================================================
//  CLASS MatadorMessageStream  --  
//===========================================================================

class MatadorMessageStream : public MatadorMessageManager
{
  friend class MatadorMessageThread;
  
public:
    virtual bool MessageTransmitted(); // Returns true if the buffer is handled.
    virtual bool MessageReceived(); // Returns true if the buffer is handled.

public:
    virtual void AttachToPtr( MatadorMessageDevice *device );
    virtual void Detach();

public:
    void Post(const MatadorMessage&  message);
    
public:
    OpenWire::EventHandler<MatadorMessageEvent> OnMessage;

public:
    MatadorMessageStream();
    virtual ~MatadorMessageStream();

protected:
    MatadorMessageQueue *mTransmitMessageQueue;

    MatadorMessageThread *mMessageThread;
    MatadorMessageDevice *mMessageDevice;
    bool mTransmitBusy;

protected:
    void ProcessMessages();
    void TransmitOutgoingMessage();
    bool ProcessIncomingMessage();
    void ProcessSystemMessage( MatadorMessage &Message );
    void ParseDebugString( std::string Msg );

};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
