//
// MatadorMessageSupport_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//
 
#include <MatadorMessageSupport_Mb.h>

namespace Innovative
{
 
//===========================================================================
//  CLASS MatadorMessageQueue  --
//===========================================================================

//---------------------------------------------------------------------------
//  MatadorMessageQueue::Push() --
//---------------------------------------------------------------------------
 
void MatadorMessageQueue::Push(const MatadorMessage & message)
{
    mSemaphore.Acquire();

    CriticalSectionArea Area(mCriticalSection);
	mMessageList.push_back(message);
}

//---------------------------------------------------------------------------
//  *MatadorMessageQueue::Pop() --
//---------------------------------------------------------------------------
 
MatadorMessage MatadorMessageQueue::Pop()
{
	mCriticalSection.Enter();

	MatadorMessage message;

	message = mMessageList.front();
	mMessageList.pop_front();

	mCriticalSection.Leave();

    mSemaphore.Release();

    return message;
}

} // namespace Innovative


