// MatadorMessage_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <MatadorMessage_Mb.h>
#include <memory.h>

namespace   Innovative
{

//---------------------------------------------------------------------------
// MatadorMessage::MatadorMessage() --
//---------------------------------------------------------------------------
 
MatadorMessage::MatadorMessage( unsigned int*  packet ) :
    inherited( packet, PacketSize )   
{
}

//---------------------------------------------------------------------------
// MatadorMessage::MatadorMessage() --
//---------------------------------------------------------------------------
 
MatadorMessage::MatadorMessage()
{
    Size(PacketSize); 
    //
    //  Packet Data is all 0s, except part of header
    mPacket[0] = static_cast<ii32>(MessageTag);
    for (int i = 1; i < PacketSize; i++)
        mPacket[i] = 0;
}

//---------------------------------------------------------------------------
// MatadorMessage::MatadorMessage() --
//---------------------------------------------------------------------------
 
MatadorMessage::MatadorMessage(const MatadorMessage&  other) :
	inherited( other )
{
    mPacket = other.mPacket; 
}

//---------------------------------------------------------------------------
//  MatadorMessage::Channel() --
//---------------------------------------------------------------------------
 
unsigned short MatadorMessage::Channel() const
{
    return GetConstShortArray()[ChannelOffset];
}

//---------------------------------------------------------------------------
//  MatadorMessage::Channel() --
//---------------------------------------------------------------------------
 
void MatadorMessage::Channel(unsigned short channel)
{
    GetShortArray()[ChannelOffset] = channel;
}
 
//---------------------------------------------------------------------------
//  MatadorMessage::TypeCode() --
//---------------------------------------------------------------------------
 
unsigned short MatadorMessage::TypeCode() const
{
    return GetConstShortArray()[MessageCodeOffset];
}

//---------------------------------------------------------------------------
//  MatadorMessage::TypeCode() --
//---------------------------------------------------------------------------
 
void MatadorMessage::TypeCode(unsigned short type_code)
{
    GetShortArray()[MessageCodeOffset] = type_code;
}

//---------------------------------------------------------------------------
//  MatadorMessage::MessageId() --
//---------------------------------------------------------------------------
 
unsigned short MatadorMessage::MessageId() const
{
    return GetConstShortArray()[MessageIdOffset];
}

//---------------------------------------------------------------------------
//  MatadorMessage::MessageId() --
//---------------------------------------------------------------------------
 
void MatadorMessage::MessageId(unsigned short msg_id)
{
    GetShortArray()[MessageIdOffset] = msg_id;
}

//---------------------------------------------------------------------------
//  MatadorMessage::Packet() --
//---------------------------------------------------------------------------
 
ii32 MatadorMessage::Packet(int idx) const
{
    //  Range check
    if (idx >= PacketSize)
        return 0;

    return mPacket[idx];
}

//---------------------------------------------------------------------------
//  MatadorMessage::Packet() --
//---------------------------------------------------------------------------
 
void MatadorMessage::Packet(int idx, ii32 data)
{
    //  Range check
    if (idx >= PacketSize)
        return;

    mPacket[idx] = data;
}

//---------------------------------------------------------------------------
//  MatadorMessage::IsSystemMessage() --
//---------------------------------------------------------------------------
 
bool MatadorMessage::IsSystemMessage() const
{
    if (mPacket[MessageIdOffset] & (1 << SystemMessageBit))
        return true;

    return false;
}

//---------------------------------------------------------------------------
//  MatadorMessage::IsSystemMessage() --
//---------------------------------------------------------------------------
 
void MatadorMessage::IsSystemMessage(bool state)
{
    if (state)
        mPacket[MessageIdOffset] |= (1 << SystemMessageBit);

    else
        mPacket[MessageIdOffset] &= ~(1 << SystemMessageBit);
}

//---------------------------------------------------------------------------
//  MatadorMessage::IsReplyExpected() --
//---------------------------------------------------------------------------
 
bool MatadorMessage::IsReplyExpected() const
{
    if (mPacket[MessageIdOffset] & (1 << ReplyExpectedBit))
        return true;

    return false;
}

//---------------------------------------------------------------------------
//  MatadorMessage::IsReplyExpected() --
//---------------------------------------------------------------------------
 
void MatadorMessage::IsReplyExpected(bool state)
{
    if (state)
        mPacket[MessageIdOffset] |= (1 << ReplyExpectedBit);
    else
        mPacket[MessageIdOffset] &= ~(1 << ReplyExpectedBit);
}

} // namespace
