// MatadorMessage_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef MatadorMessage_MbH
#define MatadorMessage_MbH

#include <Message_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS MatadorMessage  --  
//===========================================================================

class MatadorMessage : public Message
{
    typedef Message inherited;
   
public:
    static const int PacketSize = 16;
  
protected:
    static const unsigned int MessageTag = 0xCAD00000;  // "Magic" code in message header
    static const unsigned int MessageIdOffset = 0;      // Header offsets in 16 bit shorts
    static const unsigned int ChannelOffset = 2;
    static const unsigned int MessageCodeOffset = 3;
    static const unsigned int DataIntOffset = 2;        // Int offset of Data Region
    static const unsigned int DataIntMaxIdx = 14;
    static const unsigned int DataFloatMaxIdx = 14;
    static const unsigned int DataShortMaxIdx = 28;
    static const unsigned int DataCharMaxIdx = 56;
    
    static const unsigned int SystemMessageBit = 16;    // Bit lock for System Message bit
    static const unsigned int ReplyExpectedBit = 17;    // Bit lock for Reply bit

protected:
    virtual int GetDataOffset() const 
        { return DataIntOffset; }
  
protected:
    unsigned short *GetShortArray() 
        { return reinterpret_cast<unsigned short *>( &( mPacket[0]) ); }
    const unsigned short *GetConstShortArray() const 
        { return reinterpret_cast<const unsigned short *>( &( mPacket[0]) ); }
  
public:
    MatadorMessage( unsigned int *Packet );
    MatadorMessage( const MatadorMessage &other );
    MatadorMessage();

public:
    unsigned short Channel() const;
    void           Channel(unsigned short channel);
    unsigned short TypeCode() const;
    void           TypeCode(unsigned short type_code);
    unsigned short MessageId() const;
    void           MessageId(unsigned short msg_id);
    ii32           Packet( int idx) const;
    void           Packet(int idx, ii32 data);

public:
    bool           IsSystemMessage() const;
    void           IsSystemMessage( bool state );

    bool           IsReplyExpected() const;
    void           IsReplyExpected( bool state );
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
