// MemoryUtils_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2007 Innovative Integration Corporation.
//  All Rights Reserved.
//
#include <MemoryUtils_Mb.h>
#include <SingletonManager_Mb.h>
#include <string.h>

namespace Innovative
{

void   OsCopyInt32Buffer( const int *src_buffer, int *dst_buffer, size_t size );
void   OsCopyInt64Buffer( const ii64 *src_buffer, ii64 *dst_buffer, size_t size );
void   OsCopyByteBuffer( const unsigned char *src_buffer, unsigned char *dst_buffer, size_t size );

void   ( *CopyInt32Buffer )( const int *src_buffer, int *dst_buffer, size_t size ) = OsCopyInt32Buffer;
void   ( *CopyInt64Buffer )( const ii64 *src_buffer, ii64 *dst_buffer, size_t size ) = OsCopyInt64Buffer;
void   ( *CopyByteBuffer )( const unsigned char *src_buffer, unsigned char *dst_buffer, size_t size ) = OsCopyByteBuffer;

//---------------------------------------------------------------------------
//  OsCopyInt32Buffer() --
//---------------------------------------------------------------------------

void OsCopyInt32Buffer( const int *src_buffer, int *dst_buffer, size_t size )
{
    memcpy( dst_buffer, src_buffer, size * sizeof( int ) );
}

//---------------------------------------------------------------------------
//  OsCopyInt64Buffer() --
//---------------------------------------------------------------------------

void OsCopyInt64Buffer( const ii64 *src_buffer, ii64 *dst_buffer, size_t size )
{
    memcpy( dst_buffer, src_buffer, size * sizeof( ii64 ) );   
}

//---------------------------------------------------------------------------
//  OsCopyByteBuffer() --
//---------------------------------------------------------------------------

void OsCopyByteBuffer( const unsigned char *src_buffer, unsigned char *dst_buffer, size_t size )
{
    memcpy( dst_buffer, src_buffer, size );
}

}  // namespace

