// Message_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <Message_Mb.h>
#include <memory.h>

namespace   Innovative
{
#ifdef _MSC_VER		
	#pragma warning(push)	
	#pragma warning(disable : 4355)		
#endif
//---------------------------------------------------------------------------
// Message::Message() --
//---------------------------------------------------------------------------

Message::Message( unsigned int*  packet, int size ) 
{
    memcpy( &( mPacket[0]), packet, size );
}

//---------------------------------------------------------------------------
// Message::Message() --
//---------------------------------------------------------------------------

Message::Message() 
{
}

//---------------------------------------------------------------------------
// Message::Message() --
//---------------------------------------------------------------------------

Message::Message(const Message&  other) 
{
    mPacket = other.mPacket;
}
#ifdef _MSC_VER
	#pragma warning(pop)
#endif

//---------------------------------------------------------------------------
//  Message::Data() --
//---------------------------------------------------------------------------
 
ii32 Message::Data(int idx) const
{
    //  Range check
    if ( idx >= Size() )
        return 0;

    return mPacket[ GetDataOffset() + idx ];
}

//---------------------------------------------------------------------------
//  Message::Data() --
//---------------------------------------------------------------------------
 
void Message::Data(int idx, ii32 data)
{
    //  Range check
    if (idx >= Size() )
        return;

    mPacket[ GetDataOffset() + idx ] = data;
}

//---------------------------------------------------------------------------
//  Message::AsFloat() --
//---------------------------------------------------------------------------
 
float Message::AsFloat(int idx) const
{
    //  Range check
    if (idx >= Size() )
        return 0;

    return *reinterpret_cast< const float * > (GetDataPtr() + idx );
}

//---------------------------------------------------------------------------
//  Message::AsFloat() --
//---------------------------------------------------------------------------
 
void Message::AsFloat(int idx, float data)
{
    //  Range check
    if (idx >= Size() )
        return;

    union 
    {
        float   Float;
        int     Int;     
    } Value;
    Value.Float = data;

    mPacket[ GetDataOffset() + idx ] = Value.Int;
}

//---------------------------------------------------------------------------
//  Message::AsShort() --
//---------------------------------------------------------------------------
 
short Message::AsShort(int idx) const
{
    //  Range check
    if ( idx >= static_cast<int>( Size() * sizeof( ii32 ) / sizeof( short )))
        return 0;

    const short*    pkt = reinterpret_cast< const short * >(GetDataPtr());
    return pkt[idx];
}

//---------------------------------------------------------------------------
//  Message::AsShort() --
//---------------------------------------------------------------------------
 
void Message::AsShort(int idx, short data)
{
    //  Range check
    if (idx >= static_cast<int>( Size() * sizeof( ii32 ) / sizeof( short )))
        return;

    short*  pkt = reinterpret_cast< short * >(GetDataPtr());
    pkt[idx] = data;
}

//---------------------------------------------------------------------------
//  Message::AsChar() --
//---------------------------------------------------------------------------
 
char Message::AsChar(int idx) const
{
    //  Range check
    if (idx >= static_cast<int>( Size() * sizeof( ii32 )))
        return 0;

    const char*     pkt = reinterpret_cast< const char * >(GetDataPtr());
    return pkt[idx];
}

//---------------------------------------------------------------------------
//  Message::AsChar() --
//---------------------------------------------------------------------------
 
void Message::AsChar(int idx, char data)
{
    //  Range check
    if (idx >= static_cast<int>( Size() * sizeof( ii32 )))
        return;

    char*   pkt = reinterpret_cast< char * >(GetDataPtr());
    pkt[idx] = data;
}

} // namespace Innovative
