// Message_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef Message_MbH
#define Message_MbH

#include <DataTypes_Mb.h>
#include <vector>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS Message  --  
//===========================================================================

class Message
{
protected:
    mutable std::vector<ii32> mPacket;
    
protected:
    virtual int GetDataOffset() const { return 0; }
    
protected:
    ii32 *GetDataPtr() const { return reinterpret_cast<ii32 *>( &( mPacket[GetDataOffset()]) ); }
    
public:
    Message( unsigned int *packet, int size );
    Message( const Message &other );
    Message();
    virtual ~Message()
        {  }

public:
	Message &operator = ( const Message &other )
	{
		mPacket = other.mPacket;
		return *this;
	}

public:
    int     Size() const 
        {  return (int)mPacket.size();  }
    void    Size( int value ) 
        {  mPacket.resize( value );  }
  
public:
    ii32  Data( int idx) const;
    void  Data( int idx, ii32 data);
    float AsFloat(int idx) const;
    void  AsFloat(int idx, float data);
    short AsShort(int idx) const;
    void  AsShort(int idx, short data);
    char  AsChar(int idx) const;
    void  AsChar(int idx, char data);
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
