//---------------------------------------------------------------------------
// MultiChanStreamSupport_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2015 Innovative Integration Corporation.
//  All Rights Reserved.
//


#include <MultiChanStreamSupport_Mb.h>
#include <MultiChanDeviceMap_Mb.h>

namespace Innovative
{

#ifdef _MSC_VER
    #pragma warning(push)
    #pragma warning(disable : 4355)
#endif

//===========================================================================
// CLASS MultiChanStreamManagerSafeLink  --  Safe Linkage to a device
//===========================================================================
//---------------------------------------------------------------------------
//  MultiChanStreamManagerSafeLink::OnAfterLink() - handle post-link stuff
//---------------------------------------------------------------------------

void  MultiChanStreamManagerSafeLink::OnAfterLink()
{
    // Pass Internals() down to Map
    Owner->IAP_PDevMap.RegisterStreamPlugIn(Ptr()->Internals());
}

//---------------------------------------------------------------------------
//  MultiChanStreamManagerSafeLink::OnBeforeUnlink() - handle pre-unlink stuff
//---------------------------------------------------------------------------

void  MultiChanStreamManagerSafeLink::OnBeforeUnlink()
{
    Owner->IAP_PDevMap.RegisterStreamPlugIn(0);
}

//===========================================================================
//  CLASS IIsAMultiChanStreamBoard  -- Common MultiChan stream link base
//===========================================================================
//---------------------------------------------------------------------------
//  IIsAMultiChanStreamBoard::RegisterStreamPlugIn() -- attach to a streaming object
//---------------------------------------------------------------------------

void  IIsAMultiChanStreamBoard::RegisterStreamPlugIn( IMultiChanStreamManager *plug_in )
{
    if (plug_in)
        StreamManager.Link(plug_in);
    else
        StreamManager.Unlink();
}


#ifdef _MSC_VER
    #pragma warning(pop)
#endif


}  // namespace Innovative
