//  Mutex_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2007 Innovative Integration Corporation.
//  All Rights Reserved.
//



#include <Mutex_Mb.h>
#include <Poco/Foundation/include/Poco/Mutex.h>

namespace   Innovative
{

//---------------------------------------------------------------------------
//  Mutex::Mutex() --
//---------------------------------------------------------------------------

Mutex::Mutex() : Handle( new Poco::Mutex(Poco::Mutex::MUTEX_RECURSIVE) )
{
}

//---------------------------------------------------------------------------
//  Mutex::~Mutex() --
//---------------------------------------------------------------------------

Mutex::~Mutex()
{
    delete Handle;
}

//---------------------------------------------------------------------------
//  Mutex::Acquire() --
//---------------------------------------------------------------------------

bool Mutex::Acquire()
{
    Handle->lock();
    return true;
}

//---------------------------------------------------------------------------
//  Mutex::Check() --
//---------------------------------------------------------------------------

bool Mutex::Check()
{
    bool is_locked = true;

    if( Handle->tryLock() )
    {
        Handle->unlock();
        is_locked = false;
    }

    return is_locked;
}

//---------------------------------------------------------------------------
//  Mutex::Release() --
//---------------------------------------------------------------------------

bool Mutex::Release()
{
    Handle->unlock();

    return true;
}

} // namespace Innovative
