// Mutex_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2007 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef Mutex_MbH
#define Mutex_MbH


namespace Poco {
	class Mutex;
}


namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif



//========================================================================
//   CLASS Mutex
//========================================================================

class Mutex
{
public:
	//
	//  Member Functions
	Mutex();
	~Mutex();
	bool    Release();
	bool    Acquire();
	bool    Check();

protected:
	//  Member Data
	Poco::Mutex   *Handle;
};

//========================================================================
//   CLASS MutexedLock  --  Restict multiple access via a mutex
//========================================================================

class MutexedLock
{
public:
	//
	//  Member Functions
	MutexedLock(Mutex & a_mutex)
		: mutex( a_mutex )
		{  mutex.Acquire(); }

	~MutexedLock()
		{  mutex.Release();  }

private:
	//
	//  Member Data
	Mutex &    mutex;
};





#ifdef __CLR_VER
#pragma managed(pop)
#endif

} // namespace Innovative

#endif
