// NetCoffLoadThread_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef NetCoffLoadThread_MbH
#define NetCoffLoadThread_MbH

#include <Event_Mb.h>
#include <CoffFile_Mb.h>
#include <Thread_Mb.h>
#include <DataTypes_Mb.h>    // DWORD definition

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//==============================================================================
//  CLASS NetCoffLoadThread -- manages COFF load via network
//==============================================================================

class NetCoffLoadThread : public Thread
{
    typedef Thread inherited;
    friend class CoffDownloadThread;

public:
    //
    //  Member Functions
    NetCoffLoadThread(class Sbc6713e & baseboard, std::string coff_file);
    NetCoffLoadThread(std::string id, int port, std::string coff_file);

    bool  IsComplete();

protected:
    //
    //  Member Functions
    void  Execute();

private:

    CoffFile       Coff;
    Event          PacketAvailable;
    Event          PacketTransmitted;
    Event          TransmitComplete;
    Event          CoffLoadComplete;
    unsigned int   PacketAddr;
    unsigned int   PacketSize;
    const unsigned char *	PacketData;
    bool		   Eof;
    std::string	   ID;
    int            Port;
    std::string    FCoffFile;

    class CoffDownloadThread *  DLThread;
    //
    //  Member Functions
    void  DoCoffMemWrite(MemWriteEvent & Event);

    void  PostBlock(unsigned int Addr, unsigned int Size, const unsigned char * Data);
    void  AckBlock();
    void  EndOfFile();

};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

//---------------------------------------------------------------------------
#endif
