// NetImageLoadThread_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef NetImageLoadThread_MbH
#define NetImageLoadThread_MbH

#include <Event_Mb.h>
#include <SRecord_Mb.h>
#include <BinFile_Mb.h>
#include <Thread_Mb.h>
#include <Sbc6713e_Mb.h>
#include <DataTypes_Mb.h>    // DWORD definition

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//==============================================================================
//  CLASS NetImageLoadThread -- manages Logic load via network
//==============================================================================

class NetImageLoadThread : public Thread
{
    friend class Sbc6713e;
    
protected:
    //
    //  Member Functions
    NetImageLoadThread(Sbc6713e & baseboard, Sbc6713e::LoadInfoType which,
                       std::string exo_file);

    //
    //  Member Functions
    virtual void    Execute();
    virtual void    Done();

private:
    std::string             DefaultFileName;
    Sbc6713e &              Baseboard;
    SRecord                 SrImage;
    BinFile                 BinImage;
    Sbc6713e::LoadInfoType  LoadType;
    Event                   ImageLoadComplete;
    unsigned int            PacketAddr;
    unsigned int            PacketSize;
    const char *            PacketData;
    bool                    Eof;
    std::string             ID;
    int                     Port;
    std::string             FImageFile;
    class ACE_SOCK_Stream * client;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative

#endif
