// NetInfoCommThread_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//


#ifndef NetInfoCommThread_MbH
#define NetInfoCommThread_MbH

#include <Thread_Mb.h>
#include <Event_Mb.h>
#include <Sbc6713e_Mb.h>
#include <DataTypes_Mb.h>    // DWORD definition

namespace   Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//==============================================================================
//  CLASS NetInfoCommThread -- manages miscellaneous commands via network.
//==============================================================================
class NetInfoCommThread : public Thread
{
    friend class Sbc6713e;
    
public:
    //
    //  Member Functions
    NetInfoCommThread(Sbc6713e & baseboard, Sbc6713e::MiscCommId which,
                       int Arg0, int Arg1);

    //
    //  Member Functions
    virtual void    Execute();
    virtual void    Done();


private:
    Sbc6713e &              Baseboard;
    int                     PacketSize;
    const char *            PacketData;
    int                     Port;
    std::string             ID;
    Sbc6713e::MiscCommId    ReqType;
    Event                   InfoRqstComplete;
    class ACE_SOCK_Stream * client;
    int                     Param0;
    int                     Param1;

};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative

#endif
