// NetSystemTestThread_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef NetSystemTestThread_MbH
#define NetSystemTestThread_MbH

#include <Thread_Mb.h>
#include <Sbc6713e_Mb.h>
#include <SyncObjects_Mb.h>

namespace   Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//==============================================================================
//  CLASS NetSystemTestThread -- get system test info.
//==============================================================================

class NetSystemTestThread : public Thread
{
    typedef Thread inherited;
    friend class Sbc6713e;
    
public:
    //
    //  Member Functions
    NetSystemTestThread(Sbc6713e & baseboard);
    //
    //  Member Functions
    void GetSystemTestInfo(SystemTestInfo & info);  

protected:
    enum {sBeginTransfer=inherited::sLast, sLast};
    void Execute();
    void Init();

private:
    enum {rqstTestInfo = 0x50};
    
    Sbc6713e &              Baseboard;
    int                     Port;
    std::string             ID;
    class ACE_SOCK_Stream * client;
    Event                   BeginTransfer;
    Event                   TransmitComplete;
    Buffer                  RecvBuffer;
    CriticalSection         CS;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative

#endif
