//
//   NonCopyable_Mb.h   Non-copyable base class
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2003 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef NonCopyable_Mb_H
#define NonCopyable_Mb_H

namespace Innovative
{

//=============================================================================
//  CLASS Noncopyable  --  Base for non-copyable classes
//
//  Private copy constructor and copy assignment ensure classes derived from
//  class noncopyable cannot be copied.
//=============================================================================

class Noncopyable
{
protected:
    Noncopyable(){}
    virtual ~Noncopyable(){}
private:  // emphasize the following members are private
    Noncopyable( const Noncopyable& );
    const Noncopyable& operator=( const Noncopyable& );
}; 



}  // namespace Innovative

#endif

