// NotifyThread_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef NotifyThread_MbH
#define NotifyThread_MbH

#include <StartStopThread_Mb.h>
#include <Events_Mb.h>
#include <Semaphore_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS NotifyThread  --  
//===========================================================================

class NotifyThread : public StartStopThread
{
    typedef StartStopThread inherited;

public:
    OpenWire::EventHandler<OpenWire::Event> OnNotify;

public:
    NotifyThread(const char * name = "");
    NotifyThread(Event *event, const char * name = "");
   ~NotifyThread();

public:
    void Notify();

protected:
    // mNotifyEvents
    enum { sNotifyEvent=inherited::sLast, sLast };
    const bool       mOwnsEvent;
    Event *          eNotifyEvent;

protected:
    //  don't override these...
    virtual void    Init();
    virtual void    SingleExecution();

};

//===========================================================================
//  CLASS NotifySemThread  --
//===========================================================================

class NotifySemThread : public StartStopThread
{
    typedef StartStopThread inherited;

public:
    OpenWire::EventHandler<OpenWire::Event> OnNotify;

public:
    NotifySemThread(const char * name = "");
    NotifySemThread(Semaphore * sem, const char * name = "");
    virtual ~NotifySemThread();

public:
    void Notify();

protected:
    // mNotifyObjs
    enum { sNotifySem=inherited::sLast, sLast };
    const bool       mOwnsSem;
    Semaphore *      NotifySem;

protected:
    //  don't override these...
    virtual void    Init();
    virtual void    SingleExecution();

};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
