//---------------------------------------------------------------------------
// P25DeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include "P25DeviceDriver_Mb.h"

//---------------------------------------------------------------------------

//
//  Nameless namespace for 'static' data
namespace
{
//------------------------------------------------
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   P25IntStatusMask        = 0xF;
const unsigned int   P25IntStatusByteAddress = 0x64000;
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "P25DRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x000c
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name     Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
        "P25",      TARGET_BASE,         0x1303,      0x000c,     0x00,        false);
    }
};

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS P25DeviceDriver  -- Driver level code for P25 baseboard
//===========================================================================

InnovativeKernel::IsrLog * P25DeviceDriver::LOG = 0;

//---------------------------------------------------------------------------
//  constructor for class P25DeviceDriver
//---------------------------------------------------------------------------

P25DeviceDriver::P25DeviceDriver()
    :  InnovativeKernel::DualRegionDeviceDriver(
                                    InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID),
                                    P25IntStatusByteAddress,
                                    P25IntStatusMask)
{
    //  Save static pointer to log info
    LOG = & mIsrInfo;
}

//---------------------------------------------------------------------------
}; // Innovative

