//---------------------------------------------------------------------------
// PacketStreamSupport_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2010 Innovative Integration Corporation.
//  All Rights Reserved.
//


#include <PacketStreamSupport_Mb.h>
#include <PacketDeviceMap_Mb.h>

namespace Innovative
{

#ifdef _MSC_VER
    #pragma warning(push)
    #pragma warning(disable : 4355)
#endif

//===========================================================================
// CLASS PacketStreamManagerSafeLink  --  Safe Linkage to a device
//===========================================================================
//---------------------------------------------------------------------------
//  PacketStreamManagerSafeLink::OnAfterLink() - handle post-link stuff
//---------------------------------------------------------------------------

void  PacketStreamManagerSafeLink::OnAfterLink()
{
    // Pass Internals() down to Map
    Owner->IAP_PDevMap.RegisterStreamPlugIn(Ptr()->Internals());
}

//---------------------------------------------------------------------------
//  PacketStreamManagerSafeLink::OnBeforeUnlink() - handle pre-unlink stuff
//---------------------------------------------------------------------------

void  PacketStreamManagerSafeLink::OnBeforeUnlink()
{
    Owner->IAP_PDevMap.RegisterStreamPlugIn(0);
}

//===========================================================================
//  CLASS IIsAPacketStreamBoard  -- Common packet stream link base
//===========================================================================
//---------------------------------------------------------------------------
//  IIsAPacketStreamBoard::RegisterStreamPlugIn() -- attach to a streaming object
//---------------------------------------------------------------------------

void  IIsAPacketStreamBoard::RegisterStreamPlugIn( IPacketStreamManager *plug_in )
{
    if (plug_in)
        StreamManager.Link(plug_in);
    else
        StreamManager.Unlink();
}

//===========================================================================
// CLASS VitaPacketStreamManagerSafeLink  --  Safe Linkage to a device
//===========================================================================
//---------------------------------------------------------------------------
//  VitaPacketStreamManagerSafeLink::OnAfterLink() - handle post-link stuff
//---------------------------------------------------------------------------

void  VitaPacketStreamManagerSafeLink::OnAfterLink()
{
    // Pass Internals() down to Map
    Owner->IAVP_PDevMap.RegisterStreamPlugIn(Ptr()->Internals());
}

//---------------------------------------------------------------------------
//  VitaPacketStreamManagerSafeLink::OnBeforeUnlink() - handle pre-unlink stuff
//---------------------------------------------------------------------------

void  VitaPacketStreamManagerSafeLink::OnBeforeUnlink()
{
    Owner->IAVP_PDevMap.RegisterStreamPlugIn(0);
}

//===========================================================================
//  CLASS IIsAVitaPacketStreamBoard  -- Common packet stream link base
//===========================================================================
//---------------------------------------------------------------------------
//  IIsAVitaPacketStreamBoard::RegisterStreamPlugIn() -- attach to a streaming object
//---------------------------------------------------------------------------

void  IIsAVitaPacketStreamBoard::RegisterStreamPlugIn( IVitaPacketStreamManager *plug_in )
{
    if (plug_in)
        StreamManager.Link(plug_in);
    else
        StreamManager.Unlink();
}

#ifdef _MSC_VER
    #pragma warning(pop)
#endif


}  // namespace Innovative
