// PciLogicVersionInfo_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <PciLogicVersionInfo_Mb.h>

//---------------------------------------------------------------------------
namespace Innovative
{

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4355)
#endif

//===========================================================================
//  CLASS PciLogicVersionReg  --  PMC Module User Logic ID info register
//===========================================================================

class PciLogicVersionReg : public ReadOnlyRegister
{
    typedef ReadOnlyRegister inherited;

public:
    ReadOnlyRegisterBitGroup       Revision;
    ReadOnlyRegisterBitGroup       Family;
    ReadOnlyRegisterBitGroup       Pcb;
    ReadOnlyRegisterBitGroup       Type;
    ReadOnlyRegisterBitGroup       GeoAddress;

    PciLogicVersionReg(AddressingSpace & space, unsigned int offset)
        : inherited(space, offset),
          Revision(*this, 0, 16), Family(*this, 16, 4),
          Pcb(*this, 20, 4), Type(*this, 24, 8), GeoAddress(*this, 28, 3)
    {  }
};

#ifdef _MSC_VER
	#pragma warning(pop)
#endif

//===========================================================================
//  CLASS IUsesPciLogicVersionInfo -- User Interface to user logic ID
//===========================================================================
//---------------------------------------------------------------------------
//  constructor for class IUsesPciLogicVersionInfo
//---------------------------------------------------------------------------

IUsesPciLogicVersionInfo::IUsesPciLogicVersionInfo(AddressingSpace & space,
    unsigned int addr)
    :  Reg(new PciLogicVersionReg(space, addr))
{
}

//---------------------------------------------------------------------------
//  destructor for class IUsesPciLogicVersionInfo
//---------------------------------------------------------------------------

IUsesPciLogicVersionInfo::~IUsesPciLogicVersionInfo()
{
    delete Reg;    Reg = 0;
}

//---------------------------------------------------------------------------
//  IUsesPciLogicVersionInfo::PciLogicType() --
//---------------------------------------------------------------------------

short IUsesPciLogicVersionInfo::PciLogicType() const
{
    return Reg->Type;
}

//---------------------------------------------------------------------------
//  IUsesPciLogicVersionInfo::PciLogicRevision() --
//---------------------------------------------------------------------------

short IUsesPciLogicVersionInfo::PciLogicRevision() const
{
    return Reg->Revision;
}

//---------------------------------------------------------------------------
//  IUsesPciLogicVersionInfo::PciLogicFamily() --
//---------------------------------------------------------------------------

short IUsesPciLogicVersionInfo::PciLogicFamily() const
{
    return Reg->Family;
}

//---------------------------------------------------------------------------
//  IUsesPciLogicVersionInfo::PciLogicPcb() --
//---------------------------------------------------------------------------

short IUsesPciLogicVersionInfo::PciLogicPcb() const
{
    return Reg->Pcb;
}

//---------------------------------------------------------------------------
//  IUsesPciLogicVersionInfo::PciLogicGeographicAddress() --
//---------------------------------------------------------------------------

short IUsesPciLogicVersionInfo::PciLogicGeographicAddress() const
{
    return Reg->GeoAddress;
}

//---------------------------------------------------------------------------
//  IUsesPciLogicVersionInfo::PciLogicRawValue() --
//---------------------------------------------------------------------------

unsigned int IUsesPciLogicVersionInfo::PciLogicRawValue() const
{
    return Reg->Value();
}


}  // end namespace Innovative



