// PciLogicVersionInfo_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef PciLogicVersionInfo_MbH
#define PciLogicVersionInfo_MbH

#include <PciLogicVersionInfoIntf_Mb.h>
#include <HardwareRegister_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS IUsesNullPciLogicVersionInfo -- User Interface to user logic ID
//===========================================================================

class IUsesNullPciLogicVersionInfo : public PciLogicVersionInfoIntf
{
public:
    IUsesNullPciLogicVersionInfo()  {  }
    virtual ~IUsesNullPciLogicVersionInfo()  {  }

    //
    //  Interface Functions
    virtual short           PciLogicRevision() const          {  return 0;  }
    virtual short           PciLogicFamily() const            {  return 0;  }
    virtual short           PciLogicPcb() const               {  return 0;  }
    virtual short           PciLogicType() const              {  return 0;  }
    virtual short           PciLogicGeographicAddress() const {  return 0;  }
    virtual unsigned int    PciLogicRawValue() const          {  return 0;  }
};

//===========================================================================
//  CLASS IUsesPciLogicVersionInfo -- User Interface to user logic ID
//===========================================================================

class IUsesPciLogicVersionInfo : public PciLogicVersionInfoIntf
{
public:
    IUsesPciLogicVersionInfo(AddressingSpace & space, unsigned int addr);
    virtual ~IUsesPciLogicVersionInfo();

    //
    //  Interface Functions
    virtual short           PciLogicRevision() const;
    virtual short           PciLogicFamily() const;
    virtual short           PciLogicPcb() const;
    virtual short           PciLogicType() const;
    virtual short           PciLogicGeographicAddress() const;
    virtual unsigned int    PciLogicRawValue() const;

protected:
    // Data
    class PciLogicVersionReg *  Reg;
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
