//---------------------------------------------------------------------------
// Pex7CopDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2018 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <Pex7CopDeviceDriver_Mb.h>
#include <FmcCarrierMemoryMap_Mb.h>

//---------------------------------------------------------------------------

//
//  Nameless namespace for 'static' data
namespace
{

//---------------------------------------------------------------------------
//  Pex7Cop Main Device Info
//---------------------------------------------------------------------------
const unsigned int Pex7Cop_LogicDeviceBar = 2;  // Second BAR is here cause of 64 bit
                                                //   access requires pairing BARs
                                                 
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   Pex7Cop_IntStatusMask        = 0xF;
const unsigned int   Pex7Cop_IntStatusByteAddress =
    Innovative::FmcCarrier_MemoryMap::mmInterruptStatus;
//  Parameters for Driver Open
//  ...Device Driver Name

#define     Pex7Cop_TARGET_BASE             "P7COPDRV"
#define     Pex7Cop_TARGET_VENDOR_ID         0x1303
#define     Pex7Cop_TARGET_DEVICE_ID         0x0070
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
		// Name      Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
        "Pex7Cop",  Pex7Cop_TARGET_BASE,   0x1303,      0x0070,     0x00,        false);
    }
};       

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS Pex7CopDeviceDriver  -- Driver level code for Pex7Cop Family baseboard
//===========================================================================

InnovativeKernel::IsrLog * Pex7CopDeviceDriver::LOG = 0;

//---------------------------------------------------------------------------
//  constructor for class Pex7CopDeviceDriver
//---------------------------------------------------------------------------

Pex7CopDeviceDriver::Pex7CopDeviceDriver()
    :  InnovativeKernel::DualRegionDeviceDriver(
                                    InnovativeKernel::PciId(Pex7Cop_TARGET_VENDOR_ID, Pex7Cop_TARGET_DEVICE_ID),
                                    Pex7Cop_IntStatusByteAddress,
                                    Pex7Cop_IntStatusMask,
                                    Pex7Cop_LogicDeviceBar)
{
    //  Default busmaster size is 16 MB
    BusMasterSizeWords(0x1000000/sizeof(int));
    SetHighMemPoolFlag(true);    //use high mempool 64bit addressable

    //  Save static pointer to log info
    LOG = & mIsrInfo;
}


} // Innovative


