//---------------------------------------------------------------------------
// Pex7Cop_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2010 Innovative Integration Corporation.
//  All Rights Reserved.
//


#include <Pex7Cop_Mb.h>

namespace Innovative
{

#ifdef _MSC_VER
    #pragma warning(push)
    #pragma warning(disable : 4355)
#endif

//===========================================================================
//  CLASS Pex7Cop  -- Pex7Cop PCI Express baseboard object
//===========================================================================
//---------------------------------------------------------------------------
//  constructor for class Pex7Cop
//---------------------------------------------------------------------------

Pex7Cop::Pex7Cop()
    :  FmcCarrierBoard(Device), Device(this)
{
}

Pex7Cop * aPex7Cop()
{
    Pex7Cop * wombat = new Pex7Cop;
    return wombat;
}

//---------------------------------------------------------------------------
//  destructor for class Pex7Cop
//---------------------------------------------------------------------------

Pex7Cop::~Pex7Cop()
{
    Close();
}

//---------------------------------------------------------------------------
//  Pex7Cop::AfterFiclStart() --
//---------------------------------------------------------------------------

void  Pex7Cop::AfterFiclStart(FiclSystem & engine)
{
    engine.Evaluate("  0 constant Fmc   ");

    engine.Evaluate(": ?Pex7Cop "
                    "    cr .\" --- SubDevice Constants --- \" "
                    "    cr .\"   Fmc   \" "
                    "    cr  "
                    "    cr .\" ---- Pex7Cop Definitions ---- \" "
                    "    cr .\"   l@  ( addr -- data )  fetch from logic space  \" "
                    "    cr .\"   l!  ( data addr  -- ) : store to logic space   \" "
                    "    cr .\"   p@  ( addr -- data ) : fetch from pci space  \" "
                    "    cr .\"   p!  ( data addr -- ) : store to pci space   \" "
                    "    cr .\"   d@  ( addr dev -- data ) : fetch from sub-device space \" "
                    "    cr .\"   d!  ( data addr dev -- ) : store to sub-device space \" "
                    "    cr .\"   dFreq  ( f:freq dev -- ) : Set device frequency \" "
                    "    cr .\"   dFreqActual  ( dev -- f:freq) : read actual frequency \" "
                    "    cr .\"   ?Pex7Cop  : display this message \" "
                    "    cr  ; ");

    for (size_t i=0; i<FmcSlots(); i++)
        {
        if (FmcDaughter(i).Linked()==false)
            continue;
        FmcDaughter(i)->AfterFiclStart(engine);
        }

    engine.Evaluate("marker app");

    engine.Display("Pex7Cop-specific wordset loaded \n" );
    //
    //  Call base class FICL init
    FmcCarrierBoard::AfterFiclStart(engine);
}

//---------------------------------------------------------------------------
//  Pex7Cop::Do_DFetch() --  default implementation
//---------------------------------------------------------------------------

int  Pex7Cop::Do_DFetch(int dev, int addr)
{
    const int kFmc = 0;
    switch (dev)
        {
        case kFmc:
        default:
            return FmcDaughter(0)->Do_DFetch(dev, addr);
        }
}

//---------------------------------------------------------------------------
//  Pex7Cop::Do_DStore() --  default implementation
//---------------------------------------------------------------------------

void  Pex7Cop::Do_DStore(int dev, int addr, int value)
{
    const int kFmc = 0;

    switch (dev)
        {
        case kFmc:
        default:
            FmcDaughter(0)->Do_DStore(dev, addr, value);
            break;
        }
}

//---------------------------------------------------------------------------
//  Pex7Cop::Do_DFreq() --  default implementation
//---------------------------------------------------------------------------

void  Pex7Cop::Do_DFreq(int dev, float freq)
{
    const int kFmc = 0;
    switch (dev)
        {
        case kFmc:
        default:
            FmcDaughter(0)->Do_DFreq(dev, freq);
            break;
        }
}

//---------------------------------------------------------------------------
//  Pex7Cop::Do_DFreqActual() --  default implementation
//---------------------------------------------------------------------------

float  Pex7Cop::Do_DFreqActual(int dev)
{
    const int kFmc = 0;
    switch (dev)
        {
        case kFmc:
        default:
            return FmcDaughter(0)->Do_DFreqActual(dev);
        }
}

#ifdef _MSC_VER
    #pragma warning(pop)
#endif


}  // namespace Innovative
