// Pex7Cop_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2011 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef Pex7Cop_MbH
#define Pex7Cop_MbH

#include <FmcCarrierBoard_Mb.h>
#include <Pex7CopDeviceMap_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS Pex7Cop  -- Pex7Cop PCI Express baseboard object
//===========================================================================

class Pex7Cop : public FmcCarrierBoard
{

public:
    //
    //  Member Functions
    Pex7Cop();
    virtual ~Pex7Cop();

    // Methods

    //  Informational Methods
    IX6ThermalDevice &     Thermal() {  return Device.Thermal();  }
    ISelfMeasurement &     SelfMeasure()    {  return Device.SelfMeasure(); }

    IIdRom &               IdRom()   {  return Device.IdRom();   }


public: //Pseudo protected

     // FPGA type name function
      std::string FpgaName(const short Number)
      {
          switch(Number)
           {
           case 0x00: return "N/A";
           case 0x01: return "325T";
           case 0x02: return "410T";
           default: return "Unknown";
           }
      }

protected:
    //
    //  Member Data
    Pex7CopDeviceMap             Device;

    //  Ficl Interface
    virtual void    AfterFiclStart(FiclSystem & engine);

    virtual int     Do_DFetch(int dev, int addr);
    virtual void    Do_DStore(int dev, int addr, int value);
    virtual void    Do_DFreq(int dev, float freq);
    virtual float   Do_DFreqActual(int dev);
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative

#endif

