// PexCopDeviceMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2010 Innovative Integration Corporation.
//  All Rights Reserved.
//


#ifndef PexCopDeviceMap_MbH
#define PexCopDeviceMap_MbH

#include <PexCop_Mb.h>
#include <PexDeviceMap_Mb.h>
#include <Trace_Mb.h>

namespace Innovative
{

#ifdef __CLR_VER
#pragma managed(push, off)
#endif

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4355)
#endif

class PexCopDeviceMap;

//==============================================================================
//  CLASS PexCop_SioPll -- RX SIO PLL Chip (Specialization of Si5338)
//==============================================================================

class PexCop_SioPll : public Si5338
{
public:
    PexCop_SioPll(PexCopDeviceMap * owner, I2CDevice & device);

    // ...Si5338 interface impl
    virtual void            OnInit();
    virtual void            OnReapply();

protected:
    PexCopDeviceMap * Owner;
};

//===========================================================================
//  CLASS PexCopDeviceMap  -- Register & low level support for PexCop module
//===========================================================================
class PexCop;

class PexCopDeviceMap :  public PexDeviceMap

{
	friend class PexCop;
	friend class PexCop_Pll;
    friend class PexCopInputDevice;

public:
	//
	//  Member Functions
	PexCopDeviceMap(PexCop * owner);
	virtual ~PexCopDeviceMap();

//	PexCopInputDevice  &    Input();

public: // pseudo-protected
    virtual void  OpenHardware();

    //  Subdevice Customization Handlers
    virtual Si5338 *     MakeSioPllObject(I2CDevice & device);

    virtual unsigned int GetVeloInStreamCount();
    virtual unsigned int GetVeloOutStreamCount();
    virtual unsigned int GetVeloOutCommandStreamCount();

    virtual IIsAVitaPacketStreamBoard *  GetBaseboardPtr();
    virtual unsigned int                 GetPatternModeAlignment();
    virtual unsigned int                 GetPatternModeScaleFactor();
    virtual bool                         GetPatternModeSingleMemoryFlag();

protected:
    // Fields
    //PexCopInputDevice  *    FInput;

    // Data
    PexCop *      Owner;
//    Trace         Debug;

    // Methods
    void  OnStreamPreconfigHandler(OpenWire::NotifyEvent & Event);
    void  OnStreamSingleTimeAtStartConfigHandler(OpenWire::NotifyEvent & Event);
    void  OnStreamConfigureHandler(OpenWire::NotifyEvent & Event);
    void  OnBeforeStreamStartHandler(OpenWire::NotifyEvent & Event);
    void  OnAfterStreamStartHandler(OpenWire::NotifyEvent & Event);
    void  OnBeforeStreamStopHandler(OpenWire::NotifyEvent & Event);
    void  OnAfterStreamStopHandler(OpenWire::NotifyEvent & Event);
};

#ifdef _MSC_VER
    #pragma warning(pop)
#endif

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // Innovative
//---------------------------------------------------------------------------
#endif
