// PexCop_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2010 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef PexCop_MbH
#define PexCop_MbH

#include <PexBoard_Mb.h>
#include <PexCopDeviceMap_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS PexCop  -- PexCop PCI Express baseboard object
//===========================================================================

class PexCop : public PexBoard
{

public:
    //
    //  Member Functions
    PexCop();
    virtual ~PexCop();

    // Methods
//  ...Currently no base class override needed
//    virtual void                Open();
//    virtual void                Close();
//    virtual void                Reset();

    // Device access methods

    //FPGA type name function
    std::string FpgaName(const short Number)
    {
        switch(static_cast<int>(Number))
        {
         case 0: return "LX5550T";
         case 1: return "LX240T";
         case 2: return "SX315T";
         case 3: return "SX475T";
         default: return "Unknown";
        }
    }


public: //Pseudo protected

protected:
    //
    //  Member Data
    PexCopDeviceMap             Device;

    //  Ficl Interface
    virtual void    AfterFiclStart(FiclSystem & engine);

    virtual int     Do_DFetch(int dev, int addr);
    virtual void    Do_DStore(int dev, int addr, int value);
    virtual void    Do_DFreq(int dev, float freq);
    virtual float   Do_DFreqActual(int dev);
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative

#endif

