// PexDeviceMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2011 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef PexDeviceMap_MbH
#define PexDeviceMap_MbH

#include <FmcCarrierDeviceMap_Mb.h>

namespace Innovative
{

#ifdef __CLR_VER
#pragma managed(push, off)
#endif

#ifdef _MSC_VER
    #pragma warning(push)
    #pragma warning(disable : 4355)
#endif

//class PexDeviceMap;
//class X6DeviceDriver;

//===========================================================================
//  CLASS PexDeviceMap  -- Register & low level support for PexBoard
//===========================================================================

class PexDeviceMap :  public FmcCarrierAdvDeviceMap,
                      public ISuppliesAddedPexRequirements
{
public:
    friend class PexBoard;
    //
    //  Member Functions
    PexDeviceMap(IStreamDeviceEvents * owner);
	virtual ~PexDeviceMap();

	X6FpaLoader &  FpaDevice()  {  return Fpa_SDev;  }

public: // pseudo-protected

    virtual void    ConstructCustomParts();    // call in most derived ctor
    virtual void    OpenHardware();
    virtual void    PreconfigureHardware();
    virtual void    ConfigureHardware();
    virtual void    StreamStopHardware();

protected:
    //
    //  Wishbone Bus Spaces
    //
    //  Subdevices
    X6FpaLoader              Fpa_SDev;
    X6SioPll                 SioPll_SDev;

    virtual IFpaLoader &     DerivedVsProm()  {  return Fpa_SDev.VsProm();  }

};


#ifdef _MSC_VER
    #pragma warning(pop)
#endif

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // Innovative
//---------------------------------------------------------------------------
#endif
