//
// PllCalMem_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2003 Innovative Integration Corporation. 
//  All Rights Reserved.
//
// PmcIdrom storage format:
//   [Header]
//   Offset ch 0..N
//   Gain ch 0..N
//   bool Calibrated
//   float PllCorrection

#ifdef __BORLANDC__
#include <mem.h>
#endif
#include <PllCalMem_Mb.h>


namespace Innovative
{

//=============================================================================
//  CLASS IUsesPllCalibration  --  Calibration memory access class for analog I/O
//=============================================================================
//-----------------------------------------------------------------------------
//  constructor for class IUsesPllCalibration
//-----------------------------------------------------------------------------

IUsesPllCalibration::IUsesPllCalibration(
    AddressingSpace & space, unsigned int addr, int size, int channels,
        int one)
	: IUsesCalibration(space, addr, size, channels, one)
{
}

//------------------------------------------------------------------------
//  IUsesPllCalibration::PllCorrection() - Set correction value
//------------------------------------------------------------------------

IUsesPllCalibration & IUsesPllCalibration::PllCorrection(float value)
{
	int idx = (Channels*2 + 1);
	Device->WorkAreaAsFloat(PmcIdrom::waModule, idx, value);

	return *this;
}

//------------------------------------------------------------------------
//  IUsesPllCalibration::PllCorrection() - Retreive correction value
//------------------------------------------------------------------------

float IUsesPllCalibration::PllCorrection() const
{
    if (!Calibrated())
        return 1.0;

	int idx = (Channels*2 + 1);
	return Device->WorkAreaAsFloat(PmcIdrom::waModule, idx);
}


} // namespace Innovative



