// PmcBoard_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2010 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef PmcBoard_MbH
#define PmcBoard_MbH

#include <DataTypes_Mb.h>
#include <PacketDeviceMap_Mb.h>
#include <PacketStreamSupport_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//class PmcBoard;

//===========================================================================
//  CLASS PmcBoard  -- Pmc Common baseboard class
//===========================================================================

class PmcBoard : public IIsAPacketStreamBoard
{

public:
    //
    //  Member Functions
    PmcBoard(PacketDeviceMap & deviceMap);
    virtual ~PmcBoard();

    //  Informational Methods
public: // Pseudo protected
    //
    //  IPacketStreamDevice interface implementation
    virtual IPacketStreamDeviceInternals *  Internals();

    PacketDeviceMap * Debug() { return &PmcDeviceRef; };

protected:
    //
    //  Member Data
    PacketDeviceMap &     PmcDeviceRef;

};



#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative

#endif

