// ProcessEvents_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2007 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <ProcessEvents_Mb.h>

namespace Innovative
{

//===========================================================================
// CLASS ITypedStatusEventSender  --  Interface to send messages
//===========================================================================
//---------------------------------------------------------------------------
//  ITypedStatusEventSender::DeliverMessage() - send message by error level
//---------------------------------------------------------------------------

void  ITypedStatusEventSender::DeliverMessage(const std::string & msg,
                                              ProcessTypedStatusEvent::MsgType type)
{
    //  Only send message permitted by the error level state
    if (ErrorLevel >= type)
    	{
		ProcessTypedStatusEvent ptse(msg, type);
        OnMessage.Execute(ptse);
    	}
}


}   // namespace Innovative
