// PulseRepetitionIntervalIntf_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef PulseRepetitionIntervalIntf_H
#define PulseRepetitionIntervalIntf_H

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//==============================================================================
//  CLASS IPulseRepetitionIntervalIntf -- Pulse repetition interval functionality
//==============================================================================

class IPulseRepetitionIntervalIntf
{
public:
	virtual ~IPulseRepetitionIntervalIntf()  {  }

	// Methods
	virtual void 				Reset() = 0;
	virtual void    		    AddEvent(unsigned int period,
										 unsigned int delay,
										 unsigned int width ) = 0;
	virtual void 				Apply() = 0;

	// Properties
	virtual void    		    Enabled(bool state) = 0;
	virtual bool	    		Enabled() const = 0;

	virtual void    		    Run(bool state) = 0;
	virtual bool	    		Run() const = 0;

  	virtual void    		    FiniteFrames(bool state) = 0;
	virtual bool	    		FiniteFrames() const = 0;

  	virtual void    		    FiniteFrameRearm(bool state) = 0;
	virtual bool	    		FiniteFrameRearm() const = 0;

   	virtual void    		    FiniteFrameCount(unsigned short count) = 0;
	virtual unsigned short 		FiniteFrameCount() const = 0;

};

//==============================================================================
//  CLASS INullPriIntf -- Placeholder PRI functionality
//==============================================================================

class INullPriIntf : public IPulseRepetitionIntervalIntf
{
public:
    INullPriIntf()  {  }

	// Methods
	void 				Reset()  {  }
	void    		    Period(unsigned int /*samples*/)  {  }
	void    		    Delay(unsigned int /*samples*/)  {  }
	void    		    Width(unsigned int /*samples*/)  {  }
	void 				Apply()  {  }

	// Properties
	void    		    Enabled(bool /*state*/)  {  }
	bool	    		Enabled() const  {  return false;  }

	void    		    Run(bool /*state*/)  {  }
	bool	    		Run() const  {  return false;  }

   	virtual void    		    FiniteFrames(bool /*state*/)  {  }
	virtual bool	    		FiniteFrames() const {  return false;  }

  	virtual void    		    FiniteFrameRearm(bool /*state*/)  {  }
	virtual bool	    		FiniteFrameRearm() const {  return false;  }

   	virtual void    		    FiniteFrameCount(unsigned short /*count*/)  {  }
	virtual unsigned short 		FiniteFrameCount() const {  return 0;  }

};

#ifdef __CLR_VER
#pragma managed(pop)
#endif

} // end namespace Innovative


#endif
