//---------------------------------------------------------------------------
// QuadiaCs_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//


#include <QuadiaCs_Mb.h>

namespace Innovative
{
//===========================================================================
//  CLASS QuadiaCsRegisters  -- CS project Quadia extension registers
//===========================================================================
//---------------------------------------------------------------------------
//  housekeeping for class QuadiaCsRegisters
//---------------------------------------------------------------------------

// "Memory Map"
namespace  QuadiaCs_MemoryMap
{
const int   mmTrigger =  0x06;
}

using namespace QuadiaCs_MemoryMap;

//---------------------------------------------------------------------------
//  constructor for class QuadiaCsRegisters
//---------------------------------------------------------------------------
#ifdef _MSC_VER		
	#pragma warning(push)	
	#pragma warning(disable : 4355)		
#endif

QuadiaCsRegisters::QuadiaCsRegisters(AddressingSpace & PortMemory)
    :  TriggerReg(PortMemory, mmTrigger)
{
}

//---------------------------------------------------------------------------
//  destructor for class QuadiaCsRegisters
//---------------------------------------------------------------------------

QuadiaCsRegisters::~QuadiaCsRegisters()
{
}


//===========================================================================
//  CLASS QuadiaCsRegisters::TriggerRegister
//===========================================================================
//---------------------------------------------------------------------------
//  constructor for class QuadiaCsRegisters::CsTriggerRegister
//---------------------------------------------------------------------------

QuadiaCsRegisters::CsTriggerRegister::CsTriggerRegister(AddressingSpace &space, int offset )
    : inherited( space, offset ),
      AcquisitionEnabled( *this, 1 )
{
}

//===========================================================================
//  CLASS QuadiaCs  -- CS Quadia object baseboard
//===========================================================================
//---------------------------------------------------------------------------
//  housekeeping for class QuadiaCs
//---------------------------------------------------------------------------

const double max_rez = 4294967296.0;  //   2^32
const double base_freq = 130000000.0;

//---------------------------------------------------------------------------
//  constructor for class QuadiaCs
//---------------------------------------------------------------------------

QuadiaCs::QuadiaCs()
    :  XDevice(Device.PortMemory)
{
}

#ifdef _MSC_VER		
	#pragma warning(pop)	
#endif
//---------------------------------------------------------------------------
//  destructor for class QuadiaCs
//---------------------------------------------------------------------------

QuadiaCs::~QuadiaCs()
{
}

//---------------------------------------------------------------------------
//  QuadiaCs::StartAcquisition() -- Start data taking
//---------------------------------------------------------------------------

void  QuadiaCs::StartAcquisition()
{
    XDevice.TriggerReg.AcquisitionEnabled = true;
}

//---------------------------------------------------------------------------
//  QuadiaCs::StopAcquisition() -- stop data taking
//---------------------------------------------------------------------------

void  QuadiaCs::StopAcquisition()
{
    XDevice.TriggerReg.AcquisitionEnabled = false;
}


}  // end namespace Innovative;
