//  QuadiaCs_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef QuadiaCs_MbH
#define QuadiaCs_MbH

#include <HardwareRegister_Mb.h>
#include <Quadia_Mb.h>

namespace Innovative
{

//===========================================================================
//  CLASS QuadiaCsRegisters  -- CS Quadia object registers
//===========================================================================

class QuadiaCsRegisters
{
    friend class QuadiaCs;

public:
    //
    //  Member Functions
    QuadiaCsRegisters(AddressingSpace & PortMemory);
    ~QuadiaCsRegisters();

private:
    //
    //  Class CsTriggerRegister
    class CsTriggerRegister : public ShadowRegister
    {
        typedef ShadowRegister inherited;

    public:
        RegisterBit  AcquisitionEnabled;

    public:
        CsTriggerRegister(AddressingSpace &space, int offset );
    };

    CsTriggerRegister   TriggerReg;

};

//===========================================================================
//  CLASS QuadiaCs  -- CS Quadia object baseboard "helper"
//===========================================================================

class QuadiaCs : public Quadia
{
public:
    //
    //  Member Functions
    QuadiaCs();
    ~QuadiaCs();

    void  StartAcquisition();
    void  StopAcquisition();

protected:
    QuadiaCsRegisters  XDevice;
};

}; // namespace Innovative

//---------------------------------------------------------------------------
#endif


