//---------------------------------------------------------------------------
// QuadiaDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <QuadiaDeviceDriver_Mb.h>

//
//  Nameless namespace for 'static' data
namespace
{
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "QUADIADRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x0009
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
        "Quadia",     TARGET_BASE,         0x1303,      0x0009,     0x00,        false);
    }
};

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS QuadiaDeviceDriver  -- Driver level code for Quadia baseboard
//===========================================================================

//---------------------------------------------------------------------------
//  constructor for class QuadiaDeviceDriver
//---------------------------------------------------------------------------

QuadiaDeviceDriver::QuadiaDeviceDriver()
    :  InnovativeKernel::DualPortDeviceDriver(
            InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID), 1, 0)
{
}

//---------------------------------------------------------------------------
}; // Innovative

