// Quadia_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef Quadia_MbH
#define Quadia_MbH


#include <DataTypes_Mb.h>
#include <ProcessEvents_Mb.h>
#include <QuadiaDeviceMap_Mb.h>
#include <BaseboardInterfaces_Mb.h>
#include <LogicTemperatureIntf_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class FpaLoadThread;

//===========================================================================
//  CLASS Quadia  -- Quadia Base Board object
//===========================================================================

class Quadia
{
public:
    enum  LogicSelect { lsFpga0, lsFpga1, lsBothFpga };
    enum  BoardVariant { vQuadia, vDuet };
    //
    //  Member Functions
    Quadia();
    virtual ~Quadia();

    size_t          BoardCount();
    void            Open();
    void            Close();

    int   Target();
    void  Target( int value );

    bool  Led();
    void  Led( bool value );

    void  GlobalTrigger(bool value);
    void  LogicInReset(LogicSelect which, bool state);

    ii32  Dpram( int offset );
    void  Dpram( int offset, ii32 value );
    ii32  Port( int offset );
    void  Port( int offset, ii32 value );

    QuadiaDeviceMap * Debug() { return &Device; };
    InnovativeKernel::DeviceEntry & DeviceInfo();

    virtual void   Log(int /*type*/, int /*data*/)
        {  };

    // Support
    virtual void  Reset();
    BoardVariant  Variant()  {  return static_cast<BoardVariant>(Device.FVariant);  }

    // Logic programming
    IUsesVirtexFpgaLoader & Logic(int index);
    // EEprom programming
    IUsesVirtexJtagLoader & Eeprom();
    // PCI Version Info
    PciLogicVersionInfoIntf & PciLogicVersion();

    // Information
    ii32 *   PortAddress();
    ii32 *   PortPhysicalAddress();
    ii32     PortSizeWords();

    ii32 *   DpramAddress();
    ii32 *   DpramPhysicalAddress();
    ii32     DpramSizeWords();

	DualLogicTemperatureIntf &	Thermal();
    //InnovativeKernel::BoardInfo & BusInfo();

protected:
    //
    //  Member Data
    QuadiaDeviceMap          Device;

};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative

#endif

