// QuixoteDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2006 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <QuixoteDeviceDriver_Mb.h>

//
//  Nameless namespace for 'static' data
namespace
{
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "VelociaDRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x0007
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard -- Register Quixote
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID    Device ID   Sub ID   CheckSubID
        "Quixote",    TARGET_BASE,         0x1303,      0x0007,     0x00,     false);
    }
};

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS QuixoteDeviceDriver  -- Driver level code for Quixote baseboard
//===========================================================================

//---------------------------------------------------------------------------
//  constructor for class QuixoteDeviceDriver
//---------------------------------------------------------------------------

QuixoteDeviceDriver::QuixoteDeviceDriver()
    :  InnovativeKernel::DeviceDriver(
                InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID)  )    
{
}

} // namespace Innovative
