// QuixoteDeviceMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef QuixoteDeviceMap_MbH
#define QuixoteDeviceMap_MbH

#include <VirtexFpgaLoader_Mb.h>
#include <HardwareRegister_Mb.h>
#include <FpaLoadThread_Mb.h>
#include <FpaLoadBase_Mb.h>
#include <FpgaLogicVersionInfo_Mb.h>
#include <PciLogicVersionInfo_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class QuixoteDeviceDriver;

//===========================================================================
//  CLASS QuixoteDeviceMap  --
//===========================================================================

class QuixoteDeviceMap  :  public IUsesVirtexFpgaLoader,
                           public IUsesNullFpgaLogicVersionInfo,
                           public IUsesNullPciLogicVersionInfo

{
    friend class Quixote;
    
public:
    //
    //  Member Functions
    QuixoteDeviceMap();
    virtual ~QuixoteDeviceMap();

    size_t          BoardCount();
    void            Open();
    void            Close();

    void  Reset();

    int   Target();
    void  Target( int value );

    bool  Led();
    void  Led( bool value );

    bool  DspInReset();
    void  DspInReset( bool value );

    InnovativeKernel::DeviceEntry &   DeviceInfo();

protected:

    class ControlRegister : public ShadowRegister
    {
    public:
          RegisterBit       AllowBusmaster;
          RegisterBit       Led;
          RegisterBit       BaseboardReset;
          RegisterBit       HostSystemReady;
          RegisterBit       DSPInReset;
          RegisterBit       BusMasterInReset;

    public:
          ControlRegister( AddressingSpace &space, int offset );

    };

    QuixoteDeviceDriver *         Driver;

    AddressingSpace               PortMemory;
    ControlRegister               ControlReg;

private:
    //
    //  Member Data
    // FPA Eeprom programmer
    class FpaLoadThread *         EepromLoader;
    class QuixoteFpaLoader *      FFpa;
    //
    //  Member Functions
    void   ClearControlRegister();

protected:

    void      Error( std::string & message );

    bool      GetLed();
    void      SetLed( bool value );
    bool      GetDspInReset();
    void      SetDspInReset( bool value );
    int       GetTarget();
    void      SetTarget( int target );

};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
