//   QuixoteMemoryMap_Mb.h    Memory Map for Quixote baseboard
//

#ifndef QuadiaMemoryMap_MbH
#define QuadiaMemoryMap_MbH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace Quixote_MemoryMap
{
    const unsigned int  mmMailboxRamBase     = 0x0c000;
    const unsigned int  mmMailboxRam0        = 0x0c000;
    const unsigned int  mmMailboxRam1        = 0x0c001;
    const unsigned int  mmMailboxRam2        = 0x0c002;
    const unsigned int  mmMailboxRam3        = 0x0c003;
    const unsigned int  mmMailboxRam4        = 0x0c004;
    const unsigned int  mmMailboxRam5        = 0x0c005;
    const unsigned int  mmMailboxRam6        = 0x0c006;
    const unsigned int  mmMailboxRam7        = 0x0c007;
    const unsigned int  mmMailboxRam8        = 0x0c008;
    const unsigned int  mmMailboxRam9        = 0x0c009;
    const unsigned int  mmMailboxRam10       = 0x0c00a;
    const unsigned int  mmMailboxRam11       = 0x0c00b;
    const unsigned int  mmMailboxRam12       = 0x0c00c;
    const unsigned int  mmMailboxRam13       = 0x0c00d;
    const unsigned int  mmMailboxRam14       = 0x0c00e;
    const unsigned int  mmMailboxRam15       = 0x0c00f;

    const unsigned int  mmFpgaData           = 0x12000;
    const unsigned int  mmFpgaControl        = 0x12400;

    const unsigned int  mmFpaReg             = 0x12c00;
    const unsigned int  mmFifoLevelControl   = 0x13000;

    const unsigned int  mmPciBackplaneEnable = 0x14000;
    const unsigned int  mmPciInterruptEnable = 0x14400;

    const unsigned int  mmBmReadAddressReg   = 0x15000;
    const unsigned int  mmBmWriteAddressReg  = 0x15400;
    const unsigned int  mmBmRegionSizeReg    = 0x15800;

    const unsigned int  mmMailboxCmdReg      = 0x17800;
    const unsigned int  mmMailboxClearReg    = 0x17c00;

    const unsigned int  mmInterruptStatus    = 0x19000;
    const unsigned int  mmControlStatusReg   = 0x19400;

    const unsigned int  mmHpiControlLswReg   = 0x1c000;
    const unsigned int  mmHpiControlMswReg   = 0x1c400;
    const unsigned int  mmHpiAddressLswReg   = 0x1c800;
    const unsigned int  mmHpiAddressMswReg   = 0x1cc00;
    const unsigned int  mmHpiDataIncrLswReg  = 0x1d000;
    const unsigned int  mmHpiDataIncrMswReg  = 0x1d400;
    const unsigned int  mmHpiDataLswReg      = 0x1d800;
    const unsigned int  mmHpiDataMswReg      = 0x1dc00;

}

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative



#endif
