// Quixote_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2006 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <Quixote_Mb.h>
#include <Exception_Mb.h>

namespace Innovative
{
//===========================================================================
//  CLASS Quixote  --  Quixote DSP baseboard class
//===========================================================================

//---------------------------------------------------------------------------
//  constructor for class Quixote
//---------------------------------------------------------------------------

Quixote::Quixote()
{
}

//---------------------------------------------------------------------------
//  destructor for class Quixote
//---------------------------------------------------------------------------
 
Quixote::~Quixote()
{
}

//---------------------------------------------------------------------------
//  Quixote::BoardCount() --
//---------------------------------------------------------------------------
 
size_t Quixote::BoardCount()
{
    return Device.BoardCount();
}

//---------------------------------------------------------------------------
//  Quixote::Open() --
//---------------------------------------------------------------------------

void Quixote::Open()
{
    Device.Open();
}

//---------------------------------------------------------------------------
//  Quixote::Close() --
//---------------------------------------------------------------------------

void Quixote::Close()
{
    Device.Close();
}

//---------------------------------------------------------------------------
//  Quixote::Reset() --
//------------------------------------------------------------------------------
 
void Quixote::Reset()
{
    Device.Reset();    //  Board Reset
}

//---------------------------------------------------------------------------
//  Quixote::Logic() -- Return reference to FPGA Loader Interface
//---------------------------------------------------------------------------

IUsesVirtexFpgaLoader & Quixote::Logic()
{
    return Device;
}

//---------------------------------------------------------------------------
//  Quixote::VsProm() -- Return reference to FPA object
//---------------------------------------------------------------------------

FpaLoadThread & Quixote::VsProm()
{
    return *Device.EepromLoader;
}

//---------------------------------------------------------------------------
//  Quixote::Target() -- Get the target number of the board
//---------------------------------------------------------------------------

int  Quixote::Target()
{
    return Device.Target();
}

//---------------------------------------------------------------------------
//  Quixote::Target() -- Set the target number of the board
//---------------------------------------------------------------------------

void  Quixote::Target( int value )
{
    Device.Target(value);
}

//---------------------------------------------------------------------------
//  Quixote::Led() -- Read the LED state of the board
//---------------------------------------------------------------------------

bool  Quixote::Led()
{
    return Device.Led();
}

//---------------------------------------------------------------------------
//  Quixote::Led() -- Set the LED state of the board
//---------------------------------------------------------------------------

void  Quixote::Led( bool value )
{
    Device.Led(value);
}

//---------------------------------------------------------------------------
//  Quixote::DspInReset() -- Read the Dsp Reset bit
//---------------------------------------------------------------------------

bool  Quixote::DspInReset()
{
    return Device.DspInReset();
}

//---------------------------------------------------------------------------
//  Quixote::DspInReset() -- Set the Dsp Reset bit
//---------------------------------------------------------------------------

void  Quixote::DspInReset( bool value )
{
    Device.DspInReset(value);
}

//---------------------------------------------------------------------------
//  M6713::UserLogicVersion() -- Get User Logic version info
//---------------------------------------------------------------------------

FpgaLogicVersionInfoIntf & Quixote::UserLogicVersion()
{
    return Device;
}

//---------------------------------------------------------------------------
//  M6713::PciLogicVersion() -- Get PCI Logic version info
//---------------------------------------------------------------------------

PciLogicVersionInfoIntf & Quixote::PciLogicVersion()
{
    return Device;
}

//---------------------------------------------------------------------------
//  Quixote::DeviceInfo() --
//---------------------------------------------------------------------------

InnovativeKernel::DeviceEntry & Quixote::DeviceInfo()
{
    return Device.DeviceInfo();
}



} // Innovative

