// Quixote_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2006 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef Quixote_MbH
#define Quixote_MbH

#include <ProcessEvents_Mb.h>
#include <StreamSupport_Mb.h>
#include <MatadorMessageSupport_Mb.h>
#include <Event_Mb.h>
#include <QuixoteDeviceMap_Mb.h>

class BufferIndexEvent;

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class CoffFile;
class MemWriteEvent;

class MatadorDeviceMap;
class MessageHdw;
class MatadorMessageQueue;
class MatadorMessage;

//===========================================================================
//  CLASS Quixote  --  Quixote DSP baseboard class
//===========================================================================

class Quixote
{
public:
    //
    //  Member Functions
    Quixote();
    virtual ~Quixote();

    size_t          BoardCount();
    void            Open();
    void            Close();

    void  Reset();

    int   Target();
    void  Target( int value );

    bool  Led();
    void  Led( bool value );

    FpgaLogicVersionInfoIntf & UserLogicVersion();
    PciLogicVersionInfoIntf  & PciLogicVersion();

    // Logic programming
    IUsesVirtexFpgaLoader &   Logic();
    // EEprom programming
    FpaLoadThread & VsProm();
    InnovativeKernel::DeviceEntry & DeviceInfo();

protected:
    //
    //  Member Data
    QuixoteDeviceMap    Device;

private:

    bool  DspInReset();
    void  DspInReset( bool value );


};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
