// RamDataSet.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//
//---------------------------------------------------------------------------

#ifndef RamDataSet_Mb_H
#define RamDataSet_Mb_H

#include <DataSetBase_Mb.h>

namespace Innovative
{

#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
// Class RamDataSet
//===========================================================================

class RamDataSet : public EventStreamDataSet
{
public:
	RamDataSet();
	virtual ~RamDataSet();

	// Properties
	void				Memory(char * value);
	char *				Memory() const
		{  return FMemory;  }

protected:
    // Override Methods
    virtual bool        ImageOpen();
    virtual void        ImageClose();
	virtual void        ImageFetch(Subsample & sample);
	virtual void        ImageStore(Subsample & sample);
	virtual void        ImageSkip(ii64 offset);
	virtual void        ImageSeek(ii64 offset);
	virtual ii64     	ImageSize() const;
	virtual void        ImageSize(ii64 size);
	virtual void        ImageFlush();
	virtual void        ImageReadIniFile(IniFile & Ini);
	virtual void        ImageWriteIniFile(IniFile & Ini);

private:
	// Methods
	void /*__fastcall*/      SetMemory(char *memory);

    // Data
    ii64                 Position;

    // Fields
	bool                 FAutoCreate;        // Auto-create files on open fail
	ii64                 FSize;              // Size of image, in bytes
	char*                FMemory;            // Pointer to image memory
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
