// RamLogger_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef RamLogger_MbH
#define RamLogger_MbH

#include <DataTypes_Mb.h>
#include <Events_Mb.h>
#include <string>
#include <vector>
#include <ProgressEvent_Mb.h>
#include <Buffer_Mb.h>
#include <ProcessEvents_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//=============================================================================
//  CLASS RamLogger  --
//=============================================================================

class RamLogger
{
    friend class PostProcessingThread;

public:
    RamLogger();
    RamLogger( const RamLogger & other );
    ~RamLogger();

    // Assignment
    RamLogger & operator = (const RamLogger & other);

    // Methods
    void Start();
    void Stop();

    void Log( Buffer &buffer );
    void Log( const int * data, unsigned int size_in_ints );

    void LogWithHeader( Buffer &buffer );

    ii64 Logged() const;

    // Properties
    void                        Ceiling(ii64 value);
    ii64                        Ceiling() const;

    void                        FileName(const std::string & value);
    std::string                 FileName() const;

    void                        Enabled(bool state);
    bool                        Enabled() const;

    // Events
    OpenWire::EventHandler<ProgressEvent>           OnProgress;
    OpenWire::EventHandler<StartBufferEvent>        OnStart;
    OpenWire::EventHandler<OpenWire::NotifyEvent>   OnStop;

protected:
    // Fields
    ii64                        FLogged;
    ii64                        FCeiling;
    std::string                 FFileName;
    bool                        FEnabled;

    // Data
    char *                          image;
    class PostProcessingThread *    Task;

    void DoLogging(const void *data, unsigned int bytes);
    void SetCeiling(ii64 position);

};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
