// IIRandomGen.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef IIRandomGen_MbH
#define IIRandomGen_MbH

#include <CommonGen_Mb.h>
#ifndef VXWORKS
#include <IppFloatDG_Mb.h>
#endif

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//=============================================================================
//  CLASS RandomGen  --
//=============================================================================

class RandomGen : public CommonGen
{
    typedef CommonGen inherited;

public:
    // Ctor
    RandomGen();
    RandomGen(const RandomGen & other);

    // Assignment
    RandomGen & operator = ( const RandomGen & other );

    // Methods
	virtual bool            Generate(IppFloatDG & buffer);
	virtual bool    		Generate(IppComplexDG & buffer);

    // Properties
    void                    Low(float value);
    float                   Low() const;

    void                    High(float value);
    float                   High() const;

    void                    Seed(unsigned int value);
    unsigned int            Seed() const;

protected:
	// Methods
    bool 				update();

    // Fields
    float               FLow;
    float               FHigh;
	unsigned int        FSeed;

	void * 				mState;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // Innovative

#endif
