// SRecord_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef SRecord_MbH
#define SRecord_MbH

#include <FpgaImage_Mb.h>
#include <StringList_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class SRecord;

//===========================================================================
// CLASS SRecord  --  Motorola S-record file reader
//===========================================================================

class SRecord : public FpgaImage
{
public:
    // CTor
    SRecord(int maxsize=(1<<22));
    virtual ~SRecord();

    // Methods
    virtual void        Parse();
    int                 GetChecksum() const;

private:
    // Fields
    unsigned int            FSize;

    // Data
    typedef StringList      List;
    List                    Image;
    std::string             Comment;
    std::string             Line;
    int                     Cursor;
    int                     Address;


    // Methods
    int               Digit(int Width=2);
    void              ParseLine();
    void              ParseData(int Width);
    void              SetBuffer(int i, unsigned char value)
        {  Buffer[i] = value;  }
    unsigned char     GetBuffer(int i)
        {  return Buffer[i];  }
    void              SetMaxSize(int size)
        {  return Buffer.resize(size);  }
    int               GetMaxSize() const
        {  return static_cast<int>(Buffer.size());  }

    void  HandleOnFileReadProgress(ProcessProgressEvent & event);
    void  HandleOnFileReadComplete(ProcessCompletionEvent & event);

};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative

#endif
