// Sbc6713e_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//
//  SBC6713e baseboard support class
#include <Sbc6713e_Mb.h>
#include <NetCoffLoadThread_Mb.h>
#include <NetImageLoadThread_Mb.h>
#include <NetTransferThread_Mb.h>
#include <NetInfoCommThread_Mb.h>
#include <SetBoardInfoThread_Mb.h>
#include <NetTargetResetThread_Mb.h>
#include <NetSystemTestThread_Mb.h>
#undef min
#include <algorithm>

namespace   Innovative
{

//=============================================================================
//  CLASS Sbc6713e  --  Baseboard Class for SBC6713e
//=============================================================================
//------------------------------------------------------------------------------
//  constructor for class Sbc6713e
//------------------------------------------------------------------------------

Sbc6713e::Sbc6713e(std::string net_id) :
    FallowBuff(2),
    NCL(0), OXfr(0), IXfr(0), NILT(0), NICT(0), SBIT(0), NTRT(0), NSTT(0),
    FAbortSend(false), FAbortReceive(false),  NetId(net_id)
{
}

//------------------------------------------------------------------------------
//  destructor for class Sbc6713e
//------------------------------------------------------------------------------

Sbc6713e::~Sbc6713e()
{
    if (NILT)
        {
        delete NILT;
        NILT = 0;
        }
    if (NCL)
        {
        delete NCL;     // ???? Self-deleting thread class?
        NCL = 0;
        }
    if (OXfr)
        {
        delete OXfr;
        OXfr = 0;
        }
    if (IXfr)
        {
        delete IXfr;
        IXfr = 0;
        }
    if (NICT)
        {
        delete NICT;
        NICT = 0;
        }
    if (SBIT)
        {
        delete SBIT;
        SBIT = 0;
        }
    if (NTRT)
        {
    	delete NTRT;
        NTRT = 0;
        }
    if (NSTT)
        {
        delete NSTT;
        NSTT = 0;
        }
}

//------------------------------------------------------------------------------
//  Sbc6713e::RequestCoffLoad()  --  Begin COFF load process...
//------------------------------------------------------------------------------

void Sbc6713e::RequestCoffLoad(std::string coff_file)
{
    if (NCL)
        {
        delete NCL;
        NCL = 0;
        }
    NCL = new NetCoffLoadThread(*this, coff_file);
}

//------------------------------------------------------------------------------
//  Sbc6713e::DownloadProgress()  --  COFF load progress
//------------------------------------------------------------------------------

void Sbc6713e::DownloadProgress(ProcessProgressEvent & Event)
{
    //
    //  Forward the event
    OnDownloadProgress.Execute(Event);
}

//------------------------------------------------------------------------------
//  Sbc6713e::DownloadComplete()  --  COFF load completion
//------------------------------------------------------------------------------

void Sbc6713e::DownloadComplete(ProcessCompletionEvent & Event)
{
    //
    //  Forward the event
    OnDownloadComplete.Execute(Event);
}

//------------------------------------------------------------------------------
//  Sbc6713e::LogicParseProgress()  --  Forward Logic Parse Progress events
//------------------------------------------------------------------------------

void Sbc6713e::LogicParseProgress(ProcessProgressEvent & Event)
{
    //
    //  Forward the event
    OnLogicParseProgress.Execute(Event);
}

//------------------------------------------------------------------------------
//  Sbc6713e::LogicParseComplete()  --  Forward S-Record Parse Complete event
//------------------------------------------------------------------------------

void Sbc6713e::LogicParseComplete(ProcessCompletionEvent & Event)
{
    //
    //  Forward the event
    OnLogicParseComplete.Execute(Event);
}

//------------------------------------------------------------------------------
//  Sbc6713e::LogicLoadProgress()  --  Forward Logic Progress events
//------------------------------------------------------------------------------

void Sbc6713e::LogicLoadProgress(ProcessProgressEvent & Event)
{
    //
    //  Forward the event
    OnLogicLoadProgress.Execute(Event);
}

//------------------------------------------------------------------------------
//  Sbc6713e::LogicLoadComplete()  --  Forward S-Record Logic Complete event
//------------------------------------------------------------------------------

void Sbc6713e::LogicLoadComplete(ProcessCompletionEvent & Event)
{
    //
    //  Forward the event
    OnLogicLoadComplete.Execute(Event);
}

//------------------------------------------------------------------------------
//  Sbc6713e::InfoRqstComplete()  --  Forward information request Complete event
//------------------------------------------------------------------------------

void Sbc6713e::InfoRqstComplete(ProcessCompletionEvent & Event)
{
    //
    //  Forward the event
    OnInfoRqstComplete.Execute(Event);
}

//------------------------------------------------------------------------------
//  Sbc6713e::LogicLoadError()  --  Forward Logic Error events
//------------------------------------------------------------------------------

void Sbc6713e::LogicLoadError(ProcessStatusEvent & Event)
{
    //
    //  Forward the event
    OnLogicLoadError.Execute(Event);
}

//------------------------------------------------------------------------------
//  Sbc6713e::InfoRqstError()  --  Forward information request Error events
//------------------------------------------------------------------------------

void Sbc6713e::InfoRqstError(ProcessStatusEvent & Event)
{
    //
    //  Forward the event
    OnInfoRqstError.Execute(Event);
}

//------------------------------------------------------------------------------
//  Sbc6713e::Send()  --  Send a message packet to Sbc6713e
//  Returns:  NetworkTimeoutErr = 0, Success = 1, TargetTimeoutErr = 2, TargetErr = 3.
//------------------------------------------------------------------------------

Sbc6713e::CommStatusCodes Sbc6713e::Send(Buffer&  buffer)
{
    if (OXfr == 0)
        OXfr = new NetOutboundXfrThread(*this);

    return (OXfr->Send(buffer));
}

//------------------------------------------------------------------------------
//  Sbc6713e::SendCommand()  --  Send a command packet to Sbc6713e
//  Returns:  NetworkTimeoutErr = 0, Success = 1, TargetTimeoutErr = 2, TargetErr = 3.
//------------------------------------------------------------------------------

Sbc6713e::CommStatusCodes Sbc6713e::SendCommand(short CommandId, int Arg0, int Arg1, int Arg2)
{
    if (OXfr == 0)
        OXfr = new NetOutboundXfrThread(*this);

    return (OXfr->SendCommand(CommandId, Arg0, Arg1, Arg2));
}

//------------------------------------------------------------------------------
// Sbc6713e::SendClose()
//------------------------------------------------------------------------------

Sbc6713e::CommStatusCodes Sbc6713e::SendClose()
{
    if (OXfr == 0)
        OXfr = new NetOutboundXfrThread(*this);

    return (OXfr->SendClose());
}

//------------------------------------------------------------------------------
//  Sbc6713e::Recv()  --  Wait for a command or data packet from Sbc6713e
//  Returns:  NetworkTimeoutErr = 0, Success = 1, TargetTimeoutErr = 2, TargetErr = 3.
//------------------------------------------------------------------------------

Sbc6713e::CommStatusCodes Sbc6713e::Recv(RecvType&  which, Buffer&  aBuffer)
{
    if (IXfr == 0)
        IXfr = new NetInboundXfrThread(*this);

    return (IXfr->Recv(which, aBuffer));
}

//------------------------------------------------------------------------------
//  Sbc6713e::Recv()  --  Wait for a command or data packet from Sbc6713e
//  Returns:  NetworkTimeoutErr = 0, Success = 1, TargetTimeoutErr = 2, TargetErr = 3.
//------------------------------------------------------------------------------

Sbc6713e::CommStatusCodes Sbc6713e::Recv(Buffer&  aBuffer)
{
    if (IXfr == 0)
        IXfr = new NetInboundXfrThread(*this);

    return (IXfr->Recv(aBuffer));
}

//------------------------------------------------------------------------------
//  Sbc6713e::Recv()  --  Wait for a command or data packet from Sbc6713e
//  Returns:  NetworkTimeoutErr = 0, Success = 1, TargetTimeoutErr = 2, TargetErr = 3.
//------------------------------------------------------------------------------

Sbc6713e::CommStatusCodes Sbc6713e::RecvClose()
{
    if (IXfr == 0)
        IXfr = new NetInboundXfrThread(*this);

    return (IXfr->RecvClose());
}

//------------------------------------------------------------------------------
// CommStatusCodes Sbc6713e::ClearPendingXfrs()
// This method to be called when you suspect that C6713 DSP has crashed, but DM642
// is still viable. This method returns Success upon DM642 execution of command.
// This command will clear pending EDMA transactions between DM642 and C6713 DSPs.
//------------------------------------------------------------------------------

Sbc6713e::CommStatusCodes Sbc6713e::ClearPendingXfrs()
{
    if (OXfr == 0)
        OXfr = new NetOutboundXfrThread(*this);

    return (OXfr->ClearPendingXfrs());
}

//------------------------------------------------------------------------------
//  Sbc6713e::RequestImageLoad()  --  Load image file to board ROM
//------------------------------------------------------------------------------

void Sbc6713e::RequestImageLoad(LoadInfoType which, std::string exo_file)
{
    if (NILT)
        {
        delete NILT;
        NILT = 0;
        }
    NILT = new NetImageLoadThread(*this, which, exo_file);
}

//------------------------------------------------------------------------------
// Sbc6713e::RequestMiscComm(), reads firmware rev. and IP info from target.
//------------------------------------------------------------------------------

void Sbc6713e::RequestMiscComm(MiscCommId which , int Arg0 , int Arg1)
{
    if (NICT)
        {
        delete NICT;
        NICT = 0;
        }
    NICT = new NetInfoCommThread(*this, which, Arg0, Arg1);
}

//------------------------------------------------------------------------------
// Sbc6713e::WriteMiscComm, writes-to-target IP info or AppBoot setting.
//------------------------------------------------------------------------------

void  Sbc6713e::WriteMiscComm(MiscCommId which, TargetInfo Arg0, int Arg1)
{
    if (SBIT)
        {
        delete SBIT;
        SBIT = 0;
        }
    SBIT = new SetBoardInfoThread(*this, which, Arg0, Arg1);
}

//------------------------------------------------------------------------------
// Sbc6713e::TargetFwareInfo(), stores target firmware rev, read from board.
//------------------------------------------------------------------------------

void Sbc6713e::TargetFwareInfo(int ClientFwareVer, int IntfLogicVer, int LanLogicVer)
{
    BoardInfo.TargetFwareInfo(ClientFwareVer, IntfLogicVer, LanLogicVer );
}

//------------------------------------------------------------------------------
// Sbc6713e::IntfLogicVersion(), reads target Intf logic rev, read from board.
//------------------------------------------------------------------------------

int Sbc6713e::IntfLogicVersion()
{
    return BoardInfo.IntfLogicVersion();
}

//------------------------------------------------------------------------------
// Sbc6713e::LanLogicVersion(), reads target Lan logic rev, read from board.
//------------------------------------------------------------------------------

int Sbc6713e::LanLogicVersion()
{
    return BoardInfo.LanLogicVersion();
}

//------------------------------------------------------------------------------
// Sbc6713e::ClientFwareVersion(), reads target Client firmware rev, read from board.
//------------------------------------------------------------------------------

int Sbc6713e::ClientFwareVersion()
{
    return BoardInfo.ClientFwareVersion();
}

//------------------------------------------------------------------------------
// Sbc6713e::SerialNoBoardRev(), stores target Serial Number and board rev.
//------------------------------------------------------------------------------

void Sbc6713e::SerialNoBoardRev(short sn, char rev)
{
    BoardInfo.SerialNoBoardRev(sn, rev);
}

//------------------------------------------------------------------------------
// Sbc6713e::SerialNumber(), reads target Serial Number.
//------------------------------------------------------------------------------
short Sbc6713e::SerialNumber()
{
    return BoardInfo.SerialNumber();
}

//------------------------------------------------------------------------------
// Sbc6713e::BoardRevision(), reads board revision.
//------------------------------------------------------------------------------
char Sbc6713e::BoardRevision()
{
    return BoardInfo.BoardRevision();
}

//------------------------------------------------------------------------------
// Sbc6713e::SetBoardIpInfo(), stores IP info read from board (target).
//------------------------------------------------------------------------------
void Sbc6713e::StaticIPInfo( const char * TargetIpAddr, const char * TargetIpMask,
                   const char * gatewayIPAddr, const char * dnsServerIpAddr,
                   const char * domainName )
{
    BoardInfo.StaticIPInfo(TargetIpAddr, TargetIpMask, gatewayIPAddr,
                           dnsServerIpAddr, domainName);
}

//------------------------------------------------------------------------------
// Sbc6713e::UseStaticIp(), reads flag if target to use Static IP info.
//------------------------------------------------------------------------------

bool Sbc6713e::UseStaticIp()
{
    return BoardInfo.UseStaticIp();
}

//------------------------------------------------------------------------------
// Sbc6713e::UseStaticIp(), sets flag if target uses or is to use Static IP info.
//------------------------------------------------------------------------------

void Sbc6713e::UseStaticIp(bool state)
{
    BoardInfo.UseStaticIp(state);
}

//------------------------------------------------------------------------------
// Sbc6713e::TargetIpAddress(), reads IP info read from board (target).
//------------------------------------------------------------------------------

const char * Sbc6713e::TargetIpAddress() const
{
    return  BoardInfo.TargetIpAddress();
}

//------------------------------------------------------------------------------
// Sbc6713e::TargetIpMask(), reads IP mask info read from board (target).
//------------------------------------------------------------------------------

const char * Sbc6713e::TargetIpMask() const
{
    return  BoardInfo.TargetIpMask();
}

//------------------------------------------------------------------------------
// Sbc6713e::GatewayIpAddress(), reads Gate Way IP addr read from target.
//------------------------------------------------------------------------------

const char * Sbc6713e::GatewayIpAddress() const
{
    return  BoardInfo.GatewayIpAddress();
}

//------------------------------------------------------------------------------
// Sbc6713e::DnsServerIPAddress(), reads Dns IP addr read from target.
//------------------------------------------------------------------------------

const char * Sbc6713e::DnsServerIPAddress() const
{
    return  BoardInfo.DnsServerIPAddress();
}

//------------------------------------------------------------------------------
// Sbc6713e::DomainName(), reads Domain Name read from target.
//------------------------------------------------------------------------------

const char * Sbc6713e::DomainName() const
{
    return  BoardInfo.DomainName();
}

//------------------------------------------------------------------------------
// Sbc6713e::BootApplication(), sets flag "boot customer application program.
//------------------------------------------------------------------------------
void Sbc6713e::BootApplication( bool state )
{
    BoardInfo.BootApplication(state);
}

//------------------------------------------------------------------------------
// Sbc6713e::BootApplication(), reads flag "boot customer application program.
//------------------------------------------------------------------------------

bool Sbc6713e::BootApplication()
{
    return  BoardInfo.BootApplication();
}

//------------------------------------------------------------------------------
// Sbc6713e::RequestTargetReset(), sends a command to DM642 to reset entire card.
//------------------------------------------------------------------------------
void Sbc6713e::RequestTargetReset()
{
    if (NTRT)
        {
        delete NTRT;
        NTRT = 0;
        }
    NTRT = new NetTargetResetThread(*this, (Sbc6713e::MiscCommId)resetTarget, 0, 0);
}

//------------------------------------------------------------------------------
// Sbc6713e::GetSystemTestInfo() - query system test results.
//------------------------------------------------------------------------------

void Sbc6713e::GetSystemTestInfo(SystemTestInfo & info)
{
    if (!NSTT)
        NSTT = new NetSystemTestThread(*this);

    return (NSTT->GetSystemTestInfo(info));
}

//=============================================================================
//  CLASS TransferPacketHeader  --  Packet Data Transfer Header
//=============================================================================
//-----------------------------------------------------------------------------
//  housekeeping for class TransferPacketHeader
//-----------------------------------------------------------------------------
const int   DestinationAddrFieldIdx = 0;
const int   SizeFieldIdx = 1;

//const int TypeFieldIdx            = 2;
const int   ChannelFieldIdx = 2;
const int   UserFieldIdx = 3;

const int   TypeFieldSize = 16;
const int   TypeFieldBaseBit = 16;
const int   ReadChannelFieldSize = 8;
const int   ReadChannelFieldBaseBit = 0;
const int   WriteChannelFieldSize = 8;
const int   WriteChannelFieldBaseBit = 8;

namespace
{

void WriteField(Register reg, int start_bit, int width, int value)
{
    RegisterBitGroup    RBG(reg, start_bit, width);
    RBG.Value(value);
}

// Fix me
int ReadField(Register reg, int start_bit, int width)
{
    RegisterBitGroup    RBG(reg, start_bit, width);
    return RBG.Value();
}

}

//-----------------------------------------------------------------------------
//  constructor for class TransferPacketHeader
//-----------------------------------------------------------------------------

TransferPacketHeader::TransferPacketHeader() : HeaderTCWord(HeaderAS, ChannelFieldIdx)
{
    HeaderAS.Link(&Header[0]);
    Clear();
}

//-----------------------------------------------------------------------------
//  destructor for class TransferPacketHeader
//-----------------------------------------------------------------------------

TransferPacketHeader::~TransferPacketHeader()
{
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::Clear() -- Clear out header data
//-----------------------------------------------------------------------------

void TransferPacketHeader::Clear()
{
    for (int i = 0; i < 4; i++)
        Header[i] = 0;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::ReadChannel() -- Set Channel field to a Read channel
//-----------------------------------------------------------------------------

TransferPacketHeader &TransferPacketHeader::ReadChannel(int ch)
{
    if (ch >= 8)
        return *this;

    // Only one bit can be on in Read Channel AND Write Channel fields
    //   so erase both fields
    WriteField(HeaderTCWord, ReadChannelFieldBaseBit, ReadChannelFieldSize, 0);
    WriteField(HeaderTCWord,
               WriteChannelFieldBaseBit,
               WriteChannelFieldSize,
               0);

    //
    //  Set the bit now selected
    HeaderTCWord.Bit(ReadChannelFieldBaseBit + ch, true);

    return *this;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::WriteChannel() -- Set Channel to a write channel
//-----------------------------------------------------------------------------

TransferPacketHeader &TransferPacketHeader::WriteChannel(int ch)
{
    if (ch >= 8)
        return *this;

    // Only one bit can be on in Read Channel AND Write Channel fields
    //   so erase both fields
    WriteField(HeaderTCWord, ReadChannelFieldBaseBit, ReadChannelFieldSize, 0);
    WriteField(HeaderTCWord,
               WriteChannelFieldBaseBit,
               WriteChannelFieldSize,
               0);

    //
    //  Set the bit now selected
    HeaderTCWord.Bit(WriteChannelFieldBaseBit + ch, true);

    return *this;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::IsReadTransfer() -- Rtns T if transfer is Read Xfr
//-----------------------------------------------------------------------------

bool TransferPacketHeader::IsReadTransfer() const
{

    // If the Read field has a bit set, it is a read transfer
    int RF = ReadField(HeaderTCWord,
                       ReadChannelFieldBaseBit,
                       ReadChannelFieldSize);
    return RF != 0;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::IsWriteTransfer() -- Rtns T if transfer is Write Xfr
//-----------------------------------------------------------------------------

bool TransferPacketHeader::IsWriteTransfer() const
{

    // If the Read field has a bit set, it is a read transfer
    int WF = ReadField(HeaderTCWord,
                       WriteChannelFieldBaseBit,
                       WriteChannelFieldSize);
    return WF != 0;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::Channel() -- Rtns channel for read or write xfer
//-----------------------------------------------------------------------------

int TransferPacketHeader::Channel() const
{
    int RWF;
    if (IsReadTransfer())
        {
        RWF = ReadField(HeaderTCWord,
                        ReadChannelFieldBaseBit,
                        ReadChannelFieldSize);
        }
    else if (IsWriteTransfer())
        {
        RWF = ReadField(HeaderTCWord,
                        WriteChannelFieldBaseBit,
                        WriteChannelFieldSize);
        }
    else
        return -1;  // No bit set?

    // Find the one bit that is set here..takes bit+1 shifts to erase the field
    int shifts = 0;
    while (RWF != 0)
        {
        RWF >>= 1;
        shifts++;
        }

    return shifts - 1;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::Type() -- Set Type field
//-----------------------------------------------------------------------------

TransferPacketHeader &TransferPacketHeader::Type(short type)
{
    WriteField(HeaderTCWord, TypeFieldBaseBit, TypeFieldSize, type);
    return *this;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::Type() -- Return Type field
//-----------------------------------------------------------------------------

short TransferPacketHeader::Type() const
{
    int TF = ReadField(HeaderTCWord, TypeFieldBaseBit, TypeFieldSize);
    return TF;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::Size() -- Set Size field
//-----------------------------------------------------------------------------

TransferPacketHeader &TransferPacketHeader::Size(int size)
{
    Header[SizeFieldIdx] = size;
    return *this;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::Size() -- Return Size field
//-----------------------------------------------------------------------------

int TransferPacketHeader::Size() const
{
    return Header[SizeFieldIdx];
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::DestinationAddr() -- Set DestinationAddr field
//-----------------------------------------------------------------------------

TransferPacketHeader &TransferPacketHeader::DestinationAddr(int addr)
{
    Header[DestinationAddrFieldIdx] = addr;
    return *this;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::DestinationAddr() -- Return DestinationAddr field
//-----------------------------------------------------------------------------

int TransferPacketHeader::DestinationAddr() const
{
    return Header[DestinationAddrFieldIdx];
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::User() -- Set User field
//-----------------------------------------------------------------------------

TransferPacketHeader &TransferPacketHeader::User(int data)
{
    Header[UserFieldIdx] = data;
    return *this;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::User() -- Return User field
//-----------------------------------------------------------------------------

int TransferPacketHeader::User() const
{
    return Header[UserFieldIdx];
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::Arg() -- Set Command Argument field
//-----------------------------------------------------------------------------
//  Arguments are not mapped 1::1 in the command buffer
TransferPacketHeader &TransferPacketHeader::Arg(int idx, int data)
{
    int IdxMap[] = { 3, 0, 1 };
    if (idx >= 0 && idx < 3)
        Header[IdxMap[idx]] = data;
    return *this;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::Arg() -- Return Command Argument field
//-----------------------------------------------------------------------------
//  Arguments are not mapped 1::1 in the command buffer

int TransferPacketHeader::Arg(int idx) const
{
    int IdxMap[] = { 3, 0, 1 };
    if (idx >= 0 && idx < 3)
        return Header[IdxMap[idx]];
    else
        return 0;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::HeaderWord() -- Set raw word of header
//-----------------------------------------------------------------------------

TransferPacketHeader &TransferPacketHeader::HeaderWord(int idx, int data)
{
    if (idx >= 0 && idx < 4)
        Header[idx] = data;
    return *this;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::HeaderWord() -- Return raw word of header
//-----------------------------------------------------------------------------
//  Arguments are not mapped 1::1 in the command buffer

int TransferPacketHeader::HeaderWord(int idx) const
{
    if (idx >= 0 && idx < 4)
        return Header[idx];
    else
        return 0;
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::CopyTo() -- Copy header data to buffer
//-----------------------------------------------------------------------------

void TransferPacketHeader::CopyTo(Buffer&  buffer)
{
    size_t  size_in_ints = buffer.SizeInInts();
    size_t  count = std::min(static_cast<size_t>(4), size_in_ints);
    int*    Buf = buffer.Data();
	for (size_t idx = 0; idx < count; idx++)
        {
        Buf[idx] = Header[idx];
        }
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::LoadFrom() -- Load header from buffer data
//-----------------------------------------------------------------------------

void TransferPacketHeader::LoadFrom(Buffer&  buffer)
{
    const int*  Buf = buffer.ConstData();
    size_t      size_in_ints = buffer.SizeInInts();
    size_t      count = std::min(static_cast<size_t>(4), size_in_ints);
    for (size_t idx = 0; idx < count; idx++)
        {
        Header[idx] = Buf[idx];
        }
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::CopyTo() -- Copy header data to buffer
//-----------------------------------------------------------------------------

void TransferPacketHeader::CopyTo(int*  buffer)
{
    for (int idx = 0; idx < 4; idx++)
        {
        buffer[idx] = Header[idx];
        }
}

//-----------------------------------------------------------------------------
//  TransferPacketHeader::LoadFrom() -- Load header from buffer data
//-----------------------------------------------------------------------------

void TransferPacketHeader::LoadFrom(int*  buffer)
{
    for (int idx = 0; idx < 4; idx++)
        {
        Header[idx] = buffer[idx];
        }
}

}   // namespace Innovative
