//---------------------------------------------------------------------------
// SbcDuoDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2013 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <SbcDuoDeviceDriver_Mb.h>
#include <SbcDuoMemoryMap_Mb.h>

//---------------------------------------------------------------------------

//
//  Nameless namespace for 'static' data
namespace
{

//---------------------------------------------------------------------------
//  SbcDuo System Device Info
//---------------------------------------------------------------------------

const unsigned int SbcDuo_LogicDeviceBar = 2;  // Second BAR is here cause of 64 bit
                                              //   access requires pairing BARs

//------------------------------------------------
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   SbcDuo_IntStatusMask        = 0x1;
const unsigned int   SbcDuo_IntStatusByteAddress =
    Innovative::SbcDuo_MemoryMap::mmInterruptStatus;
//  Parameters for Driver Open
//  ...Device Driver Name
#define     SbcDuo_TARGET_BASE             "SBDUODRV"
#define     SbcDuo_TARGET_VENDOR_ID         0x1303
#define     SbcDuo_TARGET_DEVICE_ID         0x0071
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
		// Name      Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
        "SbcDuo Board",  SbcDuo_TARGET_BASE,         0x1303,       0x0071,      0x00,        false);
    }
};       

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS SbcDuoDeviceDriver  -- Driver level code for SbcDuo Family baseboard
//===========================================================================

InnovativeKernel::IsrLog * SbcDuoDeviceDriver::LOG = 0;

//---------------------------------------------------------------------------
//  constructor for class SbcDuoDeviceDriver
//---------------------------------------------------------------------------

SbcDuoDeviceDriver::SbcDuoDeviceDriver()
    :  InnovativeKernel::DualRegionIsrDeviceDriver(
                                    InnovativeKernel::PciId(SbcDuo_TARGET_VENDOR_ID, SbcDuo_TARGET_DEVICE_ID),
                                    SbcDuo_IntStatusByteAddress,
                                    SbcDuo_IntStatusMask,
                                    SbcDuo_LogicDeviceBar)
{
    //  Save static pointer to log info
    LOG = & mIsrInfo;
}

}; // Innovative


