//  SbcDuoMemoryMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2014  Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef SbcDuoMemoryMap_MbH
#define SbcDuoMemoryMap_MbH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace SbcDuo_MemoryMap
{
    //
    //  Logic Memory Register Offsets
    //
    //  SbcDuo Unit "Standard" WB section offsets
    const unsigned int  wbPeripheral     = 0x000;
    const unsigned int  wbLogicLoader    = 0x100;
    const unsigned int  wbTempControl    = 0x200;
    const unsigned int  wbDio            = 0x300;
    const unsigned int  wbGpsUart        = 0x400;
    const unsigned int  wbRfXcvrUart     = 0x500;
    //
    //  SbcDuo  Wishbone offsets
    //
    //  WB0 - Peripheral Registers
    const unsigned int  mmInformation           = 0x00;
    const unsigned int  mmReset                 = 0x01;
    const unsigned int  mmSubrevision           = 0x02;
    const unsigned int  mmTempAlertFlag         = 0x03;
    const unsigned int  mmIDRom                 = 0x04;
    const unsigned int  mmTimingControl         = 0x05;
    const unsigned int  mmPllControl            = 0x06;
    const unsigned int  mmPllSpi                = 0x07;
    const unsigned int  mmXmc0_I2C              = 0x08;
    const unsigned int  mmXmc1_I2C              = 0x09;
    const unsigned int  mm10GbEthernet          = 0x0a;
    const unsigned int  mmInterruptSourceSel    = 0x0b;
    const unsigned int  mmQSfp0L_Control        = 0x0c;
    const unsigned int  mmQSfp0L_I2C            = 0x0d;
    const unsigned int  mmQSfp0H_Control        = 0x0e;
    const unsigned int  mmQSfp0H_I2C            = 0x0f;
    const unsigned int  mmQSfp1L_Control        = 0x10;
    const unsigned int  mmQSfp1L_I2C            = 0x11;
    const unsigned int  mmQSfp1H_Control        = 0x12;
    const unsigned int  mmQSfp1H_I2C            = 0x13;
    const unsigned int  mmLTC_SPI_Control       = 0x1b;
    const unsigned int  mmLTC_SPI_Stat          = 0x1c;

    //  ...Trigger Config
    const unsigned int  mmTriggerCtrl           = 0x14;
    const unsigned int  mmTriggerMode           = 0x15;
    const unsigned int  mmTriggerDecimation     = 0x16;
    //  ...Trigger PRI Config
    const unsigned int  mmPri_Enable            = 0x17;
    const unsigned int  mmPri_Interval          = 0x18;
    const unsigned int  mmPri_TrigParam         = 0x19;
    const unsigned int  mmPri_CaptureWin        = 0x1a;

    //
    //  WB1 - Vsprom Loader Registers
    const unsigned int  mmVsProm_ControlAddr    = 0x00;
    const unsigned int  mmVsProm_Data           = 0x01;
    const unsigned int  mmVsProm_Opcode         = 0x02;
    //
    //  WB2 - Thermal Registers
    const unsigned int  mmTemp_TempControl      = 0x00;
    const unsigned int  mmTemp_FanThreshold     = 0x01;
    const unsigned int  mmTemp_AlertThreshold   = 0x02;
    const unsigned int  mmTemp_CommandChannel   = 0x03;
    //
    //  WB3 - DigitalIo Registers
    const unsigned int  mmDio_DataLo            = 0x00;
    const unsigned int  mmDio_DataHi            = 0x01;
    const unsigned int  mmDio_OutEnableLo       = 0x02;
    const unsigned int  mmDio_OutEnableHi       = 0x03;
    //
    //  WB4 - GPS UART
    const unsigned int  mmGpsUart0_Ctl          = 0x00;
    const unsigned int  mmGpsUart0_Tx           = 0x01;
    const unsigned int  mmGpsUart0_Rx           = 0x02;
    const unsigned int  mmGpsUart1_Ctl          = 0x03;
    const unsigned int  mmGpsUart1_Tx           = 0x04;
    const unsigned int  mmGpsUart1_Rx           = 0x05;
    const unsigned int  mmGpsUart_Status        = 0x06;
    const unsigned int  mmGpsUart_IntStatus     = 0x07;
    const unsigned int  mmGpsUart_PpsArm        = 0x08;
    //
    //  WB5 - UARTs
    const unsigned int  mmUart_0_Control        = 0x00;
    const unsigned int  mmUart_0_Tx             = 0x01;
    const unsigned int  mmUart_0_Rx             = 0x02;
    const unsigned int  mmUart_1_Control        = 0x03;
    const unsigned int  mmUart_1_Tx             = 0x04;
    const unsigned int  mmUart_1_Rx             = 0x05;
    const unsigned int  mmUartMode              = 0x06;
    const unsigned int  mmInterrupt             = 0x07;
    const unsigned int  mmGpioData              = 0x08;
    const unsigned int  mmGpioDirection         = 0x09;
    //
    //  Port Memory Register Offsets
    // Interrupts
    const unsigned int  mmInterruptStatus     = 0x19000;
    const unsigned int  mmInterruptEnable     = 0x14400;
    //  Pci
    const unsigned int  mmPciVersion          = 0x15c00;
    const unsigned int  mmPciControl          = 0x19400;
//    const unsigned int  mmEpcStatus           = 0x19800;

//
//  Babushka Register Map
//
//  ...the Duo has a serial link to an alternate logic that holds (for now)
//      registers that form an additional serial link (like nesting Babushka dolls).
    //
    //  SbcDuo Unit "Standard" WB section offsets
    const unsigned int  wbBabushkaBase     = 0x900;

    //
    //  pseudo WB9 - Babushka 1588 and UART
    const unsigned int  mmBab1588_Ctrl             = 0x00;
    const unsigned int  mmBab1588_ClkId_Lo         = 0x01;
    const unsigned int  mmBab1588_ClkId_Hi         = 0x02;
    const unsigned int  mmBab1588_Time             = 0x03;
    const unsigned int  mmBab1588_EEPromI2C        = 0x04;
    //const unsigned int  mmBab1588_Uart_Ctl         = 0x05;
    //const unsigned int  mmBab1588_Uart_Tx          = 0x06;
    //const unsigned int  mmBab1588_Uart_Rx          = 0x07;
    //const unsigned int  mmBab1588_Int              = 0x08;
    //const unsigned int  mmBab1588_Arm              = 0x09;


} // end namespace SbcDuo_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
