//  Sbc_ComExDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2006 Innovative Integration Corporation.
//  All Rights Reserved.

#include "Sbc_ComExDeviceDriver_Mb.h"
#include "Sbc_ComExMemoryMap.h"

//---------------------------------------------------------------------------

//
//  Nameless namespace for 'static' data
namespace
{

//------------------------------------------------
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   IntStatusMask        = 0x1;
const unsigned int   IntStatusByteAddress =
    Innovative::Sbc_ComEx_MemoryMap::mmInterruptStatus;
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "SBCCOMEXDRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x0040
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name            Device name base     Vendor ID   Device ID   Sub ID       CheckSubID
        "SbcComEx",        TARGET_BASE,         0x1303,     0x0040,     0x00,        false);
    }
};

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS Sbc_ComExDeviceDriver  -- Driver level code for Sbc_ComEx baseboard
//===========================================================================

//---------------------------------------------------------------------------
//  constructor for class Sbc_ComExDeviceDriver
//---------------------------------------------------------------------------

Sbc_ComExDeviceDriver::Sbc_ComExDeviceDriver()
    :  InnovativeKernel::IsrDeviceDriver(
        InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID),
                                IntStatusByteAddress,
                                IntStatusMask)
{
}

//---------------------------------------------------------------------------
}; // Innovative

