//  Sbc_ComExMemoryMap.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2006 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef Sbc_ComExMemoryMapH
#define Sbc_ComExMemoryMapH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace Sbc_ComEx_MemoryMap
{
    //
	//  Port Memory Registers
	const unsigned int  mmJtag                = 0x12c00;

	// Interrupts
	const unsigned int  mmInterruptStatus     = 0x19000;
	const unsigned int  mmInterruptEnable     = 0x14400;

	// Pci
	const unsigned int  mmPciVersion          = 0x15c00;
	const unsigned int  mmPciTestControl      = 0x17000;
	const unsigned int  mmPciControl          = 0x19400;
	const unsigned int  mmPciStatus           = 0x19800;

	// Trigger
	const unsigned int  mmSoftwareTrigger     = 0x17400;
	const unsigned int  mmTriggerControl      = 0x1a800;

	// Uart
	const unsigned int  mmUartData            = 0x1a000;
	const unsigned int  mmUartControl         = 0x1b800;
	const unsigned int  mmUartStatus          = 0x1b800;

	// GPS
	const unsigned int  mmGpsStatus           = 0x1a400;
	const unsigned int  mmGpsControl          = 0x1a400;
	const unsigned int  mmGpsTrigger          = 0x1c000;

	// Clock
	const unsigned int  mmPllClockControl     = 0x1c400;
	const unsigned int  mmPllReferenceControl = 0x1c800;
	const unsigned int  mmDecimation          = 0x1bc00;
	const unsigned int  mmClockInputMux       = 0x19C00;

	// DIO
	const unsigned int  mmDioData             = 0x1ac00;
	const unsigned int  mmDioDataHigh		  = 0x1b000;
	const unsigned int  mmDioConfig		      = 0x1b400;

	// I2C
	const unsigned int  mmI2c                 = 0x12800;
	const unsigned int  mmVcoI2C			  = 0x1CC00;

} // end namespace Sbc_ComEx_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
