// Semaphore_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2007 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef Semaphore_MbH
#define Semaphore_MbH

#include <SyncObject_Mb.h>
#include <Mutex_Mb.h>
#include <Event_Mb.h>
#include <Poco/Semaphore.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//==============================================================================
//   CLASS Semaphore
//==============================================================================
//
class Semaphore : public SyncObject
{
    friend class MultipleObjects;

public:
    // Methods
    Semaphore(unsigned int count = 0, unsigned int max_count = Infinite);

	bool            Acquire(unsigned int mS=Infinite);
    bool            Release(unsigned int count=1);
    bool            Clear();
	unsigned int    Count();

protected:
    // Generic methods
	virtual bool    WaitFor(unsigned int mS=Infinite);
    virtual bool    IsSignalled();

    // Data
    unsigned int    mMaxCount;
    unsigned int    mCount;
    Mutex			mLock;
    Event			mSignal;

    // Methods
    bool            release(unsigned int count);
    bool            signal();
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
