// SetBoardInfoThread_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//


#ifndef SetBoardInfoThread_MbH
#define SetBoardInfoThread_MbH

#include <Thread_Mb.h>
#include <Event_Mb.h>
#include <Sbc6713e_Mb.h>
#include <TargetInfo_Mb.h>

namespace   Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//==============================================================================
//  CLASS NetInfoCommThread -- manages miscellaneous commands via network.
//==============================================================================
class SetBoardInfoThread : public Thread
{
    friend class Sbc6713e;
    
public:
    //
    //  Member Functions
    SetBoardInfoThread(Sbc6713e & baseboard, Sbc6713e::MiscCommId which,
                       TargetInfo Arg0, int Arg1);

    //
    //  Member Functions
    virtual void    Execute();
    virtual void    Done();


private:
    Sbc6713e &              Baseboard;
    unsigned int            PacketSize;
    const char *            PacketData;
    int                     Port;
    std::string             ID;
    Sbc6713e::MiscCommId    ReqType;
    Event                   WriteRqstComplete;
    class ACE_SOCK_Stream * client;
    TargetInfo              Param0;
    int                     Param1;
};

//---------------------------------------------------------------------------

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative

#endif

