// SignalGen_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef SignalGen_MbH
#define SignalGen_MbH

#include <CommonGen_Mb.h>

namespace Innovative
{

#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS SignalGen  --
//===========================================================================

class SignalGen : public CommonGen
{
	typedef CommonGen inherited;

public:
    enum SignalTypes { stTone, stTriangle, stSquare, stDc };
    enum SignalCalcOptions { saDefault, saFast, saAccurate };

    // Ctor
	SignalGen();
	SignalGen(const SignalGen & other);

	// Assignment
	SignalGen & operator = (const SignalGen & other);

	// Methods
	virtual bool    Generate(IppFloatDG & buffer);
	virtual bool    Generate(IppComplexDG & buffer);

	// Properties
    void            SampleRate(float rate);
	float           SampleRate() const;

	void            Phase(float phase);
	float           Phase() const;

	void            Amplitude(float amplitude);
	float           Amplitude() const;

	void            Frequency(float frequency);
	float           Frequency() const;

	void            Asymmetry(float asymmetry);
	float           Asymmetry() const;

	void            SignalType(SignalTypes value);
	SignalTypes     SignalType() const;

	void                CalculationOption(SignalCalcOptions option);
	SignalCalcOptions   CalculationOption() const;

protected:
	// Data
	float               mPhase;
	float               mPhase1;
	Buffer              ToneScratchBuffer;

	// Fields
	float               FSampleRate;
	float               FPhase;
	float               FAmplitude;
	float               FFrequency;
	float               FAsymmetry;
	SignalTypes         FSignalType;
	SignalCalcOptions   FCalculationOption;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
