//  SimpleInterrupt_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.

#ifndef SimpleInterrupt_MbH
#define SimpleInterrupt_MbH

#include <DataTypes_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class Event;

//===========================================================================
//  CLASS ISimpleInterrupt  -- Interface to boards supporting simple ISRs
//===========================================================================

class ISimpleInterrupt
{
public:
    // Ctor
    virtual ~ISimpleInterrupt()
    	{}

    // Interface
    virtual Event *         InterruptEvent() = 0;
    virtual size_t          InterruptDepth() = 0;
    virtual unsigned int    InterruptAck() = 0;
    virtual void            InterruptEnable(bool state) = 0;
    virtual void            InterruptDispatch(unsigned int value) = 0;
};

//---------------------------------------------------------------------------
namespace SimpleIsrScheme
{
    class VirtualIsrThread;
}

//===========================================================================
//  CLASS SimpleInterrupt  -- Simple ISR handling
//===========================================================================

class SimpleInterrupt
{
public:
    SimpleInterrupt(ISimpleInterrupt & device);
    virtual ~SimpleInterrupt();

    void  Open();
    void  Close();

private:
    //
    //  Member Data
    ISimpleInterrupt &                  Device;
    SimpleIsrScheme::VirtualIsrThread * Visr;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // end namespace Innovative
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#endif
