//---------------------------------------------------------------------------

#include "SioDeviceDriver_Mb.h"

//---------------------------------------------------------------------------

//
//  Nameless namespace for 'static' data
namespace
{
//------------------------------------------------
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   PmcIntStatusMask        = 0xF;
const unsigned int   PmcIntStatusByteAddress = 0x64000;
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "SIOPMCDRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x001f
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
        "SIO Pmc",    TARGET_BASE,         0x1303,      0x001f,     0x00,        false);
    }
};

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS SioDeviceDriver  -- Driver level code for PMC baseboard
//===========================================================================

InnovativeKernel::IsrLog * SioDeviceDriver::PMC = 0;

//---------------------------------------------------------------------------
//  constructor for class SioDeviceDriver
//---------------------------------------------------------------------------

SioDeviceDriver::SioDeviceDriver()
    :  InnovativeKernel::DualRegionDeviceDriver(
                                InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID),
                                PmcIntStatusByteAddress,
                                PmcIntStatusMask)
{
    //  Default busmaster size is 4 MB
	BusMasterSizeWords(0x400000/sizeof(int));

    //  Save static pointer to log info
    PMC = & mIsrInfo;
}

//---------------------------------------------------------------------------
}; // Innovative

