//  SioMemoryMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef IISioMemoryMapH
#define IISioMemoryMapH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace IISio_MemoryMap
{
    //
    //  Port Memory Registers
    const unsigned int  mmFpgaData            = 0x12000;
    const unsigned int  mmFpgaControl         = 0x12400;
    const unsigned int  mmJtag                = 0x12c00;

    const unsigned int  mmInterruptEnable     = 0x14400;
    const unsigned int  mmCreditQueue         = 0x14800;

    const unsigned int  mmBmRingBaseAddress   = 0x15000;
    const unsigned int  mmBmRingSize          = 0x15400;

    const unsigned int  mmRxPacketTimer       = 0x16c00;    // Mocked
    const unsigned int  mmTxPacketTimer       = 0x16c00;

    const unsigned int  mmPciTestControl      = 0x17000;
    const unsigned int  mmRecvDataFifo        = 0x17c00;
    const unsigned int  mmXmitDataFifo        = 0x17c00;

    const unsigned int  mmInterruptStatus     = 0x19000;
    const unsigned int  mmControl             = 0x19400;
    const unsigned int  mmStatus              = 0x19800;
    //
    //  Logic Memory Registers
    const unsigned int  mmDiqlInputControl0   = 0x00;
    const unsigned int  mmSystemControl       = 0x01;
    const unsigned int  mmRocketIoControl     = 0x02;
    const unsigned int  mmTxFifoControl       = 0x03;

    const unsigned int  mmDiqlOutputControl0  = 0x04;
    const unsigned int  mmDiqlOutBits0        = 0x05;
    const unsigned int  mmDiqlOutBits1        = 0x06;
    const unsigned int  mmRxFifoControl       = 0x07;

    const unsigned int  mmTxSampleCount       = 0x09;
    const unsigned int  mmPlaybackStartCount  = 0x0b;
    const unsigned int  mmRxSampleCount       = 0x0d;
    const unsigned int  mmCaptureStartCount   = 0x0f;

    const unsigned int  mmNumberOfSamples     = 0x11;
    const unsigned int  mmTriggerCommand      = 0x13;
    const unsigned int  mmFramerCtl           = 0x14;
    const unsigned int  mmExternalFlowCtl     = 0x15;

    const unsigned int  mmPatternGenCtl       = 0x19;
    const unsigned int  mmDiqlInDataBits0     = 0x1c;
    const unsigned int  mmDiqlInDataBits1     = 0x1d;
    const unsigned int  mmDiqlInBitError0     = 0x1e;

    const unsigned int  mmDiqlInBitError1     = 0x1f;
    const unsigned int  mmDiqlIoStatus0       = 0x20;
    const unsigned int  mmCaptureEvent        = 0x21;
    const unsigned int  mmDiqlIoStatus1       = 0x23;
    
} // end namespace IISio_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif

} // end namespace Innovative


#endif
