// SoftwareTimer_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef SoftwareTimer_MbH
#define SoftwareTimer_MbH

#include <Thread_Mb.h>
#include <Events_Mb.h>
#include <SyncObjects_Mb.h>
#include <Trace_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//========================================================================
//  CLASS SoftwareTimer --  Simple software timer class
//========================================================================

class SoftwareTimer : public Thread
{
    typedef Thread inherited;
    
public:
    // Ctors
	SoftwareTimer(bool IgnoreFirstEvent = false);
    ~SoftwareTimer();

    // Properties
    void            Interval(int msecs);
    int             Interval() const;

    void            Enabled(bool state);
    bool            Enabled() const;

    OpenWire::ThunkedEventHandler<OpenWire::NotifyEvent>    OnElapsed;

protected:
    virtual void    Execute();

private:
    // Fields
    int             FInterval;
    bool            FEnabled;
	mutable Mutex   FLock;
	bool            IgnoreFirstEventFlag;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative

#endif

