//
// SpanInfo_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2003 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef SpanInfo_MbH
#define SpanInfo_MbH

#include <vector>

namespace Innovative
{

//=============================================================================
//  CLASS SpanInfo  --  Span information container
//=============================================================================

class SpanInfo
{
public:
    SpanInfo()
        {  }
    SpanInfo(int upper, int lower)
        : FUpper(upper), FLower(lower)
        {  }

    // Methods
    int                 Delta() const
        {  return FUpper-FLower;  }
    bool                IsUnipolar()
        {  return (FLower<0) ? false : true;  }

    // Properties
    SpanInfo &          Upper(int mV)
        {  FUpper=mV;  return *this;  }
    int                 Upper() const
        {  return FUpper;  }

    SpanInfo &          Lower(int mV)
        {  FLower=mV;  return *this;  }
    int                 Lower() const
        {  return FLower;  }

private:
    // Fields
    int                 FUpper;
    int                 FLower;
};

typedef std::vector<SpanInfo>   SpanArray;

} // namespace Innovative

#endif
