// StartStopThread_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef StartStopThread_MbH
#define StartStopThread_MbH

#include <Thread_Mb.h>
#include <MultipleObjects_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS StartStopThread  --  
//===========================================================================

class StartStopThread : public Thread
{
    typedef Thread  inherited;


public:
    // Ctor
    StartStopThread(const char * name = "");

    // Methods
    void            Start();
    void            Stop();
    void            WaitForStopped();
    void            WaitForStopped_External();
    bool            IsStopped()
                    {   return eStopped.Check();    }

protected:
    // mStartStopEvents
    enum { sStart=inherited::sLast, sStopped, sLast };

    MultipleObjects     StartStopEvents;
    Event               eStart;
    Event               eStopped;
    Event               eJustStopped;
    Event               eAmStopped;

    //  Overridable ftns to customize thread
    virtual void    AtStart();
    virtual void    AtStop();
    //  Override for thread behavior
    virtual void    SingleExecution() = 0;

    virtual void    LoadDefaultEventsInto(MultipleObjects & multi_object);

    void            Init();
    virtual void    Execute();   // Don't override
};

//===========================================================================
//  CLASS BasicSSThread  -- Basic thread with 1 waitfor & start/stop
//===========================================================================

class BasicSSThread : public StartStopThread
{
    typedef StartStopThread  inherited;

public:
    // Ctor
    BasicSSThread(const char * name = "")
        : inherited(name)
        {  }

protected:
    //  override to load notify events at start
    virtual void    Init();

    //  do one iteration of main process
    virtual void    AtExecution(int result);
    virtual void    SingleExecution();

};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
