// StateMachine_Mb.cpp
//
//  Class to extract version information from DLLs and EXEs
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2003 Innovative Integration Corporation.
//  All Rights Reserved.
//
//---------------------------------------------------------------------------

#ifndef StateMachine_MbH
#define StateMachine_MbH

#include <ProcessEvents_Mb.h>
#include <map>

namespace Innovative
{

typedef OpenWire::EventHandler<ProcessCompletionEvent> MachineState;

//===========================================================================
//  CLASS  StateMachine  --  Message-based state machine implementation
//===========================================================================

class StateMachine
{
    typedef std::map<unsigned int, MachineState> StateMap;

public:
    //
    //  Member Functions
    StateMachine();

    //
    // Maintenance
    void  Clear();
    void  Clear(unsigned int id);

    // Access
    MachineState & At(unsigned int id);

    // Transitions
    void  State(unsigned int id);
    void  Next();

    OpenWire::ThunkedEventHandler<ProcessCompletionEvent>  OnError;

private:
    //
    //  Member Data
    StateMap            Registry;
    StateMap::iterator  Iterator;

    // Methods
    void  HandleError(ProcessCompletionEvent & msg);
};
//---------------------------------------------------------------------------

}  // namespace Innovative

#endif
