// StimulusResponse_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//


#include <StimulusResponse_Mb.h>

using namespace std;

namespace   Innovative
{

//---------------------------------------------------------------------------
//  StimulusResponse Ctor
//---------------------------------------------------------------------------

StimulusResponse::StimulusResponse()
    : mSampleRate(0), mWriteBuf(NULL), mReadBuf(NULL),
      mSamples(0), mStereo(true), mAmplitude(0), mPercent(0), mPosition(0)
{
}

//---------------------------------------------------------------------------
//  StimulusResponse::Set() --
//---------------------------------------------------------------------------

void StimulusResponse::Set(float * const writeBuf, float * const readBuf,
    size_t n, double amplitude)
{
    mDebug.Log("StimulusResponse::setup");
    mWriteBuf = writeBuf;
    mReadBuf = readBuf;
    mSamples = n;
    mAmplitude = amplitude;

    if (!writeBuf)
        mDds.Init(16, amplitude);
}

//---------------------------------------------------------------------------
//  StimulusResponse::AddFrequency() --
//---------------------------------------------------------------------------

void StimulusResponse::AddFrequency(unsigned int duration, double frequency)
{
    mFrequency.push_back(frequency);
    if (!mPositions.size())
        {
        mPositions.push_back(duration);
        }
    else
        {
        mPositionsArray::iterator i(mPositions.end());
        mPositions.push_back(duration +*(--i));
        }
}

//---------------------------------------------------------------------------
//  StimulusResponse::Process() --
//---------------------------------------------------------------------------

void StimulusResponse::Process(size_t position)
{
    mPosition = position;
    mPercent = 0;
}

//---------------------------------------------------------------------------
//  StimulusResponse::Progress() --
//---------------------------------------------------------------------------

void StimulusResponse::Progress(size_t position)
{
    unsigned int percent = static_cast<unsigned int>((position*100)/mPosition);
    if (percent != mPercent)
        {
        mPercent = percent;
		ProcessProgressEvent e(percent);
		OnProgress.Execute(e);
        }
}


}  // namespace Innovative


