// StimulusResponse_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef StimulusResponse_MbH
#define StimulusResponse_MbH

#include <Dds_Mb.h>
#include <Trace_Mb.h>
#include <Events_Mb.h>
#include <ProcessEvents_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//=============================================================================
//  CLASS StimulusResponse  --
//=============================================================================

class StimulusResponse
{
public:
    StimulusResponse();
    virtual ~StimulusResponse()
        {  }

    // Overrides
    virtual void    Initialize(double sample_rate, bool stereo) = 0;
    // Run initialize before each call of Process
    virtual void    Process(size_t position) = 0;

    void            Set(float * const writeBuf, float * const readBuf,
                        size_t n, double amplitude);
    double          SampleRate()
        {  return mSampleRate;  }

    void            AddFrequency(unsigned int duration, double frequency);

    // Events
    OpenWire::EventHandler<ProcessProgressEvent>    OnProgress;
    OpenWire::EventHandler<OpenWire::NotifyEvent>   OnComplete;

protected:
    // Methods
    void                                Progress(size_t position);

    // Data
    double                              mSampleRate;
    float *                             mWriteBuf;
    float *                             mReadBuf;
    size_t                              mSamples;
    bool                                mStereo;
    double                              mAmplitude;
    unsigned int                        mPercent;
    size_t                              mPosition;

    Innovative::Dds                     mDds;
    std::vector<double>                 mFrequency;
    typedef std::vector<unsigned int>   mPositionsArray;
    mPositionsArray                     mPositions;
    Trace                               mDebug;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative

#endif
