// StopWatch_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef StopWatch_MbH
#define StopWatch_MbH

#include <stack>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//========================================================================
//  CLASS StopWatch --  Accurate stopwatch timer class
//========================================================================

class StopWatch
{
public:
    // Ctors
    StopWatch();
    StopWatch(const StopWatch & other);
    virtual ~StopWatch();

    StopWatch & operator=(const StopWatch & other);

    // Member Fcns
    void            Start();
    double          Stop();
    double          Elapsed();
    void            uS(int delay);
    double          Now();
    double          Mhz() const;

private:
    // Data
    std::stack<double> Timer;

    class StopWatchImpl * impl;
    // Methods
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative

#endif

