// StreamSupport_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//


#ifndef StreamSupport_MbH
#define StreamSupport_MbH

#include <DataTypes_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class Buffer;
class StreamDevice;

//=============================================================================
//  CLASS StreamManager  --
//=============================================================================

class StreamManager
{
public:
    // Specify driver-allocated BM region, prior to open
    virtual void            BusMasterSizeWords(unsigned int value) = 0;

    virtual void EnqueueRecvPacket(Buffer & buffer) = 0;
    virtual Buffer NextXmitPacket() = 0;
    virtual void DequeueXmitPacket() = 0;
    virtual size_t XmitQDepth() = 0;
    virtual size_t RecvQDepth() = 0;
    
    virtual bool StreamStarted() = 0;
    virtual size_t  BlockSize() = 0;

public:
    virtual void AttachToPtr( StreamDevice *device ) = 0;
    virtual void Detach() = 0;

public:
    void AttachTo( StreamDevice &device ) { return AttachToPtr( &device ); }
    virtual ~StreamManager()
     	{}

};


//=============================================================================
//  CLASS StreamDevice  --
//=============================================================================

class StreamDevice
{
public:
    virtual void            RegisterStreamPlugIn( StreamManager *plug_in ) = 0;
    virtual void            EnableBusMaster( bool enable ) = 0;

public: // Pseudo protected
    // Specify driver-allocated BM region, prior to open
    virtual void            BusMasterSizeWords(unsigned int value) = 0;
	virtual unsigned int    IncomingBusMasterSizeWords() const = 0;
	virtual unsigned int    OutgoingBusMasterSizeWords() const = 0;
    // Specify portion of BM region to actually use
    virtual void            SetBusmasterSize( int size ) = 0;

    virtual void  Reset() = 0;
    virtual void  Log(int type, int data) = 0;
	virtual void  ConfigureBusmastering() = 0;
    virtual void  PreloadXmitBusmasterRegion() = 0;
    virtual void  GrantCredit(int channel, size_t size_wds) = 0;
    virtual void  TransmitDataAvailable() = 0;

    virtual ~StreamDevice()
     	{}
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // Innovative
//---------------------------------------------------------------------------
#endif


