// StringList_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef StringList_MbH
#define StringList_MbH

#include <ProcessEvents_Mb.h>
#include <list>
#include <string>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//=============================================================================
//  CLASS StringList  --  Vector of Strings with file I/O
//=============================================================================
//  Similar to Borland's StringList class for VCL

class StringList
{
public:
    typedef std::list<std::string>  List;
    
    // Ctor
    StringList();

    typedef List::iterator iterator;
    typedef List::const_iterator const_iterator;

    OpenWire::EventHandler<ProcessProgressEvent>      OnProgress;
    OpenWire::EventHandler<ProcessCompletionEvent>    OnComplete;
    //
    //  Member Functions
    void         Clear();
    unsigned int Count() const;
    void         Add(const std::string & value);
    std::string  Pop();
    bool         FileExists(const std::string & filename) const;
    bool         LoadFromFile(const std::string & filename);
    bool         StoreToFile(const std::string & filename);
    void         Write(const std::string & name);
    int          IndexOf(const std::string & item) const;
    void         Sort();
    std::string  At(size_t idx) const;
    void         Delete(int idx);

    // List as contiguous string
    std::string  Text() const;
    std::string  AsText(const std::string & etx) const;

    void         Text(const std::string & txt);
    void         Text(const std::string & txt, const std::string & etx);

    size_t      Words(const std::string & txt, const char * delimiters="\n\r\t: ,");
    void        NextRevisions(const std::string & pn);

    iterator  begin()
        {  return FList.begin();  }
    iterator  end()
        {  return FList.end();  }
    const_iterator  begin() const
        {  return FList.begin();  }
    const_iterator  end() const
        {  return FList.end();  }

private:
    //
    //  Member Data
    List            FList;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative
#endif
