// StringVector_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef StringVector_MbH
#define StringVector_MbH

#include <ProcessEvents_Mb.h>
#include <vector>
#include <string>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//=============================================================================
//  CLASS StringVector  --  Vector of Strings with file I/O
//=============================================================================
//  Similar to Borland's StringList class for VCL

class StringVector
{
public:
    typedef std::vector<std::string>  List;
    
    typedef List::iterator iterator;
    typedef List::const_iterator const_iterator;

    // Ctor
    StringVector();

    OpenWire::EventHandler<ProcessProgressEvent>      OnProgress;
    OpenWire::EventHandler<ProcessCompletionEvent>    OnComplete;
    //
    //  Member Functions
    std::string  StringAt(size_t idx);
    void         Clear();
    size_t       Count() const;
    int          IndexOf(const std::string & item);
    void         Add(const std::string & item);
    bool         FileExists(const std::string & filename);
    bool         LoadFromFile(const std::string & filename);

    std::string  operator[](int idx) const;

    List::iterator  begin()
        {  return FList.begin();  }
    List::iterator  end()
        {  return FList.end();  }
    const_iterator  begin() const
        {  return FList.begin();  }
    const_iterator  end() const
        {  return FList.end();  }
        
private:
    //
    //  Member Data
    List            FList;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative
#endif
