// SyncObject_Mb2.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2017 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <SyncObject_Mb.h>

namespace   Innovative
{

//==============================================================================
//   CLASS SyncObject
//==============================================================================

//------------------------------------------------------------------------------
//  constructor for class SyncObject
//------------------------------------------------------------------------------

SyncObject::SyncObject()
{
}

//------------------------------------------------------------------------------
//  destructor for class SyncObject
//------------------------------------------------------------------------------

SyncObject::~SyncObject()
{
    // Remove self from owner's lists
    std::map<int, SyncObjectOwner *>::iterator iter;
    for (iter=MyOwners.begin(); iter!=MyOwners.end(); ++iter)
        iter->second->Remove(this);
}

//------------------------------------------------------------------------------
//  SyncObject::SignalOwners() -- Signal all owners
//------------------------------------------------------------------------------

void  SyncObject::SignalOwners()
{
    std::map<int, SyncObjectOwner *>::iterator iter;
    for (iter=MyOwners.begin(); iter!=MyOwners.end(); ++iter)
        iter->second->Signal();
}

//------------------------------------------------------------------------------
//  SyncObject::AddOwner() -- Add owner to list of owners
//------------------------------------------------------------------------------

void  SyncObject::AddOwner(SyncObjectOwner * owner)
{
    MyOwners[owner->Key()] = owner;
}

//------------------------------------------------------------------------------
//  SyncObject::RemoveOwner() -- Remove owner from list of owners
//------------------------------------------------------------------------------

void  SyncObject::RemoveOwner(SyncObjectOwner * owner)
{
    MyOwners.erase(owner->Key());
}

} // namespace Innovative

