// Thread_Mb2.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2007 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef Thread_MbH
#define Thread_MbH

//#define POCO_NO_WINDOWS
#include <Event_Mb.h>
#include <MultipleObjects_Mb.h>

//#include <Trace_Mb.h>
#include <string>
#include <Poco/Thread.h>
#include <Poco/Runnable.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//=============================================================================
//  CLASS Thread  --  OS Thread object wrapper
//=============================================================================

class Thread : Poco::Runnable
{
public:
	static const unsigned int Infinite=0xFFFFFFFF;

    enum ThreadPriority { tpLowest, tpLower, tpNormal,
                          tpHigher, tpHighest, tpTimeCritical=tpHighest };

    Thread(const std::string &name = "");
    virtual ~Thread();

    bool            Terminated();
    void            Shutdown(bool wait=true);
    virtual void    Resume();

    void            Priority(ThreadPriority value);
    ThreadPriority  Priority() const;

    // Synchronization support
    virtual void    LoadDefaultEventsInto(MultipleObjects & multi_object);

    bool            AddObject(SyncObject * object, int Case);
    bool            AddObject(SyncObject & object, int Case);
    int             WaitFor(unsigned int mS=SyncObject::Infinite);
 
    const std::string GetName();

    void SetCpuAffinity(int cpu);
    
protected:
    // Interface methods
    virtual bool ShouldReassert();

    // User Methods
    virtual void Init();
    virtual void Done();
    virtual void Execute() = 0;

    // Data
    enum { sTerminate=1000, sLast };
    Event               eTerminate;
    Event               eResume;
    MultipleObjects     Actions;
    //Trace               Debug;

    virtual void XXX_DebugLog(int type, int code);

private:
    // Fields
    //const std::string                    pName;
	ThreadPriority                       FPriority;
    int                                  FAffinity;
    //InnovativeKernel::Osal::OsThread     Handle;
    Poco::Thread                        *Handle;
    bool                                 Running;
    //CpuAffinityVec                       cpuAffinity;

    // Methods
    static  void  ThreadFunc(void *pData);
    void    Terminate();
    bool    WaitForCompletion();
    virtual void run();
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif
