// Tuner_MMS_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2013 Innovative Integration Corporation.
//  All Rights Reserved.
//
//---------------------------------------------------------------------------

#include <Tuner_MMS_Mb.h>
#include <sstream>
#include <StringSupport_Mb.h>

#ifdef _MSC_VER
    #pragma warning(push)
    #pragma warning(disable : 4355)
#endif

namespace Innovative
{

//===========================================================================
//  CLASS Tuner_MMS  -- Interface to Tuner Hardware
//===========================================================================
//---------------------------------------------------------------------------
//  constructor for class Tuner_MMS
//---------------------------------------------------------------------------

Tuner_MMS::Tuner_MMS()
{
}

//---------------------------------------------------------------------------
//  constructor for class Tuner_MMS (takes uart)
//---------------------------------------------------------------------------

Tuner_MMS::Tuner_MMS(IMulticharUart * uart)
	:  ITuner(uart)
{
}

//---------------------------------------------------------------------------
//  constructor for class Tuner_MMS (takes uart & parser)
//---------------------------------------------------------------------------

Tuner_MMS::Tuner_MMS(IMulticharUart * uart, ITunerMessageParser * parser)
	:  ITuner(uart, parser)
{
}

//---------------------------------------------------------------------------
//  destructor for class Tuner_MMS
//---------------------------------------------------------------------------

Tuner_MMS::~Tuner_MMS()
{
}

//---------------------------------------------------------------------------
//  Tuner_MMS::OnInit() - "Open" time specific commands
//---------------------------------------------------------------------------

void Tuner_MMS::OnInit()
{
}

//---------------------------------------------------------------------------
//  Tuner_MMS::OnReapply() - "StreamStart" time specific commands
//---------------------------------------------------------------------------

void Tuner_MMS::OnReapply()
{
}

//---------------------------------------------------------------------------
//  Tuner_MMS::OnClose() -- Close time specific commands
//---------------------------------------------------------------------------

void Tuner_MMS::OnClose()
{
}

//---------------------------------------------------------------------------
//  Tuner_MMS::OnProcessMessages() -- Crack response messages
//---------------------------------------------------------------------------

void Tuner_MMS::OnProcessMessages(TunerMessageList & /*Messages*/)
{
}

//---------------------------------------------------------------------------
//  Tuner_MMS::Reset() -- Issue Reset Command
//---------------------------------------------------------------------------

void Tuner_MMS::Reset()
{
	Command("rst");
}

//---------------------------------------------------------------------------
//  Tuner_MMS::SetEcho() -- Issue Echo Command (echo commands to output)
//---------------------------------------------------------------------------

void Tuner_MMS::SetEcho(bool state)
{
	std::string cmd("ech ");
	cmd += (state) ? '1' : '0' ;
	Command(cmd);
}

//---------------------------------------------------------------------------
//  Tuner_MMS::SetTuningFrequency() -- Set tuning frequency of tuner
//---------------------------------------------------------------------------

void Tuner_MMS::SetTuningFrequency(double freq)
{
	std::string cmd("frq ");
	cmd += DoubleToString(freq, 15);
	Command(cmd);
}

//---------------------------------------------------------------------------
//  Tuner_MMS::SetAttenuation() -- Set attenuation in dB
//---------------------------------------------------------------------------

void Tuner_MMS::SetAttenuation(double attenuation_db)
{
	std::string cmd("atn ");
	cmd += DoubleToString(attenuation_db, 15);
	Command(cmd);
}

//---------------------------------------------------------------------------
//  Tuner_MMS::GetId() -- Issue ID request Command
//---------------------------------------------------------------------------

void Tuner_MMS::GetId()
{
	Command("idn?");
}

//---------------------------------------------------------------------------
//  Tuner_MMS::GetStatus() -- Issue Status request Command
//---------------------------------------------------------------------------

void Tuner_MMS::GetStatus()
{
	Command("bit?");
}

}   // namespace Innovative
