// Tuner_MMS_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2013 Innovative Integration Corporation.
//  All Rights Reserved.
//
//---------------------------------------------------------------------------

#ifndef Tuner_MMS_MbH
#define Tuner_MMS_MbH

#include <Tuner_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS Tuner_MMS  -- Interface to MMS tuners
//===========================================================================

class Tuner_MMS : public ITuner
{
public:

	Tuner_MMS();
	Tuner_MMS(IMulticharUart * uart);
	Tuner_MMS(IMulticharUart * uart, ITunerMessageParser * parser);
	virtual ~Tuner_MMS();

	//  Command Interface
	virtual void  Reset();
	virtual void  SetEcho(bool state);
	virtual void  SetTuningFrequency(double freq);
	virtual void  SetAttenuation(double attenuation_db);

	// Queries
	virtual void  GetId();
	virtual void  GetStatus();

protected:
	//
	//  Member Functions
	virtual void    OnInit();
	virtual void    OnReapply();
	virtual void    OnClose();
	virtual void    OnProcessMessages(TunerMessageList & Messages);

};

} //Innovative

#endif
