// TxAlerts_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef TxAlerts_MbH
#define TxAlerts_MbH

#include <Events_Mb.h>
#include <AlertSystem_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS IUsesTxAlerts  -- Tx Alert User Interface
//===========================================================================

class IUsesTxAlerts
{
public:
    virtual ~IUsesTxAlerts()  
        {  }

    enum AlertType { alertTimeStampRollover, alertSoftware,
                     alertPdn0Underflow, alertPdn1Underflow,
                     alertPdn0NeedsData, alertPdn1NeedsData };

    virtual void  AlertEnable(AlertType alert, bool state) = 0;
    virtual void  AlertPassThru(AlertType alert, bool state) = 0;
    virtual void  AlertReset() = 0;
    virtual void  SoftwareAlert(unsigned int tag=0) = 0;
    //
    // Events
    OpenWire::EventHandler<AlertSignalEvent>   OnTimeStampRolloverAlert;
    OpenWire::EventHandler<AlertSignalEvent>   OnSoftwareAlert;
    OpenWire::EventHandler<AlertSignalEvent>   OnPdn0UnderflowAlert;
    OpenWire::EventHandler<AlertSignalEvent>   OnPdn1UnderflowAlert;
    OpenWire::EventHandler<AlertSignalEvent>   OnPdn0NeedsDataAlert;
    OpenWire::EventHandler<AlertSignalEvent>   OnPdn1NeedsDataAlert;
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
}
#endif

