//  TxDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2006 Innovative Integration Corporation.
//  All Rights Reserved.

#include "TxDeviceDriver_Mb.h"
#include "TxMemoryMap.h"

//---------------------------------------------------------------------------

//
//  Nameless namespace for 'static' data
namespace
{
//------------------------------------------------
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   IntStatusMask        = 0xF;
const unsigned int   IntStatusByteAddress =
    Innovative::Tx_MemoryMap::mmInterruptStatus;
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "TXPMCDRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x0011
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
        "TX Pmc",     TARGET_BASE,         0x1303,      0x0011,     0x00,        false);
    }
};

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS TxDeviceDriver  -- Driver level code for Tx baseboard
//===========================================================================

InnovativeKernel::IsrLog * TxDeviceDriver::LOG = 0;

//---------------------------------------------------------------------------
//  constructor for class TxDeviceDriver
//---------------------------------------------------------------------------

TxDeviceDriver::TxDeviceDriver()
    :  InnovativeKernel::DualRegionDeviceDriver(
                                    InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID),
                                    IntStatusByteAddress,
                                    IntStatusMask)
{
    //  Default busmaster size is 4 MB
	BusMasterSizeWords(0x400000/sizeof(int));

    //  Save static pointer to log info
    LOG = & mIsrInfo;
}

//---------------------------------------------------------------------------
}; // Innovative

