//---------------------------------------------------------------------------
// TycoGps_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.


#ifndef TycoGps_MbH
#define TycoGps_MbH

#include <Gps_Mb.h>
#include <string>
#include <Mutex_Mb.h>
#include <StringList_Mb.h>
#include <Trace_Mb.h>
#include <ctime>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif


//===========================================================================
// CLASS EpochEvent  --
//===========================================================================
/*
class EpochEvent : public OpenWire::Event
{
public:
    StringList List;

    EpochEvent(StringList & list)
        :  List(list)
        {
        }
};
*/
//===========================================================================
//  CLASS TycoGps  -- Tyco GPS interface
//===========================================================================

class TycoGps : public IGps
{
public:
	TycoGps();
	~TycoGps();

	virtual void   OnInit();

	void           Reset();
	void           Save();

protected:
	//
	//  Gps Impl functions
	virtual void   GpsBaud(BaudRates baud);
	virtual void   OnProcessMessages(GpsMessageList & Messages);

	bool		   FInitializing;
	Mutex		   mLock;

private:
	void           Sentence(IISentence type, bool state);
	void    	   Sentence(IISentence type);
	void           EnableZdaCommand();

	// Data

	unsigned int   RxTallyForInit;
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace

#endif
