//---------------------------------------------------------------------------
// UwbDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <UwbDeviceDriver_Mb.h>
#include <UwbMemoryMap_Mb.h>

//---------------------------------------------------------------------------

//
//  Nameless namespace for 'static' data
namespace
{
//------------------------------------------------
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   IntStatusMask        = 0xF;
const unsigned int   IntStatusByteAddress =
    Innovative::Uwb_MemoryMap::mmInterruptStatus;
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "UWBPMCDRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x001d
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name       Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
        "UWB Pmc",    TARGET_BASE,         0x1303,      0x001d,     0x00,        false);
    }
};

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS UwbDeviceDriver  -- Driver level code for Uwb baseboard
//===========================================================================

InnovativeKernel::IsrLog * UwbDeviceDriver::LOG = 0;

//---------------------------------------------------------------------------
//  constructor for class UwbDeviceDriver
//---------------------------------------------------------------------------

UwbDeviceDriver::UwbDeviceDriver()
    :  InnovativeKernel::DualRegionDeviceDriver(
                            InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID),
                            IntStatusByteAddress,
                            IntStatusMask)
{
    //  Default busmaster size is 4 MB
	BusMasterSizeWords(0x400000/sizeof(int));

    //  Save static pointer to log info
    LOG = & mIsrInfo;
}

//---------------------------------------------------------------------------
}; // Innovative

