// VirtexFpgaLoader_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef VirtexFpgaLoader_MbH
#define VirtexFpgaLoader_MbH

#include <FpgaLoadBase_Mb.h>
#include <HardwareRegister_Mb.h>
#include <ProcessEvents_Mb.h>
#include <string>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS IUsesVirtexFpgaLoader -- User Interface to add in Virtex Loader
//===========================================================================
//  A class that wants to implement a loader should derive from this class...

class IUsesVirtexFpgaLoader
{
public:
    IUsesVirtexFpgaLoader(AddressingSpace & space,
                          unsigned int data_addr,
                          unsigned int control_addr);
    IUsesVirtexFpgaLoader(FpgaLoadBase *fpga);
    ~IUsesVirtexFpgaLoader();

    //
    //  Interface Functions
    bool IsConfigured() const;
    void ConfigureFpga(std::string exofile);
	void ConfigureFpga(char * buffer, size_t size);

    // Events
    OpenWire::ThunkedEventHandler<ProcessProgressEvent>     OnFpgaFileReadProgress;
    OpenWire::ThunkedEventHandler<ProcessCompletionEvent>   OnFpgaFileReadComplete;

    OpenWire::ThunkedEventHandler<ProcessProgressEvent>     OnFpgaParseProgress;
    OpenWire::ThunkedEventHandler<ProcessStatusEvent>       OnFpgaParseMessage;
    OpenWire::ThunkedEventHandler<ProcessCompletionEvent>   OnFpgaParseComplete;

    OpenWire::ThunkedEventHandler<ProcessProgressEvent>     OnFpgaLoadProgress;
    OpenWire::ThunkedEventHandler<ProcessStatusEvent>       OnFpgaLoadMessage;
    OpenWire::ThunkedEventHandler<ProcessCompletionEvent>   OnFpgaLoadComplete;

protected:
    // Data
    class FpgaLoadBase *         Fpga;
    class LogicLoadThread *      LogicLoader;

    // Event interceptors
    void            HandleFileReadProgress(ProcessProgressEvent & event);
    void            HandleFileReadComplete(ProcessCompletionEvent & event);

    void            HandleParseProgress(ProcessProgressEvent & event);
    void            HandleParseMessage(ProcessStatusEvent & event);
    void            HandleParseComplete(ProcessCompletionEvent & event);

    void            HandleLoadProgress(ProcessProgressEvent & event);
    void            HandleLoadMessage(ProcessStatusEvent & event);
    void            HandleLoadComplete(ProcessCompletionEvent & event);

    void            Construct();
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
