// VirtexJtagLoader_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef VirtexJtagLoader_MbH
#define VirtexJtagLoader_MbH

#include <ProcessEvents_Mb.h>
#include <HardwareRegister_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS IUsesVirtexJtagLoader -- User Interface to mix-in JTAG Loader
//===========================================================================
//  A class that wants to implement a JTAG loader should derive from this class...

class PmcJtagPort;

class IUsesVirtexJtagLoader
{
public:
    IUsesVirtexJtagLoader(AddressingSpace & space, unsigned int addr);
    IUsesVirtexJtagLoader(PmcJtagPort *port);
    ~IUsesVirtexJtagLoader();

    //
    // Methods
    void LoadJtag(std::string file, int debug_level=0);

    // Events
    OpenWire::ThunkedEventHandler<ProcessProgressEvent>     OnJtagLoadProgress;
    OpenWire::ThunkedEventHandler<ProcessStatusEvent>       OnJtagLoadMessage;
    OpenWire::ThunkedEventHandler<ProcessCompletionEvent>   OnJtagLoadComplete;

protected:
    // Data
    PmcJtagPort *               Port;
    class XsvfLoadThread *      Loader;
    Register *                  Reg;

    // Event interceptors
    void            HandleProgress(ProcessProgressEvent & event);
    void            HandleMessage(ProcessStatusEvent & event);
    void            HandleComplete(ProcessCompletionEvent & event);
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
