//---------------------------------------------------------------------------
// VpxBoard_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2012 Innovative Integration Corporation.
//  All Rights Reserved.
//


#include <VpxBoard_Mb.h>

namespace Innovative
{

#ifdef _MSC_VER
    #pragma warning(push)
    #pragma warning(disable : 4355)
#endif

//===========================================================================
//  CLASS VpxBoard  -- Vpx Common baseboard class
//===========================================================================
//---------------------------------------------------------------------------
//  constructor for class VpxBoard
//---------------------------------------------------------------------------

VpxBoard::VpxBoard(VpxDeviceMap & deviceMap)
    :  FmcCarrierAdvBoard(deviceMap),
       VpxDeviceRef(deviceMap)
{
}

//---------------------------------------------------------------------------
//  destructor for class VpxBoard
//---------------------------------------------------------------------------

VpxBoard::~VpxBoard()
{
    // Don't call anything using VpxDeviceRef here - put in most derived class
}

//---------------------------------------------------------------------------
//  VpxBoard::ClockGen() --
//---------------------------------------------------------------------------

IVpxClkGenIo & VpxBoard::ClockGen()
{
    return VpxDeviceRef.ClockGen();
}

//---------------------------------------------------------------------------
//  VpxBoard::RawClockGenDevice() --
//---------------------------------------------------------------------------

IVpxRawClkGenDevices & VpxBoard::RawClockGenDevice()
{
    return VpxDeviceRef.RawClockGenDevice();
}



#ifdef _MSC_VER
    #pragma warning(pop)
#endif


}  // namespace Innovative
