//---------------------------------------------------------------------------
// VpxComexDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2011 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <VpxComexDeviceDriver_Mb.h>
#include <VpxComexMemoryMap_Mb.h>

//---------------------------------------------------------------------------
//
//  Nameless namespace for 'static' data
namespace
{

const unsigned int VpxComex_LogicDeviceBar = 2;  // Second BAR is here cause of 64 bit
                                                 //   access requires pairing BARs
                                                 
//------------------------------------------------
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   IntStatusMask        = 0x1;
const unsigned int   IntStatusByteAddress =
    Innovative::VpxComex_MemoryMap::mmInterruptStatus;
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "VPXCMXDRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x0060       // ?? is this right
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name      Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
        "Vpx Comex",    TARGET_BASE,         0x1303,      0x0060,     0x00,        false);
    }
};       

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS VpxComexDeviceDriver  -- Driver level code for X6 baseboard
//===========================================================================

InnovativeKernel::IsrLog * VpxComexDeviceDriver::LOG = 0;

//---------------------------------------------------------------------------
//  constructor for class VpxComexDeviceDriver
//---------------------------------------------------------------------------

VpxComexDeviceDriver::VpxComexDeviceDriver()
    :  InnovativeKernel::DualRegionIsrDeviceDriver(
                                    InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID),
                                    IntStatusByteAddress,
                                    IntStatusMask,
                                    VpxComex_LogicDeviceBar)
{
    //  Save static pointer to log info
    LOG = & mIsrInfo;
}

//---------------------------------------------------------------------------
}; // Innovative


