//  VpxComexMemoryMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2006 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef VpxComexMemoryMap_MbH
#define VpxComexMemoryMap_MbH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace VpxComex_MemoryMap
{
    //
    //  Logic Memory Register Offsets
    //
    //  Vpx Comex "Standard" WB section offsets
    const unsigned int  wbComex          = 0x000;
    //
    //  Comex Wishbone offsets
    //  ..Periph registers
    const unsigned int  mmInformation         = 0x00;
    const unsigned int  mmReset               = 0x01;
    const unsigned int  mmSubrevision         = 0x02;
    //  ..Misc
    const unsigned int  mmPcieSwitch          = 0x03;
    const unsigned int  mmVoltageStatus       = 0x04;
    //  ..Clock Registers
    const unsigned int  mmPllControl          = 0x05;
    const unsigned int  mmPllSpi              = 0x06;
    const unsigned int  mmVcxoControl         = 0x07;
    const unsigned int  mmClkControl          = 0x00;   // not available?
    //  ..More Misc
    const unsigned int  mmClockMuxControl     = 0x08;
    const unsigned int  mmClockMuxSpi         = 0x09;
    const unsigned int  mmMReset              = 0x0a;
    const unsigned int  mmGpioDirection       = 0x0b;
    const unsigned int  mmGpioData            = 0x0c;
    //  ..Gps
    const unsigned int  mmGpsUartData         = 0x0d;
    const unsigned int  mmGpsUartCtrlStatus   = 0x0e;
    const unsigned int  mmGpsCtrlStatus       = 0x0f;
    //  ..Trigger
    const unsigned int  mmTriggerMode         = 0x10;
    const unsigned int  mmTriggerFrameSize    = 0x11;
    const unsigned int  mmTriggerDecimation   = 0x12;
    const unsigned int  mmTriggerSwTrigger    = 0x13;
    const unsigned int  mmTriggerSyncSource   = 0x14;
    //  ..Unknown Stuff
    const unsigned int  mmMultiPtOutEnable    = 0x15;
    const unsigned int  mmMultiPtSource       = 0x16;
    const unsigned int  mmMultiPtFlag         = 0x17;
    //  ..Yet More Misc
    const unsigned int  mmTriggerMuxControl   = 0x18;
    const unsigned int  mmTriggerMuxSpi       = 0x19;
    //  ..Pex I2C MasterCore
    const unsigned int  mmPexMC_PrescaleLo    = 0x100;
    const unsigned int  mmPexMC_PrescaleHi    = 0x101;
    const unsigned int  mmPexMC_Control       = 0x102;
    const unsigned int  mmPexMC_DataIo        = 0x103;
    const unsigned int  mmPexMC_CmdStatus     = 0x104;
    //  ..Vcxo I2C MasterCore
    const unsigned int  mmVcxoMC_PrescaleLo   = 0x200;
    const unsigned int  mmVcxoMC_PrescaleHi   = 0x201;
    const unsigned int  mmVcxoMC_Control      = 0x202;
    const unsigned int  mmVcxoMC_DataIo       = 0x203;
    const unsigned int  mmVcxoMC_CmdStatus    = 0x204;
    //  ..Smb1 I2C MasterCore
    const unsigned int  mmSmb1MC_PrescaleLo   = 0x300;
    const unsigned int  mmSmb1MC_PrescaleHi   = 0x301;
    const unsigned int  mmSmb1MC_Control      = 0x302;
    const unsigned int  mmSmb1MC_DataIo       = 0x303;
    const unsigned int  mmSmb1MC_CmdStatus    = 0x304;
    //  ..VSProm ROM
    const unsigned int  mmVsProm_ControlAddr  = 0x400;
    const unsigned int  mmVsProm_Data         = 0x401;
    const unsigned int  mmVsProm_Opcode       = 0x402;

    //
    //  Port Memory Register Offsets
    // Interrupts
    const unsigned int  mmInterruptStatus     = 0x19000;
    const unsigned int  mmInterruptEnable     = 0x14400;
    //  Pci
    const unsigned int  mmPciVersion          = 0x15c00;
    const unsigned int  mmEpcControl          = 0x19400;
    const unsigned int  mmEpcStatus           = 0x19800;

} // end namespace VpxComex_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
