//---------------------------------------------------------------------------
// VpxComex_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2011 Innovative Integration Corporation.
//  All Rights Reserved.
//


#include <VpxComex_Mb.h>

namespace Innovative
{

#ifdef _MSC_VER
    #pragma warning(push)
    #pragma warning(disable : 4355)
#endif

//===========================================================================
//  CLASS VpxComex  -- X6 Common baseboard class
//===========================================================================
//---------------------------------------------------------------------------
//  constructor for class VpxComex
//---------------------------------------------------------------------------

VpxComex::VpxComex()
{
}

//---------------------------------------------------------------------------
//  destructor for class VpxComex
//---------------------------------------------------------------------------

VpxComex::~VpxComex()
{
}

//---------------------------------------------------------------------------
//  VpxComex::BoardCount() -- Number of enumerated baseboards
//---------------------------------------------------------------------------

size_t VpxComex::BoardCount()
{
    return Device.BoardCount();
}

//---------------------------------------------------------------------------
//  VpxComex::BoardNames() -- Get Device Names
//---------------------------------------------------------------------------

vector<string> VpxComex::BoardNames()
{
    return Device.DeviceDriver->ODevice().GetDeviceNames();
}

//---------------------------------------------------------------------------
//  VpxComex::PrintAllDevices() -- Print Device Names and Target #
//---------------------------------------------------------------------------

string VpxComex::PrintAllDevices()
{
    return Device.DeviceDriver->ODevice().PrintAllDevices();
}

//---------------------------------------------------------------------------
//  VpxComex::LicenseCheck() -- Check WD License
//---------------------------------------------------------------------------

bool  VpxComex::LicenseCheck(unsigned int & /*code*/)
{
	return true;
}

//---------------------------------------------------------------------------
//  VpxComex::Target() -- Get the target number of the board
//---------------------------------------------------------------------------

int  VpxComex::Target()
{
    return Device.Target();
}

//---------------------------------------------------------------------------
//  VpxComex::Target() -- Set the target number of the board
//---------------------------------------------------------------------------

void  VpxComex::Target( int value )
{
    Device.Target(value);
}

//---------------------------------------------------------------------------
//  VpxComex::Led() -- Read the LED state of the board
//---------------------------------------------------------------------------

bool  VpxComex::Led()
{
    return Device.Led();
}

//---------------------------------------------------------------------------
//  VpxComex::Led() -- Set the LED state of the board
//---------------------------------------------------------------------------

void  VpxComex::Led( bool value )
{
    Device.Led(value);
}

//---------------------------------------------------------------------------
//  VpxComex::GreenLed() -- Read the Green LED state
//---------------------------------------------------------------------------

bool  VpxComex::GreenLed()
{
    return Device.Periph_SDev.GreenLed();
}

//---------------------------------------------------------------------------
//  VpxComex::GreenLed() -- Set the Green LED state of the board
//---------------------------------------------------------------------------

void  VpxComex::GreenLed( bool value )
{
    Device.Periph_SDev.GreenLed(value);
}

//---------------------------------------------------------------------------
//  VpxComex::FrontPanelLed() -- Read the FrontPanel LED state
//---------------------------------------------------------------------------

bool  VpxComex::FrontPanelLed()
{
    return Device.Periph_SDev.FrontPanelLed();
}

//---------------------------------------------------------------------------
//  VpxComex::FrontPanelLed() -- Set the FrontPanel LED state of the board
//---------------------------------------------------------------------------

void  VpxComex::FrontPanelLed( bool value )
{
    Device.Periph_SDev.FrontPanelLed(value);
}

//---------------------------------------------------------------------------
//  VpxComex::Open() -- Open the baseboard
//---------------------------------------------------------------------------

void  VpxComex::Open()
{
    Device.Open();
}

//---------------------------------------------------------------------------
//  VpxComex::Close() -- Close the baseboard
//---------------------------------------------------------------------------

void  VpxComex::Close()
{
    Device.Close();
}

//---------------------------------------------------------------------------
//  VpxComex::Reset() -- Reset the baseboard
//---------------------------------------------------------------------------

void  VpxComex::Reset()
{
    Device.Reset();    // Board Reset
}

//---------------------------------------------------------------------------
//  VpxComex::Start() -- Start the clocks and triggers
//---------------------------------------------------------------------------

void  VpxComex::Start()
{
    Device.Start();
}

//---------------------------------------------------------------------------
//  VpxComex::Stop() -- Stop the clocks and triggers
//---------------------------------------------------------------------------

void  VpxComex::Stop()
{
    Device.Stop();
}

//---------------------------------------------------------------------------
//  VpxComex::Log() -- Log an entry to debug log
//---------------------------------------------------------------------------
//
//void  VpxComex::Log( int type, int value )
//{
//    Device.Log(type, value);
//}
//

//---------------------------------------------------------------------------
//  VpxComex::GpsCtrl() -- Return reference to Gps Control
//---------------------------------------------------------------------------

IX6_GpsIo &  VpxComex::GpsCtrl()
{
    return Device.Gps_SDev;
}

//---------------------------------------------------------------------------
//  VpxComex::MasterT() -- Master Timer Subsystem
//---------------------------------------------------------------------------

VpxComex_MasterTimer & VpxComex::MasterT()
{
    return Device.MasterT();
}

//---------------------------------------------------------------------------
//  VpxComex::Repeater() -- Repeater Subsystem
//---------------------------------------------------------------------------

VpxComex_Repeater & VpxComex::Repeater(unsigned int idx)
{
    return Device.Repeater(idx);
}

//---------------------------------------------------------------------------
//  VpxComex::Clock() --
//---------------------------------------------------------------------------

IX6ClockIo & VpxComex::Clock()
{
    return Device.Clock();
}

//---------------------------------------------------------------------------
//  VpxComex::ClkMux() --
//---------------------------------------------------------------------------

Cdce18005 & VpxComex::ClkMux()
{
    return Device.ClkMux();
}

//---------------------------------------------------------------------------
//  VpxComex::RawClockDevice() --
//---------------------------------------------------------------------------

IX6RawClockDevices & VpxComex::RawClockDevice()
{
    return Device.RawClockDevice();
}

//---------------------------------------------------------------------------
//  VpxComex::Info() --
//---------------------------------------------------------------------------

const IX6LogicVersionInfo & VpxComex::Info() const
{
    return Device.Info();
}

//---------------------------------------------------------------------------
//  VpxComex::Trigger() --
//---------------------------------------------------------------------------

IComexTrigger &  VpxComex::Trigger()
{
    return Device.Trigger_SDev;
}

//---------------------------------------------------------------------------
//  VpxComex::Utility() --
//---------------------------------------------------------------------------

IComexUtility &  VpxComex::Utility()
{
    return Device.Utility();
}

//---------------------------------------------------------------------------
//  VpxComex::VsProm() --
//---------------------------------------------------------------------------

IFpaLoader &  VpxComex::VsProm()
{
    return Device.VsProm();
}

//---------------------------------------------------------------------------
//  VpxComex::RawProm() --
//---------------------------------------------------------------------------

IVpxProm &  VpxComex::RawProm()
{
    return Device.VsProm_SDev.Raw();
}

//---------------------------------------------------------------------------
//  VpxComex::PeekLogic() -- Read from Logic memory region of board
//---------------------------------------------------------------------------

ii32  VpxComex::PeekLogic(int offset )
{
    return Device.PeekLogic(offset);
}

//---------------------------------------------------------------------------
//  VpxComex::PokeLogic() -- Write to Logic memory region of board
//---------------------------------------------------------------------------

void  VpxComex::PokeLogic( int offset, ii32 value )
{
    Device.PokeLogic(offset, value);
}

//---------------------------------------------------------------------------
//  VpxComex::PeekPort() -- Read from Port memory region of board
//---------------------------------------------------------------------------

ii32  VpxComex::PeekPort(int offset )
{
    return Device.PeekPort(offset);
}

//---------------------------------------------------------------------------
//  VpxComex::PokePort() -- Write to Port memory region of board
//---------------------------------------------------------------------------

void  VpxComex::PokePort( int offset, ii32 value )
{
    Device.PokePort(offset, value);
}

//---------------------------------------------------------------------------
//  VpxComex::AfterFiclStart() --
//---------------------------------------------------------------------------

void  VpxComex::AfterFiclStart(FiclSystem & engine)
{
    engine.Evaluate(" 0 constant Pll   1 constant Vcxo  2 constant ClkMux "
                    " 3 constant Smb1  4 constant Pex  5 constant TrgMux ");

    engine.Evaluate(": ?VpxComex "
                    "    cr .\" --- SubDevice Constants --- \" "
                    "    cr .\"   Pll  Vcxo  ClkMux  Smb1  Pex TrgMux\" "
                    "    cr  "
                    "    cr .\" ---- VpxEpc Definitions ---- \" "
                    "    cr .\"   l@  ( addr -- data )  fetch from logic space  \" "
                    "    cr .\"   l!  ( data addr  -- ) : store to logic space   \" "
                    "    cr .\"   p@  ( addr -- data ) : fetch from pci space  \" "
                    "    cr .\"   p!  ( data addr -- ) : store to pci space   \" "
                    "    cr .\"   d@  ( addr dev -- data ) : fetch from sub-device space \" "
                    "    cr .\"   d!  ( data addr dev -- ) : store to sub-device space \" "
                    "    cr .\"   dFreq  ( f:freq dev -- ) : Set device frequency \" "
                    "    cr .\"   dFreqActual  ( dev -- f:freq) : read actual frequency \" "
                    "    cr .\"   ?VpxEpc  : display this message \" "
                    "    cr  ; ");
    engine.Evaluate(": ?VpxEpc  ?VpxComex  ; "  );    // alias
    engine.Evaluate("marker app");

    engine.Display("VpxComex-specific wordset loaded \n" );
    //
    //  Call base class FICL init
    //X6Board::AfterFiclStart(engine);
    //  Replace Callbacks to call FICL too
    //Device.Load_StreamDeviceEventCallbacks(
    //                new FiclStreamDeviceEventCallbacks(*this, engine) );
}

//---------------------------------------------------------------------------
//  VpxComex::Do_LFetch() --  l@ implementation
//---------------------------------------------------------------------------

int  VpxComex::Do_LFetch(int addr)
{
    return PeekLogic(addr);
}

//---------------------------------------------------------------------------
//  VpxComex::Do_LStore() --  l! implementation
//---------------------------------------------------------------------------

void  VpxComex::Do_LStore(int addr, int value)
{
    PokeLogic(addr, value );
}

//---------------------------------------------------------------------------
//  VpxComex::Do_PFetch() --  p@ implementation
//---------------------------------------------------------------------------

int  VpxComex::Do_PFetch(int addr)
{
    return PeekPort(addr);
}

//---------------------------------------------------------------------------
//  VpxComex::Do_PStore() --  p! implementation
//---------------------------------------------------------------------------

void  VpxComex::Do_PStore(int addr, int value)
{
    PokePort(addr, value);
}

//---------------------------------------------------------------------------
//  VpxComex::Do_DFetch() --  default implementation
//---------------------------------------------------------------------------

int  VpxComex::Do_DFetch(int dev, int addr)
{
    const int kPll = 0;  const int kVcxo = 1;  const int kClkMux = 2;  const int kSmb1 = 3;
    const int kPex = 4;  const int kTrigMux = 5;

    switch (dev)
        {
        default:
            return 0;
        case kPll:
            return Device.Clock_SDev.Pll().Port(addr);
        case kVcxo:
            return Device.Clock_SDev.Vcxo().Port(addr);
        case kClkMux:
            return Device.ClkMux_SDev.Mux().Port(addr);
        case kSmb1:
            return Device.Smb1_SDev.Port(addr);
        case kPex:
            return Device.Pex_SDev.CsrPort(addr);
        case kTrigMux:
            return Device.TriggerMux_SDev.Mux().Port(addr);
        }
}

//---------------------------------------------------------------------------
//  VpxComex::Do_DStore() --  default implementation
//---------------------------------------------------------------------------

void  VpxComex::Do_DStore(int dev, int addr, int value)
{
    const int kPll = 0;  const int kVcxo = 1;  const int kClkMux = 2; const int kSmb1 = 3;
    const int kPex = 4;  const int kTrigMux = 5;

    switch (dev)
        {
        default:
            break;
        case kPll:
            Device.Clock_SDev.Pll().Port(addr, value);
            break;
        case kVcxo:
            Device.Clock_SDev.Vcxo().Port(addr, value);
            break;
        case kClkMux:
            Device.ClkMux_SDev.Mux().Port(addr, value);
            break;
        case kSmb1:
            Device.Smb1_SDev.Port(addr, value);
            break;
        case kPex:
            Device.Pex_SDev.CsrPort(addr, value);
            break;
        case kTrigMux:
            Device.TriggerMux_SDev.Mux().Port(addr, value);
            break;
        }
}

//---------------------------------------------------------------------------
//  VpxComex::Do_DFreq() --  default implementation
//---------------------------------------------------------------------------

void  VpxComex::Do_DFreq(int dev, float freq)
{
    const int kPll = 0;  const int kVcxo = 1;  //const int kClkMux = 2;  const int kSmb1 = 3;
    switch (dev)
        {
        default:
            break;
        case kPll:
            Device.Clock_SDev.Pll().Frequency(freq);
            Device.Clock_SDev.Pll().Reapply();
            break;
        case kVcxo:
            Device.Clock_SDev.Vcxo().Frequency(freq);
            break;
        }
}

//---------------------------------------------------------------------------
//  VpxComex::Do_DFreqActual() --  default implementation
//---------------------------------------------------------------------------

float  VpxComex::Do_DFreqActual(int dev)
{
    const int kPll = 0;  const int kVcxo = 1;  //const int kClkMux = 2;  const int kSmb1 = 3;
    switch (dev)
        {
        default:
            return 0.0f;
        case kPll:
            return static_cast<float>(Device.Clock_SDev.Pll().FrequencyActual());
        case kVcxo:
            return static_cast<float>(Device.Clock_SDev.Vcxo().FrequencyActual());
        }
}

#ifdef _MSC_VER
    #pragma warning(pop)
#endif


}  // namespace Innovative
