// VpxDeviceMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2011 Innovative Integration Corporation.
//  All Rights Reserved.
//


#ifndef VpxDeviceMap_MbH
#define VpxDeviceMap_MbH

#include <FmcCarrierDeviceMap_Mb.h>

namespace Innovative
{

#ifdef __CLR_VER
#pragma managed(push, off)
#endif

#ifdef _MSC_VER
    #pragma warning(push)
    #pragma warning(disable : 4355)
#endif

//class VpxDeviceMap;
//class X6DeviceDriver;

//===========================================================================
//  CLASS VpxDeviceMap  -- Register & low level support for VpxBoard
//===========================================================================

class VpxDeviceMap :  public FmcCarrierAdvDeviceMap,
                      public ISuppliesAddedVpxRequirements
{
public:

//    friend class VpxBoard;
    //
    //  Member Functions
    VpxDeviceMap(IStreamDeviceEvents * owner);
    virtual ~VpxDeviceMap();

    Vpx_ClockGen::VpxClkGenIo &  ClockGen()   {  return VpxCG_SDev.ClockGen();  }
    Vpx_ClockGen::VpxRawClkGenDevices &  RawClockGenDevice()   {  return VpxCG_SDev.RawClockGenDevice();  }

public: // pseudo-protected

    virtual void    ConstructCustomParts();    // call in most derived ctor
    virtual void    OpenHardware();
    virtual void    PreconfigureHardware();
    virtual void    ConfigureHardware();
    virtual void    StreamStopHardware();
    //
    //  Subdevice Customization - implement board specific pieces
    //virtual Si570 *      MakeAfeVcxoObject(IRequires_I2C_RegIo & device) = 0;
    //virtual Cdce72010 *  MakeAfePllObject() = 0;

protected:
    //
    //  Wishbone Bus Spaces
    WishboneBusSpace       WB_VpxClk;
    //
    //  Subdevices
    VpxCopFpaLoader        VFpa_SDev;
    Vpx_ClockGen           VpxCG_SDev;

    virtual IFpaLoader &   DerivedVsProm()  {  return VFpa_SDev.VsProm();  }

};


#ifdef _MSC_VER
    #pragma warning(pop)
#endif

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // Innovative
//---------------------------------------------------------------------------
#endif
