// X3Alerts_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef X3Alerts_MbH
#define X3Alerts_MbH

#include <Events_Mb.h>
#include <AlertSystem_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS IUsesX3Alerts  -- X3 Alert User Interface
//===========================================================================

class IUsesX3Alerts
{
public:
	virtual ~IUsesX3Alerts()
		{  }
		
    enum AlertType { alertTimeStampRollover, alertSoftware,
					 alertWarningTemperature,
					 alertPllLost, alertInputFifoOverrun,
					 alertInputTrigger, alertInputPretriggerError,
                     alertInputStopTrigger, alertInputOverrange,
					 alertOutputFifoUnderrun, alertOutputTrigger };

    virtual void            AlertEnable(AlertType alert, bool state) = 0;
    virtual void            AlertPassThru(AlertType alert, bool state) = 0;
    virtual void            AlertReset() = 0;
    virtual void            SoftwareAlert(unsigned int tag=0) = 0;
    virtual void            Append(const AlertData & alert) = 0;

    //
	// Events
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnTimeStampRolloverAlert;
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnSoftwareAlert;
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnWarningTemperature;
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnPllLost;
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnInputFifoOverrun;
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnInputTrigger;
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnInputPretriggerError;
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnInputStopTrigger;
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnInputOverrange;
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnOutputFifoUnderrun;
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnOutputTrigger;
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
}
#endif
