//---------------------------------------------------------------------------
// X3Board_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2010 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <X3Board_Mb.h>

namespace Innovative
{

#ifdef _MSC_VER
    #pragma warning(push)
    #pragma warning(disable : 4355)
#endif

//===========================================================================
//  CLASS X3Board  -- X3 Common baseboard class
//===========================================================================
//---------------------------------------------------------------------------
//  constructor for class X3Board
//---------------------------------------------------------------------------

X3Board::X3Board(X3DeviceMap & deviceMap)
    :  IIsAPacketStreamBoard(deviceMap), X3DeviceRef(deviceMap)
{
}

//---------------------------------------------------------------------------
//  destructor for class X3Board
//---------------------------------------------------------------------------

X3Board::~X3Board()
{
}

//---------------------------------------------------------------------------
//  X3Board::BoardCount() -- Number of enumerated baseboards
//---------------------------------------------------------------------------

bool  X3Board::LicenseCheck(unsigned int & /*code*/)
{
    return true;
}

//---------------------------------------------------------------------------
//  X3Board::Internals() -- Internal Packet Stream Interface
//---------------------------------------------------------------------------

IPacketStreamDeviceInternals *  X3Board::Internals()
{
    return &X3DeviceRef;
}

//---------------------------------------------------------------------------
//  X3Board::Log() -- Log an entry to debug log
//---------------------------------------------------------------------------

void  X3Board::Log( int type, int value )
{
    X3DeviceRef.Log(type, value);
}


#ifdef _MSC_VER
    #pragma warning(pop)
#endif


}  // namespace Innovative
