// X3Board_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2010 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef X3Board_MbH
#define X3Board_MbH

#include <DataTypes_Mb.h>
#include <X3DeviceMap_Mb.h>
#include <PacketStreamSupport_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//class X3Board;

//===========================================================================
//  CLASS X3Board  -- X3 Common baseboard class
//===========================================================================

class X3Board : public IIsAPacketStreamBoard
{

public:
    //
    //  Member Functions
    X3Board(X3DeviceMap & deviceMap);
    virtual ~X3Board();

	//  Informational Methods
    bool    LicenseCheck(unsigned int & code);



public: // Pseudo protected
    //
    //  IPacketStreamDevice interface implementation
    virtual IPacketStreamDeviceInternals *  Internals();

    X3DeviceMap * Debug() { return &X3DeviceRef; };
    virtual void   Log(int type, int data);

	virtual void  FastClock(bool /*state*/) {  }
	virtual bool  FastClock() const {  return false;  }

protected:
    //
    //  Member Data
    X3DeviceMap &                  X3DeviceRef;
    //
    //  Friend Interface Functions
    friend AddressingSpace & LogicMemorySpace( X3Board & board );
    friend AddressingSpace & PortMemorySpace( X3Board & board );

};

//---------------------------------------------------------------------------
//  LogicMemorySpace() - Return reference to LogicMemory addressing space
//---------------------------------------------------------------------------

inline AddressingSpace & LogicMemorySpace( X3Board & board )
{
    return board.X3DeviceRef.LogicMemory;
}

//---------------------------------------------------------------------------
//  PortMemorySpace() - Return reference to PortMemory addressing space
//---------------------------------------------------------------------------

inline AddressingSpace & PortMemorySpace( X3Board & board )
{
    return board.X3DeviceRef.PortMemory;
}


#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative

#endif

