// X3ClockDivider_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//


#ifndef X3ClockDivider_MbH
#define X3ClockDivider_MbH

#include <HardwareRegister_Mb.h>

namespace Innovative
{

#ifdef __CLR_VER
#pragma managed(push, off)
#endif

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4355)
#endif

//===========================================================================
//  CLASS X3ClockDivider  -- X3 PLD Clock Divider Interface
//===========================================================================

class X3ClockDivider
{
public:
	enum IIClockSource { csPll, csExternal };

    // Ctor
    X3ClockDivider(AddressingSpace &space, int offset);

    // Properties
    void                Source(int ch, IIClockSource value);
    IIClockSource       Source(int ch) const;

    void                Enable(int ch, bool state);
    bool                Enable(int ch) const;

    void                Divisor(int ch, unsigned short value);
    unsigned short      Divisor(int ch) const;

protected:
    // Fields
    int                 FSource;
    int                 FEnable;
    std::vector<short>  FDivisor;

    // Methods
    void                Port(int data, int addr);

	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//  CLASS TimerControlPldRegister  -- Timer PLD interface
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	class TimerControlPldRegister : public CachedShadowRegister
	{
		typedef CachedShadowRegister inherited;

	public:
		RegisterBitGroup	Data;
		RegisterBitGroup    Address;

		TimerControlPldRegister(AddressingSpace &space, int offset)
			:  inherited(space, offset),
			   Data(*this, 0, 16),
			   Address(*this, 16, 2)
			{
			//  Default setup ????
			}
	};

	// Registers
	TimerControlPldRegister		   	   TimerControlPldReg;
};

#ifdef _MSC_VER
	#pragma warning(pop)
#endif

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // Innovative
//---------------------------------------------------------------------------
#endif
