//  X3MemoryMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef X3MemoryMap_MbH
#define X3MemoryMap_MbH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace X3_MemoryMap
{
    //
    //  Port Memory Registers
    const unsigned int  mmFpgaData            = 0x12000;
    const unsigned int  mmFpgaControl         = 0x12400;
    const unsigned int  mmI2c                 = 0x12800;
    const unsigned int  mmJtag                = 0x12c00;

	const unsigned int  mmInterruptEnable     = 0x14400;
	const unsigned int  mmCreditQueue         = 0x14800;

	const unsigned int  mmBmRingBaseAddress   = 0x15000;
	const unsigned int  mmBmRingSize          = 0x15400;
	const unsigned int  mmPciVersion          = 0x15c00;

	const unsigned int  mmRxPacketTimer       = 0x17400;
	const unsigned int  mmTxPacketTimer       = 0x16c00;
	const unsigned int  mmPciTestControl      = 0x17000;

	const unsigned int  mmInterruptStatus     = 0x19000;
	const unsigned int  mmControl             = 0x19400;
	const unsigned int  mmStatus              = 0x19800;

	//
	//  Logic Memory Registers
	const unsigned int  mmFpgaVersion         = 0x00;
	const unsigned int  mmUserControl         = 0x01;
	const unsigned int  mmTest         		  = 0x02;
	const unsigned int  mmTempCurrent	  	  = 0x03;
	const unsigned int  mmTempWarning		  = 0x04;
	const unsigned int  mmTempFail		  	  = 0x05;
	const unsigned int  mmInTriggerDelay  	  = 0x06;
	const unsigned int  mmFrontPanelConfig 	  = 0x07;
	const unsigned int  mmPldClockControl	  = 0x08;
	const unsigned int  mmSampleClockDivider  = 0x09;
	const unsigned int  mmPll		  		  = 0x0a;
	const unsigned int  mmInChannelEnable     = 0x0b;
	const unsigned int  mmOutChannelEnable	  = 0x0c;
	const unsigned int  mmOutTriggerDelay	  = 0x0d;
	const unsigned int  mmZbtAddress          = 0x0e;
	const unsigned int  mmZbtData     	 	  = 0x0f;
	const unsigned int  mmInAmpEnable		  = 0x10;
	const unsigned int  mmOutControl		  = 0x11;
	const unsigned int  mmInControl		  	  = 0x12;
	const unsigned int  mmDioData		  	  = 0x13;
	const unsigned int  mmDioConfig 	 	  = 0x14;
	const unsigned int  mmFrontPanelData 	  = 0x15;
	const unsigned int  mmDioDataHigh     	  = 0x16;
	const unsigned int  mmInTriggerControl 	  = 0x17;
	const unsigned int  mmOutTriggerControl	  = 0x18;
	const unsigned int  mmInDecimation 	  	  = 0x19;
	const unsigned int  mmOutDecimation 	  = 0x1a;
	const unsigned int  mmOutPacketHeader     = 0x1b;
	const unsigned int  mmInPacketHeader   	  = 0x1c;
	const unsigned int  mmAlertSWTrigger      = 0x1d;
	const unsigned int  mmAlertControl		  = 0x1e;
	const unsigned int  mmAlertEnable		  = 0x1f;
	const unsigned int  mmInGainCoef      	  = 0x20;
	const unsigned int  mmInOffsetCoef    	  = 0x30;
	const unsigned int  mmOutGainCoef      	  = 0x40;
	const unsigned int  mmOutOffsetCoef    	  = 0x50;
	const unsigned int  mmSDFData             = 0x60;
	const unsigned int  mmInGainMode		  = 0x70;
    const unsigned int  mmOutDacDelay  		  = 0x7c;

	const unsigned int  mmOutGainMode		  = 0x80;  // Phony below this point
	const unsigned int  mmOutAmpEnable		  = 0x81;
} // end namespace X3_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
