// X3_10MDeviceMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//


#ifndef X3_10MDeviceMap_MbH
#define X3_10MDeviceMap_MbH

#include <X3DeviceMap_Mb.h>
#include <X3IoDevice_Mb.h>
#include <Events_Mb.h>
#include <PmcEeprom_Mb.h>
#include <Ad9511_Mb.h>

namespace Innovative
{

#ifdef __CLR_VER
#pragma managed(push, off)
#endif

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4355)
#endif

//===========================================================================
//  CLASS X3_10MDeviceMap  -- Register & low level support for SD module
//===========================================================================
class X3_10M;
class X3_10MInputDevice;
class X3_10MInputGains;

class X3_10MDeviceMap :  public X3DeviceMap,
                         public IUsesStreamDeviceEventCallbacks,
						 public IUsesNullFrontPanelPort
{
	friend class X3_10M;
    friend class X3_10MInputDevice;
    friend class X3_10MClock;

public:
	enum IIClkSelect { csInternal, csExternal };

	//
	//  Member Functions
	X3_10MDeviceMap(X3_10M * owner);
	virtual ~X3_10MDeviceMap();

	X3RangedIoDevice & 	Input();

public: // pseudo-protected
	virtual void  OpenHardware();
	void          ResetAnalog();

protected:
	// Fields
	X3_10MInputDevice * FInput;

	// Data
	X3_10M *			Owner;
	Trace				Debug;
	Ad9511Pfd *         Clock;
	PmcIdromSection     ClockParamRomSection;

	// Methods
	void  OnStreamConfigureHandler(OpenWire::NotifyEvent & Event);
	void  OnBeforeStreamStartHandler(OpenWire::NotifyEvent & Event);
	void  OnAfterStreamStartHandler(OpenWire::NotifyEvent & Event);
	void  OnBeforeStreamStopHandler(OpenWire::NotifyEvent & Event);
	void  OnAfterStreamStopHandler(OpenWire::NotifyEvent & Event);
};

#ifdef _MSC_VER
	#pragma warning(pop)
#endif

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // Innovative
//---------------------------------------------------------------------------
#endif
