// X3_A4D4DeviceMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2008 Innovative Integration Corporation.
//  All Rights Reserved.
//


#ifndef X3_A4D4DeviceMap_MbH
#define X3_A4D4DeviceMap_MbH

#include <X3DeviceMap_Mb.h>
#include <X3IoDevice_Mb.h>
#include <Events_Mb.h>
#include <PmcEeprom_Mb.h>
#include <Ad9511Duo_Mb.h>

namespace Innovative
{

#ifdef __CLR_VER
#pragma managed(push, off)
#endif

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable : 4355)
#endif

//===========================================================================
//  CLASS X3_A4D4DeviceMap  -- Register & low level support for SD module
//===========================================================================
class X3_A4D4;
class X3_A4D4InputDevice;
class X3_A4D4Clock;
class X3_A4D4OutputDevice;
class X3_A4D4DeviceMap : public X3DeviceMap,
                         public IUsesStreamDeviceEventCallbacks,
						 public IUsesFrontPanelPort
{
	friend class X3_A4D4;
    friend class X3_A4D4InputDevice;
    friend class X3_A4D4OutputDevice;
    friend class X3_A4D4Clock;

public:
	enum IIClkSelect { csInternal, csExternal };

	//
	//  Member Functions
	X3_A4D4DeviceMap(X3_A4D4 * owner);
	virtual ~X3_A4D4DeviceMap();

	X3RangedIoDevice & 	Input();
	OutDevice & 	    Output();

public: // pseudo-protected
	virtual void  OpenHardware();
    void          ResetAnalog();

protected:
	// Fields
	IIClkSelect		    FClockSelect;
	X3_A4D4InputDevice * 	FInput;
	X3_A4D4OutputDevice * 	FOutput;

	// Data
	X3_A4D4 *			Owner;
    Trace				Debug;
	Ad9511Duo *         Clock;
    PmcIdromSection     ClockParamRomSection;

	// Methods
	void  OnStreamConfigureHandler(OpenWire::NotifyEvent & Event);
	void  OnBeforeStreamStartHandler(OpenWire::NotifyEvent & Event);
	void  OnAfterStreamStartHandler(OpenWire::NotifyEvent & Event);
	void  OnBeforeStreamStopHandler(OpenWire::NotifyEvent & Event);
	void  OnAfterStreamStopHandler(OpenWire::NotifyEvent & Event);

	//
	//  Support Methods
    int                 ConfigureFilters(float rate);
};

#ifdef _MSC_VER
	#pragma warning(pop)
#endif

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // Innovative
//---------------------------------------------------------------------------
#endif
