//  X3_TimingDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2006 Innovative Integration Corporation.
//  All Rights Reserved.

#include "X3_TimingDeviceDriver_Mb.h"
#include "X3_TimingMemoryMap.h"

//---------------------------------------------------------------------------

//
//  Nameless namespace for 'static' data
namespace
{

//------------------------------------------------
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   IntStatusMask        = 0x1;
const unsigned int   IntStatusByteAddress =
    Innovative::X3_Timing_MemoryMap::mmInterruptStatus;
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "X3TIMINGDRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x0030
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
        // Name            Device name base     Vendor ID   Device ID   Sub ID       CheckSubID
        "X3Timing",        TARGET_BASE,         0x1303,     0x0030,     0x00,        false);
    }
};

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS X3_TimingDeviceDriver  -- Driver level code for X3_Timing baseboard
//===========================================================================

//---------------------------------------------------------------------------
//  constructor for class X3_TimingDeviceDriver
//---------------------------------------------------------------------------

X3_TimingDeviceDriver::X3_TimingDeviceDriver()
    :  InnovativeKernel::IsrDeviceDriver(
        InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID),
                                IntStatusByteAddress,
                                IntStatusMask)
{
}

//---------------------------------------------------------------------------
}; // Innovative

