//  X3_TimingMemoryMap.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2006 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef X3_TimingMemoryMapH
#define X3_TimingMemoryMapH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace X3_Timing_MemoryMap
{
    const unsigned int  mmI2c                 = 0x12800;
    const unsigned int  mmJtag                = 0x12c00;
	const unsigned int  mmInterruptEnable     = 0x14400;

	const unsigned int  mmTempCurrent	  	  = 0x14800;
	const unsigned int  mmTempWarning		  = 0x14c00;
	const unsigned int  mmTempFail		  	  = 0x15000;

	const unsigned int  mmPciVersion          = 0x15c00;
	const unsigned int  mmPciTestControl      = 0x17000;

	const unsigned int  mmInterruptStatus     = 0x19000;
	const unsigned int  mmControl             = 0x19400;
	const unsigned int  mmStatus              = 0x19800;

	const unsigned int  mmDioData		  	  = 0x1ac00;
	const unsigned int  mmDioConfig 	 	  = 0x1b400;

    // Trigger
    const unsigned int  mmSoftwareTrigger     = 0x17400;
    const unsigned int  mmTriggerControl      = 0x1a800;

	// Uart
	const unsigned int  mmUartData            = 0x1a000;
//	const unsigned int  mmUartControl         = 0x1b800;
	const unsigned int  mmUartStatus          = 0x1b800;

	// GPS
//	const unsigned int  mmGpsStatus           = 0x1a400;
	const unsigned int  mmGpsControl          = 0x1a400;
	const unsigned int  mmGpsTrigger          = 0x1c000;

	// Clock
	const unsigned int  mmPllSpiIntf          = 0x1c400;
	const unsigned int  mmInputMuxSpiIntf     = 0x1c800;     // Input Mux/Divider Spi
    const unsigned int  mmOutputMuxSpiIntf    = 0x1cc00;     // Output Mux/Divider Spi
	const unsigned int  mmPxiMuxSpiIntf       = 0x1d000;     // Pxi Mux/Divider Spi
	const unsigned int  mmVcxoI2C             = 0x1d400;     // Vcxo I2C & Vxo Enables
	const unsigned int  mmPllControl          = 0x1d800;     // Pll Control/Status
	const unsigned int  mmInputMuxControl     = 0x1dc00;     // Input Mux Control/Status
	const unsigned int  mmOutputMuxControl    = 0x1e000;     // Output Mux Control/Status
	const unsigned int  mmPxiMuxControl       = 0x1e400;     // PXI Mux Control/Status
	const unsigned int  mmOutputSync          = 0x1e800;     // Output Synchronization
	const unsigned int  mmClockTest           = 0x1ec00;     // Clock Test Status/Control
	const unsigned int  mmIMuxTestCount       = 0x1f000;     // IMUX Clock Count
	const unsigned int  mmPllTestCount        = 0x1f400;     // PLL Clock Count
	const unsigned int  mmOMuxTestCount       = 0x1f800;     // OMUX Clock Count
	const unsigned int  mmPxiTestCount        = 0x1fc00;     // PXI Clock Count

	const unsigned int  mmDecimation          = 0x1bc00;
} // end namespace

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
