// X5Alerts_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef X5Alerts_MbH
#define X5Alerts_MbH

#include <Events_Mb.h>
#include <AlertSystem_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS IUsesX5Alerts  -- X5 Alert User Interface
//===========================================================================

class IUsesX5Alerts
{
public:
	virtual ~IUsesX5Alerts()
		{  }
		
    enum AlertType { alertTimeStampRollover,  alertSoftware,
                     alertPatternDone,        alertWarningTemperature,
                     alertInputFifoOverrun,   alertInputTrigger,
                     alertInputOverrange,     alertOutputFifoUnderrun,     
                     alertOutputTrigger,      alertNumericError,
                     alertDdrDacQAlmostFull
                     };

    virtual void            AlertEnable(AlertType alert, bool state) = 0;
    virtual void            AlertPassThru(AlertType alert, bool state) = 0;
    virtual void            AlertReset() = 0;
    virtual void            SoftwareAlert(unsigned int tag=0) = 0;
    virtual void            Append(const AlertData & alert) = 0;
    //
	// Events
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnTimeStampRolloverAlert;
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnSoftwareAlert;
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnPatternDoneAlert;
 	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnWarningTemperature;
    OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnInputOverrange;
    OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnInputTrigger;
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnInputFifoOverrun;
	OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnOutputFifoUnderrun;
    OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnOutputTrigger;
    OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnNumericError;
    OpenWire::ThunkedEventHandler<AlertSignalEvent>   OnDdrDacQAlmostFull;
    // Trigger events missing.
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
}
#endif
