//---------------------------------------------------------------------------
// X5Board_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2010 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <X5Board_Mb.h>

namespace Innovative
{

#ifdef _MSC_VER
    #pragma warning(push)
    #pragma warning(disable : 4355)
#endif

//===========================================================================
//  CLASS X5Board  -- X5 Common baseboard class
//===========================================================================
//---------------------------------------------------------------------------
//  constructor for class X5Board
//---------------------------------------------------------------------------

X5Board::X5Board(X5DeviceMap & deviceMap)
    :  IIsAPacketStreamBoard(deviceMap), X5DeviceRef(deviceMap)
{
}

//---------------------------------------------------------------------------
//  destructor for class X5Board
//---------------------------------------------------------------------------

X5Board::~X5Board()
{
}

//---------------------------------------------------------------------------
//  X5Board::LicenseCheck() -- Quick check of license
//---------------------------------------------------------------------------

bool  X5Board::LicenseCheck(unsigned int & /*code*/)
{
    return true;
}

//---------------------------------------------------------------------------
//  X5Board::Internals() -- Internal Packet Stream Interface
//---------------------------------------------------------------------------

IPacketStreamDeviceInternals *  X5Board::Internals()
{
	return &X5DeviceRef;
}

//---------------------------------------------------------------------------
//  X5Board::Log() -- Log an entry to debug log
//---------------------------------------------------------------------------

void  X5Board::Log( int type, int value )
{
    X5DeviceRef.Log(type, value);
}


#ifdef _MSC_VER
    #pragma warning(pop)
#endif


}  // namespace Innovative
