// X5Board_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2010 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef X5Board_MbH
#define X5Board_MbH

#include <DataTypes_Mb.h>
#include <X5DeviceMap_Mb.h>
#include <PacketStreamSupport_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//class X5Board;

//===========================================================================
//  CLASS X5Board  -- X5 Common baseboard class
//===========================================================================

class X5Board : public IIsAPacketStreamBoard
{

public:
    //
    //  Member Functions
    X5Board(X5DeviceMap & deviceMap);
    virtual ~X5Board();

	//  Informational Methods
    bool    LicenseCheck(unsigned int & code);


public: // Pseudo protected
    //
    //  IPacketStreamDevice interface implementation
    virtual IPacketStreamDeviceInternals *  Internals();

    X5DeviceMap * Debug() { return &X5DeviceRef; };
    virtual void   Log(int type, int data);
    
protected:
    //
    //  Member Data
    X5DeviceMap &                  X5DeviceRef;
    //
    //  Friend Interface Functions
    friend AddressingSpace & LogicMemorySpace( X5Board & board );
    friend AddressingSpace & PortMemorySpace( X5Board & board );

};

//---------------------------------------------------------------------------
//  LogicMemorySpace() - Return reference to LogicMemory addressing space
//---------------------------------------------------------------------------

inline AddressingSpace & LogicMemorySpace( X5Board & board )
{
    return board.X5DeviceRef.LogicMemory;
}

//---------------------------------------------------------------------------
//  PortMemorySpace() - Return reference to PortMemory addressing space
//---------------------------------------------------------------------------

inline AddressingSpace & PortMemorySpace( X5Board & board )
{
    return board.X5DeviceRef.PortMemory;
}


#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative

#endif

