// X5ClockIntf.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef X5ClockIntf_H
#define X5ClockIntf_H

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//==============================================================================
//  CLASS X5ClockIntf -- User interface to control X5 clock functionality
//==============================================================================

class X5ClockIntf
{
public:
    enum IIClockSource { csExternal, csInternal };
    enum IIReferenceSource { rsExternal, rsInternal };

	virtual ~X5ClockIntf()  {  }

    //
    //  Interface Functions
	// Methods
	virtual void 				Open() {  }
	virtual void 				Reapply() {  }
	virtual double			    FrequencyActual() const = 0;

	// Properties
	virtual void    		    Frequency(double value) = 0;
	virtual double			    Frequency() const = 0;

	virtual void                Source(IIClockSource src) = 0;
	virtual IIClockSource       Source() const = 0;

	virtual void                Reference(IIReferenceSource /*src*/)  {  }
	virtual IIReferenceSource   Reference() const  {  return rsInternal;  }

	virtual void    		    ReferenceFrequency(double /*value*/)  {  }
	virtual double			    ReferenceFrequency() const  {  return 0.0;  }

    virtual bool                Locked() const = 0;
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif

} // end namespace Innovative


#endif
