//---------------------------------------------------------------------------
// X5DeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <X5DeviceDriver_Mb.h>
#include <X5MemoryMap_Mb.h>

//---------------------------------------------------------------------------

//
//  Nameless namespace for 'static' data
namespace
{

const unsigned int X5_LogicDeviceBar = 2;  // Second BAR is here cause of 64 bit
                                           //   access requires pairing BARs
                                                 
//------------------------------------------------
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   IntStatusMask        = 0xF;
const unsigned int   IntStatusByteAddress =
    Innovative::X5_MemoryMap::mmInterruptStatus;
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "X5XMCEDRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x0020		
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
		// Name      Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
        "X5 Pmc",    TARGET_BASE,         0x1303,      0x0020,     0x00,        false);
    }
};

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS X3DeviceDriver  -- Driver level code for X3 baseboard
//===========================================================================

InnovativeKernel::IsrLog * X5DeviceDriver::LOG = 0;

//---------------------------------------------------------------------------
//  constructor for class X3DeviceDriver
//---------------------------------------------------------------------------

X5DeviceDriver::X5DeviceDriver()
    :  InnovativeKernel::DualRegionDeviceDriver(
                                    InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID),
                                    IntStatusByteAddress,
                                    IntStatusMask,
                                    X5_LogicDeviceBar)
{
    //  Default busmaster size is 16 MB
	BusMasterSizeWords(0x1000000/sizeof(int));

    //  Save static pointer to log info
    LOG = & mIsrInfo;
}

//---------------------------------------------------------------------------
}; // Innovative

