//  X5MemoryMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef X5MemoryMap_MbH
#define X5MemoryMap_MbH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace X5_MemoryMap
{
    //
    //  PCI Logic Memory Registers
    //
    // Fpga management
    const unsigned int  mmFpgaData            = 0x12000;
    const unsigned int  mmFpgaControl         = 0x12400;
    const unsigned int  mmI2c                 = 0x12800;
	const unsigned int  mmFpa                 = 0x12c00;
	// DRP
	const unsigned int  mmDrp0                = 0x13000;
	const unsigned int  mmDrp1                = 0x13400;
	// Interrupts
	const unsigned int  mmInterruptEnable     = 0x14400;
	const unsigned int  mmCreditQueue         = 0x14800;
	const unsigned int  mmInterruptStatus     = 0x19000;
    // Communications
	const unsigned int  mmBmRingBaseAddress   = 0x15000;
	const unsigned int  mmBmRingSize          = 0x15400;
	const unsigned int  mmPciVersion          = 0x15c00;
	const unsigned int  mmRxPacketTimer       = 0x17400;
	const unsigned int  mmTxPacketTimer       = 0x16c00;
	const unsigned int  mmPciTestControl      = 0x17000;
    // Misc
	const unsigned int  mmControl             = 0x19400;
	const unsigned int  mmStatus              = 0x19800;

	//
	//  User Logic Memory Registers
    //
    // Version
	const unsigned int  mmFpgaVersion         = 0x00;
	const unsigned int  mmUserControl         = 0x01;
    const unsigned int  mmTest 		          = 0x02;
    // Temperature monitor
	const unsigned int  mmTempCurrent	  	  = 0x03;
	const unsigned int  mmTempWarning		  = 0x04;
	const unsigned int  mmTempFail		  	  = 0x05;
	const unsigned int  mmTempFan		  	  = 0x06;
	// Packetizer control
	const unsigned int  mmRxPacketControl     = 0x07;
    // Qdr
	const unsigned int  mmQdrSramCtl		  = 0x0a;

	const unsigned int  mmQdrSram0DataLow	  = 0x0d;  // Data is 64 bits.
	const unsigned int  mmQdrSram0DataHigh	  = 0x0e;
	const unsigned int  mmQdrSram1DataLow	  = 0x0f;  // Data is 64 bits.
	const unsigned int  mmQdrSram1DataHigh	  = 0x10;

	const unsigned int  mmQdrSram0WrAddr 	  = 0x3c;
	const unsigned int  mmQdrSram0RdAddr	  = 0x3d;
	const unsigned int  mmQdrSram1WrAddr 	  = 0x3e;
	const unsigned int  mmQdrSram1RdAddr	  = 0x3f;

    // Dio
	const unsigned int  mmDioData			  = 0x13;
	const unsigned int  mmDioConfig			  = 0x14;
    // Alerts
    const unsigned int  mmAlertSWTrigger      = 0x1d;
	const unsigned int  mmAlertControl		  = 0x1e;
	const unsigned int  mmAlertEnable		  = 0x1f;

} // end namespace X5_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
