//  X6MemoryMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2010 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef X6MemoryMap_MbH
#define X6MemoryMap_MbH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace X6_MemoryMap
{
    //
    //  X6 "Standard" WB section offsets
    const unsigned int  wbPeripheral          = 0x000;
    const unsigned int  wbLogicLoader         = 0x100;
    const unsigned int  wbTempControl         = 0x200;
    const unsigned int  wbPacketizer          = 0x300;
    const unsigned int  wbAlerts              = 0x400;
    const unsigned int  wbDigitalIo           = 0x500;
    const unsigned int  wbROM                 = 0x600;
    const unsigned int  wbMatlab              = 0x700;
    const unsigned int  wbAFE                 = 0x800;
    const unsigned int  wbDDC                 = 0x900;
    const unsigned int  wbAurora0             = 0xa00;
    const unsigned int  wbAurora1             = 0xb00;
    //
    //  X6 WB Register offsets
    //
    //  WB0 - Peripheral Registers
    const unsigned int  mmInformation         = 0x00;
    const unsigned int  mmReset               = 0x01;
    const unsigned int  mmBitstreamDate       = 0x02;
    const unsigned int  mmSubrevision         = 0x03;
                                     //       = 0x04;
    const unsigned int  mmHostTrigger         = 0x05;
    const unsigned int  mmSioXo               = 0x06;
    const unsigned int  mmLPDDR               = 0x07;
    const unsigned int  mmVeloOutTestLB       = 0x08;   // Outbound Velo Pids
    const unsigned int  mmVeloOutDataPid      = 0x09;   // Outbound Velo Pids
    const unsigned int  mmDepktzer_TotalVeloHdr =  8;
    //
    //  WB1 - Logic Fpa Bitfile Loader
    const unsigned int  mmFpa_Address         = 0x00;
    const unsigned int  mmFpa_Data            = 0x01;
    const unsigned int  mmFpa_Command         = 0x02;
    //
    //  WB2 - Logic Temperature Control
    const unsigned int  mmTemp_TempControl      = 0x00;
    const unsigned int  mmTemp_FanThreshold     = 0x01;
    const unsigned int  mmTemp_AlertThreshold   = 0x02;
    const unsigned int  mmTemp_CommandChannel   = 0x03;
    //
    //  WB3 - Packetizer Config
    const unsigned int  mmPktzer_Enable         = 0x00;
    const unsigned int  mmPktzer_AuxHdr         = 0x01;
    const unsigned int  mmPktzer_AlertHdr       = 0x02;  // Reserved for alert cfg
    const unsigned int  mmPktzer_VeloInHdr      = 0x03;  // Array of mmPktzer_TotalVeloHdr
    const unsigned int  mmPktzer_TotalVeloHdr   =    8;
    const unsigned int  mmPktzer_ForceSize      = 0x22;
    const unsigned int  mmPktzer_IntervalPeriod = 0x23;
    //
    //  WB4 - Alert Registers
    const unsigned int  mmAlert_Enable        = 0x00;
    const unsigned int  mmAlert_Control       = 0x01;
    const unsigned int  mmAlert_Software      = 0x02;
    const unsigned int  mmAlert_Clear         = 0x03;
    //
    //  WB5 - DigitalIo
    const unsigned int  mmDio_DataLo          = 0x00;
    const unsigned int  mmDio_DataHi          = 0x01;
    const unsigned int  mmDio_OutEnableLo     = 0x02;
    const unsigned int  mmDio_OutEnableHi     = 0x03;
    //
    //  WB6 - Serial Flash Rom
    const unsigned int  mmRom_AddrCtl         = 0x00;
    const unsigned int  mmRom_Data            = 0x01;
    const unsigned int  mmRom_Opcode          = 0x02;
    //
    //  WB8 - Analog Front End
    //  ...Clock Config
    const unsigned int  mmAFE_PllControl      = 0x00;
    const unsigned int  mmAFE_PllSpi          = 0x01;
    const unsigned int  mmAFE_VcxoControl     = 0x02;
    const unsigned int  mmAFE_ClkControl      = 0x03;
    //  ...AFE Common Config
    const unsigned int  mmAFE_TestControl     = 0x04;
    const unsigned int  mmAFE_FlowControl     = 0x05;
    const unsigned int  mmAFE_SoftwareTrigger = 0x06;
    const unsigned int  mmAFE_ExtSyncSelect   = 0x07;
    //  ...ADC Common
    const unsigned int  mmAFE_AdcEnable       = 0x08;
    const unsigned int  mmAFE_AdcTrigger      = 0x09;
    const unsigned int  mmAFE_AdcDecimate     = 0x0a;
    //  ...ADC PRI Config
    const unsigned int  mmAFE_AdcPriEnable    = 0x0b;
    const unsigned int  mmAFE_AdcPriInterval  = 0x0c;
    const unsigned int  mmAFE_AdcPriTrigParam = 0x0d;
    const unsigned int  mmAFE_AdcCaptureWin   = 0x0e;
    //  ...ADC SPI Config
    const unsigned int  mmAFE_AdcSpiCtrlBase   = 0x10;  // One SPI per Adc Device
    const unsigned int  mmAFE_AdcSpiCtrlDelta  =    2;
    const unsigned int  mmAFE_AdcSpiStatBase   = 0x11;
    const unsigned int  mmAFE_AdcSpiStatDelta  =    2;
    //  ...ADC Vita Timestamping
    const unsigned int  mmAFE_AdcTStampInit    = 0x20;
    const unsigned int  mmAFE_AdcTStampCtl     = 0x21;
    //  ...ADC Vita Frame Sizes
    const unsigned int  mmAFE_AdcVitaSize      = 0x30;
    const unsigned int  mmAFE_TotalAdcVitas    =   16;
    //  ...ADC Vita Stream IDs
    const unsigned int  mmAFE_AdcVitaStreamId  = 0x40;
    //  Total number is also  mmAFE_TotalAdcVitas
    //  ...ADC Gain Registers
    const unsigned int  mmAFE_AdcGainCoeff     = 0x50;
    const unsigned int  mmAFE_AdcOffsetCoeff   = 0x60;
    const unsigned int  mmAFE_TotalAdcs        =   16;   // for both
    //  ...DAC Common
    const unsigned int  mmAFE_DacEnable        = 0x80;
    const unsigned int  mmAFE_DacTrigger       = 0x81;
    const unsigned int  mmAFE_DacDecimate      = 0x82;
    const unsigned int  mmAFE_DacReset         = 0x83;
    const unsigned int  mmAFE_DacPhaseIncr     = 0x84;
    //  ...DAC PRI Config
    const unsigned int  mmAFE_DacPriEnable     = 0x85;
    const unsigned int  mmAFE_DacPriInterval   = 0x86;
    const unsigned int  mmAFE_DacPriTrigParam  = 0x87;
    const unsigned int  mmAFE_DacCaptureWin    = 0x88;
    //  ...DAC SPI Config
    const unsigned int  mmAFE_DacSpiCtrlBase   = 0x90;  // One SPI per Dac Device
    const unsigned int  mmAFE_DacSpiCtrlDelta  =    2;
    const unsigned int  mmAFE_DacSpiStatBase   = 0x91;
    const unsigned int  mmAFE_DacSpiStatDelta  =    2;
    //  ...DAC Internal Calibration
    const unsigned int  mmAFE_DacLatencyCal    = 0x98;
    //  ...DAC VITA Deframer Control
    //        = 0xA0 -0xCF
    const unsigned int  mmAFE_DacVitaStreamId  = 0xC0;
    const unsigned int  mmAFE_TotalDacVitas    =   16;
    //  ...DAC Gain/Offset Registers
    const unsigned int  mmAFE_DacGainCoeff     = 0xD0;
    const unsigned int  mmAFE_DacOffsetCoeff   = 0xE0;
    const unsigned int  mmAFE_TotalDacs        =   16;   // for both
    //
    //  WB10, WB11 - Aurora 0, 1
    const unsigned int  mmAurora_TestControl    = 0x00;
    const unsigned int  mmAurora_ControlStatus  = 0x01;
    const unsigned int  mmAurora_WritePort      = 0x02;
    const unsigned int  mmAurora_ReadPort       = 0x03;
    const unsigned int  mmAurora_SfpPortControl = 0x04;
    const unsigned int  mmAurora_SfpPortI2C     = 0x05;
    const unsigned int  mmAurora_SioXoI2C       = 0x06;

    const unsigned int  mmAurora_TestControl_1    = 0x20;
    const unsigned int  mmAurora_ControlStatus_1  = 0x21;
    const unsigned int  mmAurora_WritePort_1      = 0x22;
    const unsigned int  mmAurora_ReadPort_1       = 0x23;
    //
    //  PCI Logic Memory Registers
    //
    // Fpga management
    const unsigned int  mmFpgaData            = 0x12000;
    const unsigned int  mmFpgaControl         = 0x12400;
    const unsigned int  mmI2c                 = 0x12800;
    //const unsigned int  mmFpa                 = 0x12c00;
    // Interrupts
    const unsigned int  mmInterruptEnable     = 0x14400;
    const unsigned int  mmCreditQueue         = 0x14800;
    const unsigned int  mmKernelCacheAvail    = 0x18400;    // sent to release target hold, as cache is free to use
    const unsigned int  mmInterruptStatus     = 0x19000;
    // Communications
    const unsigned int  mmBmRingBaseAddress   = 0x15000;
    const unsigned int  mmBmRingSize          = 0x15400;
    const unsigned int  mmPciVersion          = 0x15c00;
    const unsigned int  mmRxPacketTimer       = 0x17400;
    const unsigned int  mmTxPacketTimer       = 0x16c00;
    const unsigned int  mmPciTestControl      = 0x17000;
    // Misc
    const unsigned int  mmLinkControl         = 0x18000;
    const unsigned int  mmControl             = 0x19400;
    const unsigned int  mmStatus              = 0x19800;


} // end namespace X6_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
