// X6_1000M_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2011 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef X6_1000M_MbH
#define X6_1000M_MbH

#include <X6Board_Mb.h>
#include <X6_1000MDeviceMap_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS X6_1000M  -- X6_1000M PCI Express baseboard object
//===========================================================================

class X6_1000M : public X6Board
{

public:
    //
    //  Member Functions
    X6_1000M();
    virtual ~X6_1000M();

    // Methods

    // Device access methods
    X6_1000MInputDevice  &    Input();
    X6_1000MOutputDevice  &   Output();

    IX6RawClockDevices &    RawClockDevice();

public: //Pseudo protected

protected:
    //
    //  Member Data
    X6_1000MDeviceMap_R1           Device;

    //  Ficl Interface
    virtual void    AfterFiclStart(FiclSystem & engine);

    virtual int     Do_DFetch(int dev, int addr);
    virtual void    Do_DStore(int dev, int addr, int value);
    virtual void    Do_DFreq(int dev, float freq);
    virtual float   Do_DFreqActual(int dev);
};

//===========================================================================
//  CLASS X6_1000M_R2_mixin  -- X6_1000M PCI baseboard object
//===========================================================================
//  Logic Revision 2
//
class X6_1000M_R2_mixin
{

public:
    //
    //  Member Functions
    X6_1000M_R2_mixin() {};
    virtual ~X6_1000M_R2_mixin()  {};

protected:
    //  Ficl Interface
    virtual void    Do_AfterFiclStart(FiclSystem & engine);

    virtual int     Do_DFetch(int dev, int addr);
    virtual void    Do_DStore(int dev, int addr, int value);
    virtual void    Do_DFreq(int dev, float freq);
    virtual float   Do_DFreqActual(int dev);

    virtual X6_1000MDeviceMap &    R2Device() = 0;
};

//===========================================================================
//  CLASS X6_1000M_R2in  -- X6_1000M PCI baseboard object
//===========================================================================
//  Logic Revision 2
//
class X6_1000M_R2in : public X6Board, public X6_1000M_R2_mixin
{

public:
    //
    //  Member Functions
    X6_1000M_R2in();
    virtual ~X6_1000M_R2in();

    // Methods
    X6_1000MInputDevice  &    Input();

    IX6RawClockDevices &    RawClockDevice();

public: //Pseudo protected

protected:
    //
    //  Member Data
    X6_1000MDeviceMap_R2           Device;

    virtual void    AfterFiclStart(FiclSystem & engine);

    virtual X6_1000MDeviceMap &    R2Device();
};

//===========================================================================
//  CLASS X6_1000M_R2out  -- X6_1000M PCI baseboard object
//===========================================================================
//  Logic Revision 2
//
class X6_1000M_R2out : public X6Board, public X6_1000M_R2_mixin
{

public:
    //
    //  Member Functions
    X6_1000M_R2out();
    virtual ~X6_1000M_R2out();

    // Methods
    X6_1000MOutputDevice  &   Output();

    IX6RawClockDevices &    RawClockDevice();

public: //Pseudo protected

protected:
    //
    //  Member Data
    X6_1000MDeviceMap_R2           Device;

    virtual void    AfterFiclStart(FiclSystem & engine);

    virtual X6_1000MDeviceMap &    R2Device();
};

//===========================================================================
//  CLASS X6_1000M_R2bidir bidir -- X6_1000M PCI baseboard object
//===========================================================================
//  Logic Revision 2
//
class X6_1000M_R2bidir : public X6Board, public X6_1000M_R2_mixin
{

public:
    //
    //  Member Functions
    X6_1000M_R2bidir();
    virtual ~X6_1000M_R2bidir();

    // Methods
    X6_1000MInputDevice  &    Input();
    X6_1000MOutputDevice  &   Output();

    IX6RawClockDevices &    RawClockDevice();

public: //Pseudo protected

protected:
    //
    //  Member Data
    X6_1000MDeviceMap_R2_bidir   Device;

    virtual void    AfterFiclStart(FiclSystem & engine);

    virtual X6_1000MDeviceMap &    R2Device();
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative

#endif

