// X6_250M_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2011 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef X6_250M_MbH
#define X6_250M_MbH

#include <X6Board_Mb.h>
#include <X6_250MDeviceMap_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS X6_250M  -- X6_250M PCI Express baseboard object
//===========================================================================

class X6_250M : public X6Board
{

public:
    //
    //  Member Functions
    X6_250M();
    virtual ~X6_250M();

    // Methods
//  ...Currently no base class override needed
//    virtual void                Open();
//    virtual void                Close();
//    virtual void                Reset();

    // Device access methods
    X6_250MInputDevice  &    Input();

    IX6RawClockDevices &    RawClockDevice();

public: //Pseudo protected

protected:
    //
    //  Member Data
    X6_250MDeviceMap             Device;

    //  Ficl Interface
    virtual void    AfterFiclStart(FiclSystem & engine);

    virtual int     Do_DFetch(int dev, int addr);
    virtual void    Do_DStore(int dev, int addr, int value);
    virtual void    Do_DFreq(int dev, float freq);
    virtual float   Do_DFreqActual(int dev);
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative

#endif

