// X6_400M_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2011 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef X6_400M_MbH
#define X6_400M_MbH

#include <X6Board_Mb.h>
#include <X6_400MDeviceMap_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS X6_400M  -- X6_400M PCI Express baseboard object
//===========================================================================

class X6_400M : public X6Board
{

public:
    //
    //  Member Functions
    X6_400M();
    virtual ~X6_400M();

    // Methods
//  ...Currently no base class override needed
//    virtual void                Open();
//    virtual void                Close();
//    virtual void                Reset();

    // Device access methods
    X6_400MInputDevice  &    Input();
    X6_400MOutputDevice  &   Output();

    IX6RawClockDevices &    RawClockDevice();

public: //Pseudo protected

protected:
    //
    //  Member Data
    X6_400MDeviceMap             Device;

    //  Ficl Interface
    virtual void    AfterFiclStart(FiclSystem & engine);

    virtual int     Do_DFetch(int dev, int addr);
    virtual void    Do_DStore(int dev, int addr, int value);
    virtual void    Do_DFreq(int dev, float freq);
    virtual float   Do_DFreqActual(int dev);
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative

#endif

