// X6_GSPS_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2010 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef X6_GSPS_MbH
#define X6_GSPS_MbH

#include <X6Board_Mb.h>
#include <X6_GSPSDeviceMap_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS X6_GSPS  -- X6_GSPS PCI Express baseboard object
//===========================================================================

class X6_GSPS : public X6Board
{

public:
    //
    //  Member Functions
    X6_GSPS();
    virtual ~X6_GSPS();

    // Methods
//  ...Currently no base class override needed
//    virtual void                Open();
//    virtual void                Close();
//    virtual void                Reset();

    // Device access methods
    IX6ClockIo &             Clock();
    X6_GSPSInputDevice  &    Input();

    IX6_Ad951x_RawClockDevices &    RawClockDevice();


protected:
    //
    //  Member Data
    X6_GSPSDeviceMap             Device;

    //  Ficl Interface
    virtual void    AfterFiclStart(FiclSystem & engine);

public:
    virtual int     Do_DFetch(int dev, int addr);
    virtual void    Do_DStore(int dev, int addr, int value);
    virtual void    Do_DFreq(int dev, float freq);
    virtual float   Do_DFreqActual(int dev);
};

//===========================================================================
//  CLASS X6_GSPS  -- X6_GSPS PCI Express baseboard object with pattern playing
//===========================================================================

class X6_GSPSPatternPlayer : public X6_GSPS
{
public:
    //
    //  Member Functions
    X6_GSPSPatternPlayer();
    virtual ~X6_GSPSPatternPlayer();

    X6_GSPSOutputDevice  &   Output();

};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}; // namespace Innovative

#endif

