//---------------------------------------------------------------------------
// XAFamilyDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2017 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <XAFamilyDeviceDriver_Mb.h>
#include <XAFamilyMemoryMap_Mb.h>

//---------------------------------------------------------------------------

//
//  Nameless namespace for 'static' data
namespace
{

const unsigned int XA_LogicDeviceBar = 2;  // Second BAR is here cause of 64 bit
                                           //   access requires pairing BARs
                                                 
//------------------------------------------------
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   IntStatusMask        = 0xF;
const unsigned int   IntStatusByteAddress =
    Innovative::XA_MemoryMap::mmInterruptStatus;
//  Parameters for Driver Open
//  ...Device Driver Name
#define     TARGET_BASE             "XADRV"
#define     TARGET_VENDOR_ID         0x1303
#define     TARGET_DEVICE_ID         0x0070
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
		// Name      Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
          "XA",       TARGET_BASE,         0x1303,      0x0070,     0x00,        false);
    }
};       

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS XAFamilyDeviceDriver  -- Driver level code for XA baseboard
//===========================================================================

InnovativeKernel::IsrLog * XAFamilyDeviceDriver::LOG = 0;

//---------------------------------------------------------------------------
//  constructor for class XAFamilyDeviceDriver
//---------------------------------------------------------------------------

XAFamilyDeviceDriver::XAFamilyDeviceDriver()
    :  InnovativeKernel::DualRegionDeviceDriver(
                                    InnovativeKernel::PciId(TARGET_VENDOR_ID, TARGET_DEVICE_ID),
                                    IntStatusByteAddress,
                                    IntStatusMask,
                                    XA_LogicDeviceBar)
{
    //  Default busmaster size is 16 MB
	BusMasterSizeWords(0x1000000/sizeof(int));
	
    //  Save static pointer to log info
    LOG = & mIsrInfo;
}

//---------------------------------------------------------------------------
}; // Innovative

