//  XAFamilyMemoryMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2017 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef XAFamilyMemoryMap_MbH
#define XAFamilyMemoryMap_MbH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace XA_MemoryMap
{
    //
    //  XA "Standard" WB section offsets
    const unsigned int  wbPeripheral          = 0x000;
    const unsigned int  wbLogicLoader         = 0x100;
    const unsigned int  wbTempControl         = 0x200;
    const unsigned int  wbPacketizer          = 0x300;
    const unsigned int  wbAlerts              = 0x400;
    const unsigned int  wbDigitalIo           = 0x500;
    const unsigned int  wbROM                 = 0x600;
    const unsigned int  wbMatlab              = 0x700;
    const unsigned int  wbAFE                 = 0x800;
    const unsigned int  wbUart                = 0x900;
    const unsigned int  wbAurora0             = 0xa00;
    const unsigned int  wbMrApplication       = 0x1a00;
    //
    //  XA WB Register offsets
    //
    //  WB0 - Peripheral Registers
    const unsigned int  mmInformation         = 0x00;
    const unsigned int  mmReset               = 0x01;
    const unsigned int  mmBitstreamDate       = 0x02;
    const unsigned int  mmSubrevision         = 0x03;
    const unsigned int  mmSioXo               = 0x04;
    //
    //  ARB Playback Control
    const unsigned int  mmDdr3Status          = 0x05;
    const unsigned int  mmArbPB_Control       = 0x06;
    const unsigned int  mmArbPB_Data0         = 0x07;
    const unsigned int  mmArbPB_Data1         = 0x08;
    const unsigned int  mmArbPB_Data2         = 0x09;
    const unsigned int  mmArbPB_Data3         = 0x0a;

    const unsigned int  mmVFifo_Status        = 0x0b;
    const unsigned int  mmVFifo_Depth         = 0x0c;

    const unsigned int  mmDepktzer_TotalVeloHdr =  8;
    const unsigned int  mmVeloOutDataPid      = 0x0e;   // Outbound Velo Pids

    const unsigned int  mmPowerMon_LTC_SPI_Control   = 0x16;
    const unsigned int  mmPowerMon_LTC_SPI_Stat      = 0x17;

    const unsigned int  mmFrontPanelDioData   = 0x20;
    const unsigned int  mmFrontPanelDioOutEn  = 0x21;
    //
    //  WB1 - Logic Fpa Bitfile Loader
    const unsigned int  mmFpa_AddressCtrl     = 0x00;
    const unsigned int  mmFpa_Data            = 0x01;
    const unsigned int  mmFpa_Opcode          = 0x02;
    //
    //  WB2 - Logic Temperature Control
    const unsigned int  mmTemp_TempControl      = 0x00;
    const unsigned int  mmTemp_FanThreshold     = 0x01;
    const unsigned int  mmTemp_AlertThreshold   = 0x02;
    const unsigned int  mmTemp_CommandChannel   = 0x03;
    //
    //  WB3 - Packetizer Config
    const unsigned int  mmPktzer_Enable         = 0x00;
    const unsigned int  mmPktzer_AuxHdr         = 0x01;
    const unsigned int  mmPktzer_AlertHdr       = 0x02;  // Reserved for alert cfg
    const unsigned int  mmPktzer_VeloInHdr      = 0x03;  // Array of mmPktzer_TotalVeloHdr
    const unsigned int  mmPktzer_TotalVeloHdr   =    8;
    const unsigned int  mmPktzer_ForceSize      = 0x22;
    const unsigned int  mmPktzer_IntervalPeriod = 0x23;
    //
    //  WB4 - Alert Registers
    const unsigned int  mmAlert_Enable        = 0x00;
    const unsigned int  mmAlert_Control       = 0x01;
    const unsigned int  mmAlert_Software      = 0x02;
    const unsigned int  mmAlert_Clear         = 0x03;
    //
    //  WB5 - DigitalIo
    const unsigned int  mmDio_DataLo          = 0x00;
    const unsigned int  mmDio_DataHi          = 0x01;
    const unsigned int  mmDio_OutEnableLo     = 0x02;
    const unsigned int  mmDio_OutEnableHi     = 0x03;
    //
    //  WB6 - Serial Flash Rom (IDROM)
    const unsigned int  mmRom_AddrCtl         = 0x00;
    const unsigned int  mmRom_Data            = 0x01;
    const unsigned int  mmRom_Opcode          = 0x02;
    //
    //  WB8 - Analog Front End
    //  ...Clock Config
    const unsigned int  mmAFE_PllControl      = 0x00;
    const unsigned int  mmAFE_PllSpi          = 0x01;
    const unsigned int  mmAFE_VcxoControl     = 0x02;
//    const unsigned int  mmAFE_ClkControl      = 0x03;
    //  ...AFE Common Config
    const unsigned int  mmAFE_ExtSyncSelect   = 0x04;
    const unsigned int  mmAFE_FlowControl     = 0x05;   // not used
    const unsigned int  mmAFE_TestControl     = 0x06;
    const unsigned int  mmAFE_SoftwareTrigger = 0x07;
    //  ...ADC Common
    const unsigned int  mmAFE_AdcEnable       = 0x08;
    const unsigned int  mmAFE_AdcPowerDown    = 0x09;
    const unsigned int  mmAFE_AdcTrigger      = 0x0a;
    const unsigned int  mmAFE_AdcDecimation   = 0x0b;
    const unsigned int  mmAFE_AdcReset        = 0x16;
    const unsigned int  mmAFE_AdcSync         = 0x17;
    //  ...ADC PRI Config
    const unsigned int  mmAFE_AdcPriEnable    = 0x0c;
    const unsigned int  mmAFE_AdcPriInterval  = 0x0d;
    const unsigned int  mmAFE_AdcPriTrigParam = 0x0e;
    const unsigned int  mmAFE_AdcCaptureWin   = 0x0f;
    //  ...ADC SPI Config
    const unsigned int  mmAFE_AdcSpiEnable    = 0x10;
    const unsigned int  mmAFE_AdcSpiCtrl      = 0x11;
    const unsigned int  mmAFE_AdcSpiStatus    = 0x12;
    //  ...XA_RX ADC HDW Calibration
    const unsigned int  mmAFE_AdcPowerGood    = 0x18;
    const unsigned int  mmAFE_PHYCalibration  = 0x19;
    const unsigned int  mmAFE_PHYCalibration1 = 0x1a;
    const unsigned int  mmAFE_PHYCalibration2 = 0x1b;

    //  ...ADC Gain Registers
    const unsigned int  mmAFE_AdcGainCoeff     = 0x20;
    const unsigned int  mmAFE_AdcOffsetCoeff   = 0x40;
    const unsigned int  mmAFE_TotalAdcs        =   32;   // for both
    //  ...DAC Common
    const unsigned int  mmAFE_DacEnable        = 0x60;
    const unsigned int  mmAFE_DacPowerDown     = 0x61;
    const unsigned int  mmAFE_DacTrigger       = 0x62;
    const unsigned int  mmAFE_DacDecimate      = 0x63;

    const unsigned int  mmAFE_DacTestPhaseIncr = 0x68;
    const unsigned int  mmAFE_DacReset         = 0x69;
    //  ...DAC PRI Config
    const unsigned int  mmAFE_DacPriEnable     = 0x64;
    const unsigned int  mmAFE_DacPriInterval   = 0x65;
    const unsigned int  mmAFE_DacPriTrigParam  = 0x66;
    const unsigned int  mmAFE_DacCaptureWin    = 0x67;
    //  ...DAC SPI Config
    const unsigned int  mmAFE_DacSpiEnable    = 0x70;
    const unsigned int  mmAFE_DacSpiCtrl      = 0x71;
    const unsigned int  mmAFE_DacSpiStatus    = 0x72;

    //    const unsigned int  mmAFE_DacLatencyCal    = 0x98;

    //  ...DAC Gain/Offset Registers
    const unsigned int  mmAFE_DacGainCoeff     = 0x80;
    const unsigned int  mmAFE_DacOffsetCoeff   = 0xA0;
    const unsigned int  mmAFE_TotalDacs        =   32;   // for both
    //
    //  WB9 - UARTs
    const unsigned int  mmUart_0_Control        = 0x00;
    const unsigned int  mmUart_0_Tx             = 0x01;
    const unsigned int  mmUart_0_Rx             = 0x02;
    const unsigned int  mmUart_1_Control        = 0x03;
    const unsigned int  mmUart_1_Tx             = 0x04;
    const unsigned int  mmUart_1_Rx             = 0x05;
    const unsigned int  mmUartMode              = 0x06;
    const unsigned int  mmInterrupt             = 0x07;
    const unsigned int  mmGpioData              = 0x08;
    const unsigned int  mmGpioDirection         = 0x09;
    //
    //  WB10 - Aurora 0
    const unsigned int  mmAurora_TestControl    = 0x00;
    const unsigned int  mmAurora_ControlStatus  = 0x01;
    const unsigned int  mmAurora_WritePort      = 0x02;
    const unsigned int  mmAurora_ReadPort       = 0x03;
    const unsigned int  mmAurora_SfpPortControl = 0x04;
    const unsigned int  mmAurora_SfpPortI2C     = 0x05;
    const unsigned int  mmAurora_SioXoI2C       = 0x06;

    const unsigned int  mmAurora_TestControl_1    = 0x20;
    const unsigned int  mmAurora_ControlStatus_1  = 0x21;
    const unsigned int  mmAurora_WritePort_1      = 0x22;
    const unsigned int  mmAurora_ReadPort_1       = 0x23;

    //
    //  PCI Logic Memory Registers
    //
    // Fpga management
    const unsigned int  mmFpgaData            = 0x12000;
    const unsigned int  mmFpgaControl         = 0x12400;
    const unsigned int  mmI2c                 = 0x12800;
    //const unsigned int  mmFpa                 = 0x12c00;
    // Interrupts
    const unsigned int  mmInterruptEnable     = 0x14400;
    const unsigned int  mmCreditQueue         = 0x14800;
    const unsigned int  mmKernelCacheAvail    = 0x18400;    // sent to release target hold, as cache is free to use
    const unsigned int  mmInterruptStatus     = 0x19000;
    // Communications
    const unsigned int  mmBmRingBaseAddress   = 0x15000;
    const unsigned int  mmBmRingSize          = 0x15400;
    const unsigned int  mmPciVersion          = 0x15c00;
    const unsigned int  mmRxPacketTimer       = 0x17400;
    const unsigned int  mmTxPacketTimer       = 0x16c00;
    const unsigned int  mmPciTestControl      = 0x17000;
    // Misc
    const unsigned int  mmLinkControl         = 0x18000;
    const unsigned int  mmControl             = 0x19400;
    const unsigned int  mmStatus              = 0x19800;

} // end namespace XA_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
