// XA_402_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2018 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef XA_402_MbH
#define XA_402_MbH

#include <XAFamilyBoard_Mb.h>
#include <XA_402DeviceMap_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS XA_402  -- XA_402 baseboard object
//===========================================================================

class XA_402  : public XAFamilyBoard
{


public:
    //
    //  Member Functions
    XA_402();
    virtual ~XA_402();

    // Device access methods
    XA_402InputDevice  &     Input();
    XA_402OutputDevice  &    Output();

    XA_LMK_Clock::XAClockIo &          Clock();
    XA_LMK_Clock::XARawClockDevices &  RawClockDevice();
    ISelfMeasurement &                 SelfMeasure();
    IFpaLoader &                       VsProm();
    IIdRom &                           IdRom();

public: //Pseudo protected
    XA_402DeviceMap * Debug() { return &Device; }

protected:
    //  Member Data
    XA_402DeviceMap                     Device;

    //  Ficl Interface
    virtual void    AfterFiclStart(FiclSystem & engine);
    virtual int     Do_DFetch(int dev, int addr);
    virtual void    Do_DStore(int dev, int addr, int value);
    virtual void    Do_DFreq(int dev, float freq);
    virtual float   Do_DFreqActual(int dev);
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif

