// XA_500_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2017 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef XA_500_MbH
#define XA_500_MbH

#include <XAFamilyBoard_Mb.h>
#include <XA_500DeviceMap_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif


//===========================================================================
//  CLASS XA_500  -- XA_500 baseboard object
//===========================================================================

class XA_500 : public XAFamilyBoard
{

public:
    //
    //  Member Functions
    XA_500();
    virtual ~XA_500();

//    void TestGeneratorReset() {  Device.TestGeneratorReset();  }
//    void TestGeneratorRun(bool state) {  Device.TestGeneratorRun(state);  }
//    void TestGeneratorEnable(unsigned int enable_mask, unsigned int chirp_size)
//                {  Device.TestGeneratorEnable(enable_mask, chirp_size);  }

    // Device access methods
    XA_500InputDevice  &     Input();
    XA_500OutputDevice  &    Output();

    XA_LMK_Clock::XAClockIo &          Clock();
    XA_LMK_Clock::XARawClockDevices &  RawClockDevice();

//    void  SetTriggerThreshold(double volts);

public: //Pseudo protected

protected:
    //
    //  Member Data
    XA_500DeviceMap             Device;

    //  Ficl Interface
    virtual void    AfterFiclStart(FiclSystem & engine);

    virtual int     Do_DFetch(int dev, int addr);
    virtual void    Do_DStore(int dev, int addr, int value);
    virtual void    Do_DFreq(int dev, float freq);
    virtual float   Do_DFreqActual(int dev);
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif

