// XA_RX_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2017 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef XA_RX_MbH
#define XA_RX_MbH

#include <XAFamilyBoard_Mb.h>
#include <XA_RXDeviceMap_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif


//===========================================================================
//  CLASS XA_RX  -- XA_RX baseboard object
//===========================================================================

class XA_RX : public XAFamilyBoard
{

public:
    //
    //  Member Functions
    XA_RX();
    virtual ~XA_RX();

//    void TestGeneratorReset() {  Device.TestGeneratorReset();  }
//    void TestGeneratorRun(bool state) {  Device.TestGeneratorRun(state);  }
//    void TestGeneratorEnable(unsigned int enable_mask, unsigned int chirp_size)
//                {  Device.TestGeneratorEnable(enable_mask, chirp_size);  }

    // Device access methods
    XA_RXInputDevice  &     Input();

    XA_LMK20_Clock::XAClockIo &          Clock();
    XA_LMK20_Clock::XARawClockDevices &  RawClockDevice();

    XU_DacPatternModeSystem & Memory()
    { return Device.Memory; }

//    void  SetTriggerThreshold(double volts);

public: //Pseudo protected

protected:
    //
    //  Member Data
    XA_RXDeviceMap             Device;

    //  Ficl Interface
    virtual void    AfterFiclStart(FiclSystem & engine);

    virtual int     Do_DFetch(int dev, int addr);
    virtual void    Do_DStore(int dev, int addr, int value);
    virtual void    Do_DFreq(int dev, float freq);
    virtual float   Do_DFreqActual(int dev);
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif

