//---------------------------------------------------------------------------
// XUDeviceDriver_Mb.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2016 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include <XUDeviceDriver_Mb.h>

//---------------------------------------------------------------------------

//
//  Nameless namespace for 'static' data
namespace
{

//---------------------------------------------------------------------------
//  XU Main Device Info
//---------------------------------------------------------------------------
const unsigned int XU_LogicDeviceBar = 2;  // Second BAR is here cause of 64 bit
                                           //   access requires pairing BARs
                                                 
//  Parameters for Interrupt Extension block for use by ISR
const unsigned int   XU_IntStatusMask        = 0xF;
const unsigned int   XU_IntStatusByteAddress =
        InnovativeKernel::MultiChanStandardMemoryMap::mmXuInterruptStatusRegister * sizeof(int);
//  Parameters for Driver Open
//  ...Device Driver Name
#define     XU_TARGET_BASE             "XUDRV"
#define     XU_TARGET_VENDOR_ID         0x1303
#define     XU_TARGET_DEVICE_ID         0x0070  //0x0080
//  ...Use default Target Number Offset of 0.

//==============================================================================
//  CLASS RegisterBoard --
//==============================================================================

class RegisterBoard
{

public:
    RegisterBoard()
    {
        InnovativeKernel::RegisterPciDevice(
		// Name      Device name base     Vendor ID    Device ID   Sub ID       CheckSubID
        "XU Family",  XU_TARGET_BASE,         0x1303,      0x0070,     0x00,        false);
    }
};       

RegisterBoard Registrar;

}  // nameless namespace

namespace Innovative
{
//===========================================================================
//  CLASS XUDeviceDriver  -- Driver level code for XU Family baseboard
//===========================================================================

InnovativeKernel::IsrLog * XUDeviceDriver::LOG = 0;

//---------------------------------------------------------------------------
//  constructor for class XUDeviceDriver
//---------------------------------------------------------------------------

XUDeviceDriver::XUDeviceDriver(InnovativeKernel::IMultiChanOwnerDM& odm)
    :  InnovativeKernel::MultiChannelBMDeviceDriver(odm,
                                    InnovativeKernel::PciId(XU_TARGET_VENDOR_ID, XU_TARGET_DEVICE_ID),
                                    XU_IntStatusByteAddress,
                                    XU_IntStatusMask,
                                    XU_LogicDeviceBar)
{
    SetHighMemPoolFlag(true);    //use high mempool 64bit addressable
    //  Save static pointer to log info
    LOG = & mIsrInfo;
}


} // Innovative



