//  XUFamilyMemoryMap_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2016 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef XUFamilyMemoryMap_MbH
#define XUFamilyMemoryMap_MbH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace XUFamily_MemoryMap
{
    //
    //  XU AXI Master section offsets
    const unsigned int  axiPeripheral         = 0x00000;
    const unsigned int  axiSysMgmtWizard      = 0x08000;
    const unsigned int  axiAFE                = 0x10000;
    const unsigned int  axiJESD_0             = 0x11000;
    const unsigned int  axiJESD_1             = 0x12000;
    const unsigned int  axiJESD_2             = 0x13000;
    const unsigned int  axiJESD_3             = 0x14000;
    const unsigned int  axiCustom             = 0x20000;

    //
    //  XU Basic Axi Register offsets
    //
    //  AxiPeripheral - Peripheral Registers
    const unsigned int  mmInformation         = 0x00;
    const unsigned int  mmReset               = 0x01;
    const unsigned int  mmBitstreamDate       = 0x02;
    const unsigned int  mmSubrevision         = 0x03;
    const unsigned int  mmDdr4Status          = 0x04;
    const unsigned int  mmAuroraI2C           = 0x05;
                                   //         = 0x06;
                                   //         = 0x07;
    //
    //  FPA Flash Loader
    const unsigned int  mmFpa_Address         = 0x08;
    const unsigned int  mmFpa_Data            = 0x09;
    const unsigned int  mmFpa_Command         = 0x0A;

    //
    //  Flash 2  (IDROM)?
    const unsigned int  mmFlash2_Address      = 0x0B;
    const unsigned int  mmFlash2_Data         = 0x0C;
    const unsigned int  mmFlash2_Command      = 0x0D;
    //
    //  Alert Config Registers
    const unsigned int  mmAlert_Enable        = 0x10;
    const unsigned int  mmAlert_Control       = 0x11;
    const unsigned int  mmAlert_Software      = 0x12;
    const unsigned int  mmAlert_Clear         = 0x13;

    //
    //  ARB Playback Control
    const unsigned int  mmArbPB_Control       = 0x21;
    const unsigned int  mmArbPB_Data0         = 0x22;
    const unsigned int  mmArbPB_Data1         = 0x23;
    const unsigned int  mmArbPB_Data2         = 0x24;
    const unsigned int  mmArbPB_Data3         = 0x25;
    //
    //  VFifo Status Information
    const unsigned int  mmVFifo_Status        = 0x26;
    const unsigned int  mmVFifo_Depth         = 0x27;
    //
    //  Aurora 0, 1
    const unsigned int  mmAurora_Select        = 0x28;
    const unsigned int  mmAurora_TestControl   = 0x29;
    const unsigned int  mmAurora_ControlStatus = 0x2A;
    const unsigned int  mmAurora_WritePort     = 0x2B;
    const unsigned int  mmAurora_ReadPort      = 0x2C;
    //
    //  DigitalIo
    const unsigned int  mmDioP_DataLo         = 0x2E;
    const unsigned int  mmDioP_OutEnableLo    = 0x2F;
    const unsigned int  mmDioN_DataLo         = 0x30;
    const unsigned int  mmDioN_OutEnableLo    = 0x31;
    //
    //  System Monitor
    const unsigned int  mmSysmon_Control      = 0x32;
    const unsigned int  mmSysmon_Data         = 0x33;

    //  XU Test Data Checkers/Generator Registers
    const unsigned int  mmXuCheck_TestEnable  = 0x3B;
    const unsigned int  mmXuCheck_PktSize     = 0x3C;
    const unsigned int  mmXuCheck_ChkDecimate = 0x3D;  // not used
    const unsigned int  mmXuCheck_ChkError    = 0x3E;  // not used
    const unsigned int  mmXuCheck_ExtIntTrig  = 0x3F;   //  ?
    //
    //  AxiSysMgmt - Logic Sysmon Registers
    const unsigned int  mmLogicSM_CurTemperature = 0x400;
    const unsigned int  mmLogicSM_CurVccInt      = 0x404;
    const unsigned int  mmLogicSM_CurVccAux      = 0x408;
    const unsigned int  mmLogicSM_CurVbram       = 0x418;

    const unsigned int  mmLogicSM_MaxTemperature = 0x480;
    const unsigned int  mmLogicSM_MaxVccInt      = 0x484;
    const unsigned int  mmLogicSM_MaxVccAux      = 0x488;
    const unsigned int  mmLogicSM_MaxVbram       = 0x48c;

    const unsigned int  mmLogicSM_MinTemperature = 0x490;
    const unsigned int  mmLogicSM_MinVccInt      = 0x494;
    const unsigned int  mmLogicSM_MinVccAux      = 0x498;
    const unsigned int  mmLogicSM_MinVbram       = 0x49c;

    const unsigned int  mmLogicSM_WarnThresh_U   = 0x540;
    const unsigned int  mmLogicSM_FatalThresh_U  = 0x54c;
    const unsigned int  mmLogicSM_WarnThresh_L   = 0x550;
    const unsigned int  mmLogicSM_FatalThresh_L  = 0x55c;

    //
    //  Axi AFE Registers  (analog front end)
    //
    //  Analog PLLs and other clocks
    const unsigned int  mmAFE_Pll_Control     = 0x00;
    const unsigned int  mmAFE_Pll_Spi         = 0x01;
    const unsigned int  mmAFE_Vcxo_I2C        = 0x02;
    const unsigned int  mmAFE_XO_I2C          = 0x03;
    const unsigned int  mmAFE_TXPll_Control   = 0x04;
    const unsigned int  mmAFE_TXPll_Spi       = 0x05;
    const unsigned int  mmAFE_RXPll_Control   = 0x06;
    const unsigned int  mmAFE_RXPll_Spi       = 0x07;
    //
    //  General AFE
    const unsigned int  mmAFE_ExtSyncSelect   = 0x09;
    const unsigned int  mmAFE_TestControl     = 0x0A;
    const unsigned int  mmAFE_SoftwareTrig    = 0x0B;
    //
    //  DAC AFE
    const unsigned int  mmAFE_DacEnable       = 0x0C;
    const unsigned int  mmAFE_DacPowerDown    = 0x0D;
    const unsigned int  mmAFE_DacTriggerCfg   = 0x0E;
    const unsigned int  mmAFE_DacDecimation   = 0x0F;
    //
    //  DAC PRI Mode
    const unsigned int  mmAFE_DacPriEnable    = 0x10;
    const unsigned int  mmAFE_DacPriInterval  = 0x11;
    const unsigned int  mmAFE_DacPriTrigParam = 0x12;
    const unsigned int  mmAFE_DacCaptureWin   = 0x13;
    //
    //  DAC control / SPI
    const unsigned int  mmAFE_DacReset        = 0x15;
    const unsigned int  mmAFE_DacSpiEnable    = 0x16;
    const unsigned int  mmAFE_DacSpiCtrl      = 0x17;
    const unsigned int  mmAFE_DacSpiStatus    = 0x18;

    //const unsigned int  mmAFE_DacPhaseIncr    = 0x0a;

    const unsigned int  mmAFE_DacGainCoeff    = 0x30;
    const unsigned int  mmAFE_DacOffsetCoeff  = 0x38;
    const unsigned int  mmAFE_TotalDacs       =    8;   // for both

    //
    //  Adc AFE
    const unsigned int  mmAFE_AdcEnable       = 0x40;
    const unsigned int  mmAFE_AdcPowerDown    = 0x41;
    const unsigned int  mmAFE_AdcTriggerCfg   = 0x42;
    const unsigned int  mmAFE_AdcDecimation   = 0x43;
    //
    //  Adc PRI Mode
    const unsigned int  mmAFE_AdcPriEnable    = 0x44;
    const unsigned int  mmAFE_AdcPriInterval  = 0x45;
    const unsigned int  mmAFE_AdcPriTrigParam = 0x46;
    const unsigned int  mmAFE_AdcCaptureWin   = 0x47;
    //
    //  Adc control / SPI
    const unsigned int  mmAFE_AdcReset        = 0x49;
    const unsigned int  mmAFE_AdcSpiEnable    = 0x4a;
    const unsigned int  mmAFE_AdcSpiCtrl      = 0x4b;
    const unsigned int  mmAFE_AdcSpiStatus    = 0x4c;

    const unsigned int  mmAFE_AdcGainCoeff    = 0x60;   // made up offsets
    const unsigned int  mmAFE_AdcOffsetCoeff  = 0x68;
    const unsigned int  mmAFE_TotalAdcs       =    8;   // for both


} // end namespace XUFamily_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // end namespace Innovative


#endif
