// XU_RT_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2016 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef XU_RT_MbH
#define XU_RT_MbH

#include <XUFamilyBoard_Mb.h>
#include <XU_RTDeviceMap_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif


//===========================================================================
//  CLASS XU_RT  -- XU_RT PCI Express baseboard object
//===========================================================================

class XU_RT : public XuBoard
{

public:
    //
    //  Member Functions
    XU_RT();
    virtual ~XU_RT();

//    void TestGeneratorReset() {  Device.TestGeneratorReset();  }
//    void TestGeneratorRun(bool state) {  Device.TestGeneratorRun(state);  }
//    void TestGeneratorEnable(unsigned int enable_mask, unsigned int chirp_size)
//                {  Device.TestGeneratorEnable(enable_mask, chirp_size);  }

    // Device access methods
    XU_RTInputDevice  &     Input();
    XU_RTOutputDevice  &    Output();

    XU_Chrono_Type2::ClockIo & Clock();
    XU_Chrono_Type2::RawClockDevices& RawClockDevice();

    JESD_PHY &        JesdPhy(unsigned int dev);
    AD9162_DAC &      Dac(unsigned int dev);
    AD9689_ADC &      Adc(unsigned int dev=0);

    XU_RT_SysMonInterface &  SysMon();

    void  SetTriggerThreshold(double volts);

public: //Pseudo protected

protected:
    //
    //  Member Data
    XU_RTDeviceMap             Device;

    //  Ficl Interface
    virtual void    AfterFiclStart(FiclSystem & engine);

    virtual int     Do_DFetch(int dev, int addr);
    virtual void    Do_DStore(int dev, int addr, int value);
    virtual void    Do_DFreq(int dev, float freq);
    virtual float   Do_DFreqActual(int dev);
};


#ifdef __CLR_VER
#pragma managed(pop)
#endif
} // namespace Innovative

#endif

