// XsvfLoadThread_Mb.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2005 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef XsvfLoadThread_MbH
#define XsvfLoadThread_MbH

#include <Event_Mb.h>
#include <ProcessEvents_Mb.h>
#include <Thread_Mb.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

class PmcJtagPort;

//==============================================================================
//  CLASS XsvfLoadThread -- Xsvf load via PMC JTAG port
//==============================================================================

class XsvfLoadThread : public Thread
{
    typedef Thread inherited;
    
public:
    //
    //  Member Functions
    XsvfLoadThread(PmcJtagPort * port);

    // Support
    void                    Load(std::string file, int debug_level);

    // Events
    OpenWire::EventHandler<ProcessProgressEvent>     OnLoadProgress;
    OpenWire::EventHandler<ProcessCompletionEvent>   OnLoadComplete;
    OpenWire::EventHandler<ProcessStatusEvent>       OnLoadMessage;

    // Methods
    void                    HandleLoadMessage(const char * msg);
    void                    HandleLoadProgress(int percent);

    // Data    
    int                     Percent;
protected:
    //
    //  Member Functions
    void                    Init();
    virtual void            Execute();

private:
    enum { sLoading=inherited::sLast, sLast };

    // Data
    PmcJtagPort *           Port;
    Event                   Loading;
    std::string             File;
    int                     DebugLevel;

    void                    DoLoad();
};

#ifdef __CLR_VER
#pragma managed(pop)
#endif
}  // namespace Innovative

#endif
