//
//  ZbtRam.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure 
//  agreement with Innovative Integration Corporation and may not be copied or 
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2003 Innovative Integration Corporation. 
//  All Rights Reserved.
//

#ifndef ZbtRam_MbH
#define ZbtRam_MbH

#include <HardwareRegister_Mb.h>

namespace Innovative
{

//=============================================================================
//  CLASS ZbtCell  --  ZBT RAM Memory Cell
//=============================================================================
class ZbtRam;

class ZbtCell
{
	friend class ZbtRam;

public:
	// Integer assignment
	ZbtCell & operator=(int value);
	operator int() const;

private:
	// Ctors
	ZbtCell(ZbtRam * parent, AddressingSpace & space, int addr_offset,
			int read_offset, int write_offset);
	ZbtCell(ZbtRam * parent, AddressingSpace & space, int addr_offset,
			int data_offset);

	// Data
	mutable Register    AddressReg;
	Register            ReadReg;
	ShadowRegister      WriteReg;
	ZbtRam *            Ram;
	bool				Mode;
};

//=============================================================================
//  CLASS ZbtRam  --  ZbtRam access class
//=============================================================================

class ZbtRam
{
	friend class ZbtCell;

public:
	// Ctors
	ZbtRam(AddressingSpace & space, int addr_offset, int read_offset,
		   int write_offset);
	ZbtRam(AddressingSpace & space, int addr_offset, int data_offset);

	// Methods
	ZbtCell operator [] (int idx) const;
	ZbtCell & operator [] (int idx);

private:
	mutable int         Idx;
	ZbtCell	            Cell;

	// Methods
	ZbtRam(const ZbtRam &);
	const ZbtRam & operator=(const ZbtRam &);
};


}  // namespace Innovative

#endif
