//  GpDsp_Config_Impl.cpp
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2013 Innovative Integration Corporation.
//  All Rights Reserved.
//

#include "GpDsp_Config_Impl.h"
#include <string>
#include <vector>

namespace   Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace GpDsp_Gui
{

std::string  MainFormTitleString()
{
    return std::string("Digital Instrument Application GP-GSPS");
}

std::string  SoftwareVersionString()
{
    return std::string("2.0.3");
}

//---------------------------------------------------------------------------
//  ExtClockSrcSelectStrings() -- return strings for Ext Src Select Listbox
//---------------------------------------------------------------------------

std::vector<std::string>  ExtClockSrcSelectStrings()
{
    std::vector<std::string>  List;

    List.push_back( std::string("Front Panel") );
    List.push_back( std::string("P16") );

    return List;
}

//---------------------------------------------------------------------------
//  ExtTriggerSrcSelectStrings() -- return strings for Trigger Src Select LB
//---------------------------------------------------------------------------

std::vector<std::string>  ExtTriggerSrcSelectStrings()
{
    std::vector<std::string>  List;

    List.push_back( std::string("Front Panel") );
    List.push_back( std::string("P16") );

    return List;
}

//---------------------------------------------------------------------------
//  AlertStrings() -- return vector of strings for Alert Listbox
//---------------------------------------------------------------------------

std::vector<std::string>  AlertStrings()
{
    std::vector<std::string>  List;

    List.push_back( std::string("Timestamp") );
    List.push_back( std::string("Software") );
    List.push_back( std::string("Temperature") );
    List.push_back( std::string("Vita Framer Overflow") );
    List.push_back( std::string("Trigger") );
    List.push_back( std::string("Input Overrange") );

    return List;
}

//---------------------------------------------------------------------------
//  DdcSourceList() --
//---------------------------------------------------------------------------

std::vector<std::string> DdcSourceList()
{
    std::vector<std::string> List;
    List.push_back( std::string("Adc[0]") );
    List.push_back( std::string("Adc[1]") );
    List.push_back( std::string("Test") );

    return List;
}

}  // end namespace GpDsp_Gui

namespace Drc
{

unsigned int AnalogInChannels()   // needed?
{
    return 2;
}

unsigned int AnalogInAlerts()
{
    return 6;
}

double MaxInRateMHz()
{
    return 3600.0;
}

double PhaseDetectorDefault()
{
    return 100000.0;
}


//---------------------------------------------------------------------------
//  DefaultAlertList() --
//---------------------------------------------------------------------------
std::vector<char>  DefaultAlertList()
{
    std::vector<char>  List(AnalogInAlerts(), 0);
    List[2] = List[3] = List[5] = 1;
    return List;
}

int SystemDefaultPacketSize()
{
    return 0x60000;
}

}  // end namespace Drc


namespace Duc
{

unsigned int AnalogOutChannels() 
{
    return 2;
}

double  MaxOutRateMHz()
{
    return 400.0;
}

} // end namespace Duc

#ifdef __CLR_VER
#pragma managed(pop)
#endif

}  // namespace Innovative

