#ifndef FILTER_H
#define FILTER_H

#include "string"
#include "vector"
#include <IniFile_Mb.h>

using namespace std;
using namespace Innovative;

class FilterData
{
public:
    string          Name;
    unsigned int    BStartNum;
    unsigned int    BStartDir;
    unsigned int    Taps;
    unsigned int    TapsToLoad;
    std::vector<int> Coef;
};

class PolyFilterData
{
public:
    string              Name;
    unsigned int        BStartNum;
    unsigned int        BStartDir;
    unsigned int        NPoly;
    std::vector<FilterData> PolyVec;
};

class Filter
{
public :

    typedef enum {CIC, CFIR, PFIR, COUNT} FilterTypes;

    Filter() {DataLoaded = false; DataApplied=false;}
    ~Filter() {Clear();}

    void Clear();
    void Load(const string & file);
    void LoadSection(const string &SectionName, FilterData &Coef);
    void Apply();

    bool                DataLoaded;
    bool                DataApplied;

    unsigned int        FilterSelection_1;
    unsigned int        FilterSelection_2;

    FilterData          AuxCoef;
    FilterData          CFirCoef;
    FilterData          PFirCoef;
    FilterData          Fir1Coef;
	FilterData          Fir2Coef;

    PolyFilterData      PolyFirCoef;

    int                 CicBStartNum;
    int                 CicBStartDir;
    int                 CicRate;
    float               DecimationFactor;
	float               InterpolationRate;
    string              FileName;
    IniFile             *Ini;

};

#endif // FILTER_H
