#ifndef GRAPHTOOL_MB_H
#define GRAPHTOOL_MB_H

// QT Bug! Prevent the name clash!
#undef PINT32
#undef INT32
#include <GraphingWidget.h>
#include <string>
#include <Poco_Mb.h>


using std::string;
using namespace GraphToolNS;

namespace Innovative
{


class GraphTool
{
public:

    struct ILoader {
        virtual ~ILoader() {}
        virtual void Load() = 0;
    };

    template <class T>
    struct Loader : ILoader
    {
        Loader(GraphTool &outer, T panel) :
                _outer(outer), _handle(panel)
        {}

        void Load();

        GraphTool &_outer;
        T          _handle;
    };


    GraphTool(string name = "GraphTool", string path = ".");
    ~GraphTool();

    template <typename T>
    void Attach(T x)
    {
        if (!_loader)
            _loader = new Loader<T>(*this, x);
    }

    string Path();
    void Path(const string &value);

    GraphWidget &Ref();
    GraphWidget *operator->();

private:
    // No copy or assignment
    GraphTool(const GraphTool& other);
    GraphTool& operator=(const GraphTool &other);


    string       _name;
    string       _path;
    GraphWidget *_graph;
    ILoader     *_loader;
};





}

#endif // GRAPHTOOL_MB_H
