#ifndef QTABLEWIDGETEX_H
#define QTABLEWIDGETEX_H


#include <QKeyEvent>
#include <QTableWidgetItem>

//===========================================================================
//  CLASS QTableWidgetEx --
//===========================================================================


class QTableWidgetEx : public QTableWidget
{
    Q_OBJECT
public:
    QTableWidgetEx(QWidget *parent);
    ~QTableWidgetEx();

    void keyPressEvent(QKeyEvent* event);

signals:
    void updateRequired(const std::vector<int> &selected);

protected:
  bool eventFilter(QObject *obj, QEvent *event);

private:
    typedef std::pair<QString, int> CellType;
    QList<CellType> src_cells;
};

#endif // QTABLEWIDGETEX_H
