#include "ChannelsProxy_Gp.h"

using namespace GP;

//---------------------------------------------------------------------------
//  DdcTunerWrapper::DdcTunerWrapper() -
//---------------------------------------------------------------------------

DdcTunerWrapper::DdcTunerWrapper(DdcTuner *atune, string atag, unsigned int acore) :
    tune(atune), tag(atag), core(acore)
{

}

//---------------------------------------------------------------------------
//  DdcTunerWrapper::~DdcTunerWrapper() -
//---------------------------------------------------------------------------

DdcTunerWrapper::~DdcTunerWrapper()
{

}

//---------------------------------------------------------------------------
//  DdcTunerWrapper::Reset() -
//---------------------------------------------------------------------------

void DdcTunerWrapper::Reset(unsigned int /*parent*/, bool /*value*/)
{
}

//---------------------------------------------------------------------------
//  DdcTunerWrapper::Frequency() -
//---------------------------------------------------------------------------

void DdcTunerWrapper::Frequency(unsigned int parent, double freq, double srate)
{
    tune->Frequency(parent, freq, srate);
}

//---------------------------------------------------------------------------
//  DdcTunerWrapper::ModFrequency() -
//---------------------------------------------------------------------------

void DdcTunerWrapper::ModFrequency(unsigned int parent, double freq, double srate)
{
    tune->ModFrequency(parent, freq, srate);
}

//---------------------------------------------------------------------------
//  DdcTunerWrapper::Phase() -
//---------------------------------------------------------------------------

void DdcTunerWrapper::Phase(unsigned int parent, double value)
{
    tune->PhaseOffset(parent, value);
}

//---------------------------------------------------------------------------
//  DdcTunerWrapper::TuningFrequencies() -
//---------------------------------------------------------------------------
void DdcTunerWrapper::TuningFrequencies(unsigned int parent, const vector<double> &freqs, double srate)
{
    tune->TuningFrequencies(parent, freqs, srate);
}

//---------------------------------------------------------------------------
//  DdcTunerWrapper::TuningEnable() -
//---------------------------------------------------------------------------
void DdcTunerWrapper::TuningEnable(unsigned int parent, bool en)
{
    tune->TuningEnable(parent, en);
}

//---------------------------------------------------------------------------
//  DdcTunerWrapper::TuningDataOut() -
//---------------------------------------------------------------------------
unsigned int DdcTunerWrapper::TuningDataOut(unsigned int parent)
{
    return tune->TuningDataOut(parent);
}

//---------------------------------------------------------------------------
//  DdcLowPassFilterWrapper::DdcLowPassFilterWrapper() -
//---------------------------------------------------------------------------

DdcLowPassFilterWrapper::DdcLowPassFilterWrapper(DdcLowPassFilter *alp, string atag, unsigned int acore) :
    lp(alp), tag(atag), core(acore)
{

}

//---------------------------------------------------------------------------
//  DdcLowPassFilterWrapper::~DdcLowPassFilterWrapper() -
//---------------------------------------------------------------------------

DdcLowPassFilterWrapper::~DdcLowPassFilterWrapper()
{

}

//---------------------------------------------------------------------------
//  DdcLowPassFilterWrapper::Reset() -
//---------------------------------------------------------------------------

void DdcLowPassFilterWrapper::Reset(unsigned int /*parent*/, bool /*value*/)
{
}

//---------------------------------------------------------------------------
//  DdcLowPassFilterWrapper::CicRate() -
//---------------------------------------------------------------------------

void DdcLowPassFilterWrapper::CicRate(unsigned int parent, unsigned int value)
{
    lp->CicRate(parent, value);
}

//---------------------------------------------------------------------------
//  DdcLowPassFilterWrapper::CicBStart() -
//---------------------------------------------------------------------------

void DdcLowPassFilterWrapper::CicBStart(unsigned int parent, unsigned int num, unsigned int dir)
{
    lp->CicBStart(parent, num, dir);
}

//---------------------------------------------------------------------------
//  DdcLowPassFilterWrapper::CFirCoeffs() -
//---------------------------------------------------------------------------

void DdcLowPassFilterWrapper::CFirCoeffs(unsigned int parent, std::vector<int> cfs)
{
    lp->CFirCoeffs(parent, cfs);
}

//---------------------------------------------------------------------------
//  DdcLowPassFilterWrapper::CFirBStart() -
//---------------------------------------------------------------------------

void DdcLowPassFilterWrapper::CFirBStart(unsigned int parent, unsigned int num, unsigned int dir)
{
    lp->CFirBStart(parent, num, dir);
}

//---------------------------------------------------------------------------
//  DdcLowPassFilterWrapper::PFirCoeffs() -
//---------------------------------------------------------------------------

void DdcLowPassFilterWrapper::PFirCoeffs(unsigned int parent, std::vector<int> cfs)
{
    lp->PFirCoeffs(parent, cfs);
}

//---------------------------------------------------------------------------
//  DdcLowPassFilterWrapper::PFirBStart() -
//---------------------------------------------------------------------------

void DdcLowPassFilterWrapper::PFirBStart(unsigned int parent, unsigned int num, unsigned int dir)
{
    lp->PFirBStart(parent, num, dir);
}

//---------------------------------------------------------------------------
//  DdcLowPassFilterWrapper::FirlCoeffs() -
//---------------------------------------------------------------------------

void DdcLowPassFilterWrapper::FirlCoeffs(unsigned int parent, std::vector<int> cfs)
{
    lp->FirlCoeffs(parent, cfs);
}

//---------------------------------------------------------------------------
//  DdcLowPassFilterWrapper::FirlBStart() -
//---------------------------------------------------------------------------

void DdcLowPassFilterWrapper::FirlBStart(unsigned int parent, unsigned int num, unsigned int dir)
{
    lp->FirlBStart(parent, num, dir);
}

//---------------------------------------------------------------------------
//  DdcLowPassFilterWrapper::Fir2Coeffs() -
//---------------------------------------------------------------------------

void DdcLowPassFilterWrapper::Fir2Coeffs(unsigned int parent, std::vector<int> cfs)
{
    lp->Fir2Coeffs(parent, cfs);
}

//---------------------------------------------------------------------------
//  DdcLowPassFilterWrapper::Fir2BStart() -
//---------------------------------------------------------------------------

void DdcLowPassFilterWrapper::Fir2BStart(unsigned int parent, unsigned int num, unsigned int dir)
{
    lp->Fir2BStart(parent, num, dir);
}

//---------------------------------------------------------------------------
//  DdcPolyphaseFilterWrapper::DdcPolyphaseFilterWrapper() -
//---------------------------------------------------------------------------

DdcPolyphaseFilterWrapper::DdcPolyphaseFilterWrapper(DdcPolyPhaseFilter *alp, string atag, unsigned int acore) :
    lp(alp), tag(atag), core(acore)
{

}

//---------------------------------------------------------------------------
//  DdcPolyphaseFilterWrapper::~DdcPolyphaseFilterWrapper() -
//---------------------------------------------------------------------------

DdcPolyphaseFilterWrapper::~DdcPolyphaseFilterWrapper()
{

}

//---------------------------------------------------------------------------
//  DdcPolyphaseFilterWrapper::Reset() -
//---------------------------------------------------------------------------

void DdcPolyphaseFilterWrapper::Reset(unsigned int /*parent*/, bool /*value*/)
{
}

//---------------------------------------------------------------------------
//  DdcPolyphaseFilterWrapper::PpfRate() -
//---------------------------------------------------------------------------

void DdcPolyphaseFilterWrapper::PpfCoeffs(unsigned int parent, unsigned int id, std::vector<int> cfs)
{
    lp->Coeffs(parent, id, cfs);
}

//---------------------------------------------------------------------------
//  DdcPolyphaseFilterWrapper::PpfBStart() -
//---------------------------------------------------------------------------

void DdcPolyphaseFilterWrapper::PpfBStart(unsigned int parent, unsigned int num, unsigned int dir)
{
    lp->BStart(parent, num, dir);
}

//---------------------------------------------------------------------------
//  DdcVitaFramerWrapper::DdcVitaFramerWrapper() -
//---------------------------------------------------------------------------

DdcVitaFramerWrapper::DdcVitaFramerWrapper(DdcVitaFramer *avf, string atag, unsigned int acore) :
    vf(avf), tag(atag), core(acore)
{

}

//---------------------------------------------------------------------------
//  DdcVitaFramerWrapper::~DdcVitaFramerWrapper() -
//---------------------------------------------------------------------------

DdcVitaFramerWrapper::~DdcVitaFramerWrapper()
{
}

//---------------------------------------------------------------------------
//  DdcVitaFramerWrapper::Reset() -
//---------------------------------------------------------------------------

void DdcVitaFramerWrapper::Reset(unsigned int parent, bool value)
{
    vf->Reset(parent, core, value);
    vf->CommandTrigger();
}

//---------------------------------------------------------------------------
//  DdcVitaFramerWrapper::Enable() -
//---------------------------------------------------------------------------

void DdcVitaFramerWrapper::Enable(unsigned int parent, bool value)
{
    vf->Enable(parent, value);
    vf->CommandTrigger();
}

//---------------------------------------------------------------------------
//  DdcVitaFramerWrapper::Size() -
//---------------------------------------------------------------------------

void DdcVitaFramerWrapper::Size(unsigned int parent, unsigned int value)
{
    vf->Size(parent, value);
}

//---------------------------------------------------------------------------
//  DdcVitaFramerWrapper::Size() -
//---------------------------------------------------------------------------

unsigned int DdcVitaFramerWrapper::Size(unsigned int parent)
{
    return vf->Size(parent);
}

//---------------------------------------------------------------------------
//  DdcVitaFramerWrapper::Identity() -
//---------------------------------------------------------------------------

void DdcVitaFramerWrapper::Identity(unsigned int parent, unsigned int did, unsigned int sid)
{
    vf->Identity(parent, did, sid);
}

//---------------------------------------------------------------------------
//  DdcVitaFramerWrapper::FrameMode() -
//---------------------------------------------------------------------------

void DdcVitaFramerWrapper::FrameMode(unsigned int parent, unsigned int mode, bool loc, unsigned int src)
{
    vf->FrameMode(parent, mode, loc, src);
}

//---------------------------------------------------------------------------
//  DdcVitaFramerWrapper::FrameSize() -
//---------------------------------------------------------------------------

void DdcVitaFramerWrapper::FrameSize(unsigned int parent, unsigned int value)
{
    vf->FrameSize(parent, value);
}

//---------------------------------------------------------------------------
//  DdcVitaFramerWrapper::FrameCount() -
//---------------------------------------------------------------------------

unsigned int DdcVitaFramerWrapper::FrameCount(unsigned int parent)
{
    return vf->FrameCount(parent);
}

//---------------------------------------------------------------------------
//  DdcVitaFramerWrapper::FrameDelay() -
//---------------------------------------------------------------------------

void DdcVitaFramerWrapper::FrameDelay(unsigned int parent, unsigned int value)
{
    vf->FrameDelay(parent, value);
}

//---------------------------------------------------------------------------
//  DdcVitaFramerWrapper::ReEnable() -
//---------------------------------------------------------------------------

void DdcVitaFramerWrapper::ReEnable(unsigned int parent, unsigned int value)
{
    vf->ReEnable(parent, value);
}

//---------------------------------------------------------------------------
//  ChannelizerWrapper::ChannelizerWrapper() -
//---------------------------------------------------------------------------

ChannelizerWrapper::ChannelizerWrapper(DdcChannelizer *ach, string atag, unsigned int acore) :
    chizer(ach), tag(atag), core(acore)
{

}

//---------------------------------------------------------------------------
//  ChannelizerWrapper::ChannelizerWrapper() -
//---------------------------------------------------------------------------

ChannelizerWrapper::~ChannelizerWrapper()
{
}

//---------------------------------------------------------------------------
//  ChannelizerWrapper::Reset() -
//---------------------------------------------------------------------------

void ChannelizerWrapper::Reset(unsigned int /*parent*/, bool /*value*/)
{
}

//---------------------------------------------------------------------------
//  ChannelizerWrapper::ScalingSchedule() -
//---------------------------------------------------------------------------

void ChannelizerWrapper::ScalingSchedule(unsigned int parent, unsigned int value)
{
    chizer->ScaleSchedule(parent, value);
}

//---------------------------------------------------------------------------
//  DdcPeripheralWrapper::~DdcPeripheralWrapper() -
//---------------------------------------------------------------------------

DdcPeripheralWrapper::DdcPeripheralWrapper(DdcPeripheralSM *ape, string atag, unsigned int acore):
    pe(ape), tag(atag), core(acore)
{

}

//---------------------------------------------------------------------------
//  DdcPeripheralWrapper::~DdcPeripheralWrapper() -
//---------------------------------------------------------------------------

DdcPeripheralWrapper::~DdcPeripheralWrapper()
{
}

//---------------------------------------------------------------------------
//  DdcPeripheralWrapper::BypassCore() -
//---------------------------------------------------------------------------

void DdcPeripheralWrapper::BypassCore(unsigned int parent, bool value)
{
    pe->BypassCore(parent, value);
}

//---------------------------------------------------------------------------
//  DdcPeripheralWrapper::Source() -
//---------------------------------------------------------------------------

void DdcPeripheralWrapper::Source(unsigned int parent, unsigned int in)
{
    pe->Source(parent, in);
}

//---------------------------------------------------------------------------
//  DdcPeripheralWrapper::EnableSpectrumInversion() -
//---------------------------------------------------------------------------

void DdcPeripheralWrapper::EnableSpectrumInversion(unsigned int parent, bool value)
{
    pe->EnableSpectrumInversion(parent, value);
}

//---------------------------------------------------------------------------
//  DdcPeripheralWrapper::Filter1_Select() -
//---------------------------------------------------------------------------

void DdcPeripheralWrapper::Filter1_Select(unsigned int parent, unsigned int value)
{
    pe->Filter1_Select(parent, value);
}

//---------------------------------------------------------------------------
//  DdcPeripheralWrapper::Filter2_Select() -
//---------------------------------------------------------------------------

void DdcPeripheralWrapper::Filter2_Select(unsigned int parent, unsigned int value)
{
    pe->Filter2_Select(parent, value);
}

//---------------------------------------------------------------------------
//  DdcPeripheralWrapper::Decimation() -
//---------------------------------------------------------------------------

void DdcPeripheralWrapper::Decimation(unsigned int parent, unsigned int value)
{
    pe->Decimation(parent, value);
}

//---------------------------------------------------------------------------
//  DdcPeripheralWrapper::Reset() -
//---------------------------------------------------------------------------

void DdcPeripheralWrapper::Reset(unsigned int /*parent*/, bool /*value*/)
{
}

//---------------------------------------------------------------------------
//  ChannelWrapper::ChannelWrapper() -
//---------------------------------------------------------------------------

ChannelWrapper::ChannelWrapper(Ddc_Module *amod, string /*atag*/, int aid, const DdcChannelInfo &ainfo, DdcChannelsProxy *aparent, int abid) :
    IChannel(aid, ainfo), DdcM(amod), BoardOrdinal(abid), GroupId(-1), parent(aparent)
{
    tag = "DDC[" + Innovative::IntToString(BoardOrdinal) + "][" + Innovative::IntToString(ch_id) + "]" ;
}


//---------------------------------------------------------------------------
//  ChannelWrapper::~ChannelWrapper() -
//---------------------------------------------------------------------------

ChannelWrapper::~ChannelWrapper()
{
    Clear();
}

//---------------------------------------------------------------------------
//  ChannelWrapper::Group() -
//---------------------------------------------------------------------------

void ChannelWrapper::Group(int value)
{
    GroupId = value;
}

//---------------------------------------------------------------------------
//  ChannelWrapper::Group() -
//---------------------------------------------------------------------------

int ChannelWrapper::Group()
{
    return GroupId;
}

//---------------------------------------------------------------------------
//  ChannelWrapper::VitaSize() -
//---------------------------------------------------------------------------

unsigned int ChannelWrapper::VitaSize()
{
    if (VFramerGroup.size() > 0)
        return VFramerGroup[0]->Size(ch_id);
    return 0x1008;
}

//---------------------------------------------------------------------------
//  ChannelWrapper::Clear() -
//---------------------------------------------------------------------------

void ChannelWrapper::Clear()
{
    while (PeripGroup.size() > 0)
        {
        delete PeripGroup.back();
        PeripGroup.pop_back();
        }
    while (TunerGroup.size() > 0)
        {
        delete TunerGroup.back();
        TunerGroup.pop_back();
        }
    while (LPGroup.size() > 0)
        {
        delete LPGroup.back();
        LPGroup.pop_back();
        }
    while (VFramerGroup.size() > 0)
        {
        delete VFramerGroup.back();
        VFramerGroup.pop_back();
        }
    while (ChannelizerGroup.size() > 0)
        {
        delete ChannelizerGroup.back();
        ChannelizerGroup.pop_back();
        }
    while (PGroup.size() > 0)
        {
        delete PGroup.back();
        PGroup.pop_back();
        }
}

//---------------------------------------------------------------------------
//  ChannelWrapper::Tag() -
//---------------------------------------------------------------------------

string ChannelWrapper::Tag()
{
    return tag;
}

//---------------------------------------------------------------------------
//  ChannelWrapper::Reset() -
//---------------------------------------------------------------------------

void ChannelWrapper::Reset(bool state)
{
    DdcM->Reset(state);

    for (size_t i = 0; i < VFramerGroup.size(); i++)
          VFramerGroup[i]->Reset(ch_id, state);

}

//---------------------------------------------------------------------------
//  ChannelWrapper::CommandTrigger() -
//---------------------------------------------------------------------------

void ChannelWrapper::CommandTrigger()
{
    DdcM->CommandTrigger();
}

//---------------------------------------------------------------------------
//  ChannelWrapper::AttachSettings() -
//---------------------------------------------------------------------------

void ChannelWrapper::AttachSettings(Innovative::IniSaver& saver)
{
    saver.Install( ToIni(tag + "-Channel.Source",          info.Source,    info.Source)  );
    saver.Install( ToIni(tag + "-Channel.Frequency",       info.Frequency,   info.Frequency)  );
	saver.Install( ToIni(tag + "-Channel.ModFrequency",    info.ModFrequency,   info.ModFrequency)  );
    saver.Install( ToIni(tag + "-Channel.Enable",          info.Enable,   info.Enable)  );
    saver.Install( ToIni(tag + "-Channel.SpectrumInvert",  info.SpectrumInvert,  info.SpectrumInvert)  );
    saver.Install( ToIni(tag + "-Channel.File",            info.File,   info.File)  );

    saver.Install( ToIni(tag + "-Channel.FrameMode.mode",  info.FrameMode.mode,    info.FrameMode.mode)  );
    saver.Install( ToIni(tag + "-Channel.FrameMode.sz",    info.FrameMode.sz,      info.FrameMode.sz)  );
    saver.Install( ToIni(tag + "-Channel.FrameMode.delay", info.FrameMode.delay,   info.FrameMode.delay)  );
    saver.Install( ToIni(tag + "-Channel.FrameMode.en",    info.FrameMode.en,      info.FrameMode.en)  );
    saver.Install( ToIni(tag + "-Channel.FrameMode.sched", info.FrameMode.sched,   info.FrameMode.sched)  );
}

//---------------------------------------------------------------------------
//  ChannelWrapper::ApplyEnable() -
//---------------------------------------------------------------------------

void ChannelWrapper::ApplyEnable()
{
    for (size_t i = 0; i < VFramerGroup.size(); i++)
       {
       int dest_id = info.Enable ? 0x01 : 0x8000;
       VFramerGroup[i]->Identity(ch_id, dest_id, 0x200 + ch_id);
       }
}

//---------------------------------------------------------------------------
//  ChannelWrapper::Flush() -
//---------------------------------------------------------------------------

void ChannelWrapper::Flush(bool value)
{
    for (size_t i = 0; i < VFramerGroup.size(); i++)
        {
        VFramerGroup[i]->Enable(ch_id, !value);
        VFramerGroup[i]->Reset(ch_id, value);
        }
}

//---------------------------------------------------------------------------
//  ChannelWrapper::Strobe() -
//---------------------------------------------------------------------------

void ChannelWrapper::Strobe(bool en)
{
    for (size_t i = 0; i < VFramerGroup.size(); i++)
        {
        VFramerGroup[i]->ReEnable(ch_id, en);
        }
}

//---------------------------------------------------------------------------
//  ChannelWrapper::Frequency() -
//---------------------------------------------------------------------------

void ChannelWrapper::Frequency(double freq)
{
    for (size_t i = 0; i < TunerGroup.size(); i++)
        {
        TunerGroup[i]->Frequency(ch_id, freq, parent->SamplingRate());
        }
}

//---------------------------------------------------------------------------
//  ChannelWrapper::TestExecute() -
//---------------------------------------------------------------------------


void ChannelWrapper::TestExecute()
{
    for (size_t i = 0; i < VFramerGroup.size(); i++)
        {
        VFramerGroup[i]->Enable(ch_id, 1);
        VFramerGroup[i]->Reset(ch_id, false);
        }
}

//---------------------------------------------------------------------------
//  ChannelWrapper::Apply() -
//---------------------------------------------------------------------------

void ChannelWrapper::Apply()
{
    bool filter_changed = false;

    if (LoadedFilter != info.File)
    {
        LoadedFilter  = info.File;
        filter_changed = true;

        filter.Load(info.File);
    }

    for (size_t i = 0; i < VFramerGroup.size(); i++)
        {
        VFramerGroup[i]->Enable(ch_id, 0);
        VFramerGroup[i]->Reset(ch_id, true);
        VFramerGroup[i]->Reset(ch_id, false);

        VFramerGroup[i]->FrameMode(ch_id, info.FrameMode.mode, 0, info.FrameMode.sched);
        VFramerGroup[i]->FrameSize(ch_id, info.FrameMode.sz);
        VFramerGroup[i]->FrameDelay(ch_id, info.FrameMode.delay);
        }

    for (size_t i = 0; i < PeripGroup.size(); i++)
        {
        PeripGroup[i]->Source(ch_id, info.Source);
        PeripGroup[i]->EnableSpectrumInversion(ch_id, info.SpectrumInvert);
        PeripGroup[i]->BypassCore(ch_id, parent->BypassDdc ? true : false);
        PeripGroup[i]->Filter1_Select(ch_id, filter.FilterSelection_1);
        PeripGroup[i]->Filter2_Select(ch_id, filter.FilterSelection_2);
        PeripGroup[i]->Decimation(ch_id, filter.DecimationFactor);
        }

    for (size_t i = 0; i < TunerGroup.size(); i++)
        {
        TunerGroup[i]->Frequency(ch_id, info.Frequency, parent->SamplingRate());
        TunerGroup[i]->TuningFrequencies(ch_id, Frequencies, parent->SamplingRate());
        TunerGroup[i]->TuningEnable(ch_id, info.FrameMode.en);

        if (TunerGroup[i]->CoreCount() == 2)
            TunerGroup[i]->ModFrequency(ch_id, info.ModFrequency, parent->SamplingRate());
        }

    for (size_t i = 0; filter_changed && (i < LPGroup.size()); i++)
        {
        LPGroup[i]->CicBStart(ch_id, filter.CicBStartNum, filter.CicBStartDir);
        LPGroup[i]->CicRate(ch_id, filter.CicRate);
        LPGroup[i]->CFirBStart(ch_id, filter.CFirCoef.BStartNum, filter.CFirCoef.BStartDir);
        LPGroup[i]->CFirCoeffs(ch_id, filter.CFirCoef.Coef);
        LPGroup[i]->PFirBStart(ch_id, filter.PFirCoef.BStartNum, filter.PFirCoef.BStartDir);
        LPGroup[i]->PFirCoeffs(ch_id, filter.PFirCoef.Coef);
        LPGroup[i]->FirlBStart(ch_id, filter.Fir1Coef.BStartNum, filter.Fir1Coef.BStartDir);
        LPGroup[i]->FirlCoeffs(ch_id, filter.Fir1Coef.Coef);
        LPGroup[i]->Fir2BStart(ch_id, filter.Fir2Coef.BStartNum, filter.Fir2Coef.BStartDir);
        LPGroup[i]->Fir2Coeffs(ch_id, filter.Fir2Coef.Coef);
        }

    for (size_t i = 0; filter_changed && (i < PGroup.size()); i++)
        {
        PGroup[i]->PpfBStart(ch_id, filter.PolyFirCoef.BStartNum, filter.PolyFirCoef.BStartDir);
        for (size_t ii = 0; ii < filter.PolyFirCoef.PolyVec.size(); ii++)
            PGroup[i]->PpfCoeffs(ch_id, ii, filter.PolyFirCoef.PolyVec[ii].Coef);
        }

    for (size_t i = 0; i < VFramerGroup.size(); i++)
        {
        VFramerGroup[i]->Enable(ch_id, 1);
        }

    if (filter_changed) dec = filter.DecimationFactor;
}

//---------------------------------------------------------------------------
//  ChannelWrapper::ReloadFile() -
//---------------------------------------------------------------------------

void ChannelWrapper::ReloadFile()
{
    filter.Load(info.File);
    dec = filter.DecimationFactor;
}

//---------------------------------------------------------------------------
//  ChannelWrapper::AddTunerWrapper() -
//---------------------------------------------------------------------------

void ChannelWrapper::AddTunerWrapper(DdcTunerWrapper *atune)
{
    TunerGroup.push_back(atune);
}

//---------------------------------------------------------------------------
//  ChannelWrapper::AddLowPassFilterWrapper() -
//---------------------------------------------------------------------------

void ChannelWrapper::AddLowPassFilterWrapper(DdcLowPassFilterWrapper *alp)
{
    LPGroup.push_back(alp);
}

//---------------------------------------------------------------------------
//  ChannelWrapper::AddPolyPassFilterWrapper() -
//---------------------------------------------------------------------------

void ChannelWrapper::AddPolyPassFilterWrapper(DdcPolyphaseFilterWrapper *app)
{
    PGroup.push_back(app);
}

//---------------------------------------------------------------------------
//  ChannelWrapper::AddVitaFramerWrapper() -
//---------------------------------------------------------------------------

void ChannelWrapper::AddVitaFramerWrapper(DdcVitaFramerWrapper *avf)
{
    VFramerGroup.push_back(avf);
}

//---------------------------------------------------------------------------
//  ChannelWrapper::AddPeripheralWrapper() -
//---------------------------------------------------------------------------

void ChannelWrapper::AddPeripheralWrapper(DdcPeripheralWrapper *ape)
{
    PeripGroup.push_back(ape);
}

//---------------------------------------------------------------------------
//  ChannelWrapper::AddChannelizerWrapper() -
//---------------------------------------------------------------------------

void ChannelWrapper::AddChannelizerWrapper(ChannelizerWrapper *ach)
{
    ChannelizerGroup.push_back(ach);
}

//---------------------------------------------------------------------------
//  ChannelWrapper::WhichBoard() -
//---------------------------------------------------------------------------

unsigned int ChannelWrapper::WhichBoard()
{
    return BoardOrdinal;
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::DdcChannelsProxy() -
//---------------------------------------------------------------------------

DdcChannelsProxy::DdcChannelsProxy()
{
    SRate = 1.0;
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::~DdcChannelsProxy() -
//---------------------------------------------------------------------------

DdcChannelsProxy::~DdcChannelsProxy()
{
    Clear();
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::Clear() -
//---------------------------------------------------------------------------

void DdcChannelsProxy::Clear()
{
    while (Chans.size() > 0)
        {
        delete Chans.back();
        Chans.pop_back();
        }
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::Reset() -
//---------------------------------------------------------------------------

void DdcChannelsProxy::Reset(bool state)
{
    unsigned int board = 0;
    for (size_t i = 0; i < Chans.size(); i++)
        if (board == Chans[i]->WhichBoard())
            {
            Chans[i]->Reset(state);
            Chans[i]->Reset(!state);
            board++; // trigger next board
            }
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::CommandTrigger() - Trigger each board once
//---------------------------------------------------------------------------

void DdcChannelsProxy::CommandTrigger()
{
    unsigned int board = 0;
    for (size_t i = 0; i < Chans.size(); i++)
        if (board == Chans[i]->WhichBoard())
            {
            Chans[i]->CommandTrigger();
            board++; // trigger next board
            }
}


//---------------------------------------------------------------------------
//  DdcChannelsProxy::DecimationCoeffs() -
//---------------------------------------------------------------------------

vector<float> DdcChannelsProxy::DecimationCoeffs()
{
    vector<float> cfs;
    for (size_t i = 0; i < Chans.size(); i++)
        cfs.push_back(Chans[i]->dec);

    return cfs;
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::DecimationCoeffs() -
//---------------------------------------------------------------------------
float DdcChannelsProxy::DecimationCoeffs(unsigned int ch)
{
    if (ch < Chans.size())
        return Chans[ch]->dec;

    return 1.0f;
}


//---------------------------------------------------------------------------
//  DdcChannelsProxy::DdcChannelsProxy() -
//---------------------------------------------------------------------------

IChannel *DdcChannelsProxy::operator[](unsigned int n)
{
    return Chans[n];
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::ChannelCount() -
//---------------------------------------------------------------------------

int  DdcChannelsProxy::ChannelCount(unsigned int board)
{
    int count = 0;
    for (size_t i = 0; i < Chans.size(); i++)
        if (board == Chans[i]->WhichBoard())
            count++;

    return count;
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::Size() -
//---------------------------------------------------------------------------

size_t DdcChannelsProxy::Size()
{
    return Chans.size();
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::AddChannel() -
//---------------------------------------------------------------------------

void DdcChannelsProxy::Append(ChannelWrapper *val)
{
    Chans.push_back(val);
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::SamplingRate() -
//---------------------------------------------------------------------------

void DdcChannelsProxy::SamplingRate(double value)
{
    SRate = value;
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::SamplingRate() -
//---------------------------------------------------------------------------

double DdcChannelsProxy::SamplingRate()
{
    return SRate;
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::Wrapper() -
//---------------------------------------------------------------------------

ChannelWrapper &DdcChannelsProxy::Wrapper(unsigned int channel)
{
    return *Chans[channel];
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::EnabledChannelCount() -
//---------------------------------------------------------------------------

pair<size_t, int> DdcChannelsProxy::EnabledChannelCount()
{
    size_t nchans   =  0;
    int    first_en = -1;

    for(size_t i = 0; i < Chans.size(); i++)
        if (Chans[i]->info.Enable) {
            nchans++;
            first_en = (first_en == -1) ? i : first_en;
        }

    return make_pair(nchans, first_en);
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::CalculatePacketSize() - In Frame Mode calculate Velo size
//---------------------------------------------------------------------------

size_t DdcChannelsProxy::CalculatePacketSize()
{
    pair<size_t, int> ch = EnabledChannelCount();
    if (ch.first == 0) return 0;

    size_t vsize  = Chans[ch.second]->VitaSize() - 8;
    size_t nvitas = (Cache.FrameMode.sz / vsize) + ((Cache.FrameMode.sz % vsize) ? 1 : 0);

    return (Cache.FrameMode.sz + 8 * nvitas) * ch.first;
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::AttachSettings() -
//---------------------------------------------------------------------------

void DdcChannelsProxy::AttachSettings(Innovative::IniSaver& saver)
{
    for (size_t i = 0; i < Chans.size(); i++)
        Chans[i]->AttachSettings(saver);

    // Atttach cache settings
    saver.Install( ToIni("Ddc.Cached.Source",          Cache.Source,    0)  );
    saver.Install( ToIni("Ddc.Cached.Frequency",       Cache.Frequency,   70.0f)  );
    saver.Install( ToIni("Ddc.Cached.ModFrequency",    Cache.ModFrequency,   5.0f)  );
    saver.Install( ToIni("Ddc.Cached.Enable",          Cache.Enable,   false)  );
    saver.Install( ToIni("Ddc.Cached.SpectrumInvert",  Cache.SpectrumInvert,  false)  );
    saver.Install( ToIni("Ddc.Cached.File",            Cache.File,   string(""))  );

    saver.Install( ToIni("Ddc.BypassDDC",              BypassDdc,   0)  );

    saver.Install( ToIni("Ddc.Cached.FrameMode.mode", Cache.FrameMode.mode,    0u)  );
    saver.Install( ToIni("Ddc.Cached.FrameMode.sz",   Cache.FrameMode.sz,      0u)  );
    saver.Install( ToIni("Ddc.Cached.FrameMode.delay",Cache.FrameMode.delay,   0u)  );
    saver.Install( ToIni("Ddc.Cached.FrameMode.en",   Cache.FrameMode.en,   false)  );
    saver.Install( ToIni("Ddc.Cached.FrameMode.sched",Cache.FrameMode.sched,   0u)  );

    saver.Install( ToIni("Ddc.ScheduleFreqsFile",     ScheduleFreqsFile,   string(""))  );
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::ReadFreqsFile() -
//---------------------------------------------------------------------------

vector<vector<double> > DdcChannelsProxy::ReadFrequencyList(const std::string &file)
{
    vector<vector<double> > result;
    vector<double>          temp;

    if (file.empty() || !Cache.FrameMode.en) return result;

    IniFile Ini(file, false, 1e5, false);

    size_t count =  Ini.Read("DdcCount", 0);
    for(size_t i = 0; i < count; i++){
        temp.clear();
        //
        Ini.Section = "Ddc" + IntToString(i);
        size_t sz =  Ini.Read("ArraySize", 0);
        //
        for(size_t j = 0; j < sz; j++)
            temp.push_back(Ini.Read("F" + IntToString(j), 0.0));
        result.push_back(temp);
    }

    return result;
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::ApplyCached() - Apply current settings to registers
//---------------------------------------------------------------------------

void DdcChannelsProxy::ApplyCached()
{
    FrequencyList = ReadFrequencyList(ScheduleFreqsFile);
    bool okLoad = (FrequencyList.size() == Chans.size());

    for (size_t i = 0; i < Chans.size(); i++)
        {
        Chans[i]->info.FrameMode = Cache.FrameMode;
        if (okLoad) Chans[i]->UpdateFrequencies(FrequencyList[i]);

        Chans[i]->Apply();
        Chans[i]->ApplyEnable();
        }
    CommandTrigger();
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::ApplyCached() - Apply current settings to registers
//---------------------------------------------------------------------------

void DdcChannelsProxy::ApplyCached(const vector<int> &values)
{
    for (size_t i = 0; i < values.size(); i++)
        {
        Chans[values[i]]->info.FrameMode = Cache.FrameMode;

        Chans[values[i]]->Apply();
        Chans[values[i]]->ApplyEnable();
        }
    CommandTrigger();
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::Apply() - Apply GUI settings to all channels
//---------------------------------------------------------------------------

void DdcChannelsProxy::Apply()
{
    FrequencyList = ReadFrequencyList(ScheduleFreqsFile);
    bool okLoad = (FrequencyList.size() == Chans.size());

    for (size_t i = 0; i < Chans.size(); i++)
        {
        Chans[i]->info.File           = Cache.File;
        Chans[i]->info.SpectrumInvert = Cache.SpectrumInvert;
        Chans[i]->info.Source         = Cache.Source;
        Chans[i]->info.Frequency      = Cache.Frequency;
		Chans[i]->info.ModFrequency   = Cache.ModFrequency;
        Chans[i]->info.FrameMode      = Cache.FrameMode;

        if (okLoad)  Chans[i]->UpdateFrequencies(FrequencyList[i]);
        Chans[i]->Apply();
        }
    CommandTrigger();
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::Apply() - Change settings of a single channel
//---------------------------------------------------------------------------

void DdcChannelsProxy::Apply(unsigned int value)
{
    if (value < Chans.size())
        {
        Chans[value]->info.File           = Cache.File;
        Chans[value]->info.SpectrumInvert = Cache.SpectrumInvert;
        Chans[value]->info.Source         = Cache.Source;
        Chans[value]->info.Frequency      = Cache.Frequency;
        Chans[value]->info.ModFrequency   = Cache.ModFrequency;
        Chans[value]->info.FrameMode      = Cache.FrameMode;

        Chans[value]->Apply();
        Update(Chans[value]->WhichBoard(), Chans[value]->Group());
        }

}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::Apply() - Apply to one or more
//---------------------------------------------------------------------------

void DdcChannelsProxy::Apply(const vector<int> &values)
{
    for (size_t i = 0; i < values.size(); i++)
         Apply(values[i]);
    CommandTrigger();
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::ApplyEnable() - Enable/disable channel
//---------------------------------------------------------------------------

void DdcChannelsProxy::ApplyEnable(unsigned int value)
{
    if (value < Chans.size())
        {
        Chans[value]->info.Enable = Cache.Enable;
        Chans[value]->ApplyEnable();
        UpdateEnable(Chans[value]->WhichBoard(), Chans[value]->Group());
        }

}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::ApplyEnable() - Apply to one or more
//---------------------------------------------------------------------------

void DdcChannelsProxy::ApplyEnable(const vector<int> &values)
{
    for (size_t i = 0; i < values.size(); i++)
         ApplyEnable(values[i]);
    CommandTrigger();
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::Update() -
//---------------------------------------------------------------------------

void DdcChannelsProxy::Update(unsigned int ordinal, int group)
{
    for (size_t i = 0; i < Chans.size(); i++)
        {
        if (ordinal == Chans[i]->WhichBoard() && group == Chans[i]->Group())
            {
            Chans[i]->info.SpectrumInvert = Cache.SpectrumInvert;
            Chans[i]->info.Source         = Cache.Source;
            }
        }
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::UpdateEnable() -
//---------------------------------------------------------------------------

void DdcChannelsProxy::UpdateEnable(unsigned int ordinal, int group)
{
    for (size_t i = 0; i < Chans.size(); i++)
        {
        if (ordinal == Chans[i]->WhichBoard() && group == Chans[i]->Group())
            {
            Chans[i]->info.Enable         = Cache.Enable;
            }
        }
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::ChannelTags() -
//---------------------------------------------------------------------------

void DdcChannelsProxy::ChannelTags(vector<std::string> &tags)
{
    for (size_t i = 0; i < Chans.size(); i++)
        tags.push_back(Chans[i]->Tag());
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::ChannelTags() -
//---------------------------------------------------------------------------

void DdcChannelsProxy::ChannelTags(vector<std::string> &tags, unsigned int board)
{
    for (size_t i = 0; i < Chans.size(); i++)
        if (Chans[i]->WhichBoard() == board)
            tags.push_back( string("DDC[" + Innovative::IntToString(Chans[i]->ch_id)) + "]" );
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::TestExecute() -
//---------------------------------------------------------------------------

void DdcChannelsProxy::TestExecute()
{
    Chans[0]->TestExecute();
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::Strobe() -
//---------------------------------------------------------------------------

void DdcChannelsProxy::Strobe()
{
    NextScheduledFrequency();

    for (size_t i = 0; i < Chans.size(); i++)
        if(Chans[i]->info.Enable) Chans[i]->Strobe(false);
    CommandTrigger();
    for (size_t i = 0; i < Chans.size(); i++)
        if(Chans[i]->info.Enable) Chans[i]->Strobe(true);
    CommandTrigger();
}

//---------------------------------------------------------------------------
//  DdcChannelsProxy::NextScheduledFrequency() - Loads next round of frequencies
//---------------------------------------------------------------------------

void DdcChannelsProxy::NextScheduledFrequency(bool init)
{
    if (FrequencyList.size() == 0) return;

    if (init) {
        NextSchedIndexes.resize(FrequencyList.size());
        fill(NextSchedIndexes.begin(), NextSchedIndexes.end(), 0);
    }

    for (size_t i = 0; i < Chans.size(); i++) {
        if(Chans[i]->info.Enable) {
            Chans[i]->Frequency(FrequencyList[i][NextSchedIndexes[i]]);

            NextSchedIndexes[i]++;
            NextSchedIndexes[i] %= FrequencyList[i].size();
        }
    }

    CommandTrigger();
}


//***************************************************************************
//                                 DUC
//***************************************************************************



//---------------------------------------------------------------------------
//  DucChannelWrapper::DucChannelWrapper() -
//---------------------------------------------------------------------------

DucChannelWrapper::DucChannelWrapper(Duc_Module *amod, string /*atag*/, int aid, const DucChannelInfo &ainfo, DucChannelsProxy *aparent, int abid) :
    IChannel(aid, ainfo), DucM(amod), BoardOrdinal(abid), parent(aparent)
{
    tag = "DUC[" + Innovative::IntToString(BoardOrdinal) + "][" + Innovative::IntToString(ch_id) + "]" ;
}


//---------------------------------------------------------------------------
//  DucChannelWrapper::~DucChannelWrapper() -
//---------------------------------------------------------------------------

DucChannelWrapper::~DucChannelWrapper()
{
    Clear();
}

//---------------------------------------------------------------------------
//  DucChannelWrapper::Clear() -
//---------------------------------------------------------------------------

void DucChannelWrapper::Clear()
{
    while (PeripGroup.size() > 0)
        {
        delete PeripGroup.back();
        PeripGroup.pop_back();
        }
    while (TunerGroup.size() > 0)
        {
        delete TunerGroup.back();
        TunerGroup.pop_back();
        }
    while (VFramerGroup.size() > 0)
        {
        delete VFramerGroup.back();
        VFramerGroup.pop_back();
        }
    while (LPGroup.size() > 0)
        {
        delete LPGroup.back();
        LPGroup.pop_back();
        }
    while (PGroup.size() > 0)
        {
        delete PGroup.back();
        PGroup.pop_back();
        }
}

//---------------------------------------------------------------------------
//  DucChannelWrapper::Tag() -
//---------------------------------------------------------------------------

string DucChannelWrapper::Tag()
{
    return tag;
}

//---------------------------------------------------------------------------
//  DucChannelWrapper::Reset() -
//---------------------------------------------------------------------------

void DucChannelWrapper::Reset(bool state)
{
    DucM->Reset(state);

    for (size_t i = 0; i < VFramerGroup.size(); i++)
        VFramerGroup[i]->Reset(ch_id, state);
}

//---------------------------------------------------------------------------
//  DucChannelWrapper::CommandTrigger() -
//---------------------------------------------------------------------------

void DucChannelWrapper::CommandTrigger()
{
    DucM->CommandTrigger();
}

//---------------------------------------------------------------------------
//  DucChannelWrapper::AttachSettings() -
//---------------------------------------------------------------------------

void DucChannelWrapper::AttachSettings(Innovative::IniSaver& saver)
{
    saver.Install( ToIni(tag + "-Channel.Source",          ducinfo.Source,			ducinfo.Source)  );
	saver.Install( ToIni(tag + "-Channel.Sid",			   ducinfo.StreamId,		ducinfo.StreamId)  );
    saver.Install( ToIni(tag + "-Channel.Frequency",       ducinfo.Frequency,		ducinfo.Frequency)  );
    saver.Install( ToIni(tag + "-Channel.Enable",          ducinfo.Enable,			ducinfo.Enable)  );
    saver.Install( ToIni(tag + "-Channel.SpectrumInvert",  ducinfo.SpectrumInvert,  ducinfo.SpectrumInvert)  );
    saver.Install( ToIni(tag + "-Channel.File",            ducinfo.File,			ducinfo.File)  );

}

//---------------------------------------------------------------------------
//  DucChannelWrapper::ApplyEnable() -
//---------------------------------------------------------------------------

void DucChannelWrapper::ApplyEnable()
{
    for (size_t i = 0; i < VFramerGroup.size(); i++)
       {
       int dest_id = ducinfo.Enable ? 0x01 : 0x8000;
       VFramerGroup[i]->Identity(ch_id, dest_id, 0x200 + ch_id);
       }
}

//---------------------------------------------------------------------------
//  DucChannelWrapper::Apply() -
//---------------------------------------------------------------------------

void DucChannelWrapper::Apply()
{
    filter.Load(ducinfo.File);

    for (size_t i = 0; i < VFramerGroup.size(); i++)
        {
        VFramerGroup[i]->Enable(ch_id, 0);
        VFramerGroup[i]->Reset(ch_id, true);
        VFramerGroup[i]->Reset(ch_id, false);
        }

    for (size_t i = 0; i < PeripGroup.size(); i++)
        {
        PeripGroup[i]->Source(ch_id, ducinfo.Source);
		PeripGroup[i]->Sid(ch_id, ducinfo.StreamId);
        PeripGroup[i]->EnableSpectrumInversion(ch_id, ducinfo.SpectrumInvert);
        PeripGroup[i]->Filter1_Select(ch_id, filter.FilterSelection_1);
        PeripGroup[i]->Filter2_Select(ch_id, filter.FilterSelection_2);
        PeripGroup[i]->Decimation(ch_id, filter.DecimationFactor);
        }

    for (size_t i = 0; i < TunerGroup.size(); i++)
        {
        TunerGroup[i]->Frequency(ch_id, ducinfo.Frequency, parent->SamplingRate());
        }

	for (size_t i = 0; i < LPGroup.size(); i++)
        {
        LPGroup[i]->CicBStart(ch_id, filter.CicBStartNum, filter.CicBStartDir);
        LPGroup[i]->CicRate(ch_id, filter.CicRate);
        LPGroup[i]->CFirBStart(ch_id, filter.CFirCoef.BStartNum, filter.CFirCoef.BStartDir);
        LPGroup[i]->CFirCoeffs(ch_id, filter.CFirCoef.Coef);
        LPGroup[i]->PFirBStart(ch_id, filter.PFirCoef.BStartNum, filter.PFirCoef.BStartDir);
        LPGroup[i]->PFirCoeffs(ch_id, filter.PFirCoef.Coef);
        LPGroup[i]->FirlBStart(ch_id, filter.Fir1Coef.BStartNum, filter.Fir1Coef.BStartDir);
        LPGroup[i]->FirlCoeffs(ch_id, filter.Fir1Coef.Coef);
        LPGroup[i]->Fir2BStart(ch_id, filter.Fir2Coef.BStartNum, filter.Fir2Coef.BStartDir);
        LPGroup[i]->Fir2Coeffs(ch_id, filter.Fir2Coef.Coef);
        }

    for (size_t i = 0; i < PGroup.size(); i++)
        {
        PGroup[i]->PpfBStart(ch_id, filter.PolyFirCoef.BStartNum, filter.PolyFirCoef.BStartDir);
        for (size_t ii = 0; ii < filter.PolyFirCoef.PolyVec.size(); ii++)
			PGroup[i]->PpfCoeffs(ch_id, ii, filter.PolyFirCoef.PolyVec[ii].Coef);
        }

    for (size_t i = 0; i < VFramerGroup.size(); i++)
        {
        VFramerGroup[i]->Enable(ch_id, 1);
        }

        dec = filter.DecimationFactor;
}

//---------------------------------------------------------------------------
//  DucChannelWrapper::ReloadFile() -
//---------------------------------------------------------------------------

void DucChannelWrapper::ReloadFile()
{
    filter.Load(ducinfo.File);
    dec = filter.DecimationFactor;
}

//---------------------------------------------------------------------------
//  DucChannelWrapper::AddTunerWrapper() -
//---------------------------------------------------------------------------

void DucChannelWrapper::AddTunerWrapper(DucTunerWrapper *atune)
{
    TunerGroup.push_back(atune);
}

//---------------------------------------------------------------------------
//  DucChannelWrapper::AddVitaFramerWrapper() -
//---------------------------------------------------------------------------

void DucChannelWrapper::AddVitaFramerWrapper(DucVitaFramerWrapper *avf)
{
    VFramerGroup.push_back(avf);
}

//---------------------------------------------------------------------------
//  DucChannelWrapper::AddPeripheralWrapper() -
//---------------------------------------------------------------------------

void DucChannelWrapper::AddPeripheralWrapper(DucPeripheralWrapper *ape)
{
    PeripGroup.push_back(ape);
}

//---------------------------------------------------------------------------
//  DucChannelWrapper::AddLowPassFilterWrapper() -
//---------------------------------------------------------------------------

void DucChannelWrapper::AddLowPassFilterWrapper(DucLowPassFilterWrapper *alp)
{
    LPGroup.push_back(alp);
}

//---------------------------------------------------------------------------
//  DucChannelWrapper::AddPolyPassFilterWrapper() -
//---------------------------------------------------------------------------

void DucChannelWrapper::AddPolyPassFilterWrapper(DucPolyphaseFilterWrapper *app)
{
    PGroup.push_back(app);
}

//---------------------------------------------------------------------------
//  DucChannelWrapper::WhichBoard() -
//---------------------------------------------------------------------------

unsigned int DucChannelWrapper::WhichBoard()
{
    return BoardOrdinal;
}

//---------------------------------------------------------------------------
//  DucVitaFramerWrapper::DucVitaFramerWrapper() -
//---------------------------------------------------------------------------

DucVitaFramerWrapper::DucVitaFramerWrapper(DucVitaFramer *avf, string atag, unsigned int acore) :
    vf(avf), tag(atag), core(acore)
{

}

//---------------------------------------------------------------------------
//  DucVitaFramerWrapper::~DucVitaFramerWrapper() -
//---------------------------------------------------------------------------

DucVitaFramerWrapper::~DucVitaFramerWrapper()
{
}

//---------------------------------------------------------------------------
//  DucVitaFramerWrapper::Reset() -
//---------------------------------------------------------------------------

void DucVitaFramerWrapper::Reset(unsigned int parent, bool value)
{
    vf->Reset(parent, core, value);
    vf->CommandTrigger();
}

//---------------------------------------------------------------------------
//  DucVitaFramerWrapper::Enable() -
//---------------------------------------------------------------------------

void DucVitaFramerWrapper::Enable(unsigned int parent, bool value)
{
    vf->Enable(parent, value);
    vf->CommandTrigger();
}

//---------------------------------------------------------------------------
//  DucVitaFramerWrapper::Size() -
//---------------------------------------------------------------------------

void DucVitaFramerWrapper::Size(unsigned int parent, unsigned int value)
{
    vf->Size(parent, value);
}

//---------------------------------------------------------------------------
//  DucVitaFramerWrapper::Identity() -
//---------------------------------------------------------------------------

void DucVitaFramerWrapper::Identity(unsigned int parent, unsigned int did, unsigned int sid)
{
    vf->Identity(parent, did, sid);
}

//---------------------------------------------------------------------------
//  DucPeripheralWrapper::DucPeripheralWrapper() -
//---------------------------------------------------------------------------

DucPeripheralWrapper::DucPeripheralWrapper(DucPeripheralSM *ape, string atag, unsigned int acore):
    pe(ape), tag(atag), core(acore)
{

}

//---------------------------------------------------------------------------
//  DucPeripheralWrapper::~DucPeripheralWrapper() -
//---------------------------------------------------------------------------

DucPeripheralWrapper::~DucPeripheralWrapper()
{
}

//---------------------------------------------------------------------------
//  DucPeripheralWrapper::BypassCore() -
//---------------------------------------------------------------------------

void DucPeripheralWrapper::BypassCore(unsigned int parent, bool value)
{
    pe->BypassCore(parent, value);
}

//---------------------------------------------------------------------------
//  DucPeripheralWrapper::Source() -
//---------------------------------------------------------------------------

void DucPeripheralWrapper::Source(unsigned int parent, unsigned int in)
{
    pe->Source(parent, in);
}

//---------------------------------------------------------------------------
//  DucPeripheralWrapper::Sid() -
//---------------------------------------------------------------------------

void DucPeripheralWrapper::Sid(unsigned int parent, unsigned int sid)
{
    pe->Sid(parent, sid);
}

//---------------------------------------------------------------------------
//  DucPeripheralWrapper::EnableSpectrumInversion() -
//---------------------------------------------------------------------------

void DucPeripheralWrapper::EnableSpectrumInversion(unsigned int parent, bool value)
{
    pe->EnableSpectrumInversion(parent, value);
}

//---------------------------------------------------------------------------
//  DucPeripheralWrapper::Filter1_Select() -
//---------------------------------------------------------------------------

void DucPeripheralWrapper::Filter1_Select(unsigned int parent, unsigned int value)
{
    pe->Filter1_Select(parent, value);
}

//---------------------------------------------------------------------------
//  DucPeripheralWrapper::Filter2_Select() -
//---------------------------------------------------------------------------

void DucPeripheralWrapper::Filter2_Select(unsigned int parent, unsigned int value)
{
    pe->Filter2_Select(parent, value);
}

//---------------------------------------------------------------------------
//  DucPeripheralWrapper::Decimation() -
//---------------------------------------------------------------------------

void DucPeripheralWrapper::Decimation(unsigned int parent, unsigned int value)
{
    pe->Decimation(parent, value);
}

//---------------------------------------------------------------------------
//  DucPeripheralWrapper::Reset() -
//---------------------------------------------------------------------------

void DucPeripheralWrapper::Reset(unsigned int parent, bool value)
{
    pe->Reset(parent, core, value);
}

//---------------------------------------------------------------------------
//  DucTunerWrapper::DucTunerWrapper() -
//---------------------------------------------------------------------------

DucTunerWrapper::DucTunerWrapper(DucTuner *atune, string atag, unsigned int acore) :
    tune(atune), tag(atag), core(acore)
{

}

//---------------------------------------------------------------------------
//  DucTunerWrapper::~DucTunerWrapper() -
//---------------------------------------------------------------------------

DucTunerWrapper::~DucTunerWrapper()
{

}

//---------------------------------------------------------------------------
//  DucTunerWrapper::Reset() -
//---------------------------------------------------------------------------

void DucTunerWrapper::Reset(unsigned int parent, bool value)
{
    tune->Reset(parent, core, value);
}

//---------------------------------------------------------------------------
//  DucTunerWrapper::Frequency() -
//---------------------------------------------------------------------------

void DucTunerWrapper::Frequency(unsigned int parent, double freq, double srate)
{
    tune->Frequency(parent, freq, srate);
}

//---------------------------------------------------------------------------
//  DucTunerWrapper::Phase() -
//---------------------------------------------------------------------------

void DucTunerWrapper::Phase(unsigned int parent, double value)
{
    tune->PhaseOffset(parent, value);
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::DucChannelsProxy() -
//---------------------------------------------------------------------------

DucChannelsProxy::DucChannelsProxy()
{
    SRate = 1.0;
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::~DucChannelsProxy() -
//---------------------------------------------------------------------------

DucChannelsProxy::~DucChannelsProxy()
{
    Clear();
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::Clear() -
//---------------------------------------------------------------------------

void DucChannelsProxy::Clear()
{
    while (Chans.size() > 0)
        {
        delete Chans.back();
        Chans.pop_back();
        }
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::Reset() -
//---------------------------------------------------------------------------

void DucChannelsProxy::Reset(bool state)
{
    unsigned int board = 0;
    for (size_t i = 0; i < Chans.size(); i++)
        if (board == Chans[i]->WhichBoard())
            {
            Chans[i]->Reset(state);
            Chans[i]->Reset(!state);
            board++; // trigger next board
            }
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::CommandTrigger() - Trigger each board once
//---------------------------------------------------------------------------

void DucChannelsProxy::CommandTrigger()
{
    unsigned int board = 0;
    for (size_t i = 0; i < Chans.size(); i++)
        if (board == Chans[i]->WhichBoard())
            {
            Chans[i]->CommandTrigger();
            board++; // trigger next board
            }
}


//---------------------------------------------------------------------------
//  DucChannelsProxy::DecimationCoeffs() -
//---------------------------------------------------------------------------

vector<float> DucChannelsProxy::DecimationCoeffs()
{
    vector<float> cfs;
    for (size_t i = 0; i < Chans.size(); i++)
        cfs.push_back(Chans[i]->dec);

    return cfs;
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::DecimationCoeffs() -
//---------------------------------------------------------------------------
float DucChannelsProxy::DecimationCoeffs(unsigned int ch)
{
    if (ch < Chans.size())
        return Chans[ch]->dec;

    return 1.0f;
}


//---------------------------------------------------------------------------
//  DucChannelsProxy::DucChannelsProxy() -
//---------------------------------------------------------------------------

IChannel *DucChannelsProxy::operator[](unsigned int n)
{
    return Chans[n];
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::ChannelCount() -
//---------------------------------------------------------------------------

int  DucChannelsProxy::ChannelCount(unsigned int board)
{
    int count = 0;
    for (size_t i = 0; i < Chans.size(); i++)
        if (board == Chans[i]->WhichBoard())
            count++;

    return count;
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::Size() -
//---------------------------------------------------------------------------

size_t DucChannelsProxy::Size()
{
    return Chans.size();
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::AddChannel() -
//---------------------------------------------------------------------------

void DucChannelsProxy::Append(DucChannelWrapper *val)
{
    Chans.push_back(val);
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::SamplingRate() -
//---------------------------------------------------------------------------

void DucChannelsProxy::SamplingRate(double value)
{
    SRate = value;
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::SamplingRate() -
//---------------------------------------------------------------------------

double DucChannelsProxy::SamplingRate()
{
    return SRate;
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::Wrapper() -
//---------------------------------------------------------------------------

DucChannelWrapper &DucChannelsProxy::Wrapper(unsigned int channel)
{
    return *Chans[channel];
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::AttachSettings() -
//---------------------------------------------------------------------------

void DucChannelsProxy::AttachSettings(Innovative::IniSaver& saver)
{
    for (size_t i = 0; i < Chans.size(); i++)
        Chans[i]->AttachSettings(saver);

    // Atttach cache settings
    saver.Install( ToIni("Duc.Cached.Source",          Cache.Source,    0)  );
	saver.Install( ToIni("Duc.Cached.StreamId",        Cache.StreamId,    0)  );
    saver.Install( ToIni("Duc.Cached.Frequency",       Cache.Frequency,   70.0f)  );
    saver.Install( ToIni("Duc.Cached.Enable",          Cache.Enable,   false)  );
    saver.Install( ToIni("Duc.Cached.SpectrumInvert",  Cache.SpectrumInvert,  false)  );
    saver.Install( ToIni("Duc.Cached.File",            Cache.File,   string("..\\..\\Config\\ddc_Fs250p0MHz_BW10p0MHz.ini"))  );
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::ApplyCached() - Apply current settings to registers
//---------------------------------------------------------------------------

void DucChannelsProxy::ApplyCached()
{
    for (size_t i = 0; i < Chans.size(); i++)
        {
        Chans[i]->Apply();
        Chans[i]->ApplyEnable();
        }
    CommandTrigger();
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::ApplyCached() - Apply current settings to registers
//---------------------------------------------------------------------------

void DucChannelsProxy::ApplyCached(const vector<int> &values)
{
    for (size_t i = 0; i < values.size(); i++)
        {
        Chans[values[i]]->Apply();
        Chans[values[i]]->ApplyEnable();
        }
    CommandTrigger();
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::Apply() - Apply GUI settings to all channels
//---------------------------------------------------------------------------

void DucChannelsProxy::Apply()
{
    for (size_t i = 0; i < Chans.size(); i++)
        {
        Chans[i]->ducinfo.File           = Cache.File;
        Chans[i]->ducinfo.SpectrumInvert = Cache.SpectrumInvert;
        Chans[i]->ducinfo.Source         = Cache.Source;
		Chans[i]->ducinfo.StreamId       = Cache.StreamId;
        Chans[i]->ducinfo.Frequency      = Cache.Frequency;

        Chans[i]->Apply();
        }
    CommandTrigger();
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::Apply() - Change settings of a single channel
//---------------------------------------------------------------------------

void DucChannelsProxy::Apply(unsigned int value)
{
 if (value < Chans.size())
        {
        Chans[value]->ducinfo.File           = Cache.File;
        Chans[value]->ducinfo.SpectrumInvert = Cache.SpectrumInvert;
        Chans[value]->ducinfo.Source         = Cache.Source;
		Chans[value]->ducinfo.StreamId			 = Cache.StreamId;
        Chans[value]->ducinfo.Frequency      = Cache.Frequency;

        Chans[value]->Apply();
        }
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::Apply() - Apply to one or more
//---------------------------------------------------------------------------

void DucChannelsProxy::Apply(const vector<int> &values)
{
    for (size_t i = 0; i < values.size(); i++)
         Apply(values[i]);
    CommandTrigger();
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::ApplyEnable() - Enable/disable channel
//---------------------------------------------------------------------------

void DucChannelsProxy::ApplyEnable(unsigned int value)
{
    if (value < Chans.size())
        {
        Chans[value]->ducinfo.Enable = Cache.Enable;
        Chans[value]->ApplyEnable();
        }
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::ApplyEnable() - Apply to one or more
//---------------------------------------------------------------------------

void DucChannelsProxy::ApplyEnable(const vector<int> &values)
{
    for (size_t i = 0; i < values.size(); i++)
         ApplyEnable(values[i]);
    CommandTrigger();
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::ChannelTags() -
//---------------------------------------------------------------------------

void DucChannelsProxy::ChannelTags(vector<std::string> &tags)
{
    for (size_t i = 0; i < Chans.size(); i++)
        tags.push_back(Chans[i]->Tag());
}

//---------------------------------------------------------------------------
//  DucChannelsProxy::ChannelTags() -
//---------------------------------------------------------------------------

void DucChannelsProxy::ChannelTags(vector<std::string> &tags, unsigned int board)
{
    for (size_t i = 0; i < Chans.size(); i++)
        if (Chans[i]->WhichBoard() == board)
            tags.push_back( string("DUC[" + Innovative::IntToString(Chans[i]->ch_id)) + "]" );
}

//---------------------------------------------------------------------------
//  DucLowPassFilterWrapper::DucLowPassFilterWrapper() -
//---------------------------------------------------------------------------

DucLowPassFilterWrapper::DucLowPassFilterWrapper(DucLowPassFilter *alp, string atag, unsigned int acore) :
    lp(alp), tag(atag), core(acore)
{

}

//---------------------------------------------------------------------------
//  DucLowPassFilterWrapper::~DucLowPassFilterWrapper() -
//---------------------------------------------------------------------------

DucLowPassFilterWrapper::~DucLowPassFilterWrapper()
{

}

//---------------------------------------------------------------------------
//  DucLowPassFilterWrapper::Reset() -
//---------------------------------------------------------------------------

void DucLowPassFilterWrapper::Reset(unsigned int parent, bool value)
{
    lp->Reset(parent, core, value);
}

//---------------------------------------------------------------------------
//  DucLowPassFilterWrapper::CicRate() -
//---------------------------------------------------------------------------

void DucLowPassFilterWrapper::CicRate(unsigned int parent, unsigned int value)
{
    lp->CicRate(parent, value);
}

//---------------------------------------------------------------------------
//  DucLowPassFilterWrapper::CicBStart() -
//---------------------------------------------------------------------------

void DucLowPassFilterWrapper::CicBStart(unsigned int parent, unsigned int num, unsigned int dir)
{
    lp->CicBStart(parent, num, dir);
}

//---------------------------------------------------------------------------
//  DucLowPassFilterWrapper::CFirCoeffs() -
//---------------------------------------------------------------------------

void DucLowPassFilterWrapper::CFirCoeffs(unsigned int parent, std::vector<int> cfs)
{
    lp->CFirCoeffs(parent, cfs);
}

//---------------------------------------------------------------------------
//  DucLowPassFilterWrapper::CFirBStart() -
//---------------------------------------------------------------------------

void DucLowPassFilterWrapper::CFirBStart(unsigned int parent, unsigned int num, unsigned int dir)
{
    lp->CFirBStart(parent, num, dir);
}

//---------------------------------------------------------------------------
//  DucLowPassFilterWrapper::PFirCoeffs() -
//---------------------------------------------------------------------------

void DucLowPassFilterWrapper::PFirCoeffs(unsigned int parent, std::vector<int> cfs)
{
    lp->PFirCoeffs(parent, cfs);
}

//---------------------------------------------------------------------------
//  DucLowPassFilterWrapper::PFirBStart() -
//---------------------------------------------------------------------------

void DucLowPassFilterWrapper::PFirBStart(unsigned int parent, unsigned int num, unsigned int dir)
{
    lp->PFirBStart(parent, num, dir);
}

//---------------------------------------------------------------------------
//  DucLowPassFilterWrapper::FirlCoeffs() -
//---------------------------------------------------------------------------

void DucLowPassFilterWrapper::FirlCoeffs(unsigned int parent, std::vector<int> cfs)
{
    lp->FirlCoeffs(parent, cfs);
}

//---------------------------------------------------------------------------
//  DucLowPassFilterWrapper::FirlBStart() -
//---------------------------------------------------------------------------

void DucLowPassFilterWrapper::FirlBStart(unsigned int parent, unsigned int num, unsigned int dir)
{
    lp->FirlBStart(parent, num, dir);
}

//---------------------------------------------------------------------------
//  DucLowPassFilterWrapper::Fir2Coeffs() -
//---------------------------------------------------------------------------

void DucLowPassFilterWrapper::Fir2Coeffs(unsigned int parent, std::vector<int> cfs)
{
    lp->Fir2Coeffs(parent, cfs);
}

//---------------------------------------------------------------------------
//  DucLowPassFilterWrapper::Fir2BStart() -
//---------------------------------------------------------------------------

void DucLowPassFilterWrapper::Fir2BStart(unsigned int parent, unsigned int num, unsigned int dir)
{
    lp->Fir2BStart(parent, num, dir);
}

//---------------------------------------------------------------------------
//  DucPolyphaseFilterWrapper::DucPolyphaseFilterWrapper() -
//---------------------------------------------------------------------------

DucPolyphaseFilterWrapper::DucPolyphaseFilterWrapper(DucPolyPhaseFilter *alp, string atag, unsigned int acore) :
    lp(alp), tag(atag), core(acore)
{

}

//---------------------------------------------------------------------------
//  DucPolyphaseFilterWrapper::~DucPolyphaseFilterWrapper() -
//---------------------------------------------------------------------------

DucPolyphaseFilterWrapper::~DucPolyphaseFilterWrapper()
{

}

//---------------------------------------------------------------------------
//  DucPolyphaseFilterWrapper::Reset() -
//---------------------------------------------------------------------------

void DucPolyphaseFilterWrapper::Reset(unsigned int /*parent*/, bool /*value*/)
{
}

//---------------------------------------------------------------------------
//  DucPolyphaseFilterWrapper::PpfRate() -
//---------------------------------------------------------------------------

void DucPolyphaseFilterWrapper::PpfCoeffs(unsigned int parent, unsigned int id, std::vector<int> cfs)
{
    lp->Coeffs(parent, id, cfs);
}

//---------------------------------------------------------------------------
//  DucPolyphaseFilterWrapper::PpfBStart() -
//---------------------------------------------------------------------------

void DucPolyphaseFilterWrapper::PpfBStart(unsigned int parent, unsigned int num, unsigned int dir)
{
    lp->BStart(parent, num, dir);
}
