//  GpDspMemoryMap_Gp.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2013 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef GpDspMemoryMap_GpH
#define GpDspMemoryMap_GpH

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace GpDsp_MemoryMap
{
    //
    //  GP-DSP Logic Wishbone Regioin Definitons
    const unsigned int  wbCustom              = 0x2000;   // MR_PRJ
    const unsigned int  wbDspCommon           = 0x2100;   // MR_DSP_CMN
    const unsigned int  wbDdc                 = 0x2200;   // MR_DDC
    const unsigned int  wbDuc                 = 0x2300;   // MR_DUC
    const unsigned int  wbSpectrumAnalysis    = 0x2400;   // MR_SA
    const unsigned int  wbBeamforming         = 0x2500;   // MR_BF
    const unsigned int  wbPSK                 = 0x2600;   // MR_PSK
    const unsigned int  wbFSK                 = 0x2700;   // MR_FSK

    //
    //  Shared Offsets
    //  ...all major core sections have a common header block with these offsets
    //
    //  Common Header Block
    const unsigned int  mmHeader_CoresPresent      = 0x00;
    const unsigned int  mmHeader_CmdTrigger        = 0x01;
    const unsigned int  mmHeader_CoreIndex         = 0x02;
    const unsigned int  mmHeader_ParentIndex       = 0x03;
    const unsigned int  mmSyncReset                = 0x07;
    //
    //  WB Project/Custom (0x2000) Standard Offset
    //
    //  Whole Project Header Block
    const unsigned int  mmPrjVersion               = 0x00;
    const unsigned int  mmPrj_MajorCores           = 0x01;
   //const unsigned int  mmPrj_MajorCores          = 0x02
    const unsigned int  mmPrjSubVersion            = 0x03;
    //
    //  WB DspCommon (0x2100) Offsets
    //  ....Common Header Block    @ 0x00
    const unsigned int  mmCommonCompSampleRate     = 0x04;
    const unsigned int  mmCommonCompDataLogTrig    = 0x08;
    //  ....Unbound Vita Framers   @ 0x10  (unused)
    //  ....Power Meters   @ 0x20
    const unsigned int  mmPowerMeterInfo           = 0x20;
    const unsigned int  mmPowerMeterConfig         = 0x21;
    //                                             = 0x22;
    const unsigned int  mmPowerMeterReset          = 0x23;
    const unsigned int  mmPowerMeterAccPoints      = 0x24;
    const unsigned int  mmPowerMeterSource         = 0x25;
    const unsigned int  mmPowerMeterData           = 0x26;
    const unsigned int  mmPowerMeterReady          = 0x27;
    //  ....Overflow Detector @ 0x30
    const unsigned int  mmOverflowInfo             = 0x30;
    const unsigned int  mmOverflowConfig           = 0x31;
    //                                             = 0x32;
    const unsigned int  mmOverflowReset            = 0x33;
    const unsigned int  mmOverflowData             = 0x34;
    //  ....Fifo Status @ 0x40
    const unsigned int  mmFifoStatusInfo           = 0x40;
    const unsigned int  mmFifoStatusConfig         = 0x41;
    //                                             = 0x42;
    const unsigned int  mmFifoStatusReset          = 0x43;
    const unsigned int  mmFifoStatusOverflow       = 0x44;
    const unsigned int  mmFifoStatusUnderflow      = 0x45;
    //  ....Tone Generators @ 0x50
    const unsigned int  mmToneGenInfo              = 0x50;
    const unsigned int  mmToneGenConfig            = 0x51;
    //                                             = 0x52;
    const unsigned int  mmToneGenReset             = 0x53;
    const unsigned int  mmToneGenFreq1             = 0x54;
    const unsigned int  mmToneGenPhase1            = 0x55;
    const unsigned int  mmToneGenGain1             = 0x56;
    //                                             = 0x57;
    const unsigned int  mmToneGenFreq2             = 0x58;
    const unsigned int  mmToneGenPhase2            = 0x59;
    const unsigned int  mmToneGenGain2             = 0x5A;
    //  ....AWGN Generators @ 0x60
    const unsigned int  mmAWGNGenInfo              = 0x60;
    const unsigned int  mmAWGNGenConfig            = 0x61;
    //                                             = 0x62;
    const unsigned int  mmAWGNGenReset             = 0x63;
    const unsigned int  mmAWGNGenGain              = 0x64;
    //  ....Power Management @ 0x70
    const unsigned int  mmPowerMgrInfo             = 0x70;
    const unsigned int  mmPowerMgrConfig           = 0x71;
    //                                             = 0x72;
    const unsigned int  mmPowerMgrReset            = 0x73;
    const unsigned int  mmPowerMgrGain             = 0x74;

    //
    //  DDC (0x2200) Offsets
    //  ....Common Header Block @ 0x00

    const unsigned int  mmDdcInfo                  = 0x04;
    const unsigned int  mmDdcConfig                = 0x05;
    const unsigned int  mmDdcDecimation            = 0x06;

	//  ....Ddc Peripheral   @ 0x10
    const unsigned int  mmDdcPeriphInfo            = 0x10;
    const unsigned int  mmDdcPeriphConfig          = 0x11;
    //
    const unsigned int  mmDdcPeriphReset           = 0x13;
    const unsigned int  mmDdcPeriphBypass          = 0x14;
    const unsigned int  mmDdcPeriphSource          = 0x15;
    const unsigned int  mmDdcPeriphSpectralInv     = 0x16;
    const unsigned int  mmDdcPeriphFilterSel1      = 0x17;
    const unsigned int  mmDdcPeriphFilterSel2      = 0x18;
    //  ....Ddc Tuners   @ 0x20
    const unsigned int  mmDdcTunerInfo             = 0x20;
    const unsigned int  mmDdcTunerConfig           = 0x21;
    //                                             = 0x22;
    const unsigned int  mmDdcTunerReset            = 0x23;
    const unsigned int  mmDdcTunerFrequency        = 0x24;
    const unsigned int  mmDdcTunerPhaseOfs         = 0x25;
    const unsigned int  mmDdcTunerNumFreq          = 0x26;
    const unsigned int  mmDdcTunerProgEn           = 0x27;
    const unsigned int  mmDdcTunerSchAddr          = 0x28;
    const unsigned int  mmDdcTunerSchData          = 0x29;
    const unsigned int  mmDdcTunerSchDout          = 0x2A;

    //  ....Ddc PolyPhase Filter   @ 0x30
    const unsigned int  mmDdcPolyPhaseInfo         = 0x30;
    const unsigned int  mmDdcPolyPhaseConfig       = 0x31;
    //                                             = 0x32;
    const unsigned int  mmDdcPolyPhaseReset        = 0x33;
    const unsigned int  mmDdcPolyPhaseCoeffs       = 0x34;
    const unsigned int  mmDdcPolyPhaseBStart       = 0x35;
    //  ....Lowpass Filter   @ 0x40
    const unsigned int  mmDdcLowpassInfo           = 0x40;
    const unsigned int  mmDdcLowpassConfig         = 0x41;
    //                                             = 0x42;
    const unsigned int  mmDdcLowpassReset          = 0x43;
    const unsigned int  mmDdcLowpassCicRate        = 0x44;
    const unsigned int  mmDdcLowpassCicLsb         = 0x45;
    const unsigned int  mmDdcLowpassCfirCoeff      = 0x46;
    const unsigned int  mmDdcLowpassCfirBStart     = 0x47;
    const unsigned int  mmDdcLowpassPfirCoeff      = 0x48;
    const unsigned int  mmDdcLowpassPfirBStart     = 0x49;
    const unsigned int  mmDdcLowpassFir1Coeff      = 0x4A;
    const unsigned int  mmDdcLowpassFir1BStart     = 0x4B;
    const unsigned int  mmDdcLowpassFir2Coeff      = 0x4C;
    const unsigned int  mmDdcLowpassFir2BStart     = 0x4D;

    //  ....  @ 0x50
    //  ....  Ddc Offset/Gain Calibration @ 0x60
    const unsigned int  mmDdcCalibInfo             = 0x60;
    const unsigned int  mmDdcCalibConfig           = 0x61;
    //                                             = 0x62;
    const unsigned int  mmDdcCalibReset            = 0x63;
    const unsigned int  mmDdcCalibOffset           = 0x64;
    const unsigned int  mmDdcCalibGain             = 0x65;

    //  ....  Ddc Channelizer @ 0x70
    const unsigned int  mmDdcChannelizerInfo       = 0x70;
    const unsigned int  mmDdcChannelizerConfig     = 0x71;
    //                                             = 0x72;
    const unsigned int  mmDdcChannelizerReset      = 0x73;
    const unsigned int  mmDdcChannelizerScale      = 0x74;

    //  ....  Ddc Vita Framer @ 0xE0
    const unsigned int  mmDdcVitaInfo              = 0xE0;
    const unsigned int  mmDdcVitaConfig            = 0xE1;
    //                                             = 0xE2;
    const unsigned int  mmDdcVitaReset             = 0xE3;
    const unsigned int  mmDdcVitaEnable            = 0xE4;
    const unsigned int  mmDdcVitaSize              = 0xE5;
    const unsigned int  mmDdcVitaSid               = 0xE6;
    const unsigned int  mmDdcVitaFrmMode           = 0xE8;
    const unsigned int  mmDdcVitaFrmSize           = 0xE9;
    const unsigned int  mmDdcVitaFrmCount          = 0xEA;
    const unsigned int  mmDdcVitaFrmDelay          = 0xEB;
    const unsigned int  mmDdcVitaFrmReEnable       = 0xEC;

    //  ....  Ddc Debug @ 0xF0
    const unsigned int  mmDdcDebugInfo             = 0xF0;
    const unsigned int  mmDdcDebugConfig           = 0xF1;
    //                                             = 0xF2;
    const unsigned int  mmDdcDebugReset            = 0xF3;
    const unsigned int  mmDdcDebugReg1             = 0xF4;

    //
    //  DUC (0x2300) Offsets
	const unsigned int  mmDucDecimation            = 0x06;
	//  ....Duc Peripheral   @ 0x10
    const unsigned int  mmDucPeriphInfo            = 0x10;
    const unsigned int  mmDucPeriphConfig          = 0x11;
    //                                             = 0x12;
    const unsigned int  mmDucPeriphReset           = 0x13;
    const unsigned int  mmDucPeriphBypass          = 0x14;
    const unsigned int  mmDucPeriphSource          = 0x15;
    const unsigned int  mmDucPeriphSpectralInv     = 0x16;
    const unsigned int  mmDucPeriphFilterSel1      = 0x17;
    const unsigned int  mmDucPeriphFilterSel2      = 0x18;
	const unsigned int  mmDucInputStreamId         = 0x1f;
    //  ....Duc Tuners   @ 0x20
    const unsigned int  mmDucTunerInfo             = 0x20;
    const unsigned int  mmDucTunerConfig           = 0x21;
    //                                             = 0x22;
    const unsigned int  mmDucTunerReset            = 0x23;
    const unsigned int  mmDucTunerFrequency        = 0x24;
    const unsigned int  mmDucTunerPhaseOfs         = 0x25;
    //  ....Duc PolyPhase Filter   @ 0x30
    const unsigned int  mmDucPolyPhaseInfo         = 0x30;
    const unsigned int  mmDucPolyPhaseConfig       = 0x31;
    //                                             = 0x32;
    const unsigned int  mmDucPolyPhaseReset        = 0x33;
    const unsigned int  mmDucPolyPhaseCoeffs       = 0x34;
    const unsigned int  mmDucPolyPhaseBStart       = 0x35;
    //  ....Lowpass Filter   @ 0x40
    const unsigned int  mmDucLowpassInfo           = 0x40;
    const unsigned int  mmDucLowpassConfig         = 0x41;
    //                                             = 0x42;
    const unsigned int  mmDucLowpassReset          = 0x43;
    const unsigned int  mmDucLowpassCicRate        = 0x44;
    const unsigned int  mmDucLowpassCicLsb         = 0x45;
    const unsigned int  mmDucLowpassCfirCoeff      = 0x46;
    const unsigned int  mmDucLowpassCfirBStart     = 0x47;
    const unsigned int  mmDucLowpassPfirCoeff      = 0x48;
    const unsigned int  mmDucLowpassPfirBStart     = 0x49;
    const unsigned int  mmDucLowpassFir1Coeff      = 0x4A;
    const unsigned int  mmDucLowpassFir1BStart     = 0x4B;
    const unsigned int  mmDucLowpassFir2Coeff      = 0x4C;
    const unsigned int  mmDucLowpassFir2BStart     = 0x4D;

    //  ....  @ 0x50
    //  ....  Duc Offset/Gain Calibration @ 0x60
    const unsigned int  mmDucCalibInfo             = 0x60;
    const unsigned int  mmDucCalibConfig           = 0x61;
    //                                             = 0x62;
    const unsigned int  mmDucCalibReset            = 0x63;
    const unsigned int  mmDucCalibOffset           = 0x64;
    const unsigned int  mmDucCalibGain             = 0x65;

    //  ....  Duc Vita Framer @ 0xE0
    const unsigned int  mmDucVitaInfo              = 0xE0;
    const unsigned int  mmDucVitaConfig            = 0xE1;
    //                                             = 0xE2;
    const unsigned int  mmDucVitaReset             = 0xE3;
    const unsigned int  mmDucVitaEnable            = 0xE4;
    const unsigned int  mmDucVitaSize              = 0xE5;
    const unsigned int  mmDucVitaSid               = 0xE6;
    //  ....  Duc Debug @ 0xF0
    const unsigned int  mmDucDebugInfo             = 0xF0;
    const unsigned int  mmDucDebugConfig           = 0xF1;
    //                                             = 0xF2;
    const unsigned int  mmDucDebugReset            = 0xF3;
    const unsigned int  mmDucDebugReg1             = 0xF4;
    //
    //  Spectral Analysis (0x2400) Offsets
    //  ....Common Header Block @ 0x00
    //  ....Sa Peripheral   @ 0x10
    const unsigned int  mmSaPeriphInfo            = 0x10;
    const unsigned int  mmSaPeriphConfig          = 0x11;
    //                                            = 0x12;
    const unsigned int  mmSaPeriphReset           = 0x13;
    const unsigned int  mmSaPeriphBypass          = 0x14;
    const unsigned int  mmSaPeriphSource          = 0x15;
    const unsigned int  mmSaPeriphBypassWin       = 0x16;
    const unsigned int  mmSaPeriphOutputMode      = 0x17;

    //  ....Sa Multi Buffer   @ 0x20
    const unsigned int  mmSaMultiBufInfo          = 0x20;
    const unsigned int  mmSaMultiBufConfig        = 0x21;
    //                                            = 0x22;
    const unsigned int  mmSaMultiBufReset         = 0x23;
    const unsigned int  mmSaMultiBufWinSize       = 0x24;
    const unsigned int  mmSaMultiBufDelay         = 0x25;

    //  ....Sa Windowing   @ 0x30
    const unsigned int  mmSaWindowingInfo         = 0x30;
    const unsigned int  mmSaWindowingConfig       = 0x31;
    //                                            = 0x32;
    const unsigned int  mmSaWindowingReset        = 0x33;
    const unsigned int  mmSaWindowingCoeffAddr    = 0x34;
    const unsigned int  mmSaWindowingCoeffData    = 0x35;
    const unsigned int  mmSaWindowingEn           = 0x36;

    //  ....Sa FFT   @ 0x40
    const unsigned int  mmSaFftInfo               = 0x40;
    const unsigned int  mmSaFftConfig             = 0x41;
    //                                            = 0x42;
    const unsigned int  mmSaFftReset              = 0x43;

    //  ....Sa Post Processing   @ 0x50
    const unsigned int  mmSaPostProcInfo          = 0x50;
    const unsigned int  mmSaPostProcConfig        = 0x51;
    //                                            = 0x52;
    const unsigned int  mmSaPostProcReset         = 0x53;
    const unsigned int  mmSaPostProcTrigMode      = 0x54;
    const unsigned int  mmSaPostProcSingleTrig    = 0x55;
	const unsigned int  mmSaPostProcDecimation    = 0x56;
    const unsigned int  mmSaPostProcProgEn        = 0x58;
    const unsigned int  mmSaPostProcProgAddr      = 0x59;
    const unsigned int  mmSaPostProcProgData      = 0x5A;
    const unsigned int  mmSaPostProcDataReadback  = 0x5B;
    const unsigned int  mmSaPostProcFasdCoeff     = 0x5C;

    //  ....  Sa Vita Framer @ 0xE0
    const unsigned int  mmSaVitaInfo               = 0xE0;
    const unsigned int  mmSaVitaConfig             = 0xE1;
    //                                             = 0xE2;
    const unsigned int  mmSaVitaReset              = 0xE3;
    const unsigned int  mmSaVitaEnable             = 0xE4;
    const unsigned int  mmSaVitaSize               = 0xE5;
    const unsigned int  mmSaVitaSid                = 0xE6;
    //  ....  Sa Debug @ 0xF0
    const unsigned int  mmSaDebugInfo              = 0xF0;
    const unsigned int  mmSaDebugConfig            = 0xF1;
    //                                             = 0xF2;
    const unsigned int  mmSaDebugReset             = 0xF3;
    const unsigned int  mmSaDebugReg1              = 0xF4;
    //
    //  Beamforming (0x2500) Offsets
    //  ....Common Header Block @ 0x00
    //  ....  Bf Vita Framer @ 0xE0
    const unsigned int  mmBfVitaInfo               = 0xE0;
    const unsigned int  mmBfVitaConfig             = 0xE1;
    //                                             = 0xE2;
    const unsigned int  mmBfVitaReset              = 0xE3;
    const unsigned int  mmBfVitaEnable             = 0xE4;
    const unsigned int  mmBfVitaSize               = 0xE5;
    const unsigned int  mmBfVitaSid                = 0xE6;
    //  ....  Bf Debug @ 0xF0
    const unsigned int  mmBfDebugInfo              = 0xF0;
    const unsigned int  mmBfDebugConfig            = 0xF1;
    //                                             = 0xF2;
    const unsigned int  mmBfDebugReset             = 0xF3;
    const unsigned int  mmBfDebugReg1              = 0xF4;
    //
    //  PSK (0x2600) Offsets
    //  ....Common Header Block @ 0x00
    //  ....  Psk Vita Framer @ 0xE0
    const unsigned int  mmPskVitaInfo              = 0xE0;
    const unsigned int  mmPskVitaConfig            = 0xE1;
    //                                             = 0xE2;
    const unsigned int  mmPskVitaReset             = 0xE3;
    const unsigned int  mmPskVitaEnable            = 0xE4;
    const unsigned int  mmPskVitaSize              = 0xE5;
    const unsigned int  mmPskVitaSid               = 0xE6;
    //  ....  Psk Debug @ 0xF0
    const unsigned int  mmPskDebugInfo             = 0xF0;
    const unsigned int  mmPskDebugConfig           = 0xF1;
    //                                             = 0xF2;
    const unsigned int  mmPskDebugReset            = 0xF3;
    const unsigned int  mmPskDebugReg1             = 0xF4;
    //
    //  FSK/MSK (0x2700) Offsets
    //  ....Common Header Block @ 0x00
    //  ....  Fsk Vita Framer @ 0xE0
    const unsigned int  mmFskVitaInfo              = 0xE0;
    const unsigned int  mmFskVitaConfig            = 0xE1;
    //                                             = 0xE2;
    const unsigned int  mmFskVitaReset             = 0xE3;
    const unsigned int  mmFskVitaEnable            = 0xE4;
    const unsigned int  mmFskVitaSize              = 0xE5;
    const unsigned int  mmFskVitaSid               = 0xE6;
    //  ....  Fsk Debug @ 0xF0
    const unsigned int  mmFskDebugInfo             = 0xF0;
    const unsigned int  mmFskDebugConfig           = 0xF1;
    //                                             = 0xF2;
    const unsigned int  mmFskDebugReset            = 0xF3;
    const unsigned int  mmFskDebugReg1             = 0xF4;

}  // end namespace GpDsp_MemoryMap

#ifdef __CLR_VER
#pragma managed(pop)
#endif

} // end namespace Innovative


#endif

