//  GpDsp_Config_Gp.h
//
//    INNOVATIVE INTEGRATION CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or nondisclosure
//  agreement with Innovative Integration Corporation and may not be copied or
//  disclosed except in accordance with the terms of that agreement.
//  Copyright (c) 2000..2013 Innovative Integration Corporation.
//  All Rights Reserved.
//

#ifndef GpDsp_Config_GpH
#define GpDsp_Config_GpH

#include <vector>
#include <string>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

namespace GpDsp_Gui
{
    //
    //  Parameter functions to be defined per each application
    extern std::string  MainFormTitleString();
    extern std::string  SoftwareVersionString();

    extern std::vector<std::string>  ExtClockSrcSelectStrings();
    extern std::vector<std::string>  ExtTriggerSrcSelectStrings();
    extern std::vector<std::string>  TestModeStrings();
    extern std::vector<std::string>  AlertStrings();
    extern std::vector<std::string>  DdcSourceList();
    extern std::vector<std::string>  DucSourceList();
    extern std::vector<std::string>  DucRawSourceList();

}  // end namespace GpDsp_Gui

namespace Drc
{
    //
    //  Parameter functions to be defined per each application
    extern unsigned int AnalogInChannels();
    extern unsigned int AnalogInAlerts();
    extern double       MaxInRateMHz();
    extern double       PhaseDetectorDefault();
    extern std::vector<char>  DefaultAlertList();
    extern int          SystemDefaultPacketSize();
}  // end namespace Drc

namespace Duc
{
    //
    //  Parameter functions to be defined per each application
    extern unsigned int AnalogOutChannels();
    //extern unsigned int AnalogInAlerts();
    extern double       MaxOutRateMHz();
    //extern double       PhaseDetectorDefault();

}  // end namespace Drc


#ifdef __CLR_VER
#pragma managed(pop)
#endif

} // end namespace Innovative


#endif

