#ifndef GpProject_DDC_GpH
#define GpProject_DDC_GpH

#include <Components_Gp.h>
#include <CommonModule_Gp.h>
#include <DdcModule_Gp.h>
#include <DucModule_Gp.h>
#include <SpectralModule_Gp.h>

namespace Innovative
{
#ifdef __CLR_VER
#pragma managed(push, off)
#endif

//===========================================================================
//  CLASS GpProject_DDC -- DDC project register "Extension"
//===========================================================================
//  Collect all Modules and Submodules needed for a project here

class GpProject_DDC
{
public:
    void Reset(bool value);
    void Command(bool value);

    GpProject_DDC(GpDspMemoryExtension & gp);
    ~GpProject_DDC() {}
    //
    //  "Memory Map"
    GspDspProjectInfo   ProjectInfo;
    //
    //  Common WB
    DspCommon_Module    CommonM;
    DspPowerMeterSM     PowerMeterSM;
    DspOverflowSM       OverflowSM;
    DspToneGeneratorSM  ToneGeneratorSM;

    //
    //  DDC WB
    Ddc_Module          DdcM;
    DdcPeripheralSM     DdcPeriphSM;
    DdcTuner            DdcTunerSM;
    DdcLowPassFilter    DdcLowPassFilterSM;
    DdcPolyPhaseFilter  DdcPolyPhaseFilterSM;
    DdcVitaFramer       DdcVitaFramerSM;
    DdcChannelizer      DdcChannelizerSM;

    //
    //  Spectral WB
    SpectralModule      SpectralM;
    SpectralPeripheral  SpectralPeriphM;
    SpectralMultiBuffer SpectralMultiBufferM;
    SpectralWindowing   SpectralWindowingM;
    SpectralFft         SpectralFftM;
    SpectralPostProc    SpectralPostProcM;
    SpectralVitaFramer  SpectralVitaFramerM;

    //
    //  DUC WB
    Duc_Module          DucM;
	DucPeripheralSM     DucPeriphSM;
	DucTuner            DucTunerSM;
	DucVitaFramer       DucVitaFramerSM;
	DucLowPassFilter    DucLowPassFilterSM;
	DucPolyPhaseFilter  DucPolyPhaseFilterSM;

private:

};


#ifdef __CLR_VER
#pragma managed(pop)
#endif

}  // namespace Innovative

#endif // GpProject_DDC_GpH
